/*
*************************************
file:  conv.bits.bdds.c
*************************************
*/

#define dbg_flag 0


#include "bmath.h"


/*
******************************************
Define in a decimal representation
for bdd sequence b.
******************************************
*/


unsigned int conv_bdds_to_dec(int num_bits, bdd *b)

{  /*  begin */

/* declarations  */
int k;
unsigned int a;

bdd bddzero, bddone;

/*  program  */

#if (dbg_flag > 100)
printf("\nconv_bdds_to_dec: ckp 100\n");
#endif

bddzero = zero();
bddone = one();

a = 0x0;

for (k = num_bits - 1; k >= 0; k--)
   {
      if ( bdd_equal(b[k], bddzero) )
      /* then  */
         a =  (a << 1);
      else   
        if ( bdd_equal(b[k], bddone) )
        /* then  */
            a =  ((a << 1) | 0x1);
        else
      	    {
      	       printf("\nconv_bdds_to_dec: error in bit %d\n", k);
      	     
      	       exit (1234);
      	    }

   }
   
   
delete_bdd(bddone);
delete_bdd(bddzero);


return (a);

#if (dbg_flag > 100)
printf("\nconv_bdds_to_dec: ckp 200\n");
#endif


}  /*  end  */
