/*
*************************************
file:  actions.c
*************************************
*/



#include "bmath.h"


#define dbg_flag 0


/*
******************************************
Display 1s of a boolean functions of arity n.

******************************************
*/


void display_1_bf(
int k,   /* arguments   */
int n,   /*  size of each argument   */
bdd F   /* boolean function of arity k*n   */
)

{  /*  begin */

/* declarations  */


unsigned int i, max_in;
int *ux;
int result, j;

/*  program  */

#if (dbg_flag > 100)
printf("\ndisplay_bf: ckp 100 (begin)\n");
#endif

ux = (int *) malloc(k*n * sizeof(int));

if (ux == NULL)
{
    printf("\n\nError: no space for ux (display_bf)");
    exit (1234);
}


/* define max_in   */
max_in = 1;
for (i = 0; i < k*n; i++)
{
    max_in = 2*max_in;
}

for (i = 0; i < max_in; i++)
{
 	 	/* define ux  */
 	 	conv_dec_to_bin(k*n, i, ux);
 		
 		/* define result  */
 		result = eval_bdd(F, ux, k*n);
 		
 		if (result   /*  != 0  */)
 		{   /*  print input   */

 	 	printf("\n\n\nbf tuple %u ***************", i);

 	 	
 	 	/* print arguments   */
 	 	printf("\nbf arguments");
 	 	print_state(k, n, ux);

		}   /*  end print input   */

}


free(ux);

}  /*  end  */




