/*
*************************************
file:  actions.c
*************************************
*/



#include "bmath.h"


#define dbg_flag 0

/*
******************************************
Test n bit binary operator.

******************************************
*/

void test_bin_op(
int size_in,
int size_out, 
bdd *F
)

{  /*  begin */

/* declarations  */


int i, j, h, k;
int *x, *y, *xy, *z;
int max_in;

/*  program  */

#if (dbg_flag > 100)
printf("\ndet_controller: ckp 100 (begin)\n");
#endif

/* Define input, output vector    */ 

x = (int *) malloc(size_in * sizeof(int));
if (x == NULL)
{ 
    printf("\n\nError:  no space for x (test_bin_op)");  
    exit (1234);
}

y = (int *) malloc(size_in * sizeof(int));
if (y == NULL)
{ 
    printf("\n\nError:  no space for y (test_bin_op)");  
    exit (1234);
}

xy = (int *) malloc(2*size_in * sizeof(int));
if (xy == NULL)
{ 
    printf("\n\nError:  no space for xy (test_bin_op)");  
    exit (1234);
}

z = (int *) malloc(size_out * sizeof(int));
if (z == NULL)
{ 
    printf("\n\nError:  no space for z (test_bin_op)");  
    exit (1234);
}


/* define max_in   */
max_in = 1;
for (i = 0; i < size_in; i++)
{
    max_in = 2*max_in;
}

for (i = 0; i < max_in; i++)
{
 	for (j = 0; j < max_in; j++)
 	{
 	 	/* define x  */
 	 	conv_dec_to_bin(size_in, i, x);
 	 	/* define y  */
 	 	conv_dec_to_bin(size_in, j, y);
 	 	/* define xy  */
		for (h = 0; h < size_in; h++)
		{
			xy[2*h] = x[h]; xy[2*h + 1] = y[h];
		}
 	 	/* define z  */
 	 	eval_bdd_vct(size_out, z, F, xy, 2*size_in);
 	 	k = conv_bin_to_dec(size_out, z);
 	 	/* print result   */
 	 	
 	 	printf("\n\nx = %u, y = %u, output = %u",
 	 	i, j, k);

 	}
 	
}

free(x);
free(y);
free(xy);
free(z);


}  /*  end  */




