
#include "local.h"

#include "htable.h"



#define dbg_flag 0  /* normal value: 0  */

#define dbg_compose 0   /* normal value: 0  */

#define cmp_via_rstr 0   /* normal value: 0  */



bdd compose(bdd F, int i, bdd G)
/*
**  returns graph
**  representing function
**  (F[i := G]) 
*/
{




#if (cmp_via_rstr > 0)
bdd buffer[8];
/* program  */
buffer[1] = restrict(F, i, 1);
buffer[2] = restrict(F, i, 0);
buffer[3] = NOT(G);
buffer[4] = AND(buffer[3], buffer[2]);
buffer[5] = AND(G, buffer[1]);
buffer[6] = OR(buffer[4], buffer[5]);
delete_bdd(buffer[1]);
delete_bdd(buffer[2]);
delete_bdd(buffer[3]);
delete_bdd(buffer[4]);
delete_bdd(buffer[5]);
/* return compose via restriction: just for testing  */ 
return (buffer[6]);   
#endif



#if (dbg_compose > 0)
bdd buffer[10];
static int k = -1;
FILE *myfile;
/* program  */
k++;

#if 0
printf("\n\ncompose %d:", k);
#endif


printf("\ncompose %d: compute compose via ifter: ", k);
buffer[0] = ifter(G, F, F, i, 1, 1);


printf("\ncompose %d: compute compose via restrict: ", k);
buffer[1] = restrict(F, i, 1);
buffer[2] = restrict(F, i, 0);
buffer[3] = NOT(G);
buffer[4] = AND(buffer[3], buffer[2]);
buffer[5] = AND(G, buffer[1]);
buffer[6] = OR(buffer[4], buffer[5]);

#if 1
printf("\ncompose %d: Test bdd compose: ", k);
#endif

if (! bdd_equal(buffer[6], buffer[0]) )
{
    printf("\n\ncompose %d: Error on compose(F, %d, G):\n\n", k, i);
    
    myfile = fopen("cmperr.bdd", "w+");
    fprintf(myfile, "\n\ncompose %d: Error on compose(F, %d, G)\n\n", k, i);

    fprintf(myfile, "\nbdd F:\n");
    fprint_bdd(myfile, F);

    fprintf(myfile, "\n\nbdd G:\n");
    fprint_bdd(myfile, G);

    fprintf(myfile, "\n\nbdd for compose via restriction:\n");
    fprint_bdd(myfile, buffer[6]);

    fprintf(myfile, "\nbdd for compose via ifter:\n");
    fprint_bdd(myfile, buffer[0]);

    fprintf(myfile, "\nEQ(compose via restriction, compose via ifter):\n"); 
    buffer[7] = EQ(buffer[6], buffer[0]);
    fprint_bdd(myfile, buffer[7]);
    delete_bdd(buffer[7]);
    fclose(myfile);
    
    exit (1234);
}

/* composition ok  */
#if 1
printf("ok\n");
#endif

delete_bdd(buffer[1]);
delete_bdd(buffer[2]);
delete_bdd(buffer[3]);
delete_bdd(buffer[4]);
delete_bdd(buffer[5]);
delete_bdd(buffer[6]);

return (buffer[0]); 
#endif


/* this is the normal compose function  (i.e. via ifter)   */
   return ( ifter(G, F, F, i, 1, 1) );

}




bdd compose_vct(bdd F, int *x, bdd *G, int n)
/*
**  returns graph
**  representing function
**  (F[i := G]) 
*/
{
/*  declarations  */
bdd result, buffer;
int i;

/*  program  */

if (n <= 0)
then return (F);
else  /*  n > 0  */
     {
     
     result = compose(F, x[0], G[0]);
     
     for (i = 1; i < n; i++)
        {
           buffer = compose(result, x[i], G[i]);
           delete_bdd(result);
           result = buffer;
        }

/*  result defined  */

      return ( result );
    
     }


}






bdd compose_var_vct(bdd F, int *x, int *y, int n)
/*
**  returns graph
**  representing function
**  (F[i := G]) 
*/
{
/*  declarations  */
bdd result, buffer, G;
int i;

/*  program  */


if (n <= 0)
then return (F);
else  /*  n > 0  */
     {

/*  define variable y[i]  */
   
     G = varx(y[0]);
     result = compose(F, x[0], G);
     delete_bdd(G);
     
     for (i = 1; i < n; i++)
        {
           G = varx(y[i]);
           buffer = compose(result, x[i], G);
           delete_bdd(G);
           delete_bdd(result);
           result = buffer;
        }

/*  result defined  */

      return ( result );
    
     }


}













bdd shift_variables(bdd F, int k)
/*
**  shift indexes of variables in F by k
*/

{

/* declarations */ 
bdd G;

ptrvertex p;

int new_vindex;

  /* program */

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 100: (begin) bdd header = 0x%x\n", F);
#endif

p = (ptrvertex) read_graph_root(F);

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 200: root = 0x%x\n", p);
#endif

G = get_graph_header();

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 300: new bdd header = 0x%x\n", G);
#endif


write_graph_root(G, p);

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 400\n");
#endif

write_graph_p_flip(G, read_graph_p_flip(F));

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 500: p_flip = 0x%x\n", read_graph_p_flip(F));
#endif

write_graph_flip(G, read_graph_flip(F));

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 600: flip = 0x%x\n", read_graph_flip(F));
#endif


write_graph_p_swap(G, read_graph_p_swap(F));

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 700: p_swap = 0x%x\n", read_graph_p_swap(F));
#endif


 if ( terminal(p) )
 then /*  F is terminal.  Thus G == F  */
      {

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 800: (root terminal)\n");
#endif
          write_graph_vindex(G, 0);

       /* no lock since p == NULL   */

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 1000: (end): root == terminal\n");
#endif

          return (G);
      }
else  /*  F nonterminal  */
    {

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 1100: (root nonterminal)\n");
#endif

      lock_bdd_vertex(p);
      
#if (dbg_flag > 100)
printf("\nshift_variables: ckp 1200: (root locked)\n");
#endif

      new_vindex = read_graph_vindex(F) + k;
      
#if (dbg_flag > 100)
printf("\nshift_variables: ckp 1300: vindex = %d\n", read_graph_vindex(F));
#endif

      if (new_vindex < 0)
      then 
      	{
      		printf("\n Error: vindex overflow  (shift_variables)\n");
      		exit (1234);
      		
      	}

/*  new_vindex >= 0  */

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 1400\n");
#endif
      
       write_graph_vindex(G, new_vindex);

#if (dbg_flag > 100)
printf("\nshift_variables: ckp 2000: (end): root == nonterminal\n");
#endif

       return (G);
     
    }
          
}






/* 
Evaluate bdd f 
with boolean values in x.
Size x =  n
*/


int eval_bdd(bdd f, int *x, int n)
{
/* declarations   */
int i, j;
bdd buf[2];

bdd xbdd[2];

/* prgram   */

xbdd[0] = zero();
xbdd[1] = one();

buf[0] = duplicate(f);

for (i = 0; i < n; i++)
	{
	  
	   buf[1] = compose(buf[0], i, xbdd[x[i]%2]);
	   delete_bdd(buf[0]);

	   buf[0] = buf[1];
	   
	    
	}

if ( bdd_equal(buf[0], xbdd[0]) )
{
	delete_bdd(xbdd[0]);
	delete_bdd(xbdd[1]);
	
	return (0);
}


if ( bdd_equal(buf[0], xbdd[1]) )
{
	delete_bdd(xbdd[0]);
	delete_bdd(xbdd[1]);
	
	return (1);
}


/* error   */
	delete_bdd(xbdd[0]);
	delete_bdd(xbdd[1]);

printf("\n\neval_bdd: ERROR:  result is not boolean\n\n");

printf("\nbdd 0:");
print_bdd(xbdd[0]);

printf("\nbdd 1:");
print_bdd(xbdd[1]);

printf("\nbdd result:");
print_bdd(buf[0]);

exit (1234);

}    /* end eval   */














/* 
Evaluate componentwise bdds in f 
with boolean values in x.
Size x =  n
Size f = size y = k
*/


void eval_bdd_vct(int k, int *y, bdd *f, int *x, int n)
{
/* declarations   */
int i;

/* program  */

for (i = 0; i < k; i++)
	{
	    y[i] = eval_bdd(f[i], x, n);
	}
	


}   /*  end program  */