

/*
*******************************************
file:  gc.c
*******************************************
*/

/*
**
**   performs garbace collection for T_graph
**
**
*/


#include "dag.h"
#include "local.h"


#define dbg0_flag 1000    /* normal value:  0   */
#define debug_garbage_collection 0     /* normal value:  0   */



void garbage_collection(look_up_table T)
/*
**  do garbage collection
**  on hash table
**
*/
{

  /*  declarations  */


#if (dbg0_flag > 100)
  static int count = 0;
  static int count_0 = 0;
#endif


#if (dbg0_flag > 200)
#define gc_FREQ 10000000
#endif





/*  program  */


#if debug_garbage_collection
    printf("\ncall: garbage_collection");
#endif


#if (dbg0_flag > 100)
count++;
#endif


#if (dbg0_flag > 200)
  if ( (count % gc_FREQ) == 0 )
  then
    {
      printf("\ngc: T = 0x%x: Hash Table info: count = %d\n", T, count);
      printf("gc: num.elem in T = %d; size T = %d.\n",
           get_lkup_table_elements(T), get_lkup_table_size(T));
      printf("gc: max size dag up to now = %d\n", max_size_graph);
      printf("gc: vertices to be deleted = %d\n", to_be_deleted);

    }
#endif


/*  gc   */

   
     if (
              ( get_lkup_table_elements(T) > 
                (ht_load_factor * get_lkup_table_size(T)) 
              )

          &&  ( to_be_deleted > gc_threshold )   
  
        )  
          
     then  /*  clean up  T */
        {



#if (dbg0_flag > 200)
printf("\ngc: begin garbage collection: count gc calls = %d, count gc done = %d)", 
count, count_0);
printf("\ngc: num.elem. in T = %d, size of T = %d\n", 
             get_lkup_table_elements(T), get_lkup_table_size(T));
printf("gc: vertices to be deleted = %d\n", to_be_deleted);
#endif


   /*  clean  look up table  */

   
               cleanup_lkup_table(T);

              

    

/*
**  reset to_be_deleted
**
*/

             to_be_deleted = 0;

#if (dbg0_flag > 100)
count_0++;
#endif
           
#if (dbg0_flag > 200)
printf("\ngc: end garbage collection: count gc calls = %d, count gc done = %d)", 
count, count_0);
printf("\ngc: num.elem. in T = %d, size of T = %d\n", 
             get_lkup_table_elements(T), get_lkup_table_size(T));
printf("gc: vertices to be deleted = %d\n", to_be_deleted);

#endif



            }





#if debug_garbage_collection
    printf("\nend: garbage_collection");
#endif



}


