



/*
***********************************************
file:  start_dag_env.c
***********************************************
*/


/*
*********************************
Start DAG environment
*********************************
*/

#include "dag.h"
#include "local.h"

#define long_print 0




void start_dag_env()
/*
**
**  inizialize dag environment
**
*/
{
/*  declarations  */


/*  program  */

/*
****************************
begin:    output redirection   
****************************
*/

#if 0

fclose(stdout);
freopen("start_dag_env.out", "w", stdout);

#endif

/*
****************************
end:    output redirection   
****************************
*/




  printf("\ndag version 2.2 (96.02.12) ");

#if (long_print > 100)

#if 0
  printf("\nAuthor: Enrico Tronci");
  printf("\nAffiliation: \nDip. Matematica Pura ed Applicata");
  printf("\nUniversita' dell'Aquila, Coppito 67100 L'Aquila, Italy\n");
#endif

#endif


  printf("\ndag hash table: size  = %u, load factor = %lf", 
  SIZE_DAG_HASH_TABLE,
  ht_load_factor);

  printf("\ngarbage collection threshold = %u", 
  gc_threshold
  );



#if 0

  printf("\ndag: defining environment ...\n");

  printf("\ndag hash table: size  = %u, load factor = %u", 
  SIZE_DAG_HASH_TABLE,
  ht_load_factor);
 

/*
*****************************
begin: create look up table T_graph
*****************************
*/


  
 printf("\ndag: creating look_up_table of size: %d . . .\n", 
SIZE_DAG_HASH_TABLE
);
#endif



T_dag = create_lk_up_table(
SIZE_DAG_HASH_TABLE,
read_gvertex_plot,
write_gvertex_plot,
gtest_less_than,
gtest_equal,
gdata_less_than,
free_gvertex,
gupdate_free_tags,
gto_be_erased,

gvertex_hlab,
gvertex_tlab,
size_gvtx_alllab,
get_key_hlab,
get_key_tlab,
size_key_alllab
);




#if 0
 printf("\ndag hash table size: %d\n", 
         get_lkup_table_size(T_dag)
       );
#endif

/*
*****************************
end: create look up table T_graph
*****************************
*/


#if 0
 printf("\ndag: end environment definition.\n\n");
#endif


#if (long_print > 100)
  printf("\ndag: vertex printing format:");
  printf("\nvertex = ...");
  printf("\nvertex in_edges = ...");
  printf("\nvertex plot = ...");
  printf("\nvertex length size-bits nonpointer label = ...");
  printf("\nvertex length size-bits pointer label = ...");
  printf("\nvertex size nonpointer label = ...");
  printf("\nvertex size pointer label = ...");
  printf("\nvertex label.0 = ...");
  printf("\n ...\n\n\n");
#endif  

}

