

/*
**
**  file:   varx
**
**
*/


#include "local.h"


#define dbg_flag 0


/*
**************************************************
label is as follows:
label[0] = flip side 0;
label[1] = flip side 1;
label[2] = swap side 0;
label[3] = swap side 1;
label[4] = shift side 0;
label[5] = shift side 1;
label[6] = next side 0;
label[7] = next side 1;
**************************************************
*/


bdd varx(int i)
/*
**  creates bdd representing 
**  constant i-th projection function
*/
{ 
 /* declarations */
   ptrvertex p, q, p_root;
   bdd G;

   unsigned int label[8];

  
#if (dbg_flag > 0)
static int count = 0;
#endif

  /* program */

#if (dbg_flag > 0)
    count++;
#endif

#if (dbg_flag > 100)
    printf("\nvarx(%d): ckp.%d 100 (begin)\n", i, count);
#endif

/*  define root */

label[0] = 0u;
label[1] = 0u;
label[2] = 0u;
label[3] = 0u;
label[4] = 0u;
label[5] = 0u;
label[6] = (unsigned int) get_terminal_bddvtx();
label[7] = (unsigned int) get_terminal_bddvtx();


   p_root = get_bdd_vertex(label);



/*  define bdd  */

   G = get_graph_header();


write_graph_root(G, p_root);
write_graph_p_flip(G, 0);
write_graph_flip(G, 0x1);
write_graph_vindex(G, i);
write_graph_p_swap(G, 0);

/*   p_root != NULL   */

lock_bdd_vertex(p_root);

#if (dbg_flag > 100)
    printf("\nvarx(%d): ckp.%d  500 (end)\n", i, count);
#endif

  return (G);

}






/* 
Returns nonzero iff bdd G
is a variable. In this case
*k is the variable index
*/

int is_var(bdd G, unsigned int *k)
{

   if ( read_graph_p_flip(G) != 0 )
   { return (0); }

/*  read_graph_p_flip(G) == 0  */

   if ( read_graph_flip(G) != 0x1 )
   { return (0); }

/*  read_graph_flip(G) == 0x1  */


   if ( read_graph_p_swap(G) != 0 )
   { return (0); }

/*  read_graph_p_swap(G) == 0  */

   if ( terminal((ptrvertex) read_graph_root(G)) )
   { return (0); }

/*  read_graph_root(G) nonterminal  */


   if ( nonterminal(
            read_vertex_next((ptrvertex) read_graph_root(G), 0)
                   )
      )
   { return (0); }

/* 
   read_vertex_next((ptrvertex) read_graph_root(G), 0) 
   is terminal
*/


   if ( nonterminal(
            read_vertex_next((ptrvertex) read_graph_root(G), 1)
                   )
      )
   { return (0); }
 

/* 
   read_vertex_next((ptrvertex) read_graph_root(G), 1) 
   is terminal
*/



/* bdd is a variable  */

*k = read_graph_vindex(G);

return (1);


} /* is_var  */
