
/*
*********************************************
file: read_store_key
*********************************************
*/

/*
**
**   
**
**  
**
**
*/
 


#include "local.h"


#define mask_key 0x00ffffc0

unsigned int read_gstore_word(
type_gstore p,
int i
)

{  /*  begin read_gstore_word */

switch (i)
      {
        case 0:  /*  get rid of bits 4-5 (in_edges) */
                 return ( ((unsigned int *)p)[0] & 0x00ffffcf);

        default: /* i != 0  */
                  return ( ((unsigned int *)p)[i] );
                  
      }


} /*  end read_gstore_word  */


unsigned int read_gstore_keys(
type_gstore p,
int i
)

{  /*  begin read_gstore_keys */

switch (i)
      {
        case 0:  /*  get rid of bits 0 - 5 */
                 return ( (((unsigned int *)p)[0]  & mask_key) >> 6);

        default: /* i != 0  */
                  return ( ((unsigned int *)p)[i] );
                  
      }
               

} /*  end read_gstore_keys  */


void write_gstore_keys(
type_gstore p,
int i,
unsigned int value
)

{  /*  begin write_gstore_keys */

switch (i)
      {
        case 0:  /*  get rid of bits 0 - 5 */
                 ((unsigned int *)p)[0] = 
                    (((unsigned int *)p)[0] & ~mask_key)
                  | ((value << 6) & mask_key) ;
                  return;

        default: /* i != 0  */
                  ((unsigned int *)p)[i] = value;
                  return;
                  
      }
               

} /*  end write_gstore_keys  */


unsigned int read_gstore_value(
type_gstore p,
int i
)

{  /*  begin read_gstore_value */


switch (i)
      {
        case 0:  /*  bits 24 - 31 in word 0  */
                 return ( ((unsigned int *)p)[0] >> 24);

        default: /* i > 0  */
                  return ( ((unsigned int *)p)[
                     map_size_key( ((unsigned int *)p)[0] & 0x3 ) + i - 1
                            ] );
                  
      }


} /*  end read_gstore_value  */




unsigned int write_gstore_value(
type_gstore p,
int i,
unsigned int value
)

{  /*  begin write_gstore_value */

switch (i)
      {
        case 0:  /*  bits 24 - 31 in word 0  */
                 ((unsigned int *)p)[0] = 
                    (((unsigned int *)p)[0] & ~0xff000000)
                  | (value << 24) ;
 
                  return;



        default: /* i > 0  */
        
 ((unsigned int *)p)[map_size_key( ((unsigned int *)p)[0] & 0x3 ) + i - 1] = 
value;
              return;    
      }



} /*  end write_gstore_value  */




/*  HYP.  A, B same size_key, size_value  */


void copy_gstore_value(
type_gstore A,
type_gstore B
)
{

/* declarations  */
int i, size_key, size_value;

/*  program */

/*  last word (broadcast) is to be updated not just copied  */

size_key = map_size_key( ((unsigned int *)A)[0] & 0x3 );

size_value = map_size_value( (((unsigned int *)A)[0] >> 2) & 0x3 );

((unsigned int *)A)[0] = 
                    (((unsigned int *)A)[0] & ~0xff000000)
                  | (((unsigned int *)B)[0] & 0xff000000) ;

for (i = size_key; i < size_key + size_value; i++)
   {
      ((unsigned int *)A)[i] = ((unsigned int *)B)[i];
   }


}  /*  end program */

 

