/*
**
**  file vertex.h
**
**
**  primitives on vertex 
**
*/


#ifndef gvertexh
#define gvertexh


#include <stdlib.h>
#include <stdio.h>
#include <limits.h>

typedef void* gvertex;
typedef void* gkey;


#define use_extra_gvtx_info 0  /* normal value: 0  */


#if (use_extra_gvtx_info != 0)

/* This define size of extra fields in gvterx */
#define sz_extra_gvtx_info 1
 
#define gvtx_level 0

#endif




extern
unsigned int to_be_deleted;



extern
void print_gvtx(gvertex v);

extern
void fprint_gvtx(FILE *myfile, gvertex v);

extern
write_gvtx_mark(gvertex v, unsigned int mark);

extern
unsigned int read_gvtx_mark(gvertex v);



extern 
void read_gvertex_labels(gvertex v, unsigned int *A);



extern
unsigned int gvertex_hlab(gvertex v);

extern
unsigned int gvertex_tlab(gvertex v, unsigned int i);

extern
unsigned int size_gvtx_nonptrlab(gvertex v);

extern
unsigned int size_gvtx_ptrlab(gvertex v);

extern
unsigned int size_gvtx_alllab(gvertex v);


extern
unsigned int size_gvertex(gvertex v);





extern
unsigned int get_key_hlab(gkey A);

extern
unsigned int get_key_tlab(gkey A, unsigned int i);

extern
unsigned int size_key_nonptrlab(gkey A);

extern
unsigned int size_key_ptrlab(gkey A);

extern
unsigned int size_key_alllab(gkey A);




extern
void lock_gvertex(gvertex v);


extern
void unlock_gvertex(gvertex v);

extern
int locked_gvertex(gvertex v);


extern
int unlocked_gvertex(gvertex v);

extern
void lock_gvtx_forever(gvertex v);

extern
gvertex get_new_gvertex(gkey A);


extern
unsigned int read_gvertex_in_edges(gvertex v);

extern
void write_gvertex_in_edges(gvertex v, unsigned int value);



/* begin:  for use in look up table  */

extern 
gvertex read_gvertex_plot(gvertex v);

extern
void write_gvertex_plot(gvertex v, gvertex v_plot);

extern
int gdata_less_than(gvertex v, gvertex p);

extern
int gtest_equal(gvertex v, gkey A);

extern
int gtest_less_than(gvertex v, gkey A);

extern
void free_gvertex(gvertex v);

extern
int gto_be_erased(gvertex p);

extern
void gupdate_free_tags(gvertex p);



extern
void print_gvertex_info();


/* end:  for use in look up table  */



#if (use_extra_gvtx_info != 0)
unsigned int read_extra_info_gvtx(
gvertex v, 
unsigned int i
);

void write_extra_info_gvtx(
gvertex v, 
unsigned int i, 
unsigned int value
);

#endif




#endif
