
/*   Test for gvertex 3.1   */


#include <stdio.h>
#include <stdlib.h>

#include "gvertex.h"

void test_gvtx(unsigned int *A);


main()
{
/*  declarations  */
unsigned int i, buf, A[10];
gvertex v;

/* program  */

/* initialize A (defaults)  */
for (i = 0; i < 10; i++)
	{
	   	A[i] = i;
	}

/* begin tests  */
A[0] = 0x0;    /*  nonoptrlab = 1, ptrlab = 0   */
test_gvtx(A);

for (i = 0; i < 16; i++)
	{
	   buf = (i << 20);
	   	
A[0] = (buf | 0x87054321);
test_gvtx(A);
	}



/* test in_edges count  */

	   buf = (5 << 20);
	   	
A[0] = (buf | 0x87054321);
printf("\n\nTest in_edges count");

v = get_new_gvertex(A);

printf("\n\nTest locking");

for (i = 0; i < 70000; i++)
	{
	    lock_gvertex(v);
	    
	    if ( unlocked_gvertex(v) )
	    printf("\nlocking error: v unlocked: %u", i);
	    
	    if ( (65520 < i) && (i < 65600) )
	    printf("\nin_edges count (%d) = %u",
	    i, 
	    locked_gvertex(v)
	    );
	    
	}	

printf("\n\nTest unlocking");

for (i = 0; i < 70000; i++)
	{
	    unlock_gvertex(v);
	    
	    if ( unlocked_gvertex(v) )
	    printf("\nunlocking error: v unlocked: %u", i);
	    
	    if ( locked_gvertex(v) < 0xffff )
	    printf("\nin_edges count (%d) = %u",
	    i, 
	    locked_gvertex(v)
	    );
	    
	}	

printf("\n\nEnd test unlocking");

	    printf("\nin_edges count  = %u",
	    locked_gvertex(v)
	    );
	
}  /*  end main  */



void test_gvtx(unsigned int *A)
{
/*  declarations  */
gvertex v;
int i;
static j = 0;

/*  program  */

j++;
printf("\n\nBegin test %d", j);

v = get_new_gvertex(A);
print_gvtx(v);
printf("\n\ntest labels");

/*  Choose mark value  */
write_gvtx_mark(v, j%2);

printf("\ngvertex v = 0x%x", v);
printf("\nA[0] = 0x%x", A[0]);
printf("\nget_key_hlab(A) = 0x%x", get_key_hlab(A));
printf("\ngvertex_hlab(v) = 0x%x\n", gvertex_hlab(v));

printf("\ngvtx_mark = %u", read_gvtx_mark(v));

printf("\nsize_key_nonptrlab(A) = %u = ", 
size_key_nonptrlab(A));
printf("%u = size_gvtx_nonptrlab(v)", 
size_gvtx_nonptrlab(v));

printf("\nsize_key_ptrlab(A) = %u = ", size_key_ptrlab(A));
printf("%u = size_gvtx_ptrlab(v)", 
size_gvtx_ptrlab(v));

printf("\nsize_key_alllab(A) = %u = ", size_key_alllab(A));
printf("%u = size_gvtx_alllab(v)", 
size_gvtx_alllab(v));


printf("\nsize_gvertex(v) = %u = ", size_gvertex(v));



printf(
"\nlabel %d: get_key_hlab(A) =  0x%x = 0x%x = gvertex_hlab(v)", 
		0, 
		get_key_hlab(A),
		gvertex_hlab(v)
		);

for (i = 1; i < size_key_alllab(A); i++)
	{
printf(
"\nlabel %d: get_key_tlab(A, %d) =  0x%x = 0x%x = gvertex_tlab(v, %d)", 
		i, 
		i,
		get_key_tlab(A, i),
		gvertex_tlab(v, i),
		i
		);
	}
	
free(v);

printf("\nEnd test %d", j);

}