/*
**
**  file: update.free.tags
**
**
*/


#include "local.h"

#define dbg_flag 0


void gupdate_free_tags(gvertex p)
/*
**  update in_edges from p
** 
**  Note: p may or may not be vesited
** 
**  freetags visits nonmarked unlocked vertices.
*/
{

/*  declarations  */

/*  program  */

   if ( !read_gvtx_mark(p) )
   /*  then:   p nonvisited  */
     {

       /*  visit  */
        gupdate_free_tags_step(p);
     }
     
     
}   /*   gupdate_free_tags    */




/* 
    Note: 
    If a vertex is visited then it is unlocked.
    Thus locked vertices are nonvisited.
    Moreover if a vertex is nonvisited then its sons
    are locked and thus nonvisited.
*/


void gupdate_free_tags_step(gvertex p)
/*
**  update in_edges from p
** 
**  Hyp: p nonvisited
** 
**  gupdate_free_tags_step 
**  visits nonvisited unlocked vertices.
*/
{

/*  declarations  */

int  i;
int pointer_size, nonpointer_size;
gvertex next_p;

#if (dbg_flag > 100)
static int count = 0;
#endif

/*  program  */


#if (dbg_flag > 100)
      count++;
      printf("\ngupdate_free_tags_step.%d: ckp 100, p = 0x%x", 
      count, 
      p);
#endif

#if (dbg_flag > 200)
      printf("\ngupdate_free_tags_step.%d: ckp 110, read_gvertex_in_edges(0x%x) = %d", 
      count, p, read_gvertex_in_edges(p));
#endif

   if ( unlocked_gvertex(p)  )
   /*  then  */  
   /* p unlocked and nonvisited  */
     {

       /*  visit  */

/* mark p as visited  */
write_gvtx_mark(p, 1);

nonpointer_size = size_gvtx_nonptrlab(p);   /* >= 1  */


#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 250, nonpointer_size = %d", 
      count, nonpointer_size);
#endif

pointer_size = nonpointer_size + size_gvtx_ptrlab(p);

#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 300, pointer_size = %d", 
      count, pointer_size);
#endif

      for (i = nonpointer_size; i < pointer_size; i++)
       {
         next_p = (gvertex) gvertex_tlab(p, i);   /* ptrlab  */

#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 500.%d, next_p = 0x%x", 
      count, i, next_p);
#endif

         if ( next_p != NULL )
         /*  then  */
          {

/* p was nonvisited thus next_p is locked and nonvisited   */

           	unlock_gvertex(next_p);

#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 620.%d:  next_p = 0x%x", 
      count, i, next_p);
#endif

/* next_p is nonvisited   */

              gupdate_free_tags_step(next_p);
              

#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 630.%d:  next_p = 0x%x", 
      count, i, next_p);
#endif

	}    /*  then  */
	
	
#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 700.%d (end for)", 
      count, i);
#endif


 
        }  /*  end  for  */
        
     }    /*  then  */

#if (dbg_flag > 100)
      printf("\ngupdate_free_tags_step.%d: ckp 10000 (end)", count);
#endif

  
}


