

/*
**
**  file: vertex_in_edges
**
**
*/



/*
**
**  vertex in_edges are represented in word 1, bits 0 - 15.
**
**  Saturated arithmetic used.
*/


/*  value in_edges >= 0    */


#include "gvertex.h"

#define dbg_flag 0      /* normal value: 0  */





#define mask_in_edges 0xffff


unsigned int satclp_add(unsigned int a, unsigned int b)
{
  /* declarations  */
unsigned int result;


/* program   */
result = a + b;

if (result <= mask_in_edges)
	return (result);
else
	return (mask_in_edges);
}

unsigned int satclp_sub(unsigned int a, unsigned int b)
{
  /* declarations  */
unsigned int result;


/* program   */

if (a >= mask_in_edges)	 return (mask_in_edges);


/*  a < mask_in_edges   */

if (b >= a)  return (0);

/*  b < a < mask_in_edges  */

return (a - b);

}








unsigned int read_gvertex_in_edges(gvertex v)
{
  /* declarations  */

/* program  */

return (
          	((unsigned int *) v)[1] & mask_in_edges
         );
}





void write_gvertex_in_edges(gvertex v, unsigned int value)
{
  /* declarations  */
unsigned int result;

/* program  */

((unsigned int *) v)[1] =  
 (((unsigned int *) v)[1] & ~mask_in_edges) | 
 ( value & mask_in_edges );


}  /*  end program  */



void lock_gvtx_forever(gvertex v)
{
/*  
    Edge cout infinite, i.e.
    0xffff
*/
write_gvertex_in_edges(v, 0xffff);

}   /*   end program   */




void lock_gvertex(gvertex v)
/*
**********************
lock vertex v

hyp. v != NULL
**********************
*/
{
     write_gvertex_in_edges(
v, 
satclp_add(read_gvertex_in_edges(v),  1)
					);

}   /*   end program   */




void unlock_gvertex(gvertex v)
/*
**********************
unlock vertex v

hyp. v != NULL
**********************
*/
{

#if (dbg_flag > 100)
fprintf(stderr, "\n\nunlock_gvertex: begin: v = 0x%x, in_edges = %u, to_be_deleted = %u",
v,
read_gvertex_in_edges(v),
to_be_deleted
);
#endif



     write_gvertex_in_edges(
v, 
satclp_sub(read_gvertex_in_edges(v),  1)
					);

if ( unlocked_gvertex(v) )
/* then */  to_be_deleted++; 


#if (dbg_flag > 100)
fprintf(stderr, 
"\nunlock_gvertex: end: v = 0x%x, in_edges = %u, to_be_deleted = %u\n",
v,
read_gvertex_in_edges(v),
to_be_deleted
);
#endif



}   /*   end program   */







int locked_gvertex(gvertex v)
/*
**********************
test if vertex v is locked

hyp. v != NULL
**********************
*/
{
/* True iff (read_gvertex_in_edges(v) != 0)   */

     return ( read_gvertex_in_edges(v) );

}   /*   end program   */



int unlocked_gvertex(gvertex v)
/*
**********************
test if vertex v is unlocked

hyp. v != NULL
**********************
*/
{
     if ( read_gvertex_in_edges(v) /* != 0 */)
     /* then */  return (0);
     else return (1);

}   /*   end program   */





