

/*
**
** file: get_new_vertex
**
*/


#include "gvertex.h"

#include "local.h"


#define debug_vertex 0

#define word1_mask 0xfffe0000


/*
**********************************************************
creates new vertex with label A

Hyp:
A[0]: (bits 17 - 31): label[0] (determines vtx and A sizes)
Let size_vtx_info be the size of vertex info.
A[1] - A[size_vtx_info - 1] (bits 0 - 31): 
label[1] - label[size_vtx_info]
**********************************************************
*/



gvertex get_new_gvertex(gkey A)
/*  creates new vertex with info A and size_lgh  */

{

/* declarations  */
gvertex v;
int  i;
unsigned int info_size;

#if debug_vertex
static int count = 0;
#endif


/* program  */

#if debug_vertex
count++;
#endif

#if debug_vertex
      printf("\ncall %d: get_new_gvertex\n", count);
#endif
    
/*
**  compute size of label, 
**
*/

  info_size = size_key_alllab(A);

#if (debug_vertex > 100)
      printf(
      "\ncall %d: get_new_gvertex: info_size = %d \n", 
      count, info_size
      );
#endif

/*  create new vertex   */

#if (use_extra_gvtx_info == 0)
  v = (gvertex) malloc((1 + info_size) * sizeof(unsigned int));
#endif

#if (use_extra_gvtx_info != 0)
  v = (gvertex) malloc((1 + info_size + sz_extra_gvtx_info) * sizeof(unsigned int));
#endif



  if (v == NULL) 
  /* then:  */
       {
         printf("\nNo space for new vertex (get_new_vertex)\n");
         exit (1111);
       }


/*  v != NULL  */

#if (flag_gvertex_info > 10)
update_gvertex_info(1 + info_size);
#endif

/* define info fields */

/*  Word 0 (plot) noninitialized   */

/*  Note: in_edges and mark initialized to 0  */

((unsigned int *) v)[1] = get_key_hlab(A);

/*  store A  */
for (i = 1; i < info_size; i++)
   {
     ((unsigned int *) v)[i + 1] = get_key_tlab(A, i);

#if (debug_vertex > 1000)
      printf("\ncall %d: get_new_gvertex: v[%d] = A[%d] = 0x%x\n", 
      count, i + 1, i, get_key_tlab(A, i));
#endif
   }





#if (use_extra_gvtx_info != 0)
/* init extra info */
write_extra_info_gvtx(
v, 
gvtx_level, 
0
);
#endif




  return (v);
  

}


