

/*
**
** file: read_vertex_info.c
**
*/




#include "gvertex.h"

#define mask_lab0 0xfffe0000    /*  bits 17 - 31  */

#define dbg_flag 0

#define mask_mark 0x10000    /*  bit 16  */


write_gvtx_mark(gvertex v, unsigned int mark)
{
   ((unsigned int *) v)[1] = 
   	( ((unsigned int *) v)[1] & ~mask_mark )
   |
    	( (mark << 16) & mask_mark );

}


unsigned int read_gvtx_mark(gvertex v)
{
   return  (
   	( ((unsigned int *) v)[1] & mask_mark ) >> 16 
   		);
 
}

void read_gvertex_labels(
gvertex v, 
unsigned int *A
)
{

/* declarations  */
int i;
unsigned int info_size;


/* program  */

A[0] = ( ((unsigned int *) v)[1] & mask_lab0 );

#if (dbg_flag > 1000)
printf("\nread_vertex_info: ckp 190: A[0] = 0x%x", 
((unsigned int *) v)[1] & mask_lab0);
#endif

info_size =  size_gvtx_alllab(v);

for (i = 1; i < info_size; i++)
   {
      A[i] = ((unsigned int *) v)[1 + i];

#if (dbg_flag > 1000)
printf("\nread_vertex_info: ckp 200.%d: A[%d] = 0x%x", 
i, i, ((unsigned int *) v)[1 + i]);
#endif

   } 

}  /*  end program  */


/*  Label with i == 0 (head label)  */
unsigned int gvertex_hlab(gvertex v)
{
  return ( 
              ((unsigned int *) v)[1] & mask_lab0
           );

}  /*  end program  */














/*  Label with i > 0 (tail labels) 
     If  gvertex_tlab called with i == 0 
     then wrong result.
*/

unsigned int gvertex_tlab(gvertex v, unsigned int i)
{
  return ( 
              ((unsigned int *) v)[1 + i]
           );

}  /*  end program  */











/*  Label with i == 0 (head label)  */
unsigned int get_key_hlab(gkey A)
{
  return ( 
              ((unsigned int *) A)[0] & mask_lab0
           );

}  /*  end program  */



/*  Label with i > 0 (tail labels) 
     If  get_key_tlab called with i == 0 
     then wrong result.
*/

unsigned int get_key_tlab(gkey A, unsigned int i)
{
  return ( 
              ((unsigned int *) A)[i]
           );

}  /*  end program  */




void print_gvtx(gvertex v)
{
/* declarations  */
unsigned int i, nonptrsize, gvtxsize;


/* program  */

nonptrsize = size_gvtx_nonptrlab(v);

gvtxsize = nonptrsize + size_gvtx_ptrlab(v);

printf("\ngvtx 0x%x", v);
printf("\n\tnonptrlab 0 = 0x%x", 
gvertex_hlab(v)
);

for (i = 1; i < nonptrsize; i++)
	{
printf("\n\tnonptrlab %u = 0x%x", 
i,
gvertex_tlab(v, i)
);
	
	}
	
for (i = nonptrsize; i < gvtxsize; i++)
	{
printf("\n\tptrlab %u = 0x%x", 
i,
gvertex_tlab(v, i)
);
	
	}


}   /*  print_gvtx   */














void fprint_gvtx(FILE *myfile, gvertex v)
{
/* declarations  */
unsigned int i, nonptrsize, gvtxsize;


/* program  */

nonptrsize = size_gvtx_nonptrlab(v);

gvtxsize = nonptrsize + size_gvtx_ptrlab(v);

fprintf(myfile, "\ngvtx 0x%x", v);
fprintf(myfile, "\n\tnonptrlab 0 = 0x%x", 
gvertex_hlab(v)
);

for (i = 1; i < nonptrsize; i++)
	{
fprintf(myfile, "\n\tnonptrlab %u = 0x%x", 
i,
gvertex_tlab(v, i)
);
	
	}
	
for (i = nonptrsize; i < gvtxsize; i++)
	{
fprintf(myfile, "\n\tptrlab %u = 0x%x", 
i,
gvertex_tlab(v, i)
);
	
	}


}   /*  fprint_gvtx   */














#if 0



unsigned int get_key_label(gkey A, unsigned int  i)
{

/* declarations  */


/* program  */

if (i /* != 0  */)
/* then */
  	return ( ((unsigned int *) A)[i ] );
else /* i == 0  */
  	return ( ((unsigned int *) A)[0] & mask_lab0 );

}  /*  end program  */



unsigned int get_gvertex_label(
gvertex v, 
unsigned int  i 
)
{

/* declarations  */


/* program  */

if (i /* != 0  */)
/* then */
  return (
           ((unsigned int *) v)[i + 1]
         );
else /* i == 0  */
  return ( 
           ((unsigned int *) v)[1] & mask_lab0
        );

}  /*  end program  */

/*  read vertex labels that are not pointers  */
unsigned int get_gvertex_nonptrlab(
gvertex v, 
int i 
)
{

/* declarations  */


/* program  */

if (i /* != 0  */)
/* then */
  return (
           ((unsigned int *) v)[i + 1]
         );
else /* i == 0  */
  return ( 
           ((unsigned int *) v)[1] & mask_lab0
        );

}  /*  end program  */


/*  read vertex labels that are pointers  */
unsigned int get_gvertex_ptrlab(
gvertex v, 
int i 
)
{

/* declarations  */


/* program  */

return (
          ((unsigned int *) v)[
               i + 1 + 
               size_nonptrlab(((unsigned int *) v)[1] & mask_lab0)
                     			   ]
        );

}  /*  end program  */




unsigned int fast_get_gvertex_ptrlab(
gvertex v, 
int sizenonptrlab,
int i 
)
{

/* declarations  */


/* program  */

return (
            ((unsigned int *) v)[i + 1 + sizenonptrlab]
       );

}  /*  end program  */
#endif





#if (use_extra_gvtx_info != 0)

/* read-write extra info  */

unsigned int read_extra_info_gvtx(gvertex v, unsigned int i)
{

return (  ((unsigned int *) v)[size_gvertex(v) + i] );

}



void write_extra_info_gvtx(gvertex v, unsigned int i, unsigned int value)
{

((unsigned int *) v)[size_gvertex(v) + i] = value;

}


#endif
