

/*
**
** file:  read_vertex_slgh.c
**
*/


#include "gvertex.h"
#include "local.h"

#define word_lab0 1
#define sh_mask 0x800000   /* bit 23 set to 1  */
#define topsh_mask 0x1f000000   /* set  bits 24 - 28  */

#define ptr0_mask 0x200000   /* bit 21 set to 1  */
#define ptr1_mask 0x400000   /* bit 22 set to 1  */
#define ptr01_mask 0x600000   /* bits 21, 22 set to 1  */


/*
**********************************
(	if (bit 23 in word word_lab0 is 0) then no shift word;
	if (bit 23 in word word_lab0 is 1 and 
	     value in bits 28 - 24 is less than 31) 
	then md_shift_word;
	if (bit 23 in word word_lab0 is 1 and 
	     value in bits 28 - 24 is 31) 
	then 2 copies of shift word;
)
**********************************
*/


unsigned int size_nonptrlab(unsigned int a)
{

/* declarations  */


/* program  */

if ( (a & sh_mask) ==   0)
/*  then no shift words   */
	{  return (1);  }

/*  (a & sh_mask) !=   0)   */

if ( (a & topsh_mask) <   topsh_mask)
/*  then 1 shift word   */
	{  return (2);  }
else  /*  2 shift words  */
	{  return (3);  }

}


/*
***************************

(	ptrvtx side 0
	if (bit 21 in word 0 is 0) 
	then no ptrvtx_word
	else ptrvtx_word;
)
(	ptrvtx side 1
	if (bit 22 in word 0 is 0) 
	then no ptrvtx_word
	else ptrvtx_word;
)

***************************
*/

unsigned int size_ptrlab(unsigned int a)
{

/* declarations  */


/* program  */

if ( (a & ptr01_mask) == ptr01_mask )
/*  then 2 ptrlab words   */
	{  return (2);  }

/*  (a & ptr01_mask) != ptr01_mask   */

if ( (a & ptr01_mask)  /*  != 0  */ )
/*  then 1 ptrlab words   */
	{  return (1);  }
else  /*  (a & ptr01_mask)  == 0  */
	{  return (0);  }

}



unsigned int size_gvtx(unsigned int a)
{

/* declarations  */


/* program  */

return (
1  /*  plot  */
+  size_nonptrlab(a)  /*  nonptr labels  */
+ size_ptrlab(a) /*  nonptr labels  */
);


}




unsigned int size_gvtx_nonptrlab(gvertex v)
{
    return ( size_nonptrlab(gvertex_hlab(v)) );
}

unsigned int size_gvtx_ptrlab(gvertex v)
{
    return ( size_ptrlab(gvertex_hlab(v)) );
}

unsigned int size_gvtx_alllab(gvertex v)
{
    return (  size_nonptrlab(gvertex_hlab(v)) + 
    		  size_ptrlab(gvertex_hlab(v)) 
    		);
}

unsigned int size_gvertex(gvertex v)
{
    return (  	1 +
    			size_nonptrlab(gvertex_hlab(v)) + 
    		  	size_ptrlab(gvertex_hlab(v)) 
    		);
}





unsigned int size_key_nonptrlab(gkey A)
{
    return ( size_nonptrlab(((unsigned int *) A)[0]) );
}

unsigned int size_key_ptrlab(gkey A)
{
    return ( size_ptrlab(((unsigned int *) A)[0]) );
}

unsigned int size_key_alllab(gkey A)
{
    return (  size_nonptrlab(((unsigned int *) A)[0]) + 
    		  size_ptrlab(((unsigned int *) A)[0]) 
    		);
}
