/*
**
**  file: write.lkup.table
**
*/

/*
**  insert new element in table
**
**  if data with same key already in table
**  new data inserted anyway (an the old one stays)
**
*/



#include "local.h"

#define dbg_flag 0
#define measure_non_null 0



void write_ht(htable T, unsigned int key, unsigned int value)
{

/* declarations  */
  ht_value *v, *p, *p_old;
  unsigned int a;  

#if (dbg_flag > 0)
static int count = 0;
#endif

/* programs  */


#if (dbg_flag > 0)
count++;
#endif


/*  hash key   */
a = key%get_htable_size(T);


   if (  (ht_value *) ( ((hash_table *) T) -> table[a] ) == NULL )
   /* then: no data with given key  */
        {
          v = get_new_bk();
          write_bk_key(v, key);
          write_bk_value(v, value);
          write_bk_next(v, NULL);
          
          ((hash_table *) T) -> table[a] = (ht_value) v;

          ((hash_table *) T) -> elements_in_table = 
						((hash_table *) T) -> elements_in_table + 1;



#if (measure_non_null > 0)
/* update non_null_entry  */
          ((hash_table *) T) -> non_null_entry = 
((hash_table *) T) -> non_null_entry + 1;
#endif



           return ;   
           
         };  



/*  ((hash_table *) T) -> table[a] != NULL  */



   p = (ht_value *) ((hash_table *) T) -> table[a];





    if (  key < read_bk_key(p) )
    /* then:  insert on head  */
         {
          v = get_new_bk();
          write_bk_key(v, key);
          write_bk_value(v, value);
          write_bk_next(v, p);

          ((hash_table *) T) -> table[a] =  (ht_value) v;

          ((hash_table *) T) -> elements_in_table = 
                           ((hash_table *) T) -> elements_in_table + 1;

           return;

          } 




/*  
**  key >= read_bk_key(p)
*/


   while ( read_bk_key(p) < key ) 
      {
        p_old = p;
        p = read_bk_next(p);
      }

/*  
**  key <= read_bk_key(p_old)
**  key >= read_bk_key(p)
*/

  if ( key == read_bk_key(p) )
  {
    write_bk_value(p, value);
    return;
  }

/*  
**  key > read_bk_key(p)
*/
          v = get_new_bk();
          write_bk_key(v, key);
          write_bk_value(v, value);
          write_bk_next(v, p);

          write_bk_next(p_old, v);
          

          ((hash_table *) T) -> elements_in_table = 
                           ((hash_table *) T) -> elements_in_table + 1;



      return ;



}  /* end program  */
