/*
***********************************
file: d_v_index
***********************************
*/


#include "local.h"



unsigned int get_vindex_0(
unsigned int dvindex_0,
unsigned int dvindex_1,
unsigned int dv_sgn_0,
unsigned int dv_sgn_1
)
/*  
Define virtual index 0  from dvindexes and dv_sgn's.
Note:   results >= 0.
*/
{   /*  begin program  */

/*  declarations  */


/*  program */


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 0) )
/* then */  
     {
       return (0);
     }


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 1) )
/* then */  
     {
       return (dvindex_0);
     }



if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 0) )
/* then */  
     {
       return (dvindex_1);
     }


if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 1) )
/* then */  
     {
       if (dvindex_1 > dvindex_0)
       /* then */ 
         {
            return (dvindex_1);
         }
       else 
         {       
            return (dvindex_0);
         }
     }


}  /*  end  get_vindex_0  */









unsigned int get_vindex_1(
unsigned int dvindex_0,
unsigned int dvindex_1,
unsigned int dv_sgn_0,
unsigned int dv_sgn_1
)
/*  
Define virtual index 1  from dvindexes and dv_sgn's.
Note:   results >= 0.
*/
{   /*  begin program  */

/*  declarations  */

/*  program */


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 0) )
/* then */  
     {       
       return (dvindex_0);
     }


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 1) )
/* then */  
     {
       
       return (0);
     }



if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 0) )
/* then */  
     {       
       return (dvindex_0 + dvindex_1);
     }


if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 1) )
/* then */  
     {
       if (dvindex_1 > dvindex_0)
       /* then */ 
         {       
            return (dvindex_1 - dvindex_0);
         }
       else 
         {
            return (0);
         }
     }


}  /*  end  get_vindex_1  */









unsigned int get_vindex_2(
unsigned int dvindex_0,
unsigned int dvindex_1,
unsigned int dv_sgn_0,
unsigned int dv_sgn_1
)
/*  
Define virtual index 2  from dvindexes and dv_sgn's.
Note:   results >= 0.
*/
{   /*  begin program  */

/*  declarations  */

/*  program */


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 0) )
/* then */  
     {       
       return (dvindex_1);
     }


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 1) )
/* then */  
     {       
       return (dvindex_1 + dvindex_0);
     }



if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 0) )
/* then */  
     {
       return (0);
     }


if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 1) )
/* then */  
     {
       if (dvindex_1 > dvindex_0)
       /* then */ 
         {
       
            return (0);
         }
       else 
         {
            return (dvindex_0 - dvindex_1);
         }
     }




}  /*  end  get_vindex_2  */







void def_vindex(
unsigned int dvindex_0,
unsigned int dvindex_1,
unsigned int dv_sgn_0,
unsigned int dv_sgn_1,
unsigned int *vindex_0,
unsigned int *vindex_1,
unsigned int *vindex_2
)
/*  
Define virtual indexes and dv_sgn's from dvindexes.
Note:   results >= 0.
*/
{   /*  begin program  */

/*  declarations  */

/*  program */


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 0) )
/* then */  
     {
       *vindex_0 = 0;
       *vindex_1 = dvindex_0;
       *vindex_2 = dvindex_1;      
       
       return;
     }


if ( (dv_sgn_1 == 0) && (dv_sgn_0 == 1) )
/* then */  
     {
       *vindex_0 = dvindex_0;
       *vindex_1 = 0;
       *vindex_2 = dvindex_1 + dvindex_0;      
       
       return;
     }



if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 0) )
/* then */  
     {
       *vindex_0 = dvindex_1;
       *vindex_1 = dvindex_0 + dvindex_1;
       *vindex_2 = 0;      
       
       return;
     }


if ( (dv_sgn_1 == 1) && (dv_sgn_0 == 1) )
/* then */  
     {
       if (dvindex_1 > dvindex_0)
       /* then */ 
         {
           *vindex_0 = dvindex_1;
           *vindex_1 = dvindex_1 - dvindex_0;
           *vindex_2 = 0;      
       
            return;
         }
       else 
         {
           *vindex_0 = dvindex_0;
           *vindex_1 = 0;
           *vindex_2 = dvindex_0 - dvindex_1;      
       
            return;
         }
     }


}  /*  end  def_vindex  */


void def_d_vindex(
unsigned int vindex_0,
unsigned int vindex_1,
unsigned int vindex_2,
unsigned int *dvindex_0,
unsigned int *dvindex_1,
unsigned int *dv_sgn_0,
unsigned int *dv_sgn_1
)
/*  
Compute d_virtual index from vindexes.
Note:   result >= 0.
*/
{   /*  begin program  */


/*  program */

if (vindex_1 < vindex_0)
/* then */  
        {
             *dvindex_0 = (vindex_0 - vindex_1);
             *dv_sgn_0 = 1u;
        }
else 
        {
             *dvindex_0 = (vindex_1 - vindex_0);
             *dv_sgn_0 = 0u;
        }

if (vindex_2 < vindex_0)
/* then */  
        {
             *dvindex_1 = (vindex_0 - vindex_2);
             *dv_sgn_1 = 1u;
        }
else 
        {
             *dvindex_1 = (vindex_2 - vindex_0);
             *dv_sgn_1 = 0u;
        }



}  /*  end  def_d_vindex  */

 

void def_dv_sgn(
unsigned int vindex_0,
unsigned int vindex_1,
unsigned int *dvindex_0,
unsigned int *dv_sgn_0
)
/*  
Compute d_virtual index from vindexes.
Note:   result >= 0.
*/
{   /*  begin program  */


/*  program */

if (vindex_1 < vindex_0)
/* then */  
        {
             *dvindex_0 = (vindex_0 - vindex_1);
             *dv_sgn_0 = 1u;
        }
else 
        {
             *dvindex_0 = (vindex_1 - vindex_0);
             *dv_sgn_0 = 0u;
        }

}  /*  end  def_dv_sgn  */



void update_store_dvindex(type_bdd_store p)
{

/* declarations  */

unsigned int label[10];


/*  program  */
def_vindex(
read_store_dvindex(p, 0),
read_store_dvindex(p, 1),
read_store_dv_sgn(p, 0),   
read_store_dv_sgn(p, 1),
&(label[0]),
&(label[1]),
&(label[2])
);

/*  define new  dvindexes  */

if ( terminal((ptrvertex) read_store_vertex(p, 0)) ) label[0] = VINDX_TERMINAL;
if ( terminal((ptrvertex) read_store_vertex(p, 1)) ) label[1] = VINDX_TERMINAL;
if ( terminal((ptrvertex) read_store_vertex(p, 2)) ) label[2] = VINDX_TERMINAL;

def_d_vindex(
label[0],
label[1],
label[2],
&(label[3]),  /* new_dvindex_0  */
&(label[4]),  /* new_dvindex_1  */
&(label[5]),  /* new_dv_sgn_0  */
&(label[6])  /* new_dv_sgn_1  */
);

write_store_dvindex(p, 0, label[3]);
write_store_dvindex(p, 1, label[4]);
write_store_dv_sgn(p, 0, label[5]);
write_store_dv_sgn(p, 1, label[6]);

}



void put_newdvindex_store(
type_bdd_store p,
unsigned int vindex[3]
)
{

/* declarations  */

unsigned int label[4];


/*  program  */

def_d_vindex(
vindex[0],
vindex[1],
vindex[2],
&(label[0]),  /* new_dvindex_0  */
&(label[1]),  /* new_dvindex_1  */
&(label[2]),  /* new_dv_sgn_0  */
&(label[3])  /* new_dv_sgn_1  */
);

write_store_dvindex(p, 0, label[0]);
write_store_dvindex(p, 1, label[1]);
write_store_dv_sgn(p, 0, label[2]);
write_store_dv_sgn(p, 1, label[3]);

}

