/*
**
**  file: filter_r_state
**
**
*/


#include "local.h"

#define then  /* then */


#define dbg_flag 0    /* normal value: 0 */
#define dbg_prt 0     /* normal value: 0 */

#define dbg_vtx 0  /* This MUST be 0, unless dbg  */
#define dbg_filter 0  /* This MUST be 0, unless dbg  */

#define ck_hyp 0  /* this MUST be 0, unless dbg  */





void filter_r_state_0(type_bdd_store p)
/*
*******************************************************
 put arg in canonical form (to be used when no more redexes)
*******************************************************
*/
{  /*  begin  filter_r_state_0   */
    /*  declarations  */

    unsigned int temp;
    
    /*  program  */

/* test for ifte_step(not(F), G0, G1)  ->  ifte_step(F, G1, G0)  */

/*  
**   ifte_step(F, G1, G0, i, rbit, 1)  ->  
**   ifte_step(not(F), G0, G1, i, not(rbit), 1)  
**
**   ifte_step(F, G1, G0, 0, 0, 0)  ->  
**   ifte_step(not(F), G0, G1, 0, 0, 0)  
**
**   Note: F may be terminal.
*/

   if (
        read_store_p_flip(p, 0)  /*  != 0  */
      )
   then  /*  rewriting applies  */
       {
/* define result  */

           write_store_p_flip(p, 0, 0);

/*  exchange  G0, G1  */

           temp = read_store_vertex(p, 1);
           write_store_vertex(p, 1, read_store_vertex(p, 2));
           write_store_vertex(p, 2, temp);

           temp = read_store_p_flip(p, 1);
           write_store_p_flip(p, 1, read_store_p_flip(p, 2));
           write_store_p_flip(p, 2, temp);

           temp = read_store_flip(p, 1);
           write_store_flip(p, 1, read_store_flip(p, 2));
           write_store_flip(p, 2, temp);

           temp = read_store_p_swap(p, 1);
           write_store_p_swap(p, 1, read_store_p_swap(p, 2));
           write_store_p_swap(p, 2, temp);

           temp = read_store_dvindex(p, 0);
           write_store_dvindex(p, 0, read_store_dvindex(p, 1));
           write_store_dvindex(p, 1, temp);

           temp = read_store_dv_sgn(p, 0);
           write_store_dv_sgn(p, 0, read_store_dv_sgn(p, 1));
           write_store_dv_sgn(p, 1, temp);

           if (read_store_rswitch(p)  /*  !=  0  */  )
           then write_store_rbit(p, (1 + read_store_rbit(p))%2);

       }




}  /*  end filter_state_0   */









int filter_r_state_step(type_bdd_store p)

/*
**   computes filtered state
**   from vindex and state
**
**  returns number of reduction rules applied
** 
**  HYP:  in  ifte(F, G0, G1) we can assume:
** 
**  when rswitch == 0:
**  F nonterminal;
**  G0 != G1, 
**  at least one of G0, G1 is nonterminal.
*/
{    


    /*  declarations  */

    unsigned int temp;
 
    unsigned int vindex[4];    
        
    int  result;
    
    /*  program  */





/*
*******************************************************
 put arg in canonical form

i.e.: ....

*******************************************************
*/

/*  inizialize result and vindex  */

  result = 0;

get_vindexes_store(p, vindex);











#if (ck_hyp != 0)
if (read_store_rswitch(p) == 0)
{
if ( terminal((void *) read_store_vertex(p, 0)) )
  /* error */
   {
      fprintf(stderr, 
"\nfilter_r_state_step: error: F = 0x%x is terminal\n",
read_store_vertex(p, 0)
);

exit (1);

   }




if ( 
           (read_store_vertex(p, 1) == read_store_vertex(p, 2))
        && (read_store_p_flip(p, 1) == read_store_p_flip(p, 2))
        && (read_store_p_swap(p, 1) == read_store_p_swap(p, 2))
        && (read_store_flip(p, 1) == read_store_flip(p, 2))
        && (vindex[1] == vindex[2])
   )
  /* error */
   {
      fprintf(stderr, 
"\nfilter_r_state_step: error: G1 == G2 == 0x%x\n",
read_store_vertex(p, 1)
);

exit (1);

   }


if ( 
        terminal((void *)read_store_vertex(p, 1))
     && terminal((void *)read_store_vertex(p, 2))
   )
  /* error */
   {
      fprintf(stderr, 
"\nfilter_r_state_step: error: G1 = 0x%x, G2 = 0x%x both terminal\n",
read_store_vertex(p, 1),
read_store_vertex(p, 2)
);

exit (1);

   }


}  /* then */

#endif




#if (dbg_vtx == 0)




/*  ifte_step(F, F, G) ->  ifte_step(F, 1, G)  */

   if (
          (read_store_vertex(p, 0) == read_store_vertex(p, 1))
        && (read_store_p_flip(p, 0) == read_store_p_flip(p, 1))
        && (read_store_p_swap(p, 0) == read_store_p_swap(p, 1))
        && (read_store_flip(p, 0) == read_store_flip(p, 1))

        && (vindex[0] == vindex[1])

/* i.e.        && (read_store_dvindex(p, 0) == 0)
               && (read_store_dv_sgn(p, 0) == 0)
*/

        && (read_store_rswitch(p) == 0)
         )
   then  /*  rewriting applies  */
       {
/* define result  */

           write_store_vertex(p, 1, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 1, 1);
           write_store_p_swap(p, 1, 0);
           write_store_flip(p, 1, 0);


/* update vindex, dvindex, sgn */
vindex[1] = VINDX_TERMINAL;



            result++;
       }


/*  ifte_step(F, G, F) ->  ifte_step(F, G, 0)  */

   if (
          (read_store_vertex(p, 0) == read_store_vertex(p, 2))
        && (read_store_p_flip(p, 0) == read_store_p_flip(p, 2))
        && (read_store_p_swap(p, 0) == read_store_p_swap(p, 2))
        && (read_store_flip(p, 0) == read_store_flip(p, 2))

        && (vindex[0] == vindex[2])

/* i.e.        && (read_store_dvindex(p, 1) == 0)
               && (read_store_dv_sgn(p, 1) == 0)
*/

        && (read_store_rswitch(p) == 0)
         )
   then  /*  rewriting applies  */
       {
/* define result  */

           write_store_vertex(p, 2, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 2, 0);
           write_store_p_swap(p, 2, 0);
           write_store_flip(p, 2, 0);
 

/* update vindex, dvindex, sgn */
vindex[2] = VINDX_TERMINAL;

   
              result++;

       }


/*  ifte_step(F, G, not(F)) ->  ifte_step(F, G, 1)  */

   if (
          (read_store_vertex(p, 0) == read_store_vertex(p, 2))
        && (read_store_p_flip(p, 0) != read_store_p_flip(p, 2))
        && (read_store_p_swap(p, 0) == read_store_p_swap(p, 2))
        && (read_store_flip(p, 0) == read_store_flip(p, 2))

        && (vindex[0] == vindex[2])

/* i.e.        && (read_store_dvindex(p, 1) == 0)
               && (read_store_dv_sgn(p, 1) == 0)
*/

        && (read_store_rswitch(p) == 0)
         )
   then  /*  rewriting applies  */
       {
/* define result  */

           write_store_vertex(p, 2, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 2, 1);
           write_store_p_swap(p, 2, 0);
           write_store_flip(p, 2, 0);
 

/* update vindex, dvindex, sgn */
vindex[2] = VINDX_TERMINAL;


     
            result++;

       }

/*  ifte_step(F, not(F), G) ->  ifte_step(F, 0, G)  */

   if (
          (read_store_vertex(p, 0) == read_store_vertex(p, 1))
        && (read_store_p_flip(p, 0) != read_store_p_flip(p, 1))
        && (read_store_p_swap(p, 0) == read_store_p_swap(p, 1))
        && (read_store_flip(p, 0) == read_store_flip(p, 1))

        && (vindex[0] == vindex[1])

/* i.e.        && (read_store_dvindex(p, 0) == 0)
               && (read_store_dv_sgn(p, 0) == 0)
*/


        && (read_store_rswitch(p) == 0)
         )
   then  /*  rewriting applies  */
       {
/* define result  */

           write_store_vertex(p, 1, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 1, 0);
           write_store_p_swap(p, 1, 0);
           write_store_flip(p, 1, 0);
 

/* update vindex, dvindex, sgn */
vindex[1] = VINDX_TERMINAL;
    
            result++;

       }









/*  ifte_step(F, 1, G) ->  ifte_step(G, 1, F)  */

   if (
            (read_store_vertex(p, 0) > read_store_vertex(p, 2))
         && ( terminal((ptrvertex) read_store_vertex(p, 1)) )
         && (read_store_p_flip(p, 1) == 1)
        && (read_store_rswitch(p) == 0)
      )
   then  /*  rewriting applies  */
       {
/* define result  */

/*  exchange F, G  */


           temp = read_store_vertex(p, 0);
           write_store_vertex(p, 0, read_store_vertex(p, 2));
           write_store_vertex(p, 2, temp);

           temp = read_store_p_flip(p, 0);
           write_store_p_flip(p, 0, read_store_p_flip(p, 2));
           write_store_p_flip(p, 2, temp);

           temp = read_store_flip(p, 0);
           write_store_flip(p, 0, read_store_flip(p, 2));
           write_store_flip(p, 2, temp);

           temp = read_store_p_swap(p, 0);
           write_store_p_swap(p, 0, read_store_p_swap(p, 2));
           write_store_p_swap(p, 2, temp);

           temp = vindex[0];
           vindex[0] = vindex[2];
           vindex[2] = temp;
           
#if (dbg_filter == 0)
            result++;
#endif

       }







/*  ifte_step(F, 0, G) ->  ifte_step(not(G), 0, not(F))  */

   if (
               ( read_store_vertex(p, 0) > read_store_vertex(p, 2) )
         && (terminal((ptrvertex) read_store_vertex(p, 1)) )
         && (read_store_p_flip(p, 1) == 0)
        && (read_store_rswitch(p) == 0)
      )
   then  /*  rewriting applies  */
       {
/* define result  */

/*  exchange F, G  */


           temp = read_store_vertex(p, 0);
           write_store_vertex(p, 0, read_store_vertex(p, 2));
           write_store_vertex(p, 2, temp);

           temp = read_store_p_flip(p, 0);
           write_store_p_flip(p, 0, (1 + read_store_p_flip(p, 2))%2 );
           write_store_p_flip(p, 2, (1 + temp)%2 );

           temp = read_store_flip(p, 0);
           write_store_flip(p, 0, read_store_flip(p, 2));
           write_store_flip(p, 2, temp);

           temp = read_store_p_swap(p, 0);
           write_store_p_swap(p, 0, read_store_p_swap(p, 2));
           write_store_p_swap(p, 2, temp);


           temp = vindex[0];
           vindex[0] = vindex[2];
           vindex[2] = temp;
           

#if (dbg_filter == 0)
            result++;
#endif

       }





/*  ifte_step(F, G, 0) ->  ifte_step(G, F, 0)  */

   if (
            ( read_store_vertex(p, 0) > read_store_vertex(p, 1) )
         && (terminal((ptrvertex) read_store_vertex(p, 2)) )
         && (read_store_p_flip(p, 2) == 0)
         && (read_store_rswitch(p) == 0)
     )
   then  /*  rewriting applies  */
       {
/* define result  */

/*  exchange F, G  */


#if (dbg_prt > 100)
fprintf(
stderr,
"\nfilter_r_state_step: p = 0x%x: ifte_step(F, G, 0) ->  ifte_step(G, F, 0)"
); 

fprintf(
stderr,
"\nF = 0x%x, G = 0x%x, 0 = 0x%x",
read_store_vertex(p, 0),
read_store_vertex(p, 1),
read_store_vertex(p, 2)
); 
#endif


           temp = read_store_vertex(p, 0);
           write_store_vertex(p, 0, read_store_vertex(p, 1));
           write_store_vertex(p, 1, temp);

           temp = read_store_p_flip(p, 0);
           write_store_p_flip(p, 0, read_store_p_flip(p, 1));
           write_store_p_flip(p, 1, temp);

           temp = read_store_flip(p, 0);
           write_store_flip(p, 0, read_store_flip(p, 1));
           write_store_flip(p, 1, temp);

           temp = read_store_p_swap(p, 0);
           write_store_p_swap(p, 0, read_store_p_swap(p, 1));
           write_store_p_swap(p, 1, temp);


           temp = vindex[0];
           vindex[0] = vindex[1];
           vindex[1] = temp;
           
 
#if (dbg_filter == 0)
            result++;
#endif

       }










/*  ifte_step(F, G, 1) ->  ifte_step(not(G), not(F), 1)  */

   if (
               read_store_vertex(p, 0) > read_store_vertex(p, 1)
         && terminal((ptrvertex) read_store_vertex(p, 2))
         && (read_store_p_flip(p, 2) == 1)
         && (read_store_rswitch(p) == 0)
     )
   then  /*  rewriting applies  */
       {
/* define result  */

/*  exchange F, G  */


           temp = read_store_vertex(p, 0);
           write_store_vertex(p, 0, read_store_vertex(p, 1));
           write_store_vertex(p, 1, temp);

           temp = read_store_p_flip(p, 0);
           write_store_p_flip(p, 0, (1 + read_store_p_flip(p, 1))%2 );
           write_store_p_flip(p, 1, (1 + temp)%2 );

           temp = read_store_flip(p, 0);
           write_store_flip(p, 0, read_store_flip(p, 1));
           write_store_flip(p, 1, temp);

           temp = read_store_p_swap(p, 0);
           write_store_p_swap(p, 0, read_store_p_swap(p, 1));
           write_store_p_swap(p, 1, temp);


           temp = vindex[0];
           vindex[0] = vindex[1];
           vindex[1] = temp;
           
           

#if (dbg_filter == 0)
            result++;
#endif

       }





/*  ifte_step(F, G, not(G)) ->  ifte_step(G, F, not(F))  */

   if (
               read_store_vertex(p, 0) > read_store_vertex(p, 1)
         && (read_store_vertex(p, 1) == read_store_vertex(p, 2))
         && (read_store_p_flip(p, 1) != read_store_p_flip(p, 2))
         && (read_store_p_swap(p, 1) == read_store_p_swap(p, 2))
         && (read_store_flip(p, 1) == read_store_flip(p, 2))


        && (vindex[1] == vindex[2])

/* i.e.        && (read_store_dvindex(p, 0) == read_store_dvindex(p, 1))
               && (read_store_dv_sgn(p, 0) == read_store_dv_sgn(p, 1))
*/



        && (read_store_rswitch(p) == 0)
      )
   then  /*  rewriting applies  */
       {
/* define result  */




#if (dbg_prt > 100)
fprintf(
stderr,
"\nfilter_r_state_step: p = 0x%x: (F, G, not(G)) -> (G, F, not(F))"
); 

fprintf(
stderr,
"\nF = 0x%x, G = 0x%x, not(G) = 0x%x",
read_store_vertex(p, 0),
read_store_vertex(p, 1),
read_store_vertex(p, 2)
); 
#endif


/*  exchange F, G  */

           temp = read_store_vertex(p, 0);
           write_store_vertex(p, 0, read_store_vertex(p, 1));
           write_store_vertex(p, 1, temp);

           temp = read_store_p_flip(p, 0);
           write_store_p_flip(p, 0, read_store_p_flip(p, 1) );
           write_store_p_flip(p, 1, temp );

           temp = read_store_flip(p, 0);
           write_store_flip(p, 0, read_store_flip(p, 1));
           write_store_flip(p, 1, temp);

           temp = read_store_p_swap(p, 0);
           write_store_p_swap(p, 0, read_store_p_swap(p, 1));
           write_store_p_swap(p, 1, temp);

 
/*  define 2  */

           write_store_vertex(p, 2, read_store_vertex(p, 1));
 
           write_store_p_flip(p, 2, (1 + read_store_p_flip(p, 1))%2 );

           write_store_flip(p, 2, read_store_flip(p, 1));
  
           write_store_p_swap(p, 2, read_store_p_swap(p, 1));



           temp = vindex[0];
           vindex[0] = vindex[1];
           vindex[1] = temp;
           vindex[2] = temp;
           

#if (dbg_filter == 0)
            result++;
#endif

       }











/*  ifte_step(1, G1, G0, i, rbit, 1)  ->  ifte_step(1, G1, 0, i, rbit, 1)  */
/*  remark:  if rswitch == 0 then terminal case  */
/*  This rewriting may destroy nf. Thus nf recomputed   */

   if (
            (terminal((ptrvertex) read_store_vertex(p, 0)) )
         && (read_store_p_flip(p, 0) == 1 )
         && (    nonterminal((ptrvertex) read_store_vertex(p, 2)) 
              || (read_store_p_flip(p, 2) != 0 )
            )
         && (read_store_rswitch(p) /* != 0 */ )
     )
   then  /*  rewriting applies  */
       {
/* define result  */

#if (dbg_flag > 100)
printf("\n\nfilter_r_state_step: p = 0x%x: rfilter: (1, G1, G0, i, rbit, 1)", 
p);
printf("\nvindex[0] = %u, vindex[1] = %u, vindex[2] = %u, vindex[3] = %u", vindex[0], vindex[1], vindex[2], vindex[3]);
printf("\nin vindex = %u", read_store_dvindex(p, 2));
#endif


           write_store_vertex(p, 2, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 2, 0);
           write_store_p_swap(p, 2, 0);
           write_store_flip(p, 2, 0);
 

/* update dvindex, dv_sgn  */

           vindex[2] = VINDX_TERMINAL;


/* update broadcst   */
write_store_dvindex(
p, 
2,
read_store_dvindex(p, 2) + vindex[1]
);

     
/*  restore nf  */
restriction_nf_vindex(p, vindex);

/* old version:  restriction_nf(p);  */

            result++;

#if (dbg_flag > 100)
printf("\nvindex[0] = %u, vindex[1] = %u, vindex[2] = %u, vindex[3] = %u", vindex[0], vindex[1], vindex[2], vindex[3]);
printf("\nout vindex = %u", read_store_dvindex(p, 2));
#endif


       }




/*  ifte_step(0, G1, G0, i, rbit, 1)  ->  ifte_step(0, 0, G0, i, rbit, 1)  */
/*  remark:  if rswitch == 0 then terminal case  */
   if (
               (terminal((ptrvertex) read_store_vertex(p, 0)) )
         && (read_store_p_flip(p, 0) == 0 )
         && (    nonterminal((ptrvertex) read_store_vertex(p, 1)) 
              || (read_store_p_flip(p, 1) != 0 )
            )
         && (read_store_rswitch(p) != 0)
     )
   then  /*  rewriting applies  */
       {
/* define result  */

#if (dbg_flag > 100)
printf("\n\nfilter_r_state_step: p = 0x%x: rfilter: (0, G1, G0, i, rbit, 1)", 
p);
printf("\nvindex[0] = %u, vindex[1] = %u, vindex[2] = %u, vindex[3] = %u", vindex[0], vindex[1], vindex[2], vindex[3]);
printf("\nin vindex = %u", read_store_dvindex(p, 2));
#endif
           write_store_vertex(p, 1, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 1, 0);
           write_store_p_swap(p, 1, 0);
           write_store_flip(p, 1, 0);
 

/* update dvindex, dv_sgn  */


           vindex[1] = VINDX_TERMINAL;


/* update broadcst   */
write_store_dvindex(
p, 
2,
read_store_dvindex(p, 2) + vindex[2]
);


/*  restore nf  */

restriction_nf_vindex(p, vindex);

/* old version:  restriction_nf(p);  */
     
            result++;

#if (dbg_flag > 100)
printf("\nvindex[0] = %u, vindex[1] = %u, vindex[2] = %u, vindex[3] = %u", vindex[0], vindex[1], vindex[2], vindex[3]);
printf("\nout vindex = %u", read_store_dvindex(p, 2));
#endif

       }






#endif



/*
*******************************************************
ADD MORE !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

*******************************************************
*/

/*  no more reduction rules apply  */


/* update dvindex, dv_sgn in p */
           put_newdvindex_store(p, vindex);
           


/* Update restriction parameters  */
if ( read_store_rswitch(p)  /* != 0 */ )
/* then */
    {
       
       if ( vindex[3] < vindex[0] )
       /* then */
          {
            write_store_rdvindex(p, vindex[0] - vindex[3]);
            write_store_rsgn(p, 1);
          }
       else /* vindex[3] >= vindex[0] */
          {
            write_store_rdvindex(p, vindex[3] - vindex[0]);
            write_store_rsgn(p, 0);

          }




    }


            

          return (result);


}   /*  end program  */



 











void restriction_nf_vindex(
type_bdd_store p, 
unsigned int vindex[3]
)
/*
******************************************
reduce restriction to nf
HYP. 
0. read_store_rswitch(p) != 0
1. vindex[0] = VINDX_TERMINAL

Thus read_store_rsgn(p) != 0 since p in nf.
******************************************
*/

{ 

/* declarations  */


 /*  begin  restriction_nf */

 
if (    (read_store_rswitch(p) == 0) 
     ||
        ( (vindex[3] < vindex[1]) && (vindex[3] < vindex[2]) )
   )
then  /*  no restriction takes place  */
       {
           write_store_rbit(p, 0);
           write_store_rswitch(p, 0);
           write_store_rdvindex(p, 0);
           write_store_rsgn(p, 0);
       }




}  /*  end  restriction_nf */



