
/*
*************************************************************  
    if_then_else with restriction
************************************************************
*/



#include "local.h"

#define dbg0_ifter 0  /* normal value:  0  */

#define threshold 16000



bdd ifter(
bdd G0, 
bdd G1, 
bdd G2,
unsigned int i,    /*  variable to be restricted  */
unsigned int rbit,   /*  G1, (G2) restricted to rbit (not(rbit)) on var(i)   */
unsigned int rswitch  /* restriction switch: restriction iff rswitch != 0  */
)
/*
**  returns bdd in nf
**  representing if [G0] then [G1] else [G2].
**
*/
{
   /* declarations */


   bdd G; 
   type_bdd_store p;
   unsigned int min_vindex;

  
 
#if (dbg0_ifter > 0)
static int count = 0;
#endif

#if (dbg0_ifter > 10)
unsigned int vindex_G[3];
#endif

   /* program */


#if (dbg0_ifter > 0)
count++;
if (count > threshold)
{
printf("\nifter:%d: ckp 10 (begin)", count); 
}  
#endif


#if (dbg_loop > 1050)
last_min_vindex = 0;
where_min_vindex = 0;
vindex_offset = 0;
ifter_depth = 0;
#endif


/* initialize store for result  */

p = get_graph_r_store(G0, G1, G2, i, rbit, rswitch);




#if (dbg0_ifter > 0)
if (count > threshold)
{
printf("\nifter:%d: ckp 20: store initialized: p = 0x%x", 
count,
p
); 
}  
#endif



#if (dbg0_ifter > 10)
if (count > threshold)
{
 printf("\nifter:%d: (begin): ckp 50", count);
 printf("\nvertex_0 = 0x%x, vertex_1 = 0x%x, vertex_2 = 0x%x",
 read_store_vertex(p, 0),
 read_store_vertex(p, 1),
 read_store_vertex(p, 2)
 );


 if ( terminal((ptrvertex) read_graph_root(G0)) )
 /* then */ vindex_G[0] = VINDX_TERMINAL;
 else vindex_G[0] = read_graph_vindex(G0);
 if ( terminal((ptrvertex) read_graph_root(G1)) )
 /* then */ vindex_G[1] = VINDX_TERMINAL;
 else vindex_G[1] = read_graph_vindex(G1);
  if ( terminal((ptrvertex) read_graph_root(G2)) )
 /* then */ vindex_G[2] = VINDX_TERMINAL;
 else vindex_G[2] = read_graph_vindex(G2);

 printf("\nvindex_G[0] = %u; vindex_G[1] = %u; vindex_G[2] = %u", 
 vindex_G[0], vindex_G[1], vindex_G[2]);
  
 printf("\ninput restriciton parameters: i = %d, rbit = %d, rswitch = %d",
 i,
 rbit,
 rswitch
 );

 printf("\nstore: rsgn = %d, rdvindex = %d, rbit = %d, rswitch = %d",
 read_store_rsgn(p),
 read_store_rdvindex(p),
 read_store_rbit(p),
 read_store_rswitch(p)
 );
 
 if ( rswitch != read_store_rswitch(p) )
 /* then */  /* test for error  */
      {
        if ( 
                 (i >= vindex_G[1]) 
              || (i >= vindex_G[2])
           )
        /* then */  /*  error  */
printf("\n*********** ifter: %d: error in rswitch *********\n",
count);
      }
}
#endif


lock_bdd_store(p);

/* compute result  */

#if dbg1_ifter
 printf("\nifter:%d: ckp 100 \n", count);
#endif

ifte_r_step(p);

#if (dbg0_ifter > 100)
if (count > threshold)
{
 printf("\nifter:%d: ckp 200 \n", count);
}
#endif

 G = get_graph_header();

write_graph_root(G, (ptrvertex) read_store_vertex(p, 3));
write_graph_p_flip(G, read_store_p_flip(p, 3));
write_graph_flip(G, read_store_flip(p, 3));
write_graph_p_swap(G, read_store_p_swap(p, 3));
write_graph_vindex(G, read_store_dvindex(p, 2));

#if (dbg0_ifter > 100)
if (count > threshold)
{
 printf("\nifter:%d: ckp 300 \n", count);
}
#endif

unlock_free_store(p);

#if (dbg0_ifter > 100)
if (count > threshold)
{
 printf("\nifter:%d: ckp 320 \n", count);
}
#endif



/* adjust vindex   */

if ( nonterminal(read_graph_root(G)) )
/* then */  /* read_graph_root(G) nonterminal  */
     {

#if (dbg0_ifter > 100)
if (count > threshold)
{
 printf("\nifter:%d: ckp 340 \n", count);
}
#endif



/* define update for root virtual index  */

              min_vindex = UINT_MAX;


                  
             if (

( nonterminal((ptrvertex) read_graph_root(G0)) )
&&


(read_graph_vindex(G0) < min_vindex)
                 )
             /* then */  min_vindex = read_graph_vindex(G0);

                  
             if (

( nonterminal((ptrvertex) read_graph_root(G1)) )
&&


  (read_graph_vindex(G1) < min_vindex)
                 )
             /* then */  min_vindex = read_graph_vindex(G1);

                  
             if (

( nonterminal((ptrvertex) read_graph_root(G2)) )
&&


 (read_graph_vindex(G2) < min_vindex)
                 )
             /* then */  min_vindex = read_graph_vindex(G2);


/*  min_vindex well defined and < VINDX_TERMINAL   */



#if (dbg0_ifter > 10)
if (count > threshold)
{
 printf("\nifter:%d: ckp 350:", count);
 printf("read_graph_vindex(G) = %d, min_vindex = %d, vindex = %d",
 read_graph_vindex(G), min_vindex, min_vindex + read_graph_vindex(G)
 );
}
#endif


write_graph_vindex(
G, 
min_vindex + 
read_graph_vindex(G)
);


/*  read_graph_root(G)  nonterminal  */

lock_bdd_vertex( (ptrvertex) read_graph_root(G) );

           }

else  /*   root terminal  */
    {

#if (dbg0_ifter > 100)
if (count > threshold)
{
 printf("\nifter: %d: ckp 370 \n", count);
}
#endif

write_graph_vindex(
G, 
0
);

/*  read_graph_root(G) terminal thus locking not needed  */

     }

#if (dbg0_ifter > 100)
if (count > threshold)
{
 printf("\nifter:%d: ckp 400 \n", count);
}
#endif



/*   G defined  */






#if (dbg0_ifter > 0)
if (count > threshold)
{
 printf("\nifter:%d: (end): bdd_root = 0x%x", count,  read_graph_root(G));
 printf("\nvindex = %u = 0x%x, p_flip = %u, flip = %u, p_swap = %u", 
 read_graph_vindex(G), 
 read_graph_vindex(G),
 read_graph_p_flip(G),
 read_graph_flip(G),
 read_graph_p_swap(G)
 );
 printf("\nheader = G = 0x%x, G[0] = 0x%x, G[1] = 0x%x, G[2] = 0x%x\n",
 (unsigned int) G,
 ((unsigned int *)G)[0], 
 ((unsigned int *)G)[1], 
 ((unsigned int *)G)[2]);
}
 #endif


   return (G);


}





/*
***************************************************************
end  if_then_else with restriction
***************************************************************
*/
