/*
**
**   file   ifte_r_step
**
**  
**
**
*/



#include "local.h"

/*
********************
Debugging levels:
> 1000: (enable counting)
> 1050: test for loops
> 2000: (enable printing on begin, end)
> 3000
> 4000
> 5000
> 6000
********************
*/

#define dbg_cache 0   /* This MUST be 0, execpt for dbg */

#define dbg_verbose 0    /* if != 0 long printing */


#define dbg_flag 0    /* normal value: 0  */
#define PR_ifter_INFO 100000000
#define dbg_print_info 0    /* normal value (quiet work): 0  */


#define dbg_test 0    /* normal value:   0  */

#define threshold 0

#define then /* then */





#define PROBE_FLAG 0   /*  normal value: 0  */

#if (PROBE_FLAG > 0)
#include "probes.h"

static char probe[1000];
#endif







#if ( (dbg_flag > 0) || (dbg_print_info > 1000) )
static unsigned int count_buf = 0;
#endif




void ifte_r_step(type_bdd_store p)

/*
**  recursive step computing
**  if_then_else with restriction
**
** 
*/

{
   /*  declarations */

#if ( (dbg_flag > 0) || (dbg_print_info > 1000))
unsigned int count = 0;
unsigned int call_buf = 0;
#endif

#if (dbg_print_info > 2000)
int i;
#endif


    type_bdd_store new_p_0, new_p_1;

unsigned int vindex_broad;

#if (dbg_loop > 1050)   
unsigned int present_min_vindex;
#endif 



#if (use_extra_gvtx_info != 0)
ptrvertex vbuf0, vbuf1, vbuf2;
#endif




#if (dbg_test > 100)   
unsigned int tester[10];
#endif 


  /* program */
  


#if ( (dbg_flag > 0) || (dbg_print_info > 1000))
count = count_buf;
count++;
count_buf = count;
#endif



#if (use_extra_gvtx_info != 0)
vbuf0 = (void *) read_store_vertex(p, 0);
vbuf1 = (void *) read_store_vertex(p, 1);
vbuf2 = (void *) read_store_vertex(p, 2);
#endif




#if (PROBE_FLAG > 10)
sprintf(probe,
"\n\nifte_r_step:%d:%u: begin, p=0x%x", 
count,
ifter_depth,
p
);
probesend(probe);
#endif







#if (dbg_flag > 1000)
if (count > threshold)
{
fprintf(stderr,
"\n\nifte_r_step:%d:%u: begin, p=0x%x", 
count,
ifter_depth,
p
);

#if 0
#if (use_extra_gvtx_info != 0)
printf(
", sumlev=%u", 
sum_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2)
          )
);
#endif
#endif


#if 0
printf("\nvtx.vidx.pflp.flp.pswp: 0, 1, 2");
printf("\n0x%x", read_store_vertex(p, 0));
printf(".%u", 
get_vindex_0(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);
#endif

#if 0
printf(".%u.%u.%u", 
read_store_p_flip(p, 0),
read_store_flip(p, 0),
read_store_p_swap(p, 0)
);
#endif




#if 0
printf(", 0x%x", read_store_vertex(p, 1));
printf(".%u", 
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);
#endif


#if 0
printf(".%u.%u.%u", 
read_store_p_flip(p, 1),
read_store_flip(p, 1),
read_store_p_swap(p, 1)
);
#endif



#if 0
printf(", 0x%x", read_store_vertex(p, 2));
printf(".%u", 
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);
#endif

#if 0
printf(".%u.%u.%u", 
read_store_p_flip(p, 2),
read_store_flip(p, 2),
read_store_p_swap(p, 2)
);
#endif

/* printf("\n"); */


}
#endif
















/*  begin: print ifte_step info   */
#if (dbg_print_info > 1000)

if ( count%PR_ifter_INFO == 0)
then
         {
printf("\n\n*********info ifte_r_step %d:*********************", count);

print_cache_info();
print_dag_info();
print_bdd_store_info();


#if (dbg_print_info > 2000)

for (i = 0; i < 2; i++)
  {
  
printf(
"\nread_store_dvindex(p, %d) = %u = 0x%x; read_store_dv_sgn(p, %d) = %d",
i,
read_store_dvindex(p, i),
read_store_dvindex(p, i),
i,
read_store_dv_sgn(p, i)
);

 
#if 0
printf("\nread_store_p_flip(p, %d) = %d; read_store_flip(p, %d) = %d",
i,
read_store_p_flip(p, i),
i,
read_store_flip(p, i)
);

printf("\nread_store_p_swap(p, %d) = %d",
i,
read_store_p_swap(p, i)
);
#endif

  }
  
  
#if 0
printf("\nrsgn = %d; rdvindex = %u = 0x%x; rbit = %d; rswitch = %d",
read_store_rsgn(p),
read_store_rdvindex(p),
read_store_rdvindex(p),
read_store_rbit(p),
read_store_rswitch(p)
);
#endif

printf("\nvertex_%d = 0x%x: vindex = %u = 0x%x",
0,
read_store_vertex(p, 0),
get_vindex_0(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            ),
get_vindex_0(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);

printf("\nvertex_%d = 0x%x: vindex = %u = 0x%x",
1,
read_store_vertex(p, 1),
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            ),
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);

printf("\nvertex_%d = 0x%x: vindex = %u = 0x%x",
2,
read_store_vertex(p, 2),
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            ),
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);

#endif

printCPUtime();

printf("\n********************************************\n");
        }


#endif

/*  end: print ifte_step info   */







 
 
#if (dbg_test > 100) 
/* store restriction switch before restriction */  
tester[0] = read_store_rswitch(p);
#endif 
 


/*
**  DO RESTRICTION in p    
**
**  HYP: p in nf
**
*/


       restriction(p);
       
       
/*
**  end RESTRICTION in p    
**
**  HYP: p in nf
**
*/


/* read_store_dvindex(p, 2) well defined (by restriction)  */



#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )
/* check levels */
if (
ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
vbuf0, 
vbuf1,
vbuf2
) != 0
   )
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: level error after restriction: new=%u <= old=%u\n",
count,


sum_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2)
),

sum_levels(
vbuf0, 
vbuf1,
vbuf2
)

);

fprintf(stderr,
"\noldvtx: v0=0x%x, v1=0x%x, v2=0x%x",
vbuf0,
vbuf1,
vbuf2
);
fprintf(stderr,
"\nnewvtx: v0=0x%x, v1=0x%x, v2=0x%x",
read_store_vertex(p, 0), 
read_store_vertex(p, 1),
read_store_vertex(p, 2)
);

exit (1);

}
else  /*  ok */
{
vbuf0 = (void *) read_store_vertex(p, 0);
vbuf1 = (void *) read_store_vertex(p, 1);
vbuf2 = (void *) read_store_vertex(p, 2);

}


#endif




#if ((dbg_flag > 1000) && (dbg_loop > 1050))
/*
***************************
Test for loop
***************************
*/

present_min_vindex =
get_vindex_0(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            );



if (
present_min_vindex
>
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
   )
{
present_min_vindex
=
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            );
}

if (
present_min_vindex
>
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
   )
{
present_min_vindex
=
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            );
}


#if (dbg_verbose > 1000)
fprintf(stderr, 
"\nifte_r_step:%d: present_min_vindex = %u, last_min_vindex = %u, vindex_offset = %u",
count,
present_min_vindex,
last_min_vindex,
vindex_offset
);
#endif


if ( terminal( (void *) read_store_vertex(p, 0))
     &&
     terminal( (void *) read_store_vertex(p, 1))
     &&
     terminal( (void *) read_store_vertex(p, 2))
   )
/* all terminals */
{
present_min_vindex = UINT_MAX;
}
else
/* at least one nonterminal */
{
present_min_vindex =
present_min_vindex + last_min_vindex + vindex_offset;
}




#if (dbg_verbose > 1000)
fprintf(stderr, "
\nifte_r_step:%d: (new) present_min_vindex = %u",
count,
present_min_vindex
);
#endif


if (
      (present_min_vindex <= last_min_vindex)
      &&
      (where_min_vindex != 0)
   )
/*  error  */
{

fprintf(stderr, 
"\nifte_r_step:%d: error: present_min_vindex = %u, last_min_vindex = %u, where_min_vindex = %u\n",
count,
present_min_vindex,
last_min_vindex,
where_min_vindex
);

exit (1);

}


/*  ok: present_min_vindex > last_min_vindex */

last_min_vindex = present_min_vindex;
where_min_vindex = count;


#endif





#if (dbg_test > 100) 
/* store restriction switch after restriction */  
tester[1] = read_store_rswitch(p);
/* store vindex after restriction */  
tester[2] = read_store_dvindex(p, 2);
#endif



#if (dbg_flag == 11)
if (count > threshold)
{
printf("\n\nifte_r_step:%d: ckp 10012: dv br (restriction) = %u", 
count, read_store_dvindex(p, 2) 
);


/*   *************************************  */
printf("\nvertex_%d = 0x%x: vindex = %u = 0x%x",
0,
read_store_vertex(p, 0),
get_vindex_0(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            ),
get_vindex_0(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);

printf("\nvertex_%d = 0x%x: vindex = %u = 0x%x",
1,
read_store_vertex(p, 1),
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            ),
get_vindex_1(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);

printf("\nvertex_%d = 0x%x: vindex = %u = 0x%x",
2,
read_store_vertex(p, 2),
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            ),
get_vindex_2(
  read_store_dvindex(p, 0), 
  read_store_dvindex(p, 1), 
  read_store_dv_sgn(p, 0), 
  read_store_dv_sgn(p, 1)
            )
);

printf("\nrsgn = %d; rdvindex = %u = 0x%x; rbit = %d; rswitch = %d",
read_store_rsgn(p),
read_store_rdvindex(p),
read_store_rdvindex(p),
read_store_rbit(p),
read_store_rswitch(p)
);

/*   *************************************  */

}
#endif


/*  
Test if we are in a terminal case (no cache table used here).
Filtered state in p.
*/


           if (ifte_r_terminal_case(p))
           then /* terminal case, result in p  */
                {



#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )
/* check levels */
if (
ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
vbuf0, 
vbuf1,
vbuf2
) != 0
   )
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: terminal: level error: new=%u <= old=%u\n",
count,


sum_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2)
),

sum_levels(
vbuf0, 
vbuf1,
vbuf2
)

);

fprintf(stderr,
"\noldvtx: v0=0x%x, v1=0x%x, v2=0x%x",
vbuf0,
vbuf1,
vbuf2
);
fprintf(stderr,
"\nnewvtx: v0=0x%x, v1=0x%x, v2=0x%x",
read_store_vertex(p, 0), 
read_store_vertex(p, 1),
read_store_vertex(p, 2)
);

exit (1);

}
else  /*  ok */
{
vbuf0 = (void *) read_store_vertex(p, 0);
vbuf1 = (void *) read_store_vertex(p, 1);
vbuf2 = (void *) read_store_vertex(p, 2);

}

#endif


#if (dbg_flag > 2000)
if (count > threshold)
{   /* then  */
 printf(
"\nifte_r_step:%d: ckp 123: (end with terminal case): vertex_3 = 0x%x", 
count, read_store_vertex(p, 3)
);

if (read_store_vertex(p, 3) == (unsigned int) NULL)
/* error  */
{
  printf("\nERROR: read_store_vertex(p, 3) == NULL");
  exit (1000);
}
}  /* end then  */
#endif

/*  
(ptrvertex) read_store_vertex(p, 3) may be a 
terminal or a nonterminal vertex.
*/
/* No need to lock  */


#if (dbg_flag > 5000)
if (
read_store_vertex(p, 3) == 
(unsigned int) read_vertex_next((ptrvertex) read_store_vertex(p, 3), 0)
   )
then  /* error  */
   {
    printf("\n\n*********************************************************");
    printf("\nifte_r_step: %d:  ERROR: LOOP in v_3: ckp 1001", count);
    printf("\n*********************************************************");
   }
if (
(ptrvertex) read_store_vertex(p, 3) == NULL
   )
then  /* error  */
   {
    printf("\n\n*********************************************************");
    printf("\nifte_r_step: %d:  ERROR: v_3 == NULL : ckp 1002", count);
    printf("\n*********************************************************");
   }
#endif

#if (dbg_flag == 11)
if (count > threshold)
{
printf(
"\nifte_r_step:%d: ckp 10013: T case: dv br (rstr + filter) = %u, out vtx = 0x%x", 
count, read_store_dvindex(p, 2), read_store_vertex(p, 3)
);

#if 0
printf(
"\nbroad (restriction) = %d, broad (terminal) = %d, result broad = %d", 
vindex_broad, 
read_store_dvindex(p, 2),
vindex_broad + read_store_dvindex(p, 2)
);
#endif
}
#endif


#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )

#if (dbg_verbose > 10)
fprintf(stderr, 
"\nifte_r_step:%d: return terminal case", count);

fprintf(stderr, 
"\np = 0x%x, v_0 = 0x%x, v_1 = 0x%x, v_2 = 0x%x, v_3 = 0x%x", 
p,
read_store_vertex(p, 0),
read_store_vertex(p, 1),
read_store_vertex(p, 2),
read_store_vertex(p, 3)
);
#endif


#if (dbg_verbose > 100)
print_vertex_level(stderr, (void *) read_store_vertex(p, 3));
#endif



if ( ck_vertex_level((void *) read_store_vertex(p, 3)) == 0)
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: error: terminal ck1 loop in levels\n",
count
);
exit (1);
}

if ( ck2_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
(void *) read_store_vertex(p, 3)
) == 0
   )
{
fprintf(stderr, 
"\nifte_r_step:%d: error: terminal ck2 loop in levels\n",
count
);
exit (1);
}


#endif






                  return;
                }






#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )

#if 0
/* check levels */
if (
ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
vbuf0, 
vbuf1,
vbuf2
) != 0
   )
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: nonterminal: level warning/error: new=%u <= old=%u\n",
count,


sum_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2)
),

sum_levels(
vbuf0, 
vbuf1,
vbuf2
)

);


fprintf(stderr,
"\noldvtx: v0=0x%x, v1=0x%x, v2=0x%x",
vbuf0,
vbuf1,
vbuf2
);
fprintf(stderr,
"\nnewvtx: v0=0x%x, v1=0x%x, v2=0x%x",
read_store_vertex(p, 0), 
read_store_vertex(p, 1),
read_store_vertex(p, 2)
);

/* exit (1); */

}
#endif


/* ok */
vbuf0 = (void *) read_store_vertex(p, 0);
vbuf1 = (void *) read_store_vertex(p, 1);
vbuf2 = (void *) read_store_vertex(p, 2);


#endif





/*   
**  p contains state in nf (computed by ifte_terminal_case) 
**  restriction in nf
*/

/* 
**  We are not in a terminal case thus at least one input graph 
**  is nonterminal.
*/

#if (dbg_flag == 11)
if (count > threshold)
{
printf(
"\nifte_r_step:%d: ckp 10014: (nonterminal) dv br (restriction + filter) = %u", 
count, read_store_dvindex(p, 2)
);
}
#endif


#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 200\n", count);
}
#endif



#if (dbg_test > 100) 
/* store restriction switch after terminal filter */  
tester[3] = read_store_rswitch(p);
/* store vindex after terminal filter */  
tester[4] = read_store_dvindex(p, 2);
#endif



/* store broadcast vindex and reset vindex in store   */

vindex_broad = read_store_dvindex(p, 2);
write_store_dvindex(p, 2, 0);




/*   Try to use look up table   */


   if ( 
         (read_from_cache(p) != NULL )

#if (dbg_cache != 0)
         &&
          0
#endif

      )
   then    
/*  (p) already evaluated, result defined in p via cache */
        {





#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )
/* check levels */
if (
ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
vbuf0, 
vbuf1,
vbuf2
) != 0
   )
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: cache: level error: new=%u <= old=%u\n",
count,


sum_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2)
),

sum_levels(
vbuf0, 
vbuf1,
vbuf2
)

);

fprintf(stderr,
"\noldvtx: v0=0x%x, v1=0x%x, v2=0x%x",
vbuf0,
vbuf1,
vbuf2
);
fprintf(stderr,
"\nnewvtx: v0=0x%x, v1=0x%x, v2=0x%x",
read_store_vertex(p, 0), 
read_store_vertex(p, 1),
read_store_vertex(p, 2)
);

exit (1);

}
else  /*  ok */
{
vbuf0 = (void *) read_store_vertex(p, 0);
vbuf1 = (void *) read_store_vertex(p, 1);
vbuf2 = (void *) read_store_vertex(p, 2);

}

#endif
  



#if (dbg_flag > 2000)
if (count > threshold)
{
 printf(
 "\nifte_r_step:%d: ckp 234: (end with result_via_cache): vertex_3 = 0x%x", 
count, read_store_vertex(p, 3));
}
#endif

/*  Note:  p cannot be as in cache, thus vertex must be locked  */

/*  
(ptrvertex) read_store_vertex(p, 3) may be a 
terminal or a nonterminal vertex.
*/
/* No need to lock  */



#if (dbg_flag > 5000)
if (
read_store_vertex(p, 3) == 
(unsigned int) read_vertex_next((ptrvertex) read_store_vertex(p, 3), 0)
   )
then  /* error  */
   {
    printf("\n\n*********************************************************");
    printf("\nifte_r_step: %d:  ERROR: LOOP in v_3: ckp 2001", count);
    printf("\n*********************************************************");
   }
if (
(ptrvertex) read_store_vertex(p, 3) == NULL
   )
then  /* error  */
   {
    printf("\n\n*********************************************************");
    printf("\nifte_r_step: %d:  ERROR: v_3 == NULL : ckp 2002", count);
    printf("\n*********************************************************");
   }

#endif


#if (dbg_flag == 11)
if (count > threshold)
{
printf(
"\nifte_r_step:%d: ckp 10017: (result from cache), out vtx = 0x%x", 
count, read_store_vertex(p, 3)
);
printf(
"\ndv br (restriction + filter) = %u, dv br (cache) = %u, result dv br  = %u", 
vindex_broad, 
read_store_dvindex(p, 2),
vindex_broad + read_store_dvindex(p, 2)
);
}
#endif


#if (dbg_test > 100) 
/* store vindex from cache */  
tester[5] = read_store_dvindex(p, 2);

/* print info  */
if (       (tester[0] /*  != 0 , i.e. restriction on  */)
       &&  (tester[2] != tester[4])    
   )
{
   printf("\n\nifte_r_step:%d: result from cache, out vtx = 0x%x = %u", 
count, read_store_vertex(p, 3)
);
   printf("\nvindex before restriction: %u", tester[1]);
   printf("\nrswitch after restriction: %u", tester[1]);
   printf("\nvindex after restriction: %u", tester[2]);
   printf("\nrswitch after filter: %u", tester[3]);
   printf("\nvindex after filter: %u", tester[4]);
   printf("\nvindex from cache: %u", tester[5]);
   printf("\nvindex_broad: %u (== vindex after filter)", vindex_broad);
   printf("\nvindex output: %u", 
         vindex_broad + read_store_dvindex(p, 2));


}

#endif



/*   Update broadcast   */
/* Note: this does not change value in cache  */

write_store_dvindex(
p, 
2,
vindex_broad + read_store_dvindex(p, 2)
);





#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )


#if (dbg_verbose > 10)
fprintf(stderr, 
"\nifte_r_step:%d: return from cache", count);

fprintf(stderr, 
"\np = 0x%x, v_0 = 0x%x, v_1 = 0x%x, v_2 = 0x%x, v_3 = 0x%x", 
p,
read_store_vertex(p, 0),
read_store_vertex(p, 1),
read_store_vertex(p, 2),
read_store_vertex(p, 3)
);
#endif

#if (dbg_verbose > 100)
print_vertex_level(stderr, (void *) read_store_vertex(p, 3));
#endif


if ( ck_vertex_level((void *) read_store_vertex(p, 3)) == 0)
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: error: cache ck1 loop in levels\n",
count
);
exit (1);
}


#if 0
if ( ck2_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
(void *) read_store_vertex(p, 3)
) == 0
   )
{
fprintf(stderr, 
"\nifte_r_step:%d: error: cache ck2 loop in levels\n",
count
);
exit (1);
}
#endif


#endif




         return ;
         
        }
   








#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )
/* check levels */
if (
ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
vbuf0, 
vbuf1,
vbuf2
) != 0
   )
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: noncache: level error: new=%u <= old=%u\n",
count,


sum_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2)
),

sum_levels(
vbuf0, 
vbuf1,
vbuf2
)

);

fprintf(stderr,
"\noldvtx: v0=0x%x, v1=0x%x, v2=0x%x",
vbuf0,
vbuf1,
vbuf2
);
fprintf(stderr,
"\nnewvtx: v0=0x%x, v1=0x%x, v2=0x%x",
read_store_vertex(p, 0), 
read_store_vertex(p, 1),
read_store_vertex(p, 2)
);

exit (1);

}
else  /*  ok */
{
vbuf0 = (void *) read_store_vertex(p, 0);
vbuf1 = (void *) read_store_vertex(p, 1);
vbuf2 = (void *) read_store_vertex(p, 2);

}

#endif
  



#if (dbg_flag > 2000)
if (count > threshold)
{
 printf(
 "\nifte_r_step:%d: ckp 300 (result nonterminal and not known via cache)\n", count);
}
#endif

/*  p not already evaluated or not known via look up table  */




  /*   create nonterminal vertex and evaluate further down 
        (note that at least one input vertex is a nonterminal here.
  */
         

/*  define next state  */

/* create stores for next states  */

        new_p_0 = get_new_bdd_store();

        new_p_1 = get_new_bdd_store();

#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 400\n", count);
}
#endif

        define_r_sons(p, new_p_0, new_p_1);


#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 500: p = 0x%x, read_store_vertex(p, 3) = 0x%x = %u", 
count,
p,
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);
 printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u\n", 
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);

}
#endif

         lock_bdd_store(new_p_0);

#if (dbg_loop > 1050)
vindex_offset = ((unsigned int *) read_store_vertex(p, 3))[0] ;
#endif

#if (dbg_flag > 0)
call_buf = count_buf + 1;
#endif


#if (dbg_flag > 200)
if (count > threshold)
{
 fprintf(stderr,
"\nifte_r_step:%d:%u: call_0 ifte_r_step:%d:%u", 
count, 
ifter_depth,
call_buf,
ifter_depth + 1
);
}
#endif

#if (dbg_loop > 0)   
ifter_depth++;
#endif 

#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )

#if (dbg_verbose != 0)
fprintf(stderr, 
"\nifte_r_step:%d: sum levels: p = %u, new_p_0 = %u",
count,
read_extra_info_gvtx((void *) read_store_vertex(p, 0), gvtx_level)
+ read_extra_info_gvtx((void *) read_store_vertex(p, 1), gvtx_level) 
+ read_extra_info_gvtx((void *) read_store_vertex(p, 2), gvtx_level),
read_extra_info_gvtx((void *) read_store_vertex(new_p_0, 0), gvtx_level) 
+ read_extra_info_gvtx((void *) read_store_vertex(new_p_0, 1), gvtx_level) 
+ read_extra_info_gvtx((void *) read_store_vertex(new_p_0, 2), gvtx_level)
);
#endif


if ( ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
(void *) read_store_vertex(new_p_0, 0),
(void *) read_store_vertex(new_p_0, 1),
(void *) read_store_vertex(new_p_0, 2)
) == 0
   )
{
fprintf(stderr, 
"\nifte_r_step:%d: level error in new_p_0\n",
count
);
exit (1);
}
#endif


         ifte_r_step(new_p_0);

#if (dbg_loop > 0)   
ifter_depth--;
#endif 


#if (dbg_flag > 200)
if (count > threshold)
{
 fprintf(stderr,
"\nifte_r_step:%d:%u: return_0 from: ifte_r_step:%d:%u", 
count, 
ifter_depth,
call_buf,
ifter_depth + 1
);
}
#endif


#if (dbg_loop > 1050)
last_min_vindex = present_min_vindex;
#endif


/*   lock bdd vertex  (nonterminal as well as terminal)  */

       lock_bdd_vertex((ptrvertex) read_store_vertex(new_p_0, 3));



#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 600: p = 0x%x, read_store_vertex(p, 3) = 0x%x = %u", 
count,
p,
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);
 printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u\n", 
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);

}
#endif


         lock_bdd_store(new_p_1);



#if (dbg_loop > 1050)
vindex_offset = ((unsigned int *) read_store_vertex(p, 3))[1];
#endif



#if (dbg_flag > 0)
call_buf = count_buf + 1;
#endif

#if (dbg_flag > 200)
if (count > threshold)
{
 fprintf(stderr,
"\nifte_r_step:%d:%u:  call_1 ifte_r_step:%d:%u", 
count, 
ifter_depth,
call_buf,
ifter_depth + 1
);
}
#endif


#if (dbg_loop > 0)   
ifter_depth++;
#endif 


#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )

#if (dbg_verbose != 0)
fprintf(stderr, 
"\nifte_r_step:%d: sum levels: p = %u, new_p_1 = %u",
count,
read_extra_info_gvtx((void *) read_store_vertex(p, 0), gvtx_level)
+ read_extra_info_gvtx((void *) read_store_vertex(p, 1), gvtx_level) 
+ read_extra_info_gvtx((void *) read_store_vertex(p, 2), gvtx_level),
read_extra_info_gvtx((void *) read_store_vertex(new_p_1, 0), gvtx_level) 
+ read_extra_info_gvtx((void *) read_store_vertex(new_p_1, 1), gvtx_level) 
+ read_extra_info_gvtx((void *) read_store_vertex(new_p_1, 2), gvtx_level)
);
#endif


if ( ck3_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
(void *) read_store_vertex(new_p_1, 0),
(void *) read_store_vertex(new_p_1, 1),
(void *) read_store_vertex(new_p_1, 2)
) == 0
   )
{
fprintf(stderr, 
"\nifte_r_step:%d: level error in new_p_1\n",
count
);
exit (1);
}
#endif

         ifte_r_step(new_p_1);


#if (dbg_loop > 0)   
ifter_depth--;
#endif 



#if (dbg_flag > 200)
if (count > threshold)
{
 fprintf(stderr,
"\nifte_r_step:%d:%u:  return_1 from: ifte_r_step:%d:%u", 
count, 
ifter_depth,
call_buf,
ifter_depth + 1
);
}
#endif



#if (dbg_loop > 1050)
last_min_vindex = present_min_vindex;
#endif


/*   lock bdd vertex  (nonterminal as well as terminal)  */

        lock_bdd_vertex((ptrvertex) read_store_vertex(new_p_1, 3));


#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 700: p = 0x%x, read_store_vertex(p, 3) = 0x%x = %u", 
count,
p,
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);
 printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u\n", 
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);


}
#endif


/* define root shifts in store_vertex(p), store_flip(p)   */

        define_r_root_shifts(p, new_p_0, new_p_1);


#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 800: p = 0x%x, read_store_vertex(p, 3) = 0x%x = %u", 
count,
p,
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);
 printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u\n", 
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);

}
#endif

          
/*  do_1_reductions, 
**  i.e. get rid of redundant vertices and adjust 
**  swaps and shifts accordingly
*/



        if (! root_is_1_redex(p, new_p_0, new_p_1))
        then  /* root is not a 1-redex  */
           {

#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1000 (root no 1-redex) \n", count);
}
#endif

                    ifte_r_non_1_red(p, new_p_0, new_p_1);


/*   Note: 
     (ptrvertex) read_store_vertex(p, 3) is nonterminal vertex. 
*/
/* No need to lock  read_store_vertex(p, 3) */



#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1100\n", count);
}
#endif

          }

else  /*  root is a 1-redex  */
      {

#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1200 (root 1-redex)\n", count);
}
#endif


                     ifte_r_1_red(p, new_p_0, new_p_1);

/* 
    read_store_vertex(p, 3) may be 
    terminal as well as nonterminal   
*/
/* No need to lock  read_store_vertex(p, 3)   */






#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1300\n", count);
}
#endif

      }


/* store result ifter_step   */

store_result_in_cache(p, vindex_broad);

/*  result defined  */





/*   unlock bdd vertex   */

#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1520: unlock bdd vertex (new_p_0, 3) = 0x%x\n", 
count,
read_store_vertex(new_p_0, 3) 
);
}
#endif


  unlock_bdd_vertex((ptrvertex) read_store_vertex(new_p_0, 3));




/*   unlock store   */


#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1500: unlock-free store new_p_0 = 0x%x\n", 
count,
new_p_0 
);
}
#endif




unlock_free_store(new_p_0);


/*   unlock bdd vertex   */


#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1560: unlock bdd vertex (new_p_1, 3) = 0x%x\n", 
count,
read_store_vertex(new_p_1, 3) 
);
}
#endif

  unlock_bdd_vertex((ptrvertex) read_store_vertex(new_p_1, 3));




/* unlock store */

#if (dbg_flag > 3000)
if (count > threshold)
{
 printf("\nifte_r_step:%d: ckp 1540: unlock-free store new_p_ = 0x%x\n", 
count,
new_p_1
);
}
#endif

unlock_free_store(new_p_1);





#if (dbg_flag > 2000)
if (count > threshold)
{
 printf(
 "\nifte_r_step:%d: ckp 8000 (end: nonterminal, noncache): vertex_3 = 0x%x", 
count, read_store_vertex(p, 3));
}
#endif


#if (dbg_flag > 5000)
if (
read_store_vertex(p, 3) == 
(unsigned int) read_vertex_next((ptrvertex) read_store_vertex(p, 3), 0)
   )
then  /* error  */
   {
    printf("\n\n*********************************************************");
    printf("\nifte_r_step: %d:  ERROR: LOOP in v_3: ckp 3001", count);
    printf("\n*********************************************************");
   }
if (
(ptrvertex) read_store_vertex(p, 3) == NULL
   )
then  /* error  */
   {
    printf("\n\n*********************************************************");
    printf("\nifte_r_step: %d:  ERROR: v_3 == NULL : ckp 3002", count);
    printf("\n*********************************************************");
   }

#endif

#if (dbg_flag == 11)
if (count > threshold)
{
printf(
"\nifte_r_step:%d: ckp 10020: (computed result), out vtx = 0x%x", 
count, read_store_vertex(p, 3)
);
printf(
"\ndv br (restriction + filter) = %u, dv br (computed) = %u, result dv br = %u", 
vindex_broad, 
read_store_dvindex(p, 2),
vindex_broad + read_store_dvindex(p, 2)
);
}
#endif

/* adjust vindex broadcast    */

		write_store_dvindex(
		p, 
		2,
		vindex_broad + read_store_dvindex(p, 2)
		);








#if ( (dbg_flag > 1000) && (use_extra_gvtx_info != 0) )

#if (dbg_verbose > 10)
fprintf(stderr, 
"\nifte_r_step:%d: return from recursion", count);

fprintf(stderr, 
"\np = 0x%x, v_0 = 0x%x, v_1 = 0x%x, v_2 = 0x%x, v_3 = 0x%x", 
p,
read_store_vertex(p, 0),
read_store_vertex(p, 1),
read_store_vertex(p, 2),
read_store_vertex(p, 3)
);
#endif


#if (dbg_verbose > 100)
print_vertex_level(stderr, (void *) read_store_vertex(p, 3));
#endif


if ( ck_vertex_level((void *) read_store_vertex(p, 3)) == 0)
/* error */
{
fprintf(stderr, 
"\nifte_r_step:%d: error: recursion ck1 loop in levels\n",
count
);
exit (1);
}

#if 0
if ( ck2_vtx_levels(
(void *) read_store_vertex(p, 0), 
(void *) read_store_vertex(p, 1),
(void *) read_store_vertex(p, 2),
(void *) read_store_vertex(p, 3)
)  == 0
   )
{
fprintf(stderr, 
"\nifte_r_step:%d: error: recursion ck2 loop in levels\n",
count
);
exit (1);
}
#endif


#endif





         return;

}   /*  end program  */


