/*
************************************************************
file:  local.h

************************************************************
*/



#include "ifter.h"
#include "bddstore.h"
#include "bddvtx.h"
#include "mathbdd.h"
#include "cache.h"


/* max index for variables   */
#define VINDX_TERMINAL UINT_MAX       


/* if > 1050 check for loops in ifter_step  */
#define dbg_loop  0  /* normal value: 0  */

    


#if (dbg_loop > 1050)
extern unsigned int last_min_vindex;
extern unsigned int where_min_vindex;
extern unsigned int vindex_offset;
extern unsigned int ifter_depth;
#endif




void define_next_dvindex(
type_bdd_store new_p, 
unsigned int new_vindex[3]
);


void define_root_shifts(
type_bdd_store p, 
type_bdd_store new_p_0, 
type_bdd_store new_p_1
);


void define_sons(
type_bdd_store p, 
type_bdd_store p_new_0, 
type_bdd_store p_new_1
);


int filter_state_step(type_bdd_store p);
void filter_state_0(type_bdd_store p);


void ifte_1_red(
type_bdd_store p, 
type_bdd_store new_p_0, 
type_bdd_store new_p_1
);


void ifte_non_1_red(
type_bdd_store p,
type_bdd_store new_p_0,
type_bdd_store new_p_1
);

void ifte_step(type_bdd_store p);


int ifte_terminal_case(type_bdd_store p);
int ifte_tc_step(type_bdd_store p);



void next_state(
int j, 
int i, 
type_bdd_store p, 
type_bdd_store p_new,
unsigned int new_vindex[2][3],
unsigned int vindex_G[3]
);


int result_via_cache(type_bdd_store p);

int root_is_1_redex(
type_bdd_store p,
type_bdd_store new_p_0,
type_bdd_store new_p_1
);

void same_next_state(
int i,
type_bdd_store p,
type_bdd_store new_p,
unsigned int new_vindex[3],
unsigned int old_vindex[3]
);


void store_ifte_step_result(
type_bdd_store p
);


void filter_r_state_0(type_bdd_store p);

int filter_r_state_step(type_bdd_store p);

void ifte_r_step(type_bdd_store p);

int ifte_r_terminal_case(type_bdd_store p);

int ifte_r_tc_step(type_bdd_store p);

void restriction_nf(type_bdd_store p);

void restriction(type_bdd_store p);

void restriction_step(type_bdd_store p);


void do_restriction(
type_bdd_store p,
unsigned int vindex_G[3],
unsigned int ifte_branch   /* = ifte branch for restriciton = 1, 2  */
);


void define_next_r_dv(
type_bdd_store p, 
unsigned int vindex_G[4],
type_bdd_store new_p_0, 
type_bdd_store new_p_1, 
unsigned int new_vindex[2][3]
);


void define_r_sons(
type_bdd_store p, 
type_bdd_store p_new_0, 
type_bdd_store p_new_1
);


void define_r_root_shifts(
type_bdd_store p, 
type_bdd_store new_p_0, 
type_bdd_store new_p_1
);


void ifte_r_non_1_red(
type_bdd_store p,
type_bdd_store new_p_0,
type_bdd_store new_p_1
);


void ifte_r_1_red(
type_bdd_store p, 
type_bdd_store new_p_0, 
type_bdd_store new_p_1
);

type_bdd_store get_graph_r_store(
bdd G0, 
bdd G1, 
bdd G2,
unsigned int i,
unsigned int rbit,
unsigned int rswitch
);



void update_store_dvindex(type_bdd_store p);


void put_newdvindex_store(
type_bdd_store p,
unsigned int vindex[3]
);


void restriction_nf_vindex(
type_bdd_store p, 
unsigned int vindex[3]
);



int to_be_stored(type_bdd_store p);

/*  in:  get_graph_r_store   */
void get_vindexes_store(
type_bdd_store p,
unsigned int *vindex
);

void copy_bdd_store(type_bdd_store q, type_bdd_store p);

void store_result_in_cache(type_bdd_store p, unsigned int vindex);


