                               
/*
********************************************************
file:  next_state
********************************************************
*/


/*
********************************************************
Defines next state from p in p_new;
stores assumed already existing.
********************************************************
*/


#include "local.h"

#define then  /* then */


#define dbg_new_virtual_index 0







void next_state(
int j, 
int i, 
type_bdd_store p, 
type_bdd_store p_new,
unsigned int new_vindex[2][3],
unsigned int vindex_G[3]
)

/*
**  j = 0, 1;
**  i = 0, 1, 2;
*/

{  /* begin  */

  /*  declarations  */
 
 int side;

#if dbg0_next_state
static int count = 0;
#endif



   /*  program  */

#if dbg0_next_state
     count++;
#endif

/* use present p_swap to compute side  */
side = (j + read_store_p_swap(p, i))%2;

#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 100\n", count);
#endif

/* read_store_vertex(p, i) is nonterminal */

/*  compute new vertex */

write_store_vertex(
p_new, 
i, 
(unsigned int) read_vertex_next(
(ptrvertex) read_store_vertex(p, i), 
side 
                )
);


#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 200\n", count);
#endif


/*   compute new p_flip   */

  if (side == 0)
  then /* no updating for p_flip  */
          write_store_p_flip(p_new, i, read_store_p_flip(p, i));
  else  /* updating for p_flip  */
          write_store_p_flip(
p_new, 
i, 
(read_store_p_flip(p, i) + read_store_flip(p, i))%2
                            );
 


#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 300\n", count);
#endif

#if dbg5_next_state
if ( terminal ((ptrvertex) read_store_vertex(p, i))  )
then
    {
printf("\nnext_state: %d: ckp: 350:\n", count);
printf("\nerror: read_store_vertex(0x%x, %d) is a terminal vertex \n",
p,
i
);
    }
#endif


/*  define new virtual index, p_swap, flip  */

      if ( 
terminal(
               read_vertex_next(
                                 (ptrvertex) read_store_vertex(p, i), 
                                  side
                               )
              )
           )
          then  /*  vv[i] -> next is a terminal vertex  */
              {
               
/*  compute new virtual index  */

#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 400\n", count);
#endif
                   new_vindex[j][i] = VINDX_TERMINAL; 

/* Compute new p_swap  */
 
write_store_p_swap(
p_new, 
i, 
0u
);

#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 500\n", count);
#endif


/*  compute new flip  */

write_store_flip(
p_new, 
i, 
0
);

#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 600\n", count);
#endif

 
             }
          else  /*  vv[i] -> next[side[i][j]]  nonterminal  */

               {
                
#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 700\n", count);
#endif


/*  compute new virtual index  */

                new_vindex[j][i] = 
vindex_G[i]
+ read_vertex_shift(
                      (ptrvertex) read_store_vertex(p, i), 
                      side
                   )
+ 1;

#if (dbg_new_virtual_index > 10)
 printf(
 "\nnext_state: ckp: 710: info on new virtual index for vertex 0x%x:", 
     read_vertex_next( (ptrvertex) read_store_vertex(p, i),  side));
     
 printf(
"\nvindex_G[%d] = %u; read_vertex_shift(0x%x, %d) = %u; new_vindex[%d][%d] = %u",
i, 
vindex_G[i], 
read_store_vertex(p, i), 
side,
read_vertex_shift((ptrvertex) read_store_vertex(p, i), side),
j,
i,
new_vindex[j][i]);
#endif

#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 800\n", count);
#endif

/* Compute new p_swap  */

write_store_p_swap(
p_new, 
i, 
(
  read_vertex_swap((ptrvertex) read_store_vertex(p, i), side) 
  + read_store_p_swap(p, i)
)%2
);

#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 900\n", count);
#endif


/*  compute new flip  */

write_store_flip(
p_new, 
i, 
read_vertex_flip((ptrvertex) read_store_vertex(p, i), side) 
);


#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 1000\n", count);
#endif


#if dbg10_next_state
if (new_vindex[j][i] > 100)
then
     {

printf("\n****next_state: %d: new_vindex[%d][%d] = %d, vindex_G[%d] = %d, shift = %d\n",
count,
j,
i,
new_vindex[j][i],
i,
vindex_G[i],
read_vertex_shift(
                      (ptrvertex) read_store_vertex(p, i), 
                      (j + read_store_p_swap(p, i))%2
                   )
);

      }
#endif
                      
              }   /*  end else  */


#if dbg5_next_state
 printf("\nnext_state: %d: ckp: 1100\n", count);
#endif


}  /*  end program  */

