/*
*************************************************
file:  get_graph_store
*************************************************
*/


#include "local.h"

#define dbg_get_graph_r_store 0
#define dbg1_get_graph_r_store 0
#define dbg2_get_graph_r_store 0





type_bdd_store get_graph_r_store(
bdd G0, 
bdd G1, 
bdd G2,
unsigned int i,
unsigned int rbit,
unsigned int rswitch
)

{  /* begin program  */

/* declarations  */
type_bdd_store p;
unsigned int label[4];
unsigned int ifte_vindex[3];

#if dbg_get_graph_r_store
static int count = 0;
#endif

/*  program  */

#if dbg_get_graph_r_store
count++;
#endif

#if dbg1_get_graph_r_store
printf("\nget_graph_r_store:%d: ckp 10 (begin)", count);
#endif

p = get_new_bdd_store();

#if dbg1_get_graph_r_store
printf("\nget_graph_r_store:%d: ckp 20: store p = 0x%x", 
count, p);
#endif


/* define input vertices  */

write_store_vertex(p, 0, (unsigned int) read_graph_root(G0));
write_store_vertex(p, 1, (unsigned int) read_graph_root(G1));
write_store_vertex(p, 2, (unsigned int) read_graph_root(G2));


/* define input p_swap  */

write_store_p_swap(p, 0, read_graph_p_swap(G0));
write_store_p_swap(p, 1, read_graph_p_swap(G1));
write_store_p_swap(p, 2, read_graph_p_swap(G2));


/* define input p_flip  */

write_store_p_flip(p, 0, read_graph_p_flip(G0));
write_store_p_flip(p, 1, read_graph_p_flip(G1));
write_store_p_flip(p, 2, read_graph_p_flip(G2));


/* define input flip  */

write_store_flip(p, 0, read_graph_flip(G0));
write_store_flip(p, 1, read_graph_flip(G1));
write_store_flip(p, 2, read_graph_flip(G2));


/* define input dv_sgn, dvindex  */

if ( terminal((ptrvertex) read_store_vertex(p, 0)) )
/* then */  ifte_vindex[0] = VINDX_TERMINAL;
else ifte_vindex[0] = read_graph_vindex(G0);

if ( terminal((ptrvertex) read_store_vertex(p, 1)) )
/* then */  ifte_vindex[1] = VINDX_TERMINAL;
else ifte_vindex[1] = read_graph_vindex(G1);

if ( terminal((ptrvertex) read_store_vertex(p, 2)) )
/* then */  ifte_vindex[2] = VINDX_TERMINAL;
else ifte_vindex[2] = read_graph_vindex(G2);


def_d_vindex(
ifte_vindex[0],
ifte_vindex[1],
ifte_vindex[2],
&(label[0]),   /*  dvindex_0  */
&(label[1]),   /*  dvindex_1  */
&(label[2]),   /*  dv_sgn_0  */
&(label[3])    /*  dv_sgn_1  */
);


write_store_dvindex(p, 0, label[0]);
write_store_dvindex(p, 1, label[1]);
write_store_dv_sgn(p, 0, label[2]);
write_store_dv_sgn(p, 1, label[3]);



/*  define restriciton parameters  */


if 
( 
   rswitch   /* !=  0  */
   
&& (   (ifte_vindex[1] <= i)
    || (ifte_vindex[2] <= i)
   )
)
/* then */ 
         {
           write_store_rbit(p, rbit);
           write_store_rswitch(p, rswitch);

def_dv_sgn(
ifte_vindex[0], 
i,
&(label[0]),   /*  rdvindex  */
&(label[1])   /*  rsgn  */
);

write_store_rdvindex(p, label[0]);
write_store_rsgn(p, label[1]);
        }
else  /*  no restriction  */
       {
           write_store_rbit(p, 0);
           write_store_rswitch(p, 0);
           write_store_rdvindex(p, 0);
           write_store_rsgn(p, 0);
       }

#if dbg2_get_graph_r_store
if (read_store_rswitch(p)  /*  !=  0  */)
/* then */  printf("\nget_graph_r_store: %d: read_store_rswitch(0x%x) = 0x%x\n",
count,
p,
read_store_rswitch(p)
);
#endif


#if dbg1_get_graph_r_store
printf("\nget_graph_r_store:%d: return p = 0x%x\n", count, p);
#endif

return (p);



}   /*  end program  */




int lessthan_dv(
unsigned int dvsgn1,
unsigned int dvindex1,
unsigned int dvsgn2,
unsigned int dvindex2
)
/*
**  return true iff (dvsgn1, dvindex1) < (dvsgn2, dvindex2)
**
*/
{  /*  begin  */

if ( dvsgn1 == 0 )
/* then */   /*  dvsgn1 == 0  */
    {
      if (dvsgn2 == 0)
      /* then */   /*  dvsgn1 == 0 and dvsgn2 == 0  */
          {
             if (dvindex1 < dvindex2)
             /* then */  return (1);
             else return (0);
          }
      else  /*  dvsgn1 == 0 and dvsgn2 == 1  */
          {  /*  v2 < v0 <= v1  */
            return (0);
          }
            
    } 
else  /*  dvsgn == 1  */
     {
      if (dvsgn2 == 0)
      /* then */   /*  dvsgn1 == 1 and dvsgn2 == 0  */
          {   /*  v1 < v0 <= v2  */
              return (1);
          }
      else  /*  dvsgn1 == 1 and dvsgn2 == 1  */
          {  
            if (dvindex1 > dvindex2)
            /* then */  return (1);
            else return (0);
          }
     }
     


}  /* end  */





/*
*************************
Define vindexes and restriction index from store
*************************
*/


void get_vindexes_store(
type_bdd_store p,
unsigned int *vindex
)
{

def_vindex(
read_store_dvindex(p, 0),
read_store_dvindex(p, 1),
read_store_dv_sgn(p, 0),
read_store_dv_sgn(p, 1),
&(vindex[0]),
&(vindex[1]),
&(vindex[2])
);

/* Compute rvindex. */
if ( read_store_rswitch(p)  /* != 0 */ )
/* then */
    {
       if ( read_store_rsgn(p) /* != 0 */)
       /* then */
          {
            vindex[3] = vindex[0] - read_store_rdvindex(p);
          }
       else /* read_store_rsgn(p) == 0 */
            vindex[3] = vindex[0] + read_store_rdvindex(p);
    }
else 
	{
	   vindex[3] = 0; 
	}
	
/* 
Note: 
if read_store_rswitch(p) == 0 then
no restriction takes place. 
Thus all restriction parameters are 0 and will stay 0. 
*/



/* Update vindex. */

if ( terminal( (ptrvertex) read_store_vertex(p, 0)) ) vindex[0] = VINDX_TERMINAL;
if ( terminal( (ptrvertex) read_store_vertex(p, 1)) ) vindex[1] = VINDX_TERMINAL;
if ( terminal( (ptrvertex) read_store_vertex(p, 2)) ) vindex[2] = VINDX_TERMINAL;




}   /*  end program  */

