/*
*****************************************************
file:  define_root_shifts
*****************************************************
*/

/*
**  defines root shifts 
**
*/


#include "local.h"

#define dbg_flag 0  /* normal value: 0  */
#define threshold 0     /* begin dbg printing  */


#define then /* then */

/*
*************************************
HYP:
read_store_vertex(p, 3) = head_vindex_0 - min_vindex ( > 0 )
read_store_dvindex(p, 2) = head_vindex_1 - min_vindex  ( > 0 ).
*************************************
*/




void define_r_root_shifts(
type_bdd_store p, 
type_bdd_store new_p_0, 
type_bdd_store new_p_1
)

{  /*  begin define_root_shifts */

/*  declarations  */
unsigned int *shift_values;


#if (dbg_flag > 0)
static unsigned int count = 0;
#endif

/*  program  */


#if (dbg_flag > 100)
count++;
if (count > threshold)
{
 printf("\ndefine_r_root_shifts:%d: ckp 100: p = 0x%x, new_p_0 = 0x%x, new_p_1 = 0x%x",
count,
p,
new_p_0,
new_p_1
);

printf("\nshift_values = read_store_vertex(p, 3) = 0x%x = %u", 
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);

printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u", 
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);

printf("\nread_store_dvindex(new_p_0, 2) = %u, read_store_dvindex(new_p_1, 2) = %u", 
read_store_dvindex(new_p_0, 2),
read_store_dvindex(new_p_1, 2)
);

}
#endif






shift_values = (unsigned int *) read_store_vertex(p, 3);


/* 
**   compute shift for root result and define vv_aux
*/

  
               if ( nonterminal((ptrvertex) read_store_vertex(new_p_0, 3)) )
                then 
                     {

/* In this case shift_values[0] < UINT_MAX  */

shift_values[0] = 
  (shift_values[0]
  + read_store_dvindex(new_p_0, 2))
  - 1;



                     }
                else /*  read_store_vertex(new_p_0, 3) terminal  */
                     {


shift_values[0] = 0;


                      }


              if ( nonterminal((ptrvertex) read_store_vertex(new_p_1, 3)) )
                then 
                     {

/* In this case shift_values[1] < UNIT_MAX  */


shift_values[1] = 
    (shift_values[1]
    + read_store_dvindex(new_p_1, 2))
    - 1;



                     }
                else /*  read_store_vertex(new_p_1, 3) terminal  */
                     {

shift_values[1] = 0 ;

                     }


/*  stored root shifts in store_vertex(p, 3)  */





#if (dbg_flag > 100)
if (count > threshold)
{
 printf("\ndefine_r_root_shifts:%d: ckp 2000: p = 0x%x, new_p_0 = 0x%x, new_p_1 = 0x%x",
count,
p,
new_p_0,
new_p_1
);

printf("\nshift_values = read_store_vertex(p, 3) = 0x%x = %u", 
read_store_vertex(p, 3),
read_store_vertex(p, 3)
);

printf("\nshift[0] = 0x%x = %u, shift[1] = 0x%x = %u\n", 
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[0],
((unsigned int *) read_store_vertex(p, 3))[1],
((unsigned int *) read_store_vertex(p, 3))[1]
);

}
#endif


}  /*  end define_root_shifts */

