
/*
**  file: store_ifte_result
**
**
*/


#include "local.h"

#define dbg_flag 0       /*  normal value: 0 */
#define dbg_cs 0         /* This MUST be 0, unless dbg */
#define dbg_tobestrd 0   /* normal value: 0 */

#define then /* then */




static void lock_all_store_vtx(type_bdd_store q);

static void unlock_all_store_vtx(type_bdd_store q);





void store_ifte_step_result(
type_bdd_store p
)
/*
**  store result from ifte_step computation
**
**
*/
{

/* declarations */

type_bdd_store old_value;

#if dbg0_store_ifte
static int count = 0;
#endif

/*  program */


#if dbg0_store_ifte
count++;

if (count%PR_res_INFO == 0)
then  /*  print info  */
    {
      printf("\n\n***store_ifte_step_result called %d times, info:", count);

      printf("\nsize cache (T_ifte) = %d; elements in cache = %d",
      get_cache_size(T_ifte), get_cache_elements(T_ifte));

/* count > 0  */
      printf("\n(elemtents in cache)/(storing req) = %d\n",
      get_cache_elements(T_ifte)/count);
 
    }

#endif

 
/*  store result ifte_step  */

old_value = write_into_cache(p);

lock_bdd_store(p);
lock_all_store_vtx(p);


if (old_value != NULL)  
then  /*  this implies that old_value != p, since tested read_cache  */
    {
       /*  try to free space   */

unlock_all_store_vtx(old_value);

unlock_free_store(old_value);


    }

}  /*  end program */






/* copy store p into store q  */

void copy_bdd_store(type_bdd_store q, type_bdd_store p)
{

/* copy p into q  */
write_store_vertex(q, 0, read_store_vertex(p, 0));
write_store_vertex(q, 1, read_store_vertex(p, 1));
write_store_vertex(q, 2, read_store_vertex(p, 2));
write_store_vertex(q, 3, read_store_vertex(p, 3));

write_store_p_swap(q, 0, read_store_p_swap(p, 0));
write_store_p_swap(q, 1, read_store_p_swap(p, 1));
write_store_p_swap(q, 2, read_store_p_swap(p, 2));
write_store_p_swap(q, 3, read_store_p_swap(p, 3));

write_store_p_flip(q, 0, read_store_p_flip(p, 0));
write_store_p_flip(q, 1, read_store_p_flip(p, 1));
write_store_p_flip(q, 2, read_store_p_flip(p, 2));
write_store_p_flip(q, 3, read_store_p_flip(p, 3));

write_store_flip(q, 0, read_store_flip(p, 0));
write_store_flip(q, 1, read_store_flip(p, 1));
write_store_flip(q, 2, read_store_flip(p, 2));
write_store_flip(q, 3, read_store_flip(p, 3));

write_store_dvindex(q, 0, read_store_dvindex(p, 0));
write_store_dvindex(q, 1, read_store_dvindex(p, 1));
write_store_dvindex(q, 2, read_store_dvindex(p, 2));
write_store_dv_sgn(q, 0, read_store_dv_sgn(p, 0));
write_store_dv_sgn(q, 1, read_store_dv_sgn(p, 1));

write_store_rbit(q, read_store_rbit(p));
write_store_rswitch(q, read_store_rswitch(p));
write_store_rdvindex(q, read_store_rdvindex(p));
write_store_rsgn(q, read_store_rsgn(p));



}    /* end program  */




void store_result_in_cache(type_bdd_store p, unsigned int vindex)
{
/* declarations  */
type_bdd_store q;


/*  program  */

#if (dbg_flag > 3000)
 printf("\nstore_result:%d: ckp 100 (begin)\n", count);
#endif

#if (dbg_tobestrd == 0)
if ( to_be_stored(p) )
/* then: store result  */
  {
#endif


if ( (vindex != 0)

#if (dbg_cs !=0)
||
1
#endif
   )

	{
	  	q = get_new_bdd_store();
	  
      	copy_bdd_store(q, p);

/* No need to lock   (ptrvertex) read_store_vertex(q, 3)    */

		
    	store_ifte_step_result(q);

	}
else  /* vindex_broad == 0  */
	{
    	store_ifte_step_result(p);
	}
	

    
    
#if (dbg_tobestrd == 0)   
  }
#endif

}






void lock_all_store_vtx(type_bdd_store q)
{

lock_bdd_vertex((ptrvertex) read_store_vertex(q, 0));

lock_bdd_vertex((ptrvertex) read_store_vertex(q, 1));

lock_bdd_vertex((ptrvertex) read_store_vertex(q, 2));

lock_bdd_vertex((ptrvertex) read_store_vertex(q, 3));

}



void unlock_all_store_vtx(type_bdd_store q)
{

unlock_bdd_vertex((ptrvertex) read_store_vertex(q, 0));

unlock_bdd_vertex((ptrvertex) read_store_vertex(q, 1));

unlock_bdd_vertex((ptrvertex) read_store_vertex(q, 2));

unlock_bdd_vertex((ptrvertex) read_store_vertex(q, 3));

}
