/*
**
**
**  file: ifte_terminal_case
**
**
*/


/*
********************************
filter state and test if we are in a terminal case.
result of filtering in p
***************************************
*/

#include "local.h"

#define dbg0_ifter_terminal 0
#define dbg5_ifter_terminal (dbg0_ifter_terminal && 0x0)

#define then /* then */
#define true 1
#define false 0

int ifte_r_terminal_case(type_bdd_store p)

/*
**   computes filtered state
**   from vindex and state
**
** 
**  HYP:  inifte(F, G0, G1) we can assume:
** 
**  F nonterminal, G0 != G1, at least one of G0, G1 nonterminal 
*/
{    
    /*  declarations  */

#if dbg0_ifter_terminal
static int count = 0;
#endif

#if dbg5_ifter_terminal
int wh_count = 0 ;
#endif


/* program  */

#if dbg0_ifter_terminal
count++;
#endif

/* reducr retriction to nf  */

/*
**  input HYP:  restriction in nf  
*/

/*
**  output :  restriction in nf  
*/

     while ( true )
      {

#if dbg5_ifter_terminal
wh_count++;
printf("\nifte_r_terminal_case: %d; begin while %d ..... ",
count, 
wh_count);
#endif

            if ( ifte_r_tc_step(p) )
            then  /* end with terminal case  */
                   {
#if dbg5_ifter_terminal
printf("end while %d with terminal case: return (true)\n",
wh_count);
#endif

/* Returning from here implies that result well defined  */

#if dbg5_ifter_terminal
if (
read_store_vertex(p, 3) == 
(unsigned int) read_vertex_next((ptrvertex) read_store_vertex(p, 3), 0)
   )
then  /* error  */
  {
    printf("\n\n*********************************************************");
    printf("\nifte_r_terminal: %d:  error: LOOP in v_3: ckp 11", count);
    printf("\nread_store_vertex(p, 3) = 0x%x", read_store_vertex(p, 3)); 
printf("\nread_vertex_next((ptrvertex) read_store_vertex(p, 3), 0) = 0x%x",
    read_vertex_next((ptrvertex) read_store_vertex(p, 3), 0)
    ); 
    printf("\n*********************************************************\n");
  }
#endif

                          return (true);
                          
                          
                   }
            else  /* nonterminal case  */
                   {

/* filter_r_state_step may destroy restriciton nf  */

                          if (filter_r_state_step(p) == 0)
                          then /*  end with nonterminal case  */
                                  {
/* put result in nf before returning  */
                                          filter_r_state_0(p);
                                          restriction_nf(p);
#if dbg5_ifter_terminal
printf("end while %d with nonterminal case: return (false)\n",
wh_count);
#endif
 
                                          return (false);
                                  }
                          
                          restriction_nf(p);
                  }

#if dbg5_ifter_terminal
printf("end while %d\n",
wh_count);
#endif
                  
                  
      }



}  /* end program  */











/*
**  test if we are in a terminal case
**  and, if yes, define result
**
*/

/*
** terminal cases: 
**
**  ifte_step(F, G, G) = G;
**
**  ifte_step(0, F, G) = G;
**
**  ifte_step(1, F, G) = F;


**  ifte_step(F, 1, 0) = F;
**  ifte_step(F, 0, 1) = not(F)

**  ifte_step(F, F, not(F)) = 1;
**  ifte_step(F, not(F), F) = 0;

**
*/

/*
**  convention: (?????????)
**
** terminal vertices have vindex = 0
**
*/

/* returns: (yet to be implemented, 95.2.16)
0: if no terminal case;
1: if terminal case and result is a terminal vertex;
2: if terminal case and result is a nonterminal vertex;
*/


int ifte_r_tc_step(type_bdd_store p)
/*
** HYP:
**
** input in restriciton nf;
** output in restriction nf.
**
*/
 
{  /*  begin  */

/* declarations  */

unsigned int vindex[4];   /*  vindex[3] == restriction index  */

/* program  */

/*
********************************************************************************
ifte_step(F, G, Q) = ifte_r_step(F, G, Q, 0, 0, 0)
********************************************************************************
*/

get_vindexes_store(p, vindex);



/* test for ifte_step(0, F, G) = G  */


   if (
           ( terminal((ptrvertex) read_store_vertex(p, 0)) )
        && (read_store_p_flip(p, 0) == 0)
        && (read_store_rswitch(p) == 0)
      )
   then  /*   terminal case */
       {
/* define result  */

           write_store_vertex(p, 3, read_store_vertex(p, 2));
 
           write_store_p_flip(p, 3, read_store_p_flip(p, 2));
           write_store_p_swap(p, 3, read_store_p_swap(p, 2));
           write_store_flip(p, 3, read_store_flip(p, 2));

           write_store_dvindex(
p, 
2, 
read_store_dvindex(p, 2) + vindex[2]
);


          return (true);

       }




/* test for ifte_step(1, F, G) = F  */


   if (
           ( terminal((ptrvertex) read_store_vertex(p, 0)) )
        && (read_store_p_flip(p, 0) == 1)
        && (read_store_rswitch(p) == 0)
       )
   then  /*   terminal case */
       {
/* define result  */

           write_store_vertex(p, 3, read_store_vertex(p, 1));
 
           write_store_p_flip(p, 3, read_store_p_flip(p, 1));
           write_store_p_swap(p, 3, read_store_p_swap(p, 1));
           write_store_flip(p, 3, read_store_flip(p, 1));

           write_store_dvindex(
p, 
2, 
read_store_dvindex(p, 2) + vindex[1]
);


          return (true);

       }


/*
************************************************************************
Note: F may be terminal (this may happen when rswitch != 0)
************************************************************************
*/


/* test for ifte_step(F, 1, 0) = F  (F terminal or nonterminal) */


   if (
           ( terminal((ptrvertex) read_store_vertex(p, 1)) )
        && (read_store_p_flip(p, 1) == 1)
        && ( terminal((ptrvertex) read_store_vertex(p, 2)) )
        && (read_store_p_flip(p, 2) == 0)

/*  
we assume restriction in nf, 
thus in this case rswitch == 0 and F is nonterminal  
*/

      )
   then  /*   terminal case */
       {
/* define result  */

           write_store_vertex(p, 3, read_store_vertex(p, 0));
 
           write_store_p_flip(p, 3, read_store_p_flip(p, 0));
           write_store_p_swap(p, 3, read_store_p_swap(p, 0));
           write_store_flip(p, 3, read_store_flip(p, 0));
 

#if false
           write_store_dvindex(
p, 
2, 
read_store_dvindex(p, 2)
/*  + 0u since F has a vindex <= VINDX_TERMINAL  */
);

#endif


          return (true);

       }


/* test for ifte_step(F, 0, 1) = not(F)  (F terminal or nonterminal) */


   if (
           ( terminal((ptrvertex) read_store_vertex(p, 1)) )
        && (read_store_p_flip(p, 1) == 0)
        && ( terminal((ptrvertex) read_store_vertex(p, 2)) )
        && (read_store_p_flip(p, 2) == 1)

      )
   then  /*   terminal case */
       {
/* define result  */

           write_store_vertex(p, 3, read_store_vertex(p, 0));
 
           write_store_p_flip(p, 3, (1 + read_store_p_flip(p, 0))%2);
           write_store_p_swap(p, 3, read_store_p_swap(p, 0));
           write_store_flip(p, 3, read_store_flip(p, 0));

#if false

        write_store_dvindex(
p, 
2, 
read_store_dvindex(p, 2)
  /*  + 0u since F has a vindex <= VINDX_TERMINAL  */
);
#endif


          return (true);

       }

/* test for ifte_step(F, G, G) = G  (F terminal or nonterminal) */

   if (
           (read_store_vertex(p, 1) == read_store_vertex(p, 2))
        && (read_store_p_flip(p, 1) == read_store_p_flip(p, 2))
        && (read_store_p_swap(p, 1) == read_store_p_swap(p, 2))
        && (read_store_flip(p, 1) == read_store_flip(p, 2))

        && (vindex[1] == vindex[2])

/*
        && (read_store_dvindex(p, 0) == read_store_dvindex(p, 1))
        && (read_store_dv_sgn(p, 0) == read_store_dv_sgn(p, 1))
*/

        && (read_store_rswitch(p) == 0)
     )
   then  /*   terminal case */
       {
/* define result  */

           write_store_vertex(p, 3, read_store_vertex(p, 1));
 
           write_store_p_flip(p, 3, read_store_p_flip(p, 1));
           write_store_p_swap(p, 3, read_store_p_swap(p, 1));
           write_store_flip(p, 3, read_store_flip(p, 1));
 
           write_store_dvindex(
p, 
2, 
read_store_dvindex(p, 2) + vindex[1]
);
    
     
       
           return (true);
       }



/* test for ifte_step(F, F, not(F)) = 1  (F terminal or nonterminal) */

   if (
           ( (ptrvertex) read_store_vertex(p, 0) == 
             (ptrvertex) read_store_vertex(p, 1)
           )
        && (read_store_p_flip(p, 0) == read_store_p_flip(p, 1))
        && (read_store_p_swap(p, 0) == read_store_p_swap(p, 1))
        && (read_store_flip(p, 0) == read_store_flip(p, 1))

        && (vindex[0] == vindex[1])
/*
        && (read_store_dvindex(p, 0) == 0)
        && (read_store_dv_sgn(p, 0) == 0)
*/

        && ( (ptrvertex) read_store_vertex(p, 1) == 
                (ptrvertex) read_store_vertex(p, 2)
             )
        && (read_store_p_flip(p, 1) != read_store_p_flip(p, 2))
        && (read_store_p_swap(p, 1) == read_store_p_swap(p, 2))
        && (read_store_flip(p, 1) == read_store_flip(p, 2))

        && (vindex[0] == vindex[2])
/*
        && (read_store_dvindex(p, 1) == 0)
        && (read_store_dv_sgn(p, 1) == 0)
*/
        && (read_store_rswitch(p) == 0)
      )
   then  /*   terminal case */
       {
/* define result  */


/* 
note: 
for terminal vertexes 
(unsigned int) get_graph_vertex(label) == 
(unsigned int) get_terminal_bddvtx()
*/


           write_store_vertex(p, 3, (unsigned int) get_terminal_bddvtx());


           write_store_p_flip(p, 3, 1);
           write_store_p_swap(p, 3, 0);
           write_store_flip(p, 3, 0);

#if false
write_store_dvindex(p, 2, read_store_dvindex(p, 2) + 0); 
#endif
       
           return (true);
       }



/* test for ifte_step(F, not(F), F) = 0  (F terminal or nonterminal) */

   if (
           ((ptrvertex) read_store_vertex(p, 0) == 
            (ptrvertex) read_store_vertex(p, 2))
        && (read_store_p_flip(p, 0) == read_store_p_flip(p, 2))
        && (read_store_p_swap(p, 0) == read_store_p_swap(p, 2))
        && (read_store_flip(p, 0) == read_store_flip(p, 2))

        && (vindex[0] == vindex[2])
/*
        && (read_store_dvindex(p, 1) == 0)
        && (read_store_dv_sgn(p, 1) == 0)
*/

        && ((ptrvertex) read_store_vertex(p, 1) == 
              (ptrvertex) read_store_vertex(p, 0))
        && (read_store_p_flip(p, 1) != read_store_p_flip(p, 0))
        && (read_store_p_swap(p, 1) == read_store_p_swap(p, 0))
        && (read_store_flip(p, 1) == read_store_flip(p, 0))

        && (vindex[0] == vindex[1])
/*
        && (read_store_dvindex(p, 0) == 0)
        && (read_store_dv_sgn(p, 0) == 0)
*/

        && (read_store_rswitch(p) == 0)
      )
   then  /*   terminal case */
       {
/* define result  */

/* 
note: 
for terminal vertexes (unsigned int) get_graph_vertex(label) == 
(unsigned int) get_terminal_bddvtx()
*/


    write_store_vertex(p, 3, (unsigned int) get_terminal_bddvtx());

           write_store_p_flip(p, 3, 0);
           write_store_p_swap(p, 3, 0);
           write_store_flip(p, 3, 0);
           
#if false           
           write_store_dvindex(p, 2, read_store_dvindex(p, 2) + 0);
#endif
       
           return (true);
       }





/*
**
**  ADD MORE TERMINAL CASES !!!!!!!!!!!!!!!!!!!!!!!!!!!!!
**
**
*/

          return (false);


}  /*  end program  */










void restriction_nf(type_bdd_store p)
/*
******************************************
reduce restriction to nf
******************************************
*/

{  /*  begin  restriction_nf */

if 
( 
   (read_store_rswitch(p) == 0) 
   
|| (   lessthan_dv(
                    read_store_rsgn(p), read_store_rdvindex(p),
                    read_store_dv_sgn(p, 0), read_store_dvindex(p, 0)
                   )

     && lessthan_dv(
                     read_store_rsgn(p), read_store_rdvindex(p),
                     read_store_dv_sgn(p, 1), read_store_dvindex(p, 1)
                   )
   )
       
       
 
)
then  /*  no restriction takes place  */
       {
           write_store_rbit(p, 0);
           write_store_rswitch(p, 0);
           write_store_rdvindex(p, 0);
           write_store_rsgn(p, 0);
       }




}  /*  end  restriction_nf */


