/*
*************************************************
file:  get_graph_store
*************************************************
*/


#include "local.h"


#define dbg_flag 0    /*  normal value: 0  */

#define PROBE_FLAG 0   /*  normal value: 0  */



#if (PROBE_FLAG > 0)
#include "probes.h"

static char probe[1000];
#endif




int to_be_stored(type_bdd_store p)
{  /* begin program  */

/* declarations  */

#if ( (dbg_flag > 0) || (PROBE_FLAG > 0) )
static unsigned int count = 0;
#endif


/*  program  */


#if (PROBE_FLAG > 1000000)
/* only to check that probe works */
sprintf(probe,
"to_be_stored: begin: not stored so far = %u, ", count);
probesend(probe);
#endif










    if 
(
   (read_vertex_in_edges((ptrvertex) read_store_vertex(p, 0)) <= 1)
&&
   (read_vertex_in_edges((ptrvertex) read_store_vertex(p, 1)) <= 1)
&&
   (read_vertex_in_edges((ptrvertex) read_store_vertex(p, 2)) <= 1)
)

    /* then: result not to be stored  */
       {

#if ( (dbg_flag > 0) || (PROBE_FLAG > 0) )
count++;
#endif

#if (dbg_flag > 10)
fprintf(stderr,
"\nto_be_stored: no caching 0:%u: p=0x%x, v: 0x%x.%u, 0x%x.%u, 0x%x.%u",
count,
p,
read_store_vertex(p, 0),
read_vertex_in_edges((ptrvertex) read_store_vertex(p, 0)),
read_store_vertex(p, 1),
read_vertex_in_edges((ptrvertex) read_store_vertex(p, 1)),
read_store_vertex(p, 2),
read_vertex_in_edges((ptrvertex) read_store_vertex(p, 2))
);
#endif


#if (PROBE_FLAG > 100)
sprintf(probe,
"to_be_stored: return 0:%u: p=0x%x, v: 0x%x.%u, 0x%x.%u, 0x%x.%u",
count,
p,
read_store_vertex(p, 0),
read_vertex_in_edges((ptrvertex) read_store_vertex(p, 0)),
read_store_vertex(p, 1),
read_vertex_in_edges((ptrvertex) read_store_vertex(p, 1)),
read_store_vertex(p, 2),
read_vertex_in_edges((ptrvertex) read_store_vertex(p, 2))
);

probesend(probe);
#endif


          return (0);

       }
       
  

/* At least one vertex has in_edges > 1   */
/* result to be stored  */

#if (PROBE_FLAG > 100)
sprintf(probe, "to_be_stored: return 1:%u", count);
probesend(probe);
#endif


return (1);  
  

}  /* end  */




