/*
*************************************************
file:  graph.info.h
*************************************************
*/


#ifndef infobdd_h
#define  infobdd_h



#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <time.h>

#include "bddhdr.h"



extern
void checkCPUtime();


extern
int is_bdd_one(bdd G);

extern
int is_bdd_zero(bdd G);



extern
int bdd_equal(bdd G0, bdd G1);

extern
void printCPUtime();

extern
void print_bdd(bdd G);

extern
void printinfo(bdd G);

extern
int size(bdd G);

extern
void print_bdd_info();



int read_max_size_bdd();


void write_max_size_bdd(int info);

void print_all_bddvtx(FILE *pfile);
void print_bdd_vertex(FILE *pfile, void *v);
void print_bdd_header(FILE *pfile, bdd G);

void fprint_bdd(FILE *pfile, bdd G);

extern
void satisfy_all(
FILE *satfile,
bdd G 
);


void ord_satisfy_all(
FILE *satfile,
bdd G,
unsigned int maxarg,  /* max number of bdd variables expected */
unsigned int size_ord,  /* size of ord_array */
unsigned int *ord_array
);


void bdd2c(
	FILE *pfile, 
	bdd G, 
	unsigned int maxarg,
	unsigned int size_ord, 
	unsigned int *ord_array,
        char *fname
);




/* Procedures for multiple bdd printing   */

void mprint_bdd_vertex(FILE *pfile, void *v);
void mprint_bdd_header(FILE *pfile, bdd G);
void open_mprbdd();
void close_mprbdd();
void mfprint_bdd(FILE *pfile, bdd G);

#endif

