

#include "local.h"

static unsigned int i = 0;    /*  vertex counter  */

static unsigned int hdr_i = 0;    /*  header counter  */

static htable T;   /* to be used as markers  */



void mprint_bdd_vertex(FILE *pfile, void *v)
{

if ( v == NULL) { return;}   /* terminal vertex  */

/* v is nonterminal  */
#if 0
printf("\n\nprint_bdd_vertex: v = 0x%x = %u\n\n", v, v);
#endif

fprintf(pfile, "\nvtx %u: 0x%x 0x%x 0x%x 0x%x %u %u",
i,
v, 
read_vertex_next(v, 0), 
read_vertex_next(v, 1), 

(read_vertex_swap(v, 1) << 3) | 
	(read_vertex_flip(v, 1) << 2) |
		(read_vertex_swap(v, 0) << 1) | 
			read_vertex_flip(v, 0),

read_vertex_shift(v, 0), 
read_vertex_shift(v, 1)
); 

i++;

}



void mprint_bdd_header(FILE *pfile, bdd G)
{
   fprintf(pfile, "\nhdr %u: 0x%x 0x%x 0x%x %u",
   hdr_i,
   G,
   read_graph_root(G),

   (read_graph_p_swap(G) << 2) | 
   	(read_graph_flip(G) << 1) |
   		read_graph_p_flip(G),
	
   read_graph_vindex(G)

   );
   
hdr_i++;

}   /*  end program  */




/* 
   This is a provisory implementation
   The new one shouold use marks on vertices  

*/


/*  To be called before mfprint_bdd   */
void open_mprbdd()
{

/* declarations   */

T = get_htable();
i = 0;    /*  reset vertex counter  */
hdr_i = 0;    /*  reset header counter  */

} 

/*  To be called after mfprint_bdd   */
void close_mprbdd()
{
delete_ht(T);
}



void mfprint_bdd(FILE *pfile, bdd G)
{

/* declarations   */
ptrvertex v;

/* program  */
mprint_bdd_header(pfile, G);

v = read_graph_root(G);
mfprint_bdd_step(pfile, v, T);
}

 
 

 
mfprint_bdd_step(FILE *pfile, ptrvertex v, htable T)
{
unsigned int value;

/* program  */


/* visit v  */
mprint_bdd_vertex(pfile, v);
write_ht(T, (unsigned int) v, 1);  /*  mark v as visited  */

if ( nonterminal(v) )
	{  /* visit nonvisited v sons  */
		
          if ( ! read_ht(T, 
          				(unsigned int) read_vertex_next(v, 0),
          				&value)
          	)
          /* nonvisited  */  
          mfprint_bdd_step(pfile, read_vertex_next(v, 0), T);
          
          
          if ( ! read_ht(T, 
          				(unsigned int) read_vertex_next(v, 1),
          				&value)
          	)
          /* nonvisited  */  
          mfprint_bdd_step(pfile, read_vertex_next(v, 1), T);
	}

   
}   /* end fprint_bdd_step  */









