

#include "local.h"


void print_all_bddvtx(FILE *pfile)
{
print_all_dag(pfile, print_bdd_vertex);
}



void print_bdd_vertex(FILE *pfile, void *v)
{
static int i = 0;

if ( v == NULL) { return;}   /* terminal vertex  */

/* v is nonterminal  */
#if 0
printf("\n\nprint_bdd_vertex: v = 0x%x = %u\n\n", v, v);
#endif

fprintf(pfile, "\nvtx %d: 0x%x 0x%x 0x%x 0x%x %u %u",
i,
v, 
read_vertex_next(v, 0), 
read_vertex_next(v, 1), 

(read_vertex_swap(v, 1) << 3) | 
	(read_vertex_flip(v, 1) << 2) |
		(read_vertex_swap(v, 0) << 1) | 
			read_vertex_flip(v, 0),

read_vertex_shift(v, 0), 
read_vertex_shift(v, 1)
); 

i++;

}



void print_bdd_header(FILE *pfile, bdd G)
{
   fprintf(pfile, "\nhdr: 0x%x 0x%x 0x%x %u",
   G,
   read_graph_root(G),

   (read_graph_p_swap(G) << 2) | 
   	(read_graph_flip(G) << 1) |
   		read_graph_p_flip(G),
	
   read_graph_vindex(G)

   );
   
}   /*  end program  */




/* 
   This is a provisory implementation
   The new one shouold use marks on vertices  

*/

 
void fprint_bdd(FILE *pfile, bdd G)
{

/* declarations   */
ptrvertex v;
htable T;   /* to be used as markers  */


/* program  */
print_bdd_header(pfile, G);

v = read_graph_root(G);

T = get_htable();
fprint_bdd_step(pfile, v, T);
delete_ht(T);
  
}

 
fprint_bdd_step(FILE *pfile, ptrvertex v, htable T)
{
unsigned int value;

/* program  */


/* visit v  */
print_bdd_vertex(pfile, v);
write_ht(T, (unsigned int) v, 1);  /*  mark v as visited  */

if ( nonterminal(v) )
	{  /* visit nonvisited v sons  */
		
          if ( ! read_ht(T, 
          				(unsigned int) read_vertex_next(v, 0),
          				&value)
          	)
          /* nonvisited  */  
          fprint_bdd_step(pfile, read_vertex_next(v, 0), T);
          
          
          if ( ! read_ht(T, 
          				(unsigned int) read_vertex_next(v, 1),
          				&value)
          	)
          /* nonvisited  */  
          fprint_bdd_step(pfile, read_vertex_next(v, 1), T);
	}

   
}   /* end fprint_bdd_step  */









void print_bdd(bdd G)
/*
**  prints rbdd G
*/
{


fprint_bdd(stdout, G);


#if 0

 /* declarations */
  ptrvertex v;
  boolean v_swap;
  boolean v_p_flip;
  unsigned int v_flip;
  unsigned int v_index;
  mark_type visited;

 /* program */
 




 
  v = read_graph_root(G);

  v_swap = read_graph_p_swap(G);

  v_flip = read_graph_flip(G);

  v_p_flip = read_graph_p_flip(G);

  v_index = read_graph_vindex(G);

  visited = get_new_mark();



  printf("\n\nStart graph:\n");

  printf("\nGraph head: = (G, G_root, G_p_flip, G_p_swap, G_vindex, G_flip)\n");
  printf("Graph head: (%12d,%12d,%2d,%2d,%7d,%12d)\n", 
 G, 
v, 
v_p_flip, 
v_swap,
v_index,
v_flip
);

 

  print_bdd_step(visited, v);

  printf("\n\nEnd graph\n\n");
  
  
#endif


}



#if 0

static void print_bdd_step(mark_type visited, ptrvertex v)
/*
**  prints v and nonvisited vertices 
**  below v
**
**  v is assumed nonvisited (and nonNULL)
*/
{  /*  declarations  */
   int i;

  /*  program  */

   write_vertex_mark(v, visited);

   if ( nonterminal(v) )
   then
        {

printf("\nnonterminal vertex:\n");
printf("(%12d,%12d,%12d,%12d,%12d,%3d,%3d,%6d,%6d,%3d,%7d)\n",
v, 
read_vertex_next(v, 0), 
read_vertex_next(v, 1), 
read_vertex_flip(v, 0),
read_vertex_flip(v, 1),
read_vertex_swap(v, 0), 
read_vertex_swap(v, 1),  
read_vertex_shift(v, 0), 
read_vertex_shift(v, 1), 
read_vertex_mark(v),
read_vertex_in_edges(v)
);


          if ( visited != read_vertex_mark(read_vertex_next(v, 0)) )
          then  print_bdd_step(visited, read_vertex_next(v, 0));

          if ( visited != read_vertex_mark(read_vertex_next(v, 1)) )
          then  print_bdd_step(visited, read_vertex_next(v, 1));

        }
          
   else  /* v is a terminal vertex  */
        {
 
printf("\nterminal vertex:\n");
printf("(%12d,%3d,%3d,%3d,%3d,%3d,%3d,%3d,%3d,%3d,%7d)\n",
v, 
NULL, 
NULL,
0,
0,
0, 
0,  
0, 
0, 
read_vertex_mark(v),
read_vertex_in_edges(v)
);
         }
}


#endif

