
/*
**
**  file lookuptb.h
**
**
**  primitives for look_up_table
**
*/


#ifndef lookuptableh
#define lookuptableh


#include <stdio.h>
#include <stdlib.h>
#include <limits.h>


/* syntactic sugar  */
#define boolean int
#define then   /*  then  */






typedef void *look_up_table;
typedef void *lk_up_table_value;

typedef void *ht_key;



typedef lk_up_table_value (*Value_to_Value)(lk_up_table_value);
typedef void (*Value_Value)(lk_up_table_value, lk_up_table_value);
typedef boolean (*Value_Seq_to_Boole)(lk_up_table_value, void *);
typedef boolean (*Value_Value_to_Boole)(lk_up_table_value, lk_up_table_value);
typedef boolean (*Value_to_Boole)(lk_up_table_value);
typedef void (*Value_to_Void)(lk_up_table_value);
typedef unsigned int (*Value_Uint_to_Uint)(lk_up_table_value, unsigned int);
typedef unsigned int (*Value_to_Uint)(lk_up_table_value);
typedef unsigned int (*Uint_to_Uint)(unsigned int);




extern 
lk_up_table_value read_lkup_table(
look_up_table T, 
ht_key key
);

extern 
void write_lkup_table(
look_up_table T, 
lk_up_table_value data
);

extern 
look_up_table create_lk_up_table(
int table_size,
Value_to_Value read_plot,
Value_Value write_plot,
Value_Seq_to_Boole test_less_than,
Value_Seq_to_Boole test_equal,
Value_Value_to_Boole data_less_than,
Value_to_Void free_value,
Value_to_Void update_free_tags,
Value_to_Boole to_be_erased,

Value_to_Uint htvtx_hlab,
Value_Uint_to_Uint htvtx_tlab,
Value_to_Uint size_htvtx_alllab,
Value_to_Uint get_htkey_hlab,
Value_Uint_to_Uint get_htkey_tlab,
Value_to_Uint size_htkey_alllab
);

extern
int get_lkup_table_size(look_up_table T);

extern
int get_lkup_table_elements(look_up_table T);

extern
int get_non_null_entry(look_up_table T);



extern
void cleanup_lkup_table(look_up_table T);


extern
void* read_lkuptable_entry(look_up_table T, int i);



extern
void* read_lkuptable_vtxplot(look_up_table T, void *v);


#endif








