
/*
**
**  file look.up.table.c
**
**
**  primitives for look_up_table (variable size keys)
**
**  version 2.1
*/



#include "lookuptb.h"






/*
**  each key is assumed to have T -> arg 
**  elements
**
*/


struct LkUp_Table
{
  int size_table;
  int elements_in_table;
  int non_null_entry;
  Value_to_Value read_plot;
  Value_Value write_plot;
  Value_Seq_to_Boole test_less_than;
  Value_Seq_to_Boole test_equal;
  Value_Value_to_Boole data_less_than;
  Value_to_Boole to_be_erased;
  Value_to_Void free_value;
  Value_to_Void update_free_tags;
  
  Value_to_Uint htvtx_hlab;
  Value_Uint_to_Uint htvtx_tlab;
  Value_to_Uint size_htvtx_alllab;
  Value_to_Uint get_htkey_hlab;
  Value_Uint_to_Uint get_htkey_tlab;
  Value_to_Uint size_htkey_alllab;
  
  lk_up_table_value *table;
};


typedef struct LkUp_Table lkup_table;



unsigned int 
tuple_lkup_table(look_up_table T, ht_key A);

unsigned int 
tuple_value(look_up_table T, lk_up_table_value value);






