/*
**
**  file: read.lkup.table
**
*/

#include "lookuptb.h"
#include "local.h"


#define dbg_flag 0


void* read_lkuptable_entry(look_up_table T, int i)
{
   return (
   			(void *) ((lkup_table *) T) -> table[i]
   		  );
}





void* read_lkuptable_vtxplot(look_up_table T, void *v)
{
   return (
   			( *( ((lkup_table *) T) -> read_plot ) )(v)
   		  );
}




lk_up_table_value read_lkup_table(
look_up_table T,
ht_key A
)

{

/* declarations  */
  unsigned int a;
  lk_up_table_value v;

#if (dbg_flag > 0)
static int count = 0;
#endif

/* programs  */


#if (dbg_flag > 0)
count++;
#endif


   a = tuple_lkup_table(T, A);
   
#if (dbg_flag > 100)
printf("\nread_lkup_table: %u: ckp 100: a = %u",
count, 
a
);
#endif

   if (  ((lkup_table *) T) -> table[a] == NULL )
   then 
   	{
#if (dbg_flag > 100)
printf("\nread_lkup_table: %u: ckp 150: nonfound",
count 
);
#endif
   	
   	return (NULL);  /* no data with given key  */
   	}


/*  ((lkup_table *) T) -> table[a] != NULL  */

/* There might be a data with given key  */


   v = ((lkup_table *) T) -> table[a];

   /*  v != NULL  */

#if (dbg_flag > 100)
printf("\nread_lkup_table: %u: ckp 200: head v = 0x%x",
count, 
v
);
#endif

   while ( ( *( ((lkup_table *) T) -> test_less_than ) )(v, A) ) 
      {
         v =  ( *( ((lkup_table *) T) -> read_plot ) )(v);

#if (dbg_flag > 100)
printf("\nread_lkup_table: %u: ckp 300.v = 0x%x",
count, 
v
);
#endif
      }

    if ( ( *( ((lkup_table *) T) -> test_equal ) )(v, A) )
    then  /* found  */
        {

#if (dbg_flag > 100)
printf("\nread_lkup_table: %u: ckp 400: found: v = 0x%x",
count, 
v
);
#endif
 
            return (v);
        }

/*  data not in table  */

#if (dbg_flag > 100)
/* test if data is not in table  */

v = ((lkup_table *) T) -> table[a];

 while ( v != NULL ) 
      {

    if ( ( *( ((lkup_table *) T) -> test_equal ) )(v, A) )
    then  /* error: data found */
        {
          printf(
"\n\n*******************************************************************"
);
          printf(
"\nread_lkup_table: error: NULL result when vertex is in table"
);
          printf(
"\n*******************************************************************\n\n"
);
       }
 
        v =  ( *( ((lkup_table *) T) -> read_plot ) )(v);

      }

#endif



#if (dbg_flag > 100)
printf("\nread_lkup_table: %u: ckp 900: nonfound",
count 
);
#endif
 

        return (NULL);






}  /* end program  */
