



/*
***********************************************
file:  start_environment
***********************************************
*/


#include "bddstart.h"
#include "cache.h"
#include "dag.h"
#include "clocktm.h"

#include "etlogo.h"


#define print_limits 0
#define print_on_file 0

#define long_print 0


/*
*********************************
Start bdd env and define parameters.

optval[0] = hash table size;
optval[1] = cache size;
optval[2] = garbage collection thresold;

optfval[0] = ht load factor.
***********************************
*/

void start_bdd_env(
unsigned int *optval,
double *optfval
)
/*
**
**  inizialize environment
**  for graph manipulation
**
*/
{
/*  declarations  */


#if print_limits
 struct rlimit * mem_lim;
#endif

/*  program  */

/*
****************************
begin:    output redirection   
****************************
*/

#if (print_on_file > 10)

fclose(stdout);
freopen("ouput.BDD", "w", stdout);

#endif

/*
****************************
end:    output redirection   
****************************
*/

  printf("\n\nBDD version: 11.2 (96.02.12)");

et_signature();


set_dag_par(
optval[0],
optval[2],
optfval[0]
);

set_cache_par(optval[1]);


#if (long_print > 100)
  printf("\n\nBDD: defining environment ...\n");
#endif

 
#if print_limits

/*  print limits  */

  mem_lim = (struct rlimit *) malloc(sizeof(struct rlimit));


  printf("\n*********LIMITS:\n");

 

  printf("\n RLIMIT_CPU = %d\n", getrlimit(RLIMIT_CPU, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);

  printf("\n RLIMIT_FSIZE = %d\n", getrlimit(RLIMIT_FSIZE, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);

  printf("\n RLIMIT_RSS = %d\n", getrlimit(RLIMIT_RSS, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);

  printf("\n RLIMIT_STACK = %d\n", getrlimit(RLIMIT_STACK, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);


  free(mem_lim);



/*  end print limits  */

#endif



/* Start cache environment  */

start_cache_env();
  

/* Start dag environment  */


start_dag_env();


start_bddvtx_env();


#if (long_print > 100)
printf("\nBDD: end environment definition.\n");
#endif


/*  initialize clock  */

set_clock();


}

