



/*
***********************************************
file:  start_environment
***********************************************
*/


#include "bddstart.h"
#include "cache.h"
#include "dag.h"
#include "clocktm.h"


#define print_limits 0
#define print_on_file 0

#define long_print 0


void start_environment()
/*
**
**  inizialize environment
**  for graph manipulation
**
*/
{
/*  declarations  */


#if print_limits
 struct rlimit * mem_lim;
#endif

/*  program  */

/*
****************************
begin:    output redirection   
****************************
*/

#if (print_on_file > 10)

fclose(stdout);
freopen("ouput.BDD", "w", stdout);

#endif

/*
****************************
end:    output redirection   
****************************
*/

  printf("\n\nBDD version: 11.1 (95.12.18)");
  printf("\nAuthor: Enrico Tronci");
  printf("\nAffiliation: \nDip. Matematica Pura ed Applicata");
  printf("\nUniversita' di L'Aquila, Coppito 67100 L'Aquila, Italy\n");


#if (long_print > 100)
  printf("\n\nBDD: defining environment ...\n");
#endif

 
#if print_limits

/*  print limits  */

  mem_lim = (struct rlimit *) malloc(sizeof(struct rlimit));


  printf("\n*********LIMITS:\n");

 

  printf("\n RLIMIT_CPU = %d\n", getrlimit(RLIMIT_CPU, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);

  printf("\n RLIMIT_FSIZE = %d\n", getrlimit(RLIMIT_FSIZE, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);

  printf("\n RLIMIT_RSS = %d\n", getrlimit(RLIMIT_RSS, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);

  printf("\n RLIMIT_STACK = %d\n", getrlimit(RLIMIT_STACK, mem_lim) );
  
  printf("\n rlim_cur = %d (curren soft memory limit)\n", mem_lim -> rlim_cur);
  printf("\n rlim_max = %d (curren hard memory limit)\n", mem_lim -> rlim_max);


  free(mem_lim);



/*  end print limits  */

#endif



/* Start cache environment  */

start_cache_env();
  

/* Start dag environment  */


start_dag_env();


start_bddvtx_env();


#if (long_print > 100)
printf("\nBDD: end environment definition.\n");
#endif


/*  initialize clock  */

set_clock();


}

