/*
**
**  file:  bddstore.h
**
**
*/


#ifndef bddstore_h
#define bddstore_h




#define write_store_in_edges(p, value) write_gstore_in_edges(p, value)
#define read_store_in_edges(p) read_gstore_in_edges(p)
#define free_bdd_store(p) free_gstore(p)
#define lock_bdd_store(p) lock_gstore(p)
#define unlock_bdd_store(p) unlock_gstore(p)
#define print_bdd_store_info() print_gstore_info()


typedef void* type_bdd_store;





type_bdd_store get_new_bdd_store();



void write_store_dvindex(
type_bdd_store p, 
int i, 
unsigned int value
);

void write_store_dv_sgn(
type_bdd_store p, 
int i, 
unsigned int value
)
;

unsigned int read_store_dv_sgn(
type_bdd_store p, 
int i
)
;


void write_store_flip(
type_bdd_store p, 
int i, 
unsigned int value
)
;

unsigned int read_store_flip(
type_bdd_store p, 
int i
);


void write_store_p_flip(
type_bdd_store p, 
int i, 
unsigned int value
)
;




unsigned int read_store_p_flip(
type_bdd_store p, 
int i
)
;

void write_store_p_swap(
type_bdd_store p, 
int i, 
unsigned int value
)
;


unsigned int  read_store_p_swap(
type_bdd_store p, 
int i
)
;

void write_store_rdvindex(
type_bdd_store p, 
unsigned int value
);

unsigned int read_store_rdvindex(
type_bdd_store p
)
;



void write_store_rbit(
type_bdd_store p, 
unsigned int value
)
;

unsigned int read_store_rbit(
type_bdd_store p
)
;


void write_store_rswitch(
type_bdd_store p, 
unsigned int value
)
;

unsigned int read_store_rswitch(
type_bdd_store p
);




void write_store_rsgn(
type_bdd_store p, 
unsigned int value
)
;



unsigned int read_store_rsgn(
type_bdd_store p
)
;


void write_store_swap(
type_bdd_store p, 
int i, 
unsigned int value
)
;


unsigned int read_store_swap(
type_bdd_store p, 
int i
)
;



void write_store_vertex(
type_bdd_store p, 
int i, 
unsigned int value
)
;

unsigned int read_store_vertex(
type_bdd_store p, 
int i
)
;







unsigned int read_store_dvindex(
type_bdd_store p, 
int i
);




void write_bdd_store_generic(
type_bdd_store p, 
unsigned int word, 
unsigned int position, 
unsigned int mask, 
unsigned int value
)
;

#endif







