/*
**
**  file bddvtx.h
**
**
**  primitives on bdd_vertex 
**
*/


#ifndef bddvtx_h
#define bddvtx_h


#include "gvertex.h"



#define lock_bdd_vertex(v) lock_gvertex(v)
#define unlock_bdd_vertex(v) unlock_gvertex(v)
#define locked_bdd_vertex(v) locked_gvertex(v) 
#define unlocked_bdd_vertex(v) unlocked_gvertex(v)
#define read_vertex_mark(v) read_gvtx_mark(v)
#define write_vertex_mark(v, m) write_gvtx_mark(v, m)
#define read_vertex_in_edges(v) read_gvertex_in_edges(v)
#define write_vertex_in_edges(v, k) write_gvertex_in_edges(v, k)


typedef void *ptrvertex;

extern unsigned int read_vertex_flip(ptrvertex v, int j);
extern unsigned int read_vertex_swap(ptrvertex v, int j);
extern unsigned int read_vertex_shift(ptrvertex v, int j);
extern ptrvertex read_vertex_next(ptrvertex v, int j);

extern ptrvertex get_bdd_vertex(unsigned int *A);

extern
void start_bddvtx_env();


extern
int terminal(ptrvertex v);

extern
int nonterminal(ptrvertex v);


extern
ptrvertex get_terminal_bddvtx();


/*
**************************************************
A is as follows:
A[0] = flip side 0;
A[1] = flip side 1;
A[2] = swap side 0;
A[3] = swap side 1;
A[4] = shift side 0;
A[5] = shift side 1;
A[6] = next side 0;
A[7] = next side 1;
**************************************************
*/


#define get_graph_vertex(A) get_bdd_vertex(A)




#if 0
extern
void read_vertex_labels(
ptrvertex v,
unsigned int *A 
);

extern
unsigned int make_shift(
unsigned int shift_1, 
unsigned int shift_0
);


unsigned int make_vtx_label(
unsigned int B[5], 
unsigned int next_0,
unsigned int next_1,
unsigned int p_swap_0,
unsigned int p_swap_1,
unsigned int flip_0,
unsigned int flip_1,
unsigned int shift_0,
unsigned int shift_1
);


extern
int zero_labels(ptrvertex v);
#endif



#if (use_extra_gvtx_info != 0)
int ck_vertex_level(ptrvertex v);

void print_vertex_level(FILE *fileptr, ptrvertex v);

int ck2_vtx_levels(
ptrvertex v0, 
ptrvertex v1,
ptrvertex v2,
ptrvertex v3
);



int ck3_vtx_levels(
ptrvertex pv0, 
ptrvertex pv1,
ptrvertex pv2,
ptrvertex nv0, 
ptrvertex nv1,
ptrvertex nv2
);



unsigned int sum_levels(
ptrvertex v0,
ptrvertex v1,
ptrvertex v2
);

#endif



#endif
