

/*
**
** file: newvtx.c
**
*/


/*
******************************************
B is given accordingly to bdd vertex conceptual fields;
A is defined so that gvertex.h can be used
******************************************
*/



/*
**************************************************
B is as follows:
B[0] = flip side 0;
B[1] = flip side 1;
B[2] = swap side 0;
B[3] = swap side 1;
B[4] = shift side 0;
B[5] = shift side 1;
B[6] = next side 0;
B[7] = next side 1;
**************************************************
*/

#include "local.h"

#include "dag.h"



#define debug_flag 0    /* normal value: 0  */
#define threshold 0

#define mask_flip_0 0x20000   /*  bit  17  */
#define mask_swap_0 0x40000    /*  bit  18  */
#define mask_flip_1 0x80000     /*  bit  19  */
#define mask_swap_1 0x100000     /*  bit  20  */




ptrvertex get_bdd_vertex(
unsigned int *B
)
/*  creates new vertex with label A    */

{

/* declarations  */

#if (debug_flag > 0)
static unsigned int count = 0;
#endif

unsigned int A[6];
unsigned int size_nonptr_lab;
unsigned int size_ptr_lab;

ptrvertex v;

/* program  */

#if (debug_flag > 0)
count++;
#endif
 
#if (debug_flag > 100)
if (count > threshold)
{     
printf("\nget_bdd_vertex:%u:  ckp 100 (begin)", count);      	
}
#endif
 

/* define shift  */

size_nonptr_lab = shift_default(A, B);

#if (debug_flag > 100)
if (count > threshold)
{ 
printf("\nget_bdd_vertex:%u:  ckp 150", count);      	
#if (0)
      printf("\nget_bdd_vertex: ckp 1150: A[0] = 0x%x", A[0]);
#endif
}
#endif

/* define next  */

size_ptr_lab = next_default(size_nonptr_lab, A, B);

#if (debug_flag > 100)
if (count > threshold)
{     
printf("\nget_bdd_vertex:%u:  ckp 170", count);      	
}
#endif
 
/* define flip  */
A[0] = (A[0] & ~mask_flip_0) | (mask_flip_0 & (B[0] << 17));
A[0] = (A[0] & ~mask_flip_1) | (mask_flip_1 & (B[1] << 19));

#if 0
#if (debug_flag > 100)
if (count > threshold)
{ 
printf("\nget_bdd_vertex:%u:  ckp 200", count);      	
}
#endif
#endif


/* define swap  */
A[0] = (A[0] & ~mask_swap_0) | (mask_swap_0 & (B[2] << 18));
A[0] = (A[0] & ~mask_swap_1) | (mask_swap_1 & (B[3] << 20));

/*  A defined  */


#if (debug_flag > 1000)
      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (flip side %d)",
      0, 0, B[0], 0);
      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (flip side %d)",
      1, 1, B[1], 1);

      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (swap side %d)",
      0, 0, B[2], 0);
      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (swap side %d)",
      1, 1, B[3], 1);
       
      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (shift side %d)",
      0, 0, B[4], 0);
      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (shift side %d)",
      1, 1, B[5], 1);

      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (next side %d)",
      0, 0, B[6], 0);
      printf("\nget_bdd_vertex: ckp 1200.%d: B[%d] = 0x%x (next side %d)",
      1, 1, B[7], 1);

        
      printf("\n\nget_bdd_vertex: ckp 1250: A[0] = 0x%x", A[0]);
      printf(" ~ 0x%x = get_key_hlab(A)", get_key_hlab(A));
      printf("\nget_bdd_vertex: ckp 1260: A[1] = 0x%x", A[1]);
      printf("\nget_bdd_vertex: ckp 1270: A[2] = 0x%x", A[2]);
      printf("\nget_bdd_vertex: ckp 1280: A[3] = 0x%x", A[3]);
      printf("\nget_bdd_vertex: ckp 1290: A[4] = 0x%x", A[4]);
      printf("\nget_bdd_vertex: ckp 1300: A[5] = 0x%x", A[5]);
      printf("\nget_bdd_vertex: ckp 1310: A[6] = 0x%x", A[6]);
      printf("\nget_bdd_vertex: ckp 1310: size_nonptr_lab = %d", 
      size_nonptr_lab);
      printf(" = %d = size_key_nonptrlab(A)", 
      size_key_nonptrlab(A));
      printf("\nget_bdd_vertex: ckp 1320: size_ptr_lab = %d", 
      size_ptr_lab);
      printf(" = %d = size_key_ptrlab(A)", 
      size_key_ptrlab(A));
#endif

#if (debug_flag > 100)
if (count > threshold)
{ 
printf("\nget_bdd_vertex:%u:  ckp 5000", count);      	
}
#endif

/* return bdd vertex  */

v = (ptrvertex) get_dag_vertex(A) ;


#if (debug_flag > 100)
if (count > threshold)
{ 
printf("\nget_bdd_vertex:%u:  ckp 5100: define level", count);      	
}
#endif






#if (use_extra_gvtx_info != 0)
if ( read_extra_info_gvtx(v, gvtx_level) == 0 ) 
/* new vertex: define info */
{



/*  levels */

write_extra_info_gvtx(
v, 
gvtx_level,
0
);

if ( (void *) B[6] != NULL )
{
write_extra_info_gvtx(
v, 
gvtx_level,
read_extra_info_gvtx( (void *) B[6], gvtx_level)
);
}


if ( (void *) B[7] != NULL )
{
if ( read_extra_info_gvtx(v, gvtx_level) 
     < 
     read_extra_info_gvtx((void *) B[7], gvtx_level)
   )
    {
      write_extra_info_gvtx(
v, 
gvtx_level,
read_extra_info_gvtx( (void *) B[7], gvtx_level)
);
    }
}



write_extra_info_gvtx(
v, 
gvtx_level,
read_extra_info_gvtx(v, gvtx_level) + 1
);

 
}


else /* check if gvtx_level well defined */
{

if ( (void *) read_vertex_next(v, 0) != NULL )
{
if (
     read_extra_info_gvtx(v, gvtx_level)
     <=
     read_extra_info_gvtx(
               (void *) read_vertex_next(v, 0), 
               gvtx_level
                         )
   )
/* error */
{
  fprintf(stderr, 
"\nget_bdd_vertex: level error v = 0x%x.%u, next0 = 0x%x.%u\n",
v,
read_extra_info_gvtx(v, gvtx_level),
read_vertex_next(v, 0),
read_extra_info_gvtx(
               (void *) read_vertex_next(v, 0), 
               gvtx_level
                         )
);

exit (1);
}
}




if ( (void *) read_vertex_next(v, 1) != NULL )
{
if (
     read_extra_info_gvtx(v, gvtx_level)
     <=
     read_extra_info_gvtx(
               (void *) read_vertex_next(v, 1), 
               gvtx_level
                         )
   )
/* error */
{
  fprintf(stderr, 
"\nget_bdd_vertex: level error v = 0x%x.%u, next1 = 0x%x.%u\n",
v,
read_extra_info_gvtx(v, gvtx_level),
read_vertex_next(v, 1),
read_extra_info_gvtx(
               (void *) read_vertex_next(v, 1), 
               gvtx_level
                         )
);

exit (1);
}
}


} /* else */




/* check well formedness */
if ( 
(
     ( (void *) read_vertex_next(v, 0) != NULL )
     &&
     ( (void *) read_vertex_next(v, 1) == NULL )
)
||
(
     ( (void *) read_vertex_next(v, 0) == NULL )
     &&
     ( (void *) read_vertex_next(v, 1) != NULL )
)
  )
/* error */
{
fprintf(stderr, 
"\nget_bdd_vertex:error:no wf v=0x%x, nxt0 = 0x%x, nxt1 = 0x%x\n",
v,
read_vertex_next(v, 0),
read_vertex_next(v, 1)
);

exit (1);
}


#endif




#if (debug_flag > 100)
if (count > threshold)
{ 
printf("\nget_bdd_vertex:%u:  ckp 6000 (end)", count);      	
}
#endif


return ( v );


}







#if (use_extra_gvtx_info != 0)


int ck_vertex_level(ptrvertex v)
{

if ( nonterminal(v) )
  {

if ( read_extra_info_gvtx(v, gvtx_level)
     <=
     read_extra_info_gvtx(read_vertex_next(v, 0), gvtx_level)
   )
/* error */
{
    return (0);
}


if ( read_extra_info_gvtx(v, gvtx_level)
     <=
     read_extra_info_gvtx(read_vertex_next(v, 1), gvtx_level)
   )
/* error */
{
    return (0);
}

 }


/*  ok  */

return (1);


}  /* end */







void print_vertex_level(FILE *fileptr, ptrvertex v)
{

if ( nonterminal(v) )
  {

fprintf(fileptr, 
"\nvtx.level: next0 = 0x%x.%u, next1 = 0x%x.%u, vertex = 0x%x.%u",
read_vertex_next(v, 0),
read_extra_info_gvtx(read_vertex_next(v, 0), gvtx_level),

read_vertex_next(v, 1),
read_extra_info_gvtx(read_vertex_next(v, 1),gvtx_level),

v,
read_extra_info_gvtx(v,gvtx_level)
);


  }

}  /* end  */






int ck2_vtx_levels(
ptrvertex v0, 
ptrvertex v1,
ptrvertex v2,
ptrvertex v3
)
{


if 
(

   ( read_extra_info_gvtx(v0, gvtx_level)
     <
     read_extra_info_gvtx(v3, gvtx_level)
   )
&&
  
  ( read_extra_info_gvtx(v1, gvtx_level)
     <
     read_extra_info_gvtx(v3, gvtx_level)
   )

&&
 
  ( read_extra_info_gvtx(v2, gvtx_level)
     <
     read_extra_info_gvtx(v3, gvtx_level)
   )
)
/* error */
{
    return (0);
}

else   /*  ok  */
{ return (1); }


}  /* end */













int ck3_vtx_levels(
ptrvertex pv0, 
ptrvertex pv1,
ptrvertex pv2,
ptrvertex nv0, 
ptrvertex nv1,
ptrvertex nv2
)
{


if 
(

   ( read_extra_info_gvtx(pv0, gvtx_level)
     +
     read_extra_info_gvtx(pv1, gvtx_level)
     +
     read_extra_info_gvtx(pv2, gvtx_level)
   )
   <=
  
   ( read_extra_info_gvtx(nv0, gvtx_level)
     +
     read_extra_info_gvtx(nv1, gvtx_level)
     +
     read_extra_info_gvtx(nv2, gvtx_level)
   )

)
{
    return (0);
}

else   
{ return (1); }


}  /* end */





unsigned int sum_levels(
ptrvertex v0,
ptrvertex v1,
ptrvertex v2
)
{

return ( 
read_extra_info_gvtx(v0, gvtx_level)
     +
     read_extra_info_gvtx(v1, gvtx_level)
     +
     read_extra_info_gvtx(v2, gvtx_level)
       );


}  /* end */




#endif


