


#include "bddvtx2c.h"




static
unsigned int arg_from_var(unsigned int i);

static 
char pick_value(
unsigned int *vtxstate,
int nontrm_0,
int nontrm_1
);


static
int update_state(
unsigned int *vtxstate,
int xvalue,
unsigned int shift_0,
unsigned int shift_1,
unsigned int swap_0,
unsigned int swap_1,
unsigned int flip_0,
unsigned int flip_1
);



static
int ck_terminal(unsigned int v);


static
int ck_nonterminal(unsigned int v);





int bdd2c_eval(
unsigned int vname,
unsigned int vindex,
char p_flip,
char flip,
char p_swap,
char *x
)
{
/* dcls */
unsigned int vtxstate[4];
unsigned int v;

int nontrm_0, nontrm_1;
int idx;


/* prg */

v = vname;
vtxstate[0] = vindex;
vtxstate[1] = p_flip;
vtxstate[2] = flip;
vtxstate[3] = p_swap;




while ( ck_nonterminal(v) )
{ /* nonterminal */


/* v is nonterminal */



nontrm_0 = ck_nonterminal(bddvtxtab[v].vtx_next[0]);


nontrm_1 = ck_nonterminal(bddvtxtab[v].vtx_next[1]);



idx = arg_from_var(vtxstate[0]);



/* if.then: pick at random x trying to get sat asg. */

if (x[idx] == 'x') x[idx] = pick_value(vtxstate, nontrm_0, nontrm_1);
       

/*  x[arg_from_var(size_ord, ord_array, vtxstate[0])] == 
   '0' or '1' 
*/



if ( 
update_state(
vtxstate, 
x[idx] - '0', 
bddvtxtab[v].shift[0], 
bddvtxtab[v].shift[1], 
bddvtxtab[v].swap[0], 
bddvtxtab[v].swap[1], 
bddvtxtab[v].flip[0], 
bddvtxtab[v].flip[1]
            ) 
   )
/* side == 1 */
{ 


v = bddvtxtab[v].vtx_next[1];
 

}

else  /* side == 0  */
{ 

v = bddvtxtab[v].vtx_next[0];

}



}   /*  while  */



/* terminal */

     return(vtxstate[1]);




}   /*  bdd2c_eval  */




  



int update_state(
unsigned int *vtxstate,
int xvalue,
unsigned int shift_0,
unsigned int shift_1,
unsigned int swap_0,
unsigned int swap_1,
unsigned int flip_0,
unsigned int flip_1
)
{
if ( (xvalue + vtxstate[3])%2 == 0 )
/* no flip used to update p_flip  */
	{
		/* update pflip stays the same  */
/* vtxstate[1] = vtxstate[1]; */

		/* update virtual index  */
vtxstate[0] = vtxstate[0] +  shift_0 + 1;

		/* update pswap  */
vtxstate[3] = (vtxstate[3] +  swap_0)%2;

		/* update flip  */
vtxstate[2] = flip_0;

		return (0);

	}

/* side == 1: use flip to update p_flip  */
else
	{

/*  update pflip  */
vtxstate[1] = (vtxstate[1] + vtxstate[2])%2;

		/* update virtual index  */
vtxstate[0] = vtxstate[0] +  shift_1 + 1;

		/* update pswap  */
vtxstate[3] = (vtxstate[3] +  swap_1)%2;


		/* update flip  */
vtxstate[2] = flip_1;
   
		return (1) ;

	}





}  /* update_state  */







/*
***********************************
pich_state tries to pick
a value leading to a satisfying
assignment.
If no bbdvar following the current one
is constrained then pick is guaranteed
to return a value for the current bddvar
leading to a sat asg.
Otherwise pick returns a random value.
*************************************
*/



char pick_value(
unsigned int *vtxstate,
int def_nontrm_0,
int def_nontrm_1
)
{
/*  dcl */

int nontrm_0;
int nontrm_1;
unsigned int side_0, side_1;


/*  prg */


side_0 = vtxstate[3]%2;

side_1 = (1 + vtxstate[3])%2;



switch ( side_0 )
      {
           case 0: /* side_0 == 0, side_1 == 1  */

                   nontrm_0 = def_nontrm_0;
                   nontrm_1 = def_nontrm_1;
                   break;


           case 1:   /*  side_0 == 1, side_1 == 0  */


                   nontrm_0 = def_nontrm_1;
                   nontrm_1 = def_nontrm_0;
                   break;

          default: /* error */
                   printf("\npick_value: error\n");
                   exit (1); 


      }





if (  /*  xvalue == 0  */     
     ( nontrm_0
        ||
       ( (vtxstate[1] + side_0*vtxstate[2])%2 == 1 )
     )
       
    &&

      ( nontrm_1
        ||
       ( (vtxstate[1] + side_1*vtxstate[2])%2 == 1 )
      )

   )
/* both 0, 1 are good candidates */
  {

return ( '0' + (rand()%2) );

  }  




/* at least one terminal  */

if (  /*  xvalue == 0  */     
     ( nontrm_0
        ||
       ( (vtxstate[1] + side_0*vtxstate[2])%2 == 1 )
     )
   )
/* then side_1 is false  */
{
return ('0');
}





if (  /*  xvalue == 1  */     
     ( nontrm_1 
        ||
       ( (vtxstate[1] + side_1*vtxstate[2])%2 == 1 )
     )
   )
/* then side_0  is false  */
{
return ('1');
}




}  /*  pick_value  */







unsigned int arg_from_var(unsigned int i)
{
/* dcl */


/* prg  */

if (i < size_ord)
/* in ord_array */
	{ return (ord_array[i]); }
else
	{ return (i); }

}  /* arg_from_var  */




int ck_terminal(unsigned int v)
{


   if ( v == term_vtx_name )
   /* then */   /* terminal vertex  */   return (1);
   else  /* nonterminal vertex  */  return (0);

}




int ck_nonterminal(unsigned int v)
{


   if ( v == term_vtx_name )
   /* then */   /* terminal vertex  */   return (0);
   else  /* nonterminal vertex  */  return (1);

}



void mkvtx(
unsigned int vtxname,
unsigned int next0,
unsigned int next1,
unsigned int shift0,
unsigned int shift1,
unsigned int swap0,
unsigned int swap1,
unsigned int flip0,
unsigned int flip1
)
{
bddvtxtab[vtxname].vtx_next[0] = next0;
bddvtxtab[vtxname].vtx_next[1] = next1;

bddvtxtab[vtxname].shift[0] = shift0;
bddvtxtab[vtxname].shift[1] = shift1;

bddvtxtab[vtxname].swap[0] = swap0;
bddvtxtab[vtxname].swap[1] = swap1;

bddvtxtab[vtxname].flip[0] = flip0;
bddvtxtab[vtxname].flip[1] = flip1;




}   /*  mkvtx  */

