/*
************************************
file: ifte.c
************************************
*/


#include "local.h"


#define namesz 50

#define dbg_flag 0  /* normal value: 0  */



void apply_C_code(prghdr *p)
{
/* dcl  */
FILE *qfile, *cfile;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */

#if 0
/* not available message  */

fprintf(stderr, 
"\n\nSorry, C_code not available with this BDD package\n\n");

/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);

return;
#endif



/*  OK  */




if (p -> cfilename == NULL)
/* define file name for C code  */
{

p -> cfilename = (char *) malloc(namesz*sizeof(char));
if (p -> cfilename == NULL)
/* error */
{
fprintf(stderr, "\n\napply_C_code: error: no malloc space");
exit (1);

}

/* p -> cfilename != NULL  */

sprintf(p -> cfilename, "%s.c",  
p -> answfilename
);

cfile = fopen(p -> cfilename, "w");
fprintf(cfile, "\n\n/*  C code from bsp compiler  */\n\n");
fclose(cfile);

}






#if (print_info > 5)
begin_prt_info(p);



#if (keep_ids > 0)
printf(": C_code %s %s \"%s\"",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#if (keep_ids == 0)
printf(": C_code p%x X%x \"%s\"",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2)
);
#endif


#endif

#if (dbg_flag > 10)
printf("\napply_C_code:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
#endif


/* print answer to query */

qfile = fopen(p -> answfilename, "a");

#if (keep_ids > 0)
fprintf(qfile, 
"\n\n\nC_code %s %s \"%s\" in file %s\n",
vtxeval(regfield(p -> pc, query_word0), 1),
vtxeval(regfield(p -> pc, query_word0 + 1), 1),
regfield(p -> pc, query_word0 + 2),
p -> cfilename
);
#endif


#if (keep_ids == 0)
fprintf(qfile, 
"\n\n\nC_code p%x X%x \"%s\" in file %s\n",
regfield(p -> pc, query_word0),
regfield(p -> pc, query_word0 + 1),
regfield(p -> pc, query_word0 + 2),
p -> cfilename
);
#endif


fclose(qfile);


/* print code */

cfile = fopen(p -> cfilename, "a+");


fprintf(cfile, "\n\n");

bdd2c(

cfile,

regfield(
	regfield(p -> pc, query_word0),
	bddvalue
	),

p -> maxarg,

(unsigned int) 
regfield(
	regfield(p -> pc, query_word0 + 1),
	ordlist_word0
	),  /* size of ord_array */

regfield(
	regfield(p -> pc, query_word0 + 1),
	ordlist_word0 + 1
	), /*  ord_array  */


(char *) regfield(p -> pc, query_word0 + 2)

);


fclose(cfile);




/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);



#if (print_info > 5)
end_prt_info(p);
#endif

}  /*  apply_C_code  */
