/*
************************************
file: ifte.c
************************************
*/


#include "local.h"

/* 0: quiet, >10: show instruction when executed */
#define prt_instr 0  


#define no_unlink_freed 0   /* normal value: 0  */



#define dbg_flag 0  /* normal value: 0  */
#define dbg_bdd 0  /* normal value: 0  */

#define dbg_2 0   /* normal value: 0  */

#define do_not_free 0  /* normal value: 0 */

#define ONLY_RESET 0   /* normal value: 0 */




static void unlink_free(void *ptrfree);





void apply_free(prghdr *p)
{


/* dcl  */
unsigned int i;
void *next_pc;
void *ptr2free;


#if (dbg_flag > 0)
void *info_ptr;
static int count = 0;
count++;
#endif


/*  prg  */


#if (print_info > 5)
#if (prt_instr > 10)
begin_prt_info(p);


#if (keep_ids > 0)
printf(": free %s",
vtxeval(regfield(p -> pc, free_word0), 1)
);
#endif

#if (keep_ids == 0)
printf(": free p%x",
regfield(p -> pc, free_word0)
);
#endif



#endif
#endif



#if (dbg_bdd > 100)
printf("\n\nfree: regfield(p -> pc, free_word0) = 0x%x",
regfield(p -> pc, free_word0)
);


printf("\nfree: bddvalue = 0x%x",
regfield(regfield(p -> pc, free_word0), bddvalue)
);

#if 0
printf("\nfree root = 0x%x",
read_graph_root(
	regfield(regfield(p -> pc, free_word0), bddvalue)
		)
);
prt_vtx_state(stdout, 
(void *) read_graph_root(
	regfield(regfield(p -> pc, free_word0), bddvalue)
		)
);
printf("\n");
#endif
#endif



#if (do_not_free == 1)

/* advance pc */
p -> pc = regfield(p -> pc, ptr_down);

#if (dbg_flag > 10)
printf("\napply_free:%u: (not freeing) new pc = 0x%x\n\n", count, p -> pc);
#endif

return;
#endif





#if (dbg_flag > 5)
printf("\n\napply_free:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
printf("\nregfield(p -> pc, op_code) = %u = '%c'", 
regfield(p -> pc, op_code),
regfield(p -> pc, op_code)
);
printf("\nregfield(p -> pc, free_word0) = 0x%x",
regfield(p -> pc, free_word0)
);
printf("\nregeval(regfield(p -> pc, free_word0)) = 0x%x",
regeval(regfield(p -> pc, free_word0))
);
#endif




if (regeval(regfield(p -> pc, free_word0)) == NULL)
/* 
      Id not yet defined. 
      Thus we are on first iteration of a loop. 
      Just advance pc.
*/
  {


/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);

#if (dbg_flag > 10)
printf("\napply_free:%u: id undefined: end: new pc = 0x%x\n\n", 
count, 
p -> pc
);
#endif


return;


  }



/*   regeval(regfield(p -> pc, free_word0)) != NULL  */



#if (dbg_flag > 5)
printf("\napply_free:%u: ", count);
printf("regeval(regfield(p -> pc, free_word0)) = 0x%x != NULL",
regeval(regfield(p -> pc, free_word0))
);

printf("\nregfield(regfield(p -> pc, free_word0), op_code) = %u = '%c'",
regfield(regfield(p -> pc, free_word0), op_code),
regfield(regfield(p -> pc, free_word0), op_code)
);
printf("\nregfield(regfield(p -> pc, free_word0), bddvalue) = 0x%x",
regfield(regfield(p -> pc, free_word0), bddvalue)
);

#endif



if ( regfield(regfield(p -> pc, free_word0), bddvalue) != NULL )
   /* reset bdd */
{ /* then reset bdd  */



#if (dbg_flag > 5)
printf(
"\napply_free:%u: then: regfield(regfield(p -> pc, free_word0), bddvalue) = 0x%x != NULL",
count, 
regfield(regfield(p -> pc, free_word0), bddvalue)
);
#endif

#if 1
 delete_nonglb_bdd( read_bddvalue(regfield(p -> pc, free_word0)) );


#if (dbg_flag > 10)
printf("\napply_free:%u: bdd 0x%x freed", 
count,
read_bddvalue(regfield(p -> pc, free_word0))
);
#endif



/* reset */
regfield(regfield(p -> pc, free_word0), bddvalue) = NULL;



/*  store in free1 pointer to first free (this one)  */

regfield(regfield(p -> pc, free_word0), free1) =
p -> pc;




#if (dbg_2 > 0)
read_bddvalue(regfield(p -> pc, free_word0))
=
nonglb2null(
    read_bddvalue(regfield(p -> pc, free_word0))
);
#endif


switch ( (int) regfield(regfield(p -> pc, free_word0), op_code)  )
   {
       case tk_join:

#if (dbg_flag > 5)
printf("\napply_free:%u: regfield(regfield(p -> pc, free_word0), op_code) == tk_join == %u", 
count, 
tk_join
);
#endif
       
for (
i = 0; 
i < (unsigned int) regfield(regfield(p -> pc, free_word0), join_word0); 
i++)
           {


#if (dbg_flag > 5)
printf("\napply_free:%u: switch: join:  i = %u, deleting bdd:", count, i);
printf("\nread_bddarray(regfield(p -> pc, free_word0), i) = 0x%x", 
read_bddarray(regfield(p -> pc, free_word0), i)
);
#endif


delete_nonglb_bdd( 
        read_bddarray(regfield(p -> pc, free_word0), i)
                 );


#if (dbg_flag > 5)
printf("\napply_free:%u: switch: join:  i = %u, bdd deleted", count, i);
#endif


#if (dbg_2 > 0)
read_bddarray(regfield(p -> pc, free_word0), i)
=
nonglb2null(
    read_bddarray(regfield(p -> pc, free_word0), i)
);
#endif


           }



#if 0
/* free bddarray */

free(regfield(regfield(p -> pc, free_word0), bddarray));
#endif


                break;
        



       default:  /* do nothing */

                break;


   }


#endif


#if (dbg_flag > 10)
printf("\napply_free:%u: advance pc: old pc = 0x%x", count, p -> pc);
#endif


/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);

#if (dbg_flag > 10)
printf("\napply_free:%u: new pc = 0x%x\n\n", count, p -> pc);
#endif


} /* then reset bdd  */



#if (ONLY_RESET != 0)
/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);

#if (dbg_flag > 10)
printf("\napply_free:%u: new pc = 0x%x\n\n", count, p -> pc);
#endif

return;
#endif


#if (ONLY_RESET == 0)

else  /* regfield(regfield(p -> pc, free_word0), bddvalue) == NULL  */
   {     /* else:  unlink */


#if (dbg_flag > 5)
printf(
"\napply_free:%u: else: regfield(regfield(p -> pc, free_word0), bddvalue) = 0x%x == NULL",
count, 
regfield(regfield(p -> pc, free_word0), bddvalue)
);
#endif



#if (no_unlink_freed == 0)







/* unlink first free */
unlink_free( regfield(regfield(p -> pc, free_word0), free1) );





switch ( (int) regfield(regfield(p -> pc, free_word0), op_code)  )
   {
       case tk_join:

#if (dbg_flag > 5)
printf(
"\napply_free:%u: freeing regfield(regfield(p -> pc, free_word0), bddarray) = 0x%x", 
count,
regfield(regfield(p -> pc, free_word0), bddarray)
);
#endif
       


/* free bddarray */

free(regfield(regfield(p -> pc, free_word0), bddarray));



#if (dbg_flag > 5)
printf(
"\napply_free:%u: freed regfield(regfield(p -> pc, free_word0), bddarray) = 0x%x", 
count,
regfield(regfield(p -> pc, free_word0), bddarray)
);
#endif


                break;
        



       default:  /* do nothing */

                break;


   }


/* unlink freed id */


#if (dbg_flag > 10)
printf("\napply_free:%u: unlink freed id", 
count
);
printf("\nregfield(p -> pc, free_word0) = 0x%x", 
regfield(p -> pc, free_word0)
);
printf("\nnext_pc = regfield(regfield(p -> pc, free_word0), ptr_up) = 0x%x", 
regfield(regfield(p -> pc, free_word0), ptr_up)
);
#endif

next_pc =
regfield(regfield(p -> pc, free_word0), ptr_up);



#if (dbg_flag > 10)
printf("\napply_free:%u: ", 
count
);
printf("before: regfield(next_pc, ptr_down) = 0x%x", 
regfield(next_pc, ptr_down)
);
printf("\nregfield(regfield(p -> pc, free_word0), ptr_down) = 0x%x", 
regfield(regfield(p -> pc, free_word0), ptr_down)
);
#endif


regfield(next_pc, ptr_down)
=
regfield(regfield(p -> pc, free_word0), ptr_down);


#if (dbg_flag > 10)
printf("\napply_free:%u: ", 
count
);
printf("after: regfield(next_pc, ptr_down) = 0x%x", 
regfield(next_pc, ptr_down)
);
#endif

#if (dbg_flag > 10)
printf("\napply_free:%u: before:", 
count
);
printf(
"\nregfield(regfield(regfield(p -> pc, free_word0), ptr_down), ptr_up) = 0x%x", 
regfield(regfield(regfield(p -> pc, free_word0), ptr_down), ptr_up)
);
#endif

regfield(
   regfield(regfield(p -> pc, free_word0), ptr_down), 
   ptr_up
        )
=
next_pc;

#if (dbg_flag > 10)
printf("\napply_free:%u: after:", 
count
);
printf(
"\nregfield(regfield(regfield(p -> pc, free_word0), ptr_down), ptr_up) = 0x%x", 
regfield(regfield(regfield(p -> pc, free_word0), ptr_down), ptr_up)
);
#endif


#if 0
/* this is to be done at symbol table level */

#if (dbg_flag > 10)
printf("\napply_free:%u: free string freed id", count);
printf("\nfreeing string: %s", 
vtxeval(regfield(p -> pc, free_word0), 1)
);
#endif


/* free string */
free(vtxeval(regfield(p -> pc, free_word0), 1));
#endif


#if (dbg_flag > 10)
printf("\napply_free:%u: ck_st: delete id %s from symbol table", 
count,
vtxeval(regfield(p -> pc, free_word0), 1)
);
#endif

#if (dbg_flag > 0)
info_ptr =
#endif

free_symbtab_bucket(
    Key_Words_Table, 
    vtxeval(regfield(p -> pc, free_word0), 1)
);


#if (dbg_flag > 10)
printf("\napply_free:%u: expected: info_ptr == 0x%x == 0x%x == regfield(p -> pc, free_word0)", 
count,
info_ptr,
regfield(p -> pc, free_word0)
);

if ( info_ptr != regfield(p -> pc, free_word0) )
/* error */
  {
     fprintf(stderr, 
"\n\nerror: info_ptr != regfield(p -> pc, free_word0)");

     exit (1);
  }
#endif


#if (dbg_flag > 10)
printf("\napply_free:%u: free vtx freed id", count);
printf("\nfreeing: regeval(regfield(p -> pc, free_word0)) = 0x%x", 
regeval(regfield(p -> pc, free_word0))
);
#endif

/* free vtx */
free( regeval(regfield(p -> pc, free_word0)) );



#if (dbg_flag > 10)
printf("\napply_free:%u: free idvtx freed id", count);
printf("\nfreeing: regfield(p -> pc, free_word0) = 0x%x", 
regfield(p -> pc, free_word0)
);
#endif

/*  free idvtx */
free( regfield(p -> pc, free_word0) );







/* save next value for pc */
next_pc = regfield(p -> pc, ptr_down);




/* unlink second free instruction */

unlink_free(p -> pc);







/* advance pc */

p -> pc = next_pc;

#if (dbg_flag > 10)
printf("\napply_free:%u: end: ", count);
printf("p -> pc = 0x%x\n\n", 
p -> pc
);
#endif

#endif




#if (no_unlink_freed != 0)

#if (dbg_flag > 10)
printf("\napply_free:%u: advance pc", count);
#endif


/* advance pc */

p -> pc = regfield(p -> pc, ptr_down);

#endif


   }    /* else:  unlink */


#endif
/* close: ONLY_RESET */






#if (print_info > 5)
#if (prt_instr > 10)
end_prt_info(p);
#endif
#endif


}  /*  apply_free  */















void unlink_free(void *ptrfree)
{

/* unlink free instruction */


#if (dbg_flag > 10)
printf("\n\nunlink_free: begin: free ptr: 0x%x", ptrfree);
printf("\nregfield(ptrfree, ptr_up) = 0x%x", 
regfield(ptrfree, ptr_up)
);
printf("\nregfield(ptrfree, ptr_down) = 0x%x", 
regfield(ptrfree, ptr_down)
);
printf("\nregfield(regfield(ptrfree, ptr_up), ptr_down) = 0x%x", 
regfield(regfield(ptrfree, ptr_up), ptr_down)
);
printf("\nregfield(regfield(ptrfree, ptr_down), ptr_up) = 0x%x", 
regfield(regfield(ptrfree, ptr_down), ptr_up)
);
#endif


regfield(regfield(ptrfree, ptr_up), ptr_down) =
regfield(ptrfree, ptr_down);

regfield(regfield(ptrfree, ptr_down), ptr_up)
=
regfield(ptrfree, ptr_up);

#if (dbg_flag > 10)
printf("\nunlink_free: new values: ");
printf("\nregfield(regfield(ptrfree, ptr_up), ptr_down) = 0x%x", 
regfield(regfield(ptrfree, ptr_up), ptr_down)
);
printf("\nregfield(regfield(ptrfree, ptr_down), ptr_up) = 0x%x", 
regfield(regfield(ptrfree, ptr_down), ptr_up)
);
#endif


#if (dbg_flag > 10)
printf("\nunlink_free: regeval(ptrfree) = 0x%x", 
regeval(ptrfree)
);
#endif


#if (dbg_flag > 10)
printf("\nunlink_free: next_pc = regfield(ptrfree, ptr_down) = 0x%x", 
regfield(ptrfree, ptr_down)
);
#endif



#if (dbg_flag > 10)
printf("\nunlink_free: free vtx free instruction");
printf("\n\tfreeing: regeval(ptrfree) = 0x%x", regeval(ptrfree));
#endif

/* free vtx */
free( regeval(ptrfree) );


#if (dbg_flag > 10)
printf("\nunlink_free: free idvtx free instruction");
printf("\n\tfreeing: ptrfree = 0x%x", ptrfree);
#endif

/*  free idvtx */
free( ptrfree );


#if (dbg_flag > 10)
printf("\nunlink_free: 0x%x: end\n\n", ptrfree);
#endif



}       /* unlink_free()  */




