/*
************************************
file: ifte.c
************************************
*/


#include "local.h"


#define prt_instr 0  /* 0: quiet, > 10> show instruction when exec */



#define dbg_flag 0  /* normal value: 0  */


void apply_loopback(prghdr *p)
{
/* dcl  */
void *prg_reg;
void *last_reg;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (print_info > 5)
#if (prt_instr > 10)
begin_prt_info(p);


#if (keep_ids > 0)
printf(": loopback %s",
vtxeval(regfield(p -> pc, loopback_word0), 1)
);
#endif


#if (keep_ids == 0)
printf(": loopback p%x",
regfield(p -> pc, loopback_word0)
);
#endif



#endif
#endif


#if (dbg_flag > 10)
printf("\n\napply_loopback:%u: begin: p = 0x%x, pc = 0x%x", count, p, p -> pc);
printf("\np -> old_bddvalue == 0x%x", p -> old_bddvalue);
printf("\np -> new_bddvalue == 0x%x", p -> new_bddvalue);
printf("\np -> pc == 0x%x", p -> pc);
printf("\nregeval(p -> pc) == 0x%x", regeval(p -> pc));
printf("\n");
#endif




  if ( bdd_equal(p -> old_bddvalue, 
                 p -> new_bddvalue
                ) 
    )
  /* advance pc  */
   {

#if (dbg_flag > 10)
printf("\n\napply_loopback:%u: old bdd 0x%x == new bdd 0x%x", count,
p -> old_bddvalue,
p -> new_bddvalue
);
#endif
   
     delete_nonglb_bdd( p -> old_bddvalue );

     p -> pc = regfield(p -> pc, ptr_down);
     return;

   }


#if (dbg_flag > 10)
printf("\napply_loopback:%u: old bdd 0x%x != new bdd 0x%x: reset", count,
p -> old_bddvalue,
p -> new_bddvalue
);
#endif


/*  !bdd_equal(p -> old_bddvalue, p -> new_bddvalue)   */

/*  loopback and reset  */


/*  reset */

/* go to last nonfree instruct. before loopback  */

last_reg = p -> pc;


while (1)
{

last_reg = regfield(last_reg, ptr_up);

         switch ( (int) regfield(last_reg, op_code) )
               {

                 case tk_ifte:
                 case tk_compose:
                 case tk_xarg:
                 case tk_boolean:
                 case tk_prj:
                 case tk_join:


                  break;



                 default:  /* do nothing  */

                 continue;


               }

     /* nonfree in last_reg */

     break;

}  /* while  */





prg_reg = regfield(p -> pc, loopback_word0);

#if (dbg_flag > 10)
printf("\napply_loopback:%u: prg_reg = 0x%x", count, prg_reg);
#endif


while ( prg_reg != last_reg )
     {

#if (dbg_flag > 10)
printf("\napply_loopback:%u: begin while: ", count, prg_reg);
printf("\nprg_reg == 0x%x != 0x%x == regfield(p -> pc, ptr_up)", 
prg_reg,
regfield(p -> pc, ptr_up)
);
printf("\nregfield(prg_reg, op_code) == %u == '%c'", 
regfield(prg_reg, op_code),
regfield(prg_reg, op_code)
);

#endif

         switch ( (int) regfield(prg_reg, op_code) )
               {

                 case tk_ifte:
                 case tk_compose:
                 case tk_xarg:
                 case tk_boolean:
                 case tk_prj:
                 case tk_join:

#if (dbg_flag > 10)
printf("\napply_loopback:%u: switch: tk_ifte ... deleting bdd 0x%x", 
count,
read_bddvalue(prg_reg)
);
#endif

 if (read_bddvalue(prg_reg) != NULL)
    { 
      delete_nonglb_bdd( read_bddvalue(prg_reg) ); 
    }

#if (dbg_flag > 10)
printf("\napply_loopback:%u: bdd deleted", 
count
);
#endif


 regfield(prg_reg, bddvalue) = glb_bdd_zero;

#if (dbg_flag > 10)
printf("\napply_loopback:%u: bdd reset to 0", 
count
);
#endif


 break;


                 default:  /* do nothing  */

#if (dbg_flag > 10)
printf("\napply_loopback:%u: switch: default: do nothing", 
count
);
#endif

                        break;


               }

#if (dbg_flag > 10)
printf("\napply_loopback:%u: end switch", 
count
);
#endif

        prg_reg = regfield(prg_reg, ptr_down);


     }


#if (dbg_flag > 10)
printf("\napply_loopback:%u: end while", 
count
);
#endif


/* delete old value */

     delete_nonglb_bdd( p -> old_bddvalue );



/* loopback pc */

p -> pc = regfield(p -> pc, loopback_word0);



#if (dbg_flag > 10)
printf("\napply_loopback:%u: p -> pc = 0x%x", 
count,
p -> pc
);
#endif


ite_counter++;

#if (dbg_flag > 10)
printf("\napply_loopback:%u: ite_counter == %u", 
count,
ite_counter
);
#endif



#if (print_info > 5)
#if (prt_instr > 10)
end_prt_info(p);
#endif
#endif


#if (dbg_flag > 10)
printf("\n\napply_loopback:%u: end: new pc = 0x%x", 
count,
p -> pc
);
#endif


}  /*  apply_loopback */
