/*
**************************
prgvtx.h
**************************
*/


#ifndef prgvtx_h
#define prgvtx_h

#include <stdlib.h>
#include <stdio.h>



#define regeval(L) (*((void **) L))
#define vtxeval(v, i) ((void **) v)[i]
#define regfield(L, i) vtxeval(regeval(L), i)




#if (dbg_flag > 100)
printf("\nupdate_compose:%u: key %s, reglist_reg = 0x%x, reglist_size = %u", 
count,
key,
vtxeval(regeval(calling_reg), compose_word0 + 2),
reglist_size
);
#endif


#define ptr_up 0
#define ptr_down 1
#define op_code 2
#define bddvalue 3
#define free1 4
#define bddarray 5

#define max_size_vtx 8

/*
**************************
begin, end (used only for padding)
Note: no words.
Vertex Format:
ptr_up ptr_down opcode 
**************************
*/

#define size_begin (max_size_vtx - 5)
#define size_end (max_size_vtx - 5)


/*
**************************
ifte
Vertex Format:
ptr_up ptr_down opcode bddvalue free1
id id id 
**************************
*/

#define size_ifte max_size_vtx
#define ifte_word0 5




/*
**************************
compose
Vertex Format:
ptr_up ptr_down opcode bddvalue free1
id num id 
**************************
*/

#define size_compose max_size_vtx
#define compose_word0 5




/* query: isone, satasg, eval, C
Vertex Format:
ptr_up ptr_down opcode id ordlist_reg string
*/
#define size_query (max_size_vtx - 2)
#define query_word0 3





/* boole:
Vertex Format:
ptr_up ptr_down opcode bddvalue free1 boolean_value
*/
#define size_boole (max_size_vtx - 2)
#define boole_word0 5


/* xarg:
Vertex Format:
ptr_up ptr_down opcode bddvalue free1 unsigned_int
*/
#define size_xarg (max_size_vtx - 2)
#define xarg_word0 5



/* prj:
Vertex Format:
ptr_up ptr_down opcode bddvalue free1 id unsigned_int
*/
#define size_prj (max_size_vtx - 1)
#define prj_word0 5


/*  join as ordlist  */

/* join
Vertex Format:
ptr_up ptr_down opcode bddvalue free1 bddarray size_fws_list fws_list
*/
#define size_join max_size_vtx
#define join_word0 6



/* ordlist
Vertex Format:
ptr_up ptr_down opcode size_fws_list fws_list
*/
#define size_ordlist (max_size_vtx - 3)
#define ordlist_word0 3




/* loopback
Vertex Format:
ptr_up ptr_down opcode register
*/
#define size_loopback (max_size_vtx - 4)
#define loopback_word0 3



/* free
Vertex Format:
ptr_up ptr_down opcode register
*/
#define size_free (max_size_vtx - 4)
#define free_word0 3



/*
***************************************
prg header:
ord: arg order;
prg: program;
reg: reglists;
xlist: xlists;
pc: program counter
mode: (mode: set, reset)
target: (target: prg instruction up to which resetting)
*****************************************
*/




typedef struct Program_Header
{

  void *prg;
  void *pc;        /* program counter */
  void *ordlist;
  void *old_bddvalue;
  void *new_bddvalue;
  char *answfilename;
  unsigned int maxarg;
  char *cfilename;

} prghdr;









void* get_prgvtx(unsigned int size);


void fprint_prgvtx(FILE* fileptr, void* p);


prghdr* get_prghdr();



#endif

