/*
*************************************
file: loadkeys.c
Load keywords in symbol table T.
*************************************
*/


#include "local.h"



#define debug 0     /* normal value: 0  */
 


void load_keywords(void* T)
{
/* declarations  */


void* p;   /*  bucket  */

char *key;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* programs  */


#if (dbg_flag > 0)
printf("\n\nload_keywords:%u: ckp 100: symbol_table = 0x%x",
count,
T
);
#endif





/* Load keywords  */


p = get_new_stbk();
write_stbk_key(p, "(");
write_stbk_tkcode(p, tk_leftpar);
write_stbk_info(p, NULL);
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, ")");
write_stbk_tkcode(p, tk_rightpar);
write_stbk_info(p, NULL);
write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "{");
write_stbk_tkcode(p, tk_leftcurl);
write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "}");
write_stbk_tkcode(p, tk_rightcurl);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "=");
write_stbk_tkcode(p, tk_equal);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "ifte");
write_stbk_tkcode(p, tk_ifte);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, "compose");
write_stbk_tkcode(p, tk_compose);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "xarg");
write_stbk_tkcode(p, tk_xarg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 


p = get_new_stbk();
write_stbk_key(p, "prj");
write_stbk_tkcode(p, tk_prj);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 


p = get_new_stbk();
write_stbk_key(p, "join");
write_stbk_tkcode(p, tk_join);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 



p = get_new_stbk();
write_stbk_key(p, "boole");
write_stbk_tkcode(p, tk_boolean);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  



p = get_new_stbk();
write_stbk_key(p, "ordlist");
write_stbk_tkcode(p, tk_ordlist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 




p = get_new_stbk();
write_stbk_key(p, "isone");
write_stbk_tkcode(p, tk_isone);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "eval");
write_stbk_tkcode(p, tk_eval);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  



p = get_new_stbk();
write_stbk_key(p, "satasg");
write_stbk_tkcode(p, tk_satasg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  




  
p = get_new_stbk();
write_stbk_key(p, "C_code");
write_stbk_tkcode(p, tk_C);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  



p = get_new_stbk();
write_stbk_key(p, "loopback");
write_stbk_tkcode(p, tk_loopback);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


p = get_new_stbk();
write_stbk_key(p, "free");
write_stbk_tkcode(p, tk_free);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  





p = get_new_stbk();
write_stbk_key(p, "exec");
write_stbk_tkcode(p, tk_exec);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);







#if 0
p = get_new_stbk();
write_stbk_key(p, "i");
write_stbk_tkcode(p, tk_ifte);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "c");
write_stbk_tkcode(p, tk_compose);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

 p = get_new_stbk();
write_stbk_key(p, "x");
write_stbk_tkcode(p, tk_xarg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

 p = get_new_stbk();
write_stbk_key(p, "p");
write_stbk_tkcode(p, tk_prj);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


 p = get_new_stbk();
write_stbk_key(p, "j");
write_stbk_tkcode(p, tk_join);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "b");
write_stbk_tkcode(p, tk_boolean);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "X");
write_stbk_tkcode(p, tk_ordlist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


p = get_new_stbk();
write_stbk_key(p, "q");
write_stbk_tkcode(p, tk_isone);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


p = get_new_stbk();
write_stbk_key(p, "e");
write_stbk_tkcode(p, tk_eval);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "s");
write_stbk_tkcode(p, tk_satasg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "C");
write_stbk_tkcode(p, tk_C);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "K");
write_stbk_tkcode(p, tk_loopback);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "F");
write_stbk_tkcode(p, tk_free);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

#endif


}  /* prg  */





