/*
*************************************
file: setlex.c


Set lexan local variables.

Usage of lexan:


lexinput = fopen(filename, "r");
begin_lexan();
set_lexan(lexinput, filename);


.... read tokens .....




end_lexan();  %delete char buf and symbol table

fclose(lexinput);

Primes:
9997, 100003, 1000003
*************************************
*/


#include "local.h"





#define debug 0       /* normal value: 0  */
#define print_stb 0   /* normal value: 0  */


#define ST_SIZE 9997   /*  prime number  */




void begin_lexan()
{

/* size symbol table prime number  */
Key_Words_Table = create_symb_table(ST_SIZE);



lexbuf = (char *) malloc( sizeof(char) * BSIZE );

if (lexbuf == NULL)
  {
     printf("\ninit_lexan: no malloc space  ");
     exit (1000);
  }

/*  lexbuf != NULL  */



load_keywords(Key_Words_Table);

}






void end_lexan()
{

#if (debug > 10)
printf("\nend_lexan: begin: free lexbuf");
#endif

free(lexbuf);

#if (debug > 10)
printf("\nend_lexan: delete symbol table");
#endif

#if (print_stb > 10)
/*
*******************************
Print Symbol table for debug
*******************************
*/
printf("\n\n\n\n\n");
printf("\n*******************************************");
printf("\nSymbol Table");
printf("\n*******************************************");
print_symbtab(stdout, Key_Words_Table);
#endif


check_id_def(Key_Words_Table);

delete_symbtab(Key_Words_Table);

#if (debug > 10)
printf("\nend_lexan: end");
#endif

}










void set_lexan(
FILE* src_file,
char* filename
)
{

lexfile_ptr = src_file;
lexfile_name = filename;
line_number = 1;

}  /*  set_lexan   */



FILE* lexan_file()
{
   return (lexfile_ptr);
}



char* lexan_fname()
{
   return (lexfile_name);
}





void lexreset_linenum()
{
  line_number = 1;
}



unsigned int lex_line_number()
{
  return (line_number);
}


