/*
*************************************
file: symbtab.c

This version of lexan
does not need a symbol table since all keywords are chars and there are no identifiers.

All that is needed is an array of size 256
to record keyword codes (i.e. keychar codes).

*************************************
*/




#include "local.h"



#define debug 0     /* normal value: 0  */
 




/*
****************************
A token has two fields:
field 0: code for token type (i.e. num, string, keyword)
field 1: value (i.e. num value or pointer to string,
                nonused for keywords)
*****************************
*/


void* make_token()
{
/* declarations  */

void* p;

/*  program  */

p = (void *) malloc(sizeof(unsigned int) * 2);

if (p == NULL)
  {
     printf("\nmake_token: no malloc space\n");
     exit (1000);
  }

/*  p != NULL  */


  return (p);


}  /*  make_token  */









unsigned int read_token_lexcode(void* token)
{
   return ( ((unsigned int *) token)[0] );
}



unsigned int read_token_value(void* token)
{
   return ( ((unsigned int *) token)[1] );
}




void write_token_lexcode(void* token, unsigned int value)
{
   ((unsigned int *) token)[0] = value;
}


void write_token_value(void* token, unsigned int value)
{
   ((unsigned int *) token)[1] = value;
}


