/*
*************************************
file: download.c



Write program p in file filename.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
#define print_ord 100  /* normal value: 0  */
#define argpos_arity 20  /* used in print argpos */




void download(prghdr* phdr, /* program header */
              char *filename)
{

/* dcl  */
FILE* fileptr;
void* p;  /* prg label for instruction  */
void *p_vtx;   /* prg vertex  */
unsigned int i;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndownload:%u: begin, open file", count);
#endif


fileptr = fopen(filename, "w");




#if (dbg_flag > 100)
printf("\ndownload:%u: print ordlist", count);
#endif



/*  maxarg  */

fprintf(fileptr, "\n\n/* maxarg = %u */\n\n",
phdr -> maxarg
);



/*
*************************
Print ordlists
*************************
*/

fprintf(fileptr, "\n\n/* Ordlists */\n\n");

/*  first instruction */
p = phdr -> ordlist;

 while (p != NULL)
  {
       /* print line, p != NULL */

p_vtx = *((void* *) p);

       fprint_prgvtx(fileptr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */






#if (dbg_flag > 100)
printf("\ndownload:%u: print program", count);
#endif


/*
*************************
Print program instructions 
*************************
*/
fprintf(fileptr, "\n\n/* Program */\n\n");

/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       p_vtx = *((void* *) p);

       fprint_prgvtx(fileptr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */







#if (dbg_flag > 100)
printf("\ndownload:%u: close file", count);
#endif



fclose(fileptr);


#if (dbg_flag > 10)
printf("\ndownload:%u: end", count);
#endif




}  /*  prg  */





















