/*
***********************************
File: fifo.c


***********************************
*/


#include "local.h"

#define dbg_flag 0




typedef struct QUEUE queue;

struct QUEUE
{
unsigned int info;
queue *next;
};


void* create_fifo()
{
/* declarations  */


/* program  */
/*  declarations  */
unsigned int *result;

/*  program  */

result = (unsigned int *) malloc(
              sizeof(unsigned int) * 2
                        );

if (result == NULL)
{
  printf("\ncreate_fifo: error: no malloc space");
  exit (1000);
}

/*  result != NULL  */

result[0] = (unsigned int) NULL;
result[1] = (unsigned int) NULL;

return ( (void *) result);



}





void in_fifo(void *fifo, unsigned int value)
{
/* declarations  */
queue *p;


#if (dbg_flag > 0)
static unsigned int counter = 0;

counter++;
#endif


/*  program  */

#if (dbg_flag > 10)
printf("\n\nin_fifo:%u:  ckp 100 (begin): value = %u = 0x%x", 
counter, value, value);
#endif

p = (queue *) malloc(sizeof(queue));

#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 200: p = 0x%x", counter, p);
#endif


if (p == NULL)
{
  printf("\nput_fifo_bpft: error: no malloc space");
  exit (1000);
}

#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 300", counter);
#endif



/*  p != NULL  */

(p -> info) = value;
(p -> next) = NULL;


#if (dbg_flag > 10)
printf("\nin_fifo:%u: ckp 400: info = %u = 0x%x, next = 0x%x", 
counter, p -> info, p -> info, p -> next);
#endif



if ( ((queue *) ((unsigned int *) fifo)[0]) == NULL)
/*  empty queue  */
{
#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 500: head = 0x%x", 
counter, ((queue *) ((unsigned int *) fifo)[0])
);
#endif

   ((unsigned int *) fifo)[0] = (unsigned int) p;
   ((unsigned int *) fifo)[1] = (unsigned int) p;

#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 600", counter);
#endif

}
else  /*  queue nonempty  */
    {

#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 700: head = 0x%x", 
counter, ((queue *) ((unsigned int *) fifo)[0])
);
#endif

      ((queue *) ((unsigned int *) fifo)[1]) -> next = p;

#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 720", counter);
#endif


      ((unsigned int *) fifo)[1] = (unsigned int) p;

#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 800", counter);
#endif

    }


#if (dbg_flag > 10)
printf("\nin_fifo:%u:  ckp 1000", counter);
#endif

}   /*  in_fifo  */




/*  HYP: fifo nonempty   */
unsigned int out_fifo(void *fifo)
{
/* declarations  */
queue *p;
unsigned int result;

/*  program  */

p = ((queue *) ((unsigned int *) fifo)[0]);

((queue *) ((unsigned int *) fifo)[0]) = (p -> next);

result = (p -> info);

free(p);

return ( result );


}  /*  get_fifo_bpft   */



void delete_fifo(void *fifo)
{
/* declarations  */
queue *p, *q;

/*  program  */

p = ((queue *) ((unsigned int *) fifo)[0]);

while (p != NULL)
  {
    q = (p -> next);
    free(p);
    p = q;
  }

/*  empty queue  */

free(fifo);

}



