/*
*************************************
file: rterm.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or strin pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 20  /* normal value: 0  */
 






void* read_eterm()
{
/* dcl */

unsigned int i;

void* p[2];  /*  token  */
void* tbuf;  /*  fifo  */

unsigned int tsize = 1;

void* *term;
void *vtx;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 100)
printf("\nread_eterm:%u: ckp 100: (begin)", count);
#endif


tbuf = create_fifo();
in_fifo(tbuf, (unsigned int) tk_eval);




/* read number  */
read_new_token(p);
if (p[0] != (void *) tk_num)
/* error  */
  {
       printf("\nerror in file %s line %u: number expected",
               lexan_fname(), lex_line_number()
             );
       exit (1000);
  }


#if (dbg_flag > 100)
printf("\nread_eterm:%u: ckp 200: found num %u", count, p[1]);
#endif

/*  ok: num found  */
in_fifo(tbuf, (unsigned int) p[1]);
tsize++;


/* read string */
read_new_token(p);
if (p[0] != (void *) tk_string)
/* error  */
  {
       printf("\nerror in file %s line %u: string expected",
               lexan_fname(), lex_line_number()
             );
       exit (1000);
  }


/* ok string found  */
#if (dbg_flag > 10)
printf("\nread_eterm:%u: ckp 350: string 0x%x: %s", count, p[1], p[1]);
#endif

in_fifo(tbuf, (unsigned int) p[1]);
tsize++;


/*  term in fifo of size tbuf  */


/*  term in fifo of size tbuf  */

term =  emptyfifo(tbuf, tsize);





/* 
*****************************
Term in term: define prgvtx 
***************************** 
*/

vtx = mkqvtx(term);

/* delete term  */
free(term);


/* return prgvtx */
return (vtx);






}  /*  read_eterm() */













