/*
*************************************
file: rterm.c

Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or strin pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 




void* read_ordlist(void* *p  /* token */)
{
/*  dcl  */


unsigned int listsize = 0;

void* listq_fifo;
void* tlist_vtx;

void* result;
void* vtx;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */


#if (dbg_flag > 100)
printf("\nread_ordlist:%u: ckp 100: (begin)", count);
#endif


/* Opcode is in p[0].  */


vtx = get_prgvtx(size_ordlist);

((void* *) vtx)[op_code] = p[0];



/* read ordlist id */

read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}



/* ok: p[0] == tk_id  */
check_newdef(p);

result = read_stbk_info(p[1]);
*((void* *) result) = vtx;



/* read list of from-width-step  */
/* read '(' */
read_new_token(p);
if (p[0] != (void *) tk_leftpar)
/* error  */
  {
       printf("\nerror in file %s line %u: '(' expected",
               lexan_fname(), lex_line_number()
             );
       exit (1000);
  }


/* ok ( found */
#if (dbg_flag > 100)
printf("\nread_cterm:%u: ckp 300: found '('", count);
#endif



listq_fifo = create_fifo();



/* listsize == 0 */
while (1)
     {

      switch (read_new_token(p))
            {

                case tk_rightpar:  /*  end list */

#if (dbg_flag > 100)
printf("\nread_cterm:%u: ckp 400: found ')'", count);
#endif

                       break;

                case tk_num:  /*  num  */

#if (dbg_flag > 100)
printf("\nread_cterm:%u: ckp 500: found num %u", count, p[1]);
#endif

                       in_fifo(listq_fifo, (unsigned int) p[1]);
                       listsize++;


                       continue;




                default:
                     printf("\nerror in file %s line %u: number or ')' expected",
                     lexan_fname(), lex_line_number());

              exit (1);


            }

/*  ) found, exit while */

         break;
     }







/* listsize >= 0  */

/* note listsize CAN be 0: 
   automatic var ordering
*/


if (listsize == 0)
{ tlist_vtx = NULL;}
else /* listsize >= 1 */
    {
      tlist_vtx =  get_prgvtx(listsize);
   }



/* store listq_fifo  */




/* store listq_fifo  */
emptyfifo2vtx(listq_fifo, tlist_vtx, listsize);





/* store listsize */
((void* *) vtx)[ordlist_word0] = (void *) listsize;


/* store tlist_vtx */
((void* *) vtx)[ordlist_word0 + 1] = tlist_vtx;




/*  check if ordlist is a permutation  */

switch ( check_ordlist(result) )
     {
        case 0: /* ok */
                return ( result );




        case 1: /* out of range */
  printf("\nerror in file %s line %u: value out of range in ordlist",
          lexan_fname(), lex_line_number());

           exit (1);



        case 2: /* redefinition */
  printf("\nerror in file %s line %u: multiple def in ordlist",
          lexan_fname(), lex_line_number());

            exit (1);


        default: /* unk error code */

  printf("\nerror in file %s line %u: unknown error code",
          lexan_fname(), lex_line_number());

             exit (1);

     }




}  /*  read_ordlist()  */

