/*
*************************************
file: upload.c

Print prgvtx on file
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */




void fprint_prgvtx(FILE* fileptr, void* p_lab)
{
/* p_lab: pointer to reg */

/* dcl  */
unsigned int i;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
printf("\nfprint_prgvtx: ckp 100: (begin)");
#endif



p =  *((void* *) p_lab);


       switch ( (unsigned int) ((void* *) p)[op_code] )
          {

              case tk_ifte:
 

#if (keep_ids > 0)
                   fprintf(fileptr, "ifte %s %s %s %s\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, ifte_word0), 1),
vtxeval(vtxeval(p, ifte_word0 + 1), 1),
vtxeval(vtxeval(p, ifte_word0 + 2), 1)
);
#endif


#if (keep_ids == 0)
                  fprintf(fileptr, "ifte p%x p%x p%x p%x\n",
p_lab,
vtxeval(p, ifte_word0),
vtxeval(p, ifte_word0 + 1),
vtxeval(p, ifte_word0 + 2)
);
#endif

 
#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_ifte);
fprintf(fileptr, " */\n");
#endif



                     break;


              case tk_compose:
 
#if (keep_ids > 0)
                 fprintf(fileptr, "compose %s %s %u %s\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, compose_word0), 1),
vtxeval(p, compose_word0 + 1),
vtxeval(vtxeval(p, compose_word0 + 2), 1)
);
#endif



#if (keep_ids == 0)
                 fprintf(fileptr, "compose p%x p%x %u p%x\n",
p_lab,
vtxeval(p, compose_word0),
vtxeval(p, compose_word0 + 1),
vtxeval(p, compose_word0 + 2)
);
#endif



#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_compose);
fprintf(fileptr, " */\n");
#endif

 
                        break;








                   case tk_xarg:

#if (keep_ids > 0)
                      fprintf(fileptr, "xarg %s %u\n",
vtxeval(p_lab, 1),
vtxeval(p, xarg_word0)
);
#endif



#if (keep_ids == 0)
                      fprintf(fileptr, "xarg p%x %u\n",
p_lab,
((void* *) p)[xarg_word0]
);
#endif



#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif



#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_xarg);
fprintf(fileptr, " */\n");
#endif

 
                        break;











                    case tk_boolean:



#if (keep_ids > 0)
                     fprintf(fileptr, "boole %s %u\n",
vtxeval(p_lab, 1),
vtxeval(p, boole_word0)
);
#endif



#if (keep_ids == 0)
                      fprintf(fileptr, "boole p%x %u\n",
p_lab,
((void* *) p)[boole_word0]
);
#endif



#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_boole);
fprintf(fileptr, " */\n");
#endif



                        break;





                   case tk_prj:

#if (keep_ids > 0)
                      fprintf(fileptr, "prj %s %s %u\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, prj_word0), 1),
vtxeval(p, prj_word0 + 1)
);
#endif



#if (keep_ids == 0)
                      fprintf(fileptr, "prj p%x p%x %u\n",
p_lab,
vtxeval(p, prj_word0),
vtxeval(p, prj_word0 + 1)
);
#endif



#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif



#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_prj);
fprintf(fileptr, " */\n");
#endif

 
                        break;







            case tk_join:  


#if (keep_ids > 0)
   fprintf(fileptr, "join %s (", vtxeval(p_lab, 1));
#endif


#if (keep_ids == 0)
                      fprintf(fileptr, "join p%x (",
p_lab
);
#endif



              
                    for (
i = 0; 
i < ((unsigned int) ((void* *) p)[join_word0]); 
i++)
                       {
#if (keep_ids > 0)
fprintf(fileptr, "%s ",
   vtxeval(vtxeval(regfield(p_lab, join_word0 + 1), i), 1)
 );
#endif


#if (keep_ids == 0)
fprintf(fileptr, "%u ",
    vtxeval(regfield(p_lab, join_word0 + 1), i)
 );
#endif
                       } /* for */



                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_join);
fprintf(fileptr, " */\n");
#endif


 
                        break;












                    case tk_free:

#if (keep_ids > 0)
              fprintf(fileptr, "free %s\n",
vtxeval(vtxeval(p, free_word0), 1)
);
#endif



#if (keep_ids == 0)
                      fprintf(fileptr, "free p%x\n",
((void* *) p)[free_word0]
);
#endif



#if (longprint > 10)
fprintf(fileptr, "/* reg=0x%x  vtx=0x%x  up=0x%x  down=0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_loopback);
fprintf(fileptr, " */\n");
#endif



                        break;





                    case tk_loopback:

#if (keep_ids > 0)
              fprintf(fileptr, "loopback %s\n",
vtxeval(vtxeval(p, loopback_word0), 1)
);

#endif



#if (keep_ids == 0)
                    fprintf(fileptr, "loopback p%x\n",
((void* *) p)[loopback_word0]
);
#endif


#if (longprint > 10)
fprintf(fileptr, "/* reg=0x%x  vtx=0x%x  up=0x%x  down=0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_loopback);
fprintf(fileptr, " */\n");
#endif



                        break;





           case tk_isone:  /* query isone  */
           case tk_eval: /* eval  */
           case tk_satasg:  /* satasg  */
           case tk_C:  /* C function */



#if (keep_ids > 0)
                      fprintf(fileptr, "%c %s %s \"%s\"\n",
((void* *) p)[op_code],
vtxeval(vtxeval(p, query_word0), 1),   /* fun */
vtxeval(vtxeval(p, query_word0 + 1), 1),  /* ordlist */
vtxeval(p, query_word0 + 2)   /* string */
);
#endif



#if (keep_ids == 0)
                      fprintf(fileptr, "%c p%x %c%x \"%s\"\n",
((void* *) p)[op_code],
((void* *) p)[query_word0],
tk_ordlist, vtxeval(p, query_word0 + 1),
((void* *) p)[query_word0 + 2]
);
#endif



#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;









            case tk_ordlist:  


#if (keep_ids > 0)
   fprintf(fileptr, "ordlist %s (", vtxeval(p_lab, 1));
#endif


#if (keep_ids == 0)
                      fprintf(fileptr, "ordlist %c%x (",
tk_ordlist,
p_lab
);
#endif



              
                    for (i = 0; i < ((unsigned int) ((void* *) p)[ordlist_word0]); i++)
                       {
fprintf(fileptr, "%u ",
((unsigned int *) ((void* *) p)[ordlist_word0 + 1])[i]
 );

                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_ordlist);
fprintf(fileptr, " */\n");
#endif


 
                        break;





           case tk_begin:  
           case tk_end:
                          /* These are internal instructions
                             only used for padding.
                             No printing 
                           */

                         break;




                 default:  /* error  */
                          printf("\nfprint_prgvtx: error: unknown prog. instruction");
                          exit (1);
        

          }  /* switch */



#if (dbg_flag > 0)
printf("\nfprint_prgvtx: ckp 1100 (end)");
#endif



}  /*  prg  */






void dump_reg(FILE* fileptr, void* p, unsigned int size)
{
/* dcl */
unsigned int i;

/* prg */
fprintf(fileptr, "dump id = 0x%x, vtx = *id = 0x%x:\n",
p, *((void**) p));

for (i = 0; i < size; i++)
   fprintf(fileptr, "vtx[%u] = 0x%x ", i, (*((void***) p))[i]);


}  /*  dump_reg  */

















