/*
********************************
file: config.c

Reads file ~/.bfpcnfg

and defines options.

Format file .bfpcnfg:

-option_number value

where:


option_number is an 
unsigned int denoting an option
value is the value of the option.

Option numbers:

0:  Size bdd hash table
1:  Size cache memory in bdd package
2:  load factor for bdd hash table
3:  threshold for starting garbage collection.


********************************
*/



#include "local.h"

#define dbg_flag 0    /* normal value: 0  */


static
void def_value(
FILE *optfile,
unsigned int i,
unsigned int *optval,
double *optfval
);




void def_options(
unsigned int *optval,
double *optfval
)
{
/*  declarations  */
FILE *optfile, *temp;
unsigned int i;

char line[200];
char mypath[200];

char c;

/*  program  */

#if (dbg_flag > 100)
printf("\ndef_options: ckp 100 (begin)");
#endif

/* get ${home} value  */

temp = fopen("t5e6m7p8.bfp", "w+");
fprintf(temp, "#! /bin/csh\n");
fprintf(temp, "echo ${home} > t1e2m3p4.bfp\n");
fclose(temp);
system("chmod u+x t5e6m7p8.bfp");
system("t5e6m7p8.bfp");
system("rm t5e6m7p8.bfp"); 


temp = fopen("t1e2m3p4.bfp", "r");
fscanf(temp, "%s", line);
fclose(temp);
system("rm t1e2m3p4.bfp"); 


#if (dbg_flag > 100)
printf("\ndef_options: ckp 150: ${home} = %s", line);
#endif

sprintf(mypath, "%s/.bfpcnfg", line);


#if (dbg_flag > 100)
printf("\ndef_options: ckp 160: mypath = %s", mypath);
#endif



optfile = fopen(mypath, "r");

#if (dbg_flag > 100)
printf("\ndef_options: ckp 200");
#endif

#if (dbg_flag > 100)
printf("\ndef_options: ckp 210: bfp config file:\n");
while ( (c = getc(optfile)) != EOF ) putc(c, stdout);
rewind(optfile);
#endif


while ( (c = getc(optfile)) != EOF )  
  {  /* wh  */
       switch (c)
         {   /* sw  */
             
             case '-':  /* option number follows  */
                    
#if (dbg_flag > 100)
printf("\ndef_options: ckp  (- found)");
#endif

                      /* read opt number and define opt value  */
                      fscanf(optfile, "%u", &i);

                      def_value(
optfile, 
i,
optval,
optfval
);

break;

            case '%':   /*  comment: skip line  */
#if (dbg_flag > 100)
printf("\ndef_options: ckp  (%% found)");
#endif

                           c = getc(optfile);
                           if (c == EOF) return;
                           /* c != EOF  */
                        while (c != '\n')
                            {  
                               /* c != EOF  */
                               c = getc(optfile);
                               if (c == EOF) return;
                            }

                        /* c == '\n'  */

                        break;


         }   /* sw  */

    
   
  }   /* wh  */



fclose(optfile);



}  /*  def_options   */





static
void def_value(
FILE *optfile,
unsigned int i,
unsigned int *optval,
double *optfval
)
{


switch (i)
    { /*  sw  */
    
       case 0:   /* Size bdd hash table */
               
                 fscanf(optfile, "%u", &(optval[0]));

#if (dbg_flag > 100)
printf("\ndef_value: ckp 200: bdd hast tab: %u",
optval[0]
);
#endif

                 return;

                
       case 1:   /* Size cache memory in bdd package */
               
                 fscanf(optfile, "%u", &(optval[1]));

#if (dbg_flag > 100)
printf("\ndef_value: ckp 300: bdd cache: %u",
optval[1]
);
#endif

                 return;

                
       case 2:   /* Load factor for bdd hash table */
               
                 fscanf(optfile, "%lf", &(optfval[0]));

#if (dbg_flag > 100)
printf("\ndef_value: ckp 400: load factor: %lf",
optfval[0]
);
#endif


                 return;

       case 3:   /* Threshold for starting garbage collection */
               
                 fscanf(optfile, "%u", &(optval[2]));

#if (dbg_flag > 100)
printf("\ndef_value: ckp 500: threshold: %u",
optval[2]
);
#endif


                 return;


        default:  /* No match  */
               printf("\ndef_value: Error in .bfpcnfg: no match.");
               exit (1000);


    }  /*  sw  */




}   /* def_value  */

