/*
*************************************
file: initbdd.c
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 

void init_bdd(prghdr *p)
{

/* dcl  */
void 	*prg_reg;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */



#if (dbg_flag > 10)
printf("\ninit_bdd:%u: initialize reg's to 0", count, p);
#endif


prg_reg = p -> prg;


while ( prg_reg != NULL )
     {
       /* prg_reg != NULL */
    

         init_bdd_step(prg_reg);


prg_reg = regfield(prg_reg, ptr_down);



     }  /* while  */





#if (dbg_flag > 10)
printf("\ninit_bdd:%u: end: p = 0x%x", count, p);
#endif


}  /*  prg  */










void init_bdd_step(void *prg_reg)
{

/* dcl  */
unsigned int i;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */



#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: initialize reg to 0", count, p);
#endif


/* hyp:  prg_reg != NULL */
    


switch ( (int) regfield(prg_reg, op_code) )
      {
           case tk_ifte:
           case tk_compose:
           case tk_xarg:
           case tk_boolean:
           case tk_prj:

#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: ifte, etc.", count);
#endif

                        /* program instruction: init to 0  */

                        regfield(prg_reg, bddvalue) = glb_bdd_zero;
                        break;




           case tk_join:  /* create and initialize bddarray */


#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: join: create bddarray", count);
#endif

#if 0
/* not needed now since done in parser when reading join */
/* create */
              regfield(prg_reg, bddarray) = 
(bdd) get_prgvtx( (unsigned int) regfield(prg_reg, join_word0) );
#endif



#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: join: initialize bddarray", count);
#endif


/* initialize */

for (
i = 0; 
i < (unsigned int) regfield(prg_reg, join_word0); 
i++)
           {


#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: join: init i = %u", count, i);
#endif


vtxeval(regfield(prg_reg, bddarray), i) = glb_bdd_zero;

           }


#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: join: end init bddarray", count);
#endif



                            break;




           case tk_exec: 

#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: exec", count);
#endif


/* initialize */

for (
i = 1; 
i < (unsigned int) regfield(prg_reg, join_word0); 
i = i + 2
)
           {


#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: join: init i = %u", count, i);
#endif

regfield(
    vtxeval(regfield(prg_reg, join_word0 + 1), i),
                     bddvalue
         )
= glb_bdd_zero;

           }


#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: switch: exec: end init", count);
#endif



                            break;





           default:  /* do nothing */
                      break;


      }  /* switch */



#if (dbg_flag > 10)
printf("\ninit_bdd_step:%u: end: p = 0x%x", count, p);
#endif


}  /*  init_bdd_step() */


















