/*
********************************
file: rw.c

Read Write info table
********************************
*/



#include "local.h"

#include "apply.h"


#include <time.h>


#define print_config 0 /* normal value: 0   */

#define dbg_flag 0 /* normal value: 0   */

#define ck_bddvalue 0  /* normal value: 0   */



/* normal value: 10, use 0 for quiet operation   */
#define print_info 10 


static void runprg_step(prghdr *p);



/*
***************************
Initialize run env 
***************************
*/

void init_run_env()
{
/* declarations  */


/* config values  */
unsigned int optval[3];
double optfval[1];

#if (print_config > 0)
unsigned int i;
#endif


/* program  */
#if (dbg_flag > 100)
printf("\ninit_run_env: begin: define apply table");
#endif


/* define ap table  */

def_apply_table();




#if (dbg_flag > 100)
printf("\nrunprg: start bdd env");
#endif


/*  Read configuration file: .bfpcnfg  */


def_options(optval, optfval);

#if (print_config > 0)
/* print config values  */
for (i = 0; i < 3; i++)
    printf("\nbfp: optval[%u] = %u",
i, optval[i]
);

for (i = 0; i < 1; i++)
    printf("\nbfp: optfval[%u] = %lf",
i, optfval[i]
);
#endif


/* start bdd environment  */
start_bdd_env(optval, optfval);



#if (dbg_flag > 100)
printf("\nrunprg: init bdd values for reg's");
#endif



#if (dbg_flag > 10)
printf("\ninit_bdd:%u: begin: p = 0x%x: define global bdds", count, p);
#endif


init_global_bdds();


}  /* init_run_env()  */







/*
************************
Run program.
************************
*/

void runprg(prghdr *p)
{   /* begin program  */



/* program  */

#if (dbg_flag > 100)
printf("\nrun_program: begin: init bdd reg's");
#endif



init_bdd(p);


#if (dbg_flag > 100)
printf("\nrunprg: start bdd computation");
#endif



runprg_step(p);




#if (dbg_flag > 100)
printf("\nrunprg: end of bdd computation");
#endif



/*  print bdd, time and memory info  */

print_bdd_info();


#if (dbg_flag > 100)
printf("\nrunprg: end");
#endif

}   /* end program  */
















void runprg_step(prghdr *p)
{
/* dcl */


#if (print_info > 0)
long time_rhs[2];
#endif


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif

#if (ck_bddvalue > 0)
static unsigned int i_step = 0;
#endif

/*  prg  */


#if (dbg_flag > 10)
printf("\nrunprg_step:%u: begin: init pc.", count);
#endif

#if (print_info > 5)
printf("\n\n\n");
#endif

p -> pc = p -> prg;

/* initialize timer */
glb_time_rhs[0] = clock();



while (p -> pc != NULL)
   {

#if 0
#if (print_info > 5)
time_rhs[0] = clock();
printf("%u: pc = %x", ite_counter, p -> pc);
#endif
#endif
 
#if (ck_bddvalue > 10)
fprintf(stderr, "\n\n******begin step %u: old_bddvalue == 0x%x, new_bddvalue == 0x%x\n",
i_step,
p -> old_bddvalue,
p -> new_bddvalue
);
#endif



      
       apply(regfield(p -> pc, op_code))(p);


#if (ck_bddvalue > 10)
fprintf(stderr, "\n\n------end step %u: old_bddvalue == 0x%x, new_bddvalue == 0x%x\n",
i_step,
p -> old_bddvalue,
p -> new_bddvalue
);

i_step++;
#endif


#if 0
#if (print_info > 5)
time_rhs[1] = clock();
printf(": %lf (sec.)\n",
((double) (time_rhs[1] - time_rhs[0]))/((double) CLOCKS_PER_SEC));
#endif
#endif

   }



}   /*  runprg_step     */










