/*
**************************
lextkns.h

Token codes for lexan.

Note token codes for keuwords are 8 bits (char).
Thus in 0 - 255.
**************************
*/



#ifndef lextkns_h
#define lextkns_h


/*
***********************************
FLAGS
***********************************
*/



/* 
if keep_ids == 0 then ids deleted
if keep_ids > 0 then ids kept

Use keep_ids == 0 to save memory.
*/
#define keep_ids 10


/* 
*******************************
filter_ids == 0: no filtering,

filter_ids > 100: 
only info for ids not starting with _ printed
********************************
*/

#define filter_ids 10000



/*  
******************************************
lexan token codes 
******************************************
*/

#define tk_unk 1000
#define tk_num 1001
#define tk_eof 1002
#define tk_string 1003
#define tk_id 1004
#define tk_newid 1005
#define tk_oldid 1006



/*  keywords  */
#define tk_leftpar '('
#define tk_leftcurl '{'
#define tk_rightpar ')'
#define tk_rightcurl '}'
#define tk_equal '='

#define tk_ifte 'i'
#define tk_compose 'c'
#define tk_xarg 'x'

#define tk_boolean 'b'

#define tk_isone 'q'
#define tk_eval 'e'
#define tk_satasg 's'
#define tk_C 'C'

#define tk_ordlist 'X'

#define tk_loopback 'K'
#define tk_free 'F'


#define tk_prj 'p'
#define tk_join 'j'
#define tk_exec 'V'




/* begin, end are only used in 
   the internal representation
   of program for padding
   purposes
*/

#define tk_begin 'B'
#define tk_end 'E'

#endif

