/*
**************************
prgvtx.h
**************************
*/


#ifndef prgvtx_h
#define prgvtx_h

#include <stdlib.h>
#include <stdio.h>



#define regeval(L) (*((void **) L))
#define vtxeval(v, i) ((void **) v)[i]
#define regfield(L, i) vtxeval(regeval(L), i)




#if (dbg_flag > 100)
printf("\nupdate_compose:%u: key %s, reglist_reg = 0x%x, reglist_size = %u", 
count,
key,
vtxeval(regeval(calling_reg), compose_word0 + 2),
reglist_size
);
#endif


#define ptr_up 0
#define ptr_down 1
#define op_code 2
#define bddvalue 3
#define bddarray 4



/*
**************************
begin, end (used only for padding)
Note: no words.
Vertex Format:
ptr_up ptr_down opcode 
**************************
*/

#define size_begin 3
#define size_end 3


/*
**************************
ifte
Vertex Format:
ptr_up ptr_down opcode bddvalue
id id id 
**************************
*/

#define size_ifte 7
#define ifte_word0 4




/*
**************************
compose
Vertex Format:
ptr_up ptr_down opcode bddvalue
id num id 
**************************
*/

#define size_compose 7
#define compose_word0 4




/* query: isone, satasg, eval, C
Vertex Format:
ptr_up ptr_down opcode id ordlist_reg string
*/
#define size_query 6
#define query_word0 3





/* boole:
Vertex Format:
ptr_up ptr_down opcode bddvalue boolean_value
*/
#define size_boole 5
#define boole_word0 4


/* xarg:
Vertex Format:
ptr_up ptr_down opcode bddvalue unsigned_int
*/
#define size_xarg 5
#define xarg_word0 4



/* prj:
Vertex Format:
ptr_up ptr_down opcode bddvalue id unsigned_int
*/
#define size_prj 6
#define prj_word0 4


/*  join as ordlist  */

/* join
Vertex Format:
ptr_up ptr_down opcode bddvalue bddarray size_fws_list fws_list
*/
#define size_join 7
#define join_word0 5



/* ordlist
Vertex Format:
ptr_up ptr_down opcode size_fws_list fws_list
*/
#define size_ordlist 5
#define ordlist_word0 3




/* loopback
Vertex Format:
ptr_up ptr_down opcode register
*/
#define size_loopback 4
#define loopback_word0 3



/* free
Vertex Format:
ptr_up ptr_down opcode register
*/
#define size_free 4
#define free_word0 3



/*
***************************************
prg header:
ord: arg order;
prg: program;
reg: reglists;
xlist: xlists;
pc: program counter
mode: (mode: set, reset)
target: (target: prg instruction up to which resetting)
*****************************************
*/




typedef struct Program_Header
{

  void *prg;
  void *pc;        /* program counter */
  void *ordlist;
  void *old_bddvalue;
  char *answfilename;
  unsigned int maxarg;
  char *cfilename;

} prghdr;









void* get_prgvtx(unsigned int size);


void fprint_prgvtx(FILE* fileptr, void* p);


prghdr* get_prghdr();



#endif

