/*
*************************************
file: boole.c


Read id def via boole.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_boole(void* *p  /* token */)
{
/*  dcl  */
void* result;
void* vtx;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_boo:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in p[0].
   We need to read 1 id and an unsigned int
*/



vtx = get_prgvtx(size_boole);

((void* *) vtx)[op_code] = p[0];



/* Note: no varord field for boole */


/* read id for boole_reg  */

read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */
check_newdef(p);

result = read_stbk_info(p[1]);
*((void* *) result) = vtx;



read_new_token(p);
if (p[0] != (void *) tk_num)
/* error */
{
                 printf("\nerror in file %s line %u: num expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_num */

if ( ((unsigned int) p[1]) > 1 )
/* error */
  {
                 printf("\nerror in file %s line %u: 0 or 1 expected",
                          lexan_fname(), lex_line_number());

                 exit (1);

  }

/* ok  */

((void* *) vtx)[boole_word0] = p[1];


    
/* return result */

return (result);


}  /*  read_boole  */ 












