/*
*************************************
file: upload.c

Load program in file into RAM.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 

prghdr* upload(char *filename)
{

/* dcl  */

FILE *lexinput, *tmp_file;

prghdr* p;  /*  program header  */

void 	*tail_prg,
	*tail_ordlist,
	*bsaterm, *bsa_vtx;



/* prg  */


#if (dbg_flag > 0)
printf("\nupload: begin: open input file, start lexan");
#endif



/* initialize lexan  */

lexinput = fopen(filename, "r");
begin_lexan();
set_lexan(lexinput, filename);





#if (dbg_flag > 0)
printf("\nupload: init. prg. hdr.");
#endif


/* create program header  */
p = get_prghdr();


p -> ordlist = NULL;

tail_prg = NULL;
tail_ordlist = NULL;

/* initialize maxarg */
p -> maxarg = 0;


#if (dbg_flag > 0)
printf("\nupload: pad prg with begin");
#endif

p -> prg = get_prgvtx(1);
regeval(p -> prg) = get_prgvtx(size_begin);
vtxeval(regeval(p -> prg), ptr_up) = NULL;
vtxeval(regeval(p -> prg), ptr_down) = NULL;
vtxeval(regeval(p -> prg), op_code) = (void *) tk_begin;
tail_prg = p -> prg;


/* 
   p -> prg != NULL 
   tail_prg != NULL
*/



#if (dbg_flag > 0)
printf("\nupload: read terms");
#endif

/* read all terms in program  */ 

while ( (bsaterm = read_new_term()) != NULL)
     {
       /* bsaterm != NULL */
    

/* move to prgvtx  */

bsa_vtx =  *((void* *) bsaterm);


switch ( (unsigned int) ((void* *) bsa_vtx)[op_code] )
      {
           case tk_ifte:
           case tk_compose:
           case tk_boolean:
           case tk_join:
           case tk_prj:


           case tk_loopback:
           case tk_free:

           case tk_isone:  /* query isone  */
           case tk_eval: /* eval  */
           case tk_satasg:  /* satasg  */
           case tk_C:  /* C function */

           case tk_exec:

                        /* program instruction and queries
                            as well as definition 
                       */

/* tail_prg != NULL */

(*((void** *) tail_prg))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_prg; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in program */
tail_prg = bsaterm;



                        break;




           case tk_xarg:


                       /* program instruction 
                            as well as definition 
                            update maxarg
                       */



/* tail_prg != NULL */

(*((void** *) tail_prg))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_prg; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in program */
tail_prg = bsaterm;



if ( 1 + (unsigned int) regfield(tail_prg, xarg_word0) 
      >  
     (p -> maxarg)
   )
/* update maxarg */
  {

p -> maxarg = 
     1 + (unsigned int) regfield(tail_prg, xarg_word0);

  }



                        break;





            case tk_ordlist:  

/* ordlist: not a prg instr. nor a def. */



if (tail_ordlist == NULL)
     p -> ordlist = bsaterm;
else (*((void** *) tail_ordlist))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_ordlist; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in ordlist list */
tail_ordlist = bsaterm;


                      break;




           default:  /* error  */
                     printf("\nError: unknown instruction\n");
                     exit (1000);

      }  /* switch */





     }  /* while  */



#if (dbg_flag > 0)
printf("\nupload: no more terms: pad with end");
#endif



/* tail_prg != NULL */
vtxeval(regeval(tail_prg), ptr_down) = get_prgvtx(1);
bsa_vtx = get_prgvtx(size_end);
regeval(vtxeval(regeval(tail_prg), ptr_down)) = bsa_vtx;

vtxeval(bsa_vtx, ptr_up) = tail_prg;
vtxeval(bsa_vtx, ptr_down) = NULL;
vtxeval(bsa_vtx, op_code) = (void *) tk_end;

/* no need to update tail_prg */
/* tail_prg = vtxeval(regeval(tail_prg), ptr_down); */


#if 0
/* False: this needs not to be the case */
#if (dbg_flag > 0)
printf("\nupload: check that size_ordlist == maxarg ");
#endif

if ( p -> maxarg 
    != 
    (unsigned int) regfield(p -> ordlist, ordlist_word0) 
   )
/* error  */
{
 printf("\nupload: error: maxarg = %u != %u = ordlist_size",
          p -> maxarg, regfield(p -> ordlist, ordlist_word0));

  exit (1);
          

}
#endif




#if (dbg_flag > 0)
printf("\nupload: close lexan");
#endif


end_lexan();



/* 
   maxarg well defined. 
   Store maxarg in file .tmp.bsp
*/

tmp_file = fopen(".tmp.bsp", "w");
fprintf(tmp_file, "maxarg %u", p -> maxarg);
fclose(tmp_file);



#if (dbg_flag > 0)
printf("\nupload: close input file");
#endif


fclose(lexinput);

#if (dbg_flag > 0)
printf("\nupload: return prg.hdr 0x%x", p);
#endif



return (p);


}  /*  prg  */





















