/*
*************************************
file: ckprjoin.c

Check the following:

1. All prj args are join
2. All joins have at least 2 args.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */








void ck_prj_join(prghdr* phdr /* program header */)
{

/* dcl  */
void* p;  /* prg label for instruction  */
void *p_vtx;   /* prg vertex  */



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndownload:%u: begin, open file", count);
#endif




/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       p_vtx = *((void* *) p);

       ck_step(phdr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */






#if (dbg_flag > 10)
printf("\ndownload:%u: end", count);
#endif




}  /*  prg  */













void ck_step(prghdr *phdr, void *p_lab)
{
/* p_lab: pointer to reg */

/* dcl  */
unsigned int i;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
printf("\nck_step: ckp 100: (begin)");
#endif



p =  *((void* *) p_lab);


       switch ( (unsigned int) ((void* *) p)[op_code] )
          {



              case tk_prj:


/* Check that arg 1 be join  */


if ( vtxeval(vtxeval(vtxeval(p, prj_word0), 0), op_code)  
     !=
     (void *) tk_join
   )
/* error: join expected */
{

fprintf(stderr, "\nck_step: error: join expected as arg{2} of prj in:\n");


#if (keep_ids > 0)
                      fprintf(stderr, "prj %s %s %u\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, prj_word0), 1),
vtxeval(p, prj_word0 + 1)
);
#endif



#if (keep_ids == 0)
                      fprintf(stderr, "prj p%x p%x %u\n",
p_lab,
vtxeval(p, prj_word0),
vtxeval(p, prj_word0 + 1)
);
#endif



exit (1);


}


/* ok  */




                        break;



   



            case tk_join:  


/* check that at least 2 args in join */

if (
     ((unsigned int) ((void* *) p)[join_word0]) < 2
   )
/* error */
{


fprintf(stderr, "\nck_step: error: found %u args, at least 2 args expected in join:\n",
((unsigned int) ((void* *) p)[join_word0])
);




#if (keep_ids > 0)
   fprintf(stderr, "join %s (", vtxeval(p_lab, 1));
#endif


#if (keep_ids == 0)
                      fprintf(stderr, "join p%x (",
p_lab
);
#endif



              
                    for (
i = 0; 
i < ((unsigned int) ((void* *) p)[join_word0]); 
i++)
                       {
#if (keep_ids > 0)
fprintf(stderr, "%s ",
   vtxeval(vtxeval(regfield(p_lab, join_word0 + 1), i), 1)
 );
#endif


#if (keep_ids == 0)
fprintf(stderr, "%u ",
    vtxeval(regfield(p_lab, join_word0 + 1), i)
 );
#endif
                       } /* for */



                      fprintf(stderr, ")\n");


exit (1);


}


/* ok */


 
                        break;





default :  /* nothing to check */

         break;



}   /*  switch  */






}   /* ck_step */














