/*
**************************
prgvtx.h
**************************
*/


#ifndef prgvtx_h
#define prgvtx_h

#include <stdlib.h>
#include <stdio.h>



#define regeval(L) (*((void **) L))
#define vtxeval(v, i) ((void **) v)[i]
#define regfield(L, i) vtxeval(regeval(L), i)




#if (dbg_flag > 100)
printf("\nupdate_compose:%u: key %s, reglist_reg = 0x%x, reglist_size = %u", 
count,
key,
vtxeval(regeval(calling_reg), compose_word0 + 2),
reglist_size
);
#endif


#define ptr_up 0
#define ptr_down 1
#define op_code 2
#define loopback 3
#define bddvalue 4
#define mark0 5
#define mark1 6
#define mark2 7


/*
**************************
begin, end (used only for padding)
Note: no words.
Vertex Format:
ptr_up ptr_down opcode 
**************************
*/

#define size_begin 3
#define size_end 3


/*
**************************
ifte
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2   
id id id 
**************************
*/

#define size_ifte 11
#define ifte_word0 8




/*
**************************
compose
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2
id num id 
**************************
*/

#define size_compose 11
#define compose_word0 8




/* query: isone, satasg, eval, C
Vertex Format:
ptr_up ptr_down opcode loopback id ordlist_reg string
*/
#define size_query 7
#define query_word0 4





/* boole:
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2 boolean_value
*/
#define size_boole 9
#define boole_word0 8


/* xarg:
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2 unsigned_int
*/
#define size_xarg 9
#define xarg_word0 8




/* prj:
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2 id unsigned_int
*/
#define size_prj 10
#define prj_word0 8



/*  join as ordlist  */



/* ordlist
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2 size_fws_list fws_list
*/
#define size_ordlist 10
#define ordlist_word0 8




/* loopback
Vertex Format:
ptr_up ptr_down opcode loopback bddvalue mark0 mark1 mark2 register
*/
#define size_loopback 9
#define loopback_word0 8



/* free
Vertex Format:
ptr_up ptr_down opcode register
*/
#define size_free 4
#define free_word0 3



/*
***************************************
prg header:
ord: arg order;
prg: program;
reg: reglists;
xlist: xlists;
pc: program counter
mode: (mode: set, reset)
target: (target: prg instruction up to which resetting)
*****************************************
*/




typedef struct Program_Header
{

  void *prg;
  void *pc;        /* program counter */
  void *ordlist;
  void *querylist;
} prghdr;









void* get_prgvtx(unsigned int size);


void fprint_prgvtx(FILE* fileptr, void* p);


prghdr* get_prghdr();



#endif

