/*
*********************************
file: bp20.c
*********************************
*/


#include "local.h"

#include "etlogo.h"



#define dbg_flag 0  /*  normal value: 0  */




void bp20(char *prgfile, char* bpfile)
{
/* declarations  */


prghdr* prg;


/* prg */


#if (dbg_flag > 0)
printf("\nbp20: begin: prgfile = %s, bpfile = %s",
prgfile, bpfile
);
#endif



 printf("\n\n\nbp20 version: 1.1 (March 97)");

et_signature();



#if (dbg_flag > 0)
printf("\nbp20: upload %s", prgfile);
#endif


prg = upload(prgfile);


#if (dbg_flag > 10)
printf("\nbp20: show input prgfile in: showprg.bp20");
download(prg, "showprg.bp20");
#endif



#if (dbg_flag > 0)
printf("\nbp20: loop optimization");
#endif

loop_optimization(prg);


#if (dbg_flag > 0)
printf("\nbp20: show loop optimization in: loopopt.bp20");
download(prg, "loopopt.bp20");
#endif




#if (dbg_flag > 0)
printf("\nbp20: define loopback");
#endif



define_loopback(prg);



#if (dbg_flag > 0)
printf("\nbp20: insert loopback");
#endif


insert_loopback(prg);


#if (dbg_flag > 0)
printf("\nbp20: show loopback in: loopback.bp20");
download(prg, "loopback.bp20");
#endif



#if (dbg_flag > 100)
printf("\nbp20: define insert free");
#endif



define_free(prg);

#if (dbg_flag > 0)
printf("\nbp20: show free in: free.bp20");
download(prg, "free.bp20");
#endif




#if (dbg_flag > 100)
printf("\nbp20: schedule query");
#endif


position_query(prg);

#if (dbg_flag > 0)
printf("\nbp20: query scheduled: output file in %s", bpfile);
#endif


download(prg, bpfile);




printf("\n\n\nbp20: time, memory info:\n\n\n");

print_rusage(stdout);

#if 0
system("ps -u | egrep \"PID|bp20\""); /* linux home PC */
system("ps -lu tronci | egrep \"PID|bp20\""); /* SUN, Solaris: smaq20 */
#endif


#if (dbg_flag > 100)
printf("\nbp20: end");
#endif

}    /*  main  */



