/*
*************************************
file: loopopt.c

Esy part of loop optimization.



*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 
#define soon_flg 0  /* normal value:  0  */



/* move booleans to prg head */

/* move xargs to prg head */

/* 
   move defs with rhs in prg head into prg head,
   in pc adr of last instruction inserted,
   pc = NULL if no instruction inserted
*/


#if (soon_flg > 10)
static
int is_soon_used(
	prghdr *p, 
	void *prg_reg
);
#endif



void loop_optmz1(prghdr* p)
{
/* dcl */
void* prg_reg;
void* prg_vtx;

int move_done;


#if (dbg_flag > 0)
static int count = 0;
unsigned int ii = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nloop_optmz1:%u: begin: program = 0x%x", count, p);
#endif


/* reset bddvalue */
 bdd_to_null(p);




/* begin easy part */
/* move booleans to prg head */

/* move xargs to prg head */

/* move defs with rhs in prg head into prg head*/
/* end easy part */



/* initialize pc to last instruction inserted: begin */
p -> pc = p -> prg;  /* begin: != NULL */



move_done = 1;

while (move_done != 0)
 {


move_done = 0;

/*  first instruction not inserted on top */
prg_reg = vtxeval(regeval(p -> pc), ptr_down);


 while (prg_reg != NULL)
  {
       /* print line, p != NULL */

       prg_vtx = regeval(prg_reg);



#if (dbg_flag > 100)
ii++;
printf("\nloop_optmz1:%u: begin switch %u: prg_vtx = 0x%x", 
count, ii, prg_vtx);
#endif


       switch( (int) vtxeval(prg_vtx, op_code) )
          {

           case tk_xarg:
           case tk_boolean:

                        move_mark_def(p, prg_reg);
                        move_done = 1;
                        break;



           case tk_ifte:


                     if ( ifte_is_movable(p, prg_reg)
#if (soon_flg > 10)
                           &&  is_soon_used(p, prg_reg)
#endif

                         )
                     {
                        move_mark_def(p, prg_reg);
                        move_done = 1;
                     }


                     break;



           case tk_compose:


                     if ( compose_is_movable(p, prg_reg)
#if (soon_flg > 10)
                           && is_soon_used(p, prg_reg)
#endif

                        )
                     {
                        move_mark_def(p, prg_reg);
                        move_done = 1;
                     }


                     break;





           case tk_prj:


                     if ( prj_is_movable(p, prg_reg)
#if (soon_flg > 10)
                           && is_soon_used(p, prg_reg)
#endif

                        )
                     {
                        move_mark_def(p, prg_reg);
                        move_done = 1;
                     }


                     break;







           case tk_join:


                     if ( join_is_movable(p, prg_reg)
#if (soon_flg > 10)
                          && is_soon_used(p, prg_reg)
#endif

                        )
                     {
                        move_mark_def(p, prg_reg);
                        move_done = 1;
                     }


                     break;




           case tk_exec:

/* is assumed to be in right position  */

                        move_mark_def(p, prg_reg);
                        move_done = 1;
                        break;


#if 0

       /* mark as defined */
vtxeval(regeval(prg_reg), bddvalue) = (void *) 1;

break;

              if ( exec_is_movable(p, prg_reg) )
                     {
                        move_mark_def(p, prg_reg);
                        move_done = 1;
                     }


                     break;
#endif





           default:  /* do nothing on query  */
          
                     break;

          }


#if (dbg_flag > 100)
printf("\nloop_optmz1:%u: end switch %u: prg_vtx = 0x%x", 
count, ii, prg_vtx);
#endif




       prg_reg = vtxeval(prg_vtx, ptr_down);


  }   /* while */


}  /*  while */







}   /* prg  */







/* to do  */


/* move and mark as defined  in bdd field */
/* HYP: (because of padding with begin, end)
   prg_reg != NULL 
   p -> prg != NULL
   p -> pc != NULL
   vtxeval(regeval(prg_reg), ptr_up) != NULL
   vtxeval(regeval(prg_reg), ptr_down) != NULL
   vtxeval(regeval(p -> pc), ptr_down) != NULL
*/




void move_mark_def(prghdr *p, void *prg_reg)
{
/* dcl */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nmove_mark_def:%u: begin: program = 0x%x; prg_reg = 0x%x, p -> pc = 0x%x", 
count, p, prg_reg, p -> pc);
#endif


/* mark as defined */
vtxeval(regeval(prg_reg), bddvalue) = (void *) 1;

#if (dbg_flag > 100)
printf("\nmove_mark_def:%u: append prg_reg to p -> pc", count);
#endif


p -> pc = move_reg(p, p -> pc, prg_reg);
 
  
#if (dbg_flag > 100)
printf("\nmove_mark_def:%u: end: new value of p -> pc: 0x%x (== prg_reg == 0x%x)", 
count, p -> pc, prg_reg);
#endif



}  /*  move_mark_def   */















/*
   HYP:  vtxeval(regeval(prg_reg), op_code) == tk_ifte

   Returns true (nonzero) iff prg_reg can be moved
   (i.e. its rhs symbols are defined).

*/


int ifte_is_movable(prghdr *p, void *prg_reg)
{
/* dcl */


/* prg */


if (
reg_is_undefined(p, prg_reg, vtxeval(regeval(prg_reg), ifte_word0))
    )
/* undefined */
return (0);

/* rhs 0 defined */

if (
reg_is_undefined(p, prg_reg, vtxeval(regeval(prg_reg), ifte_word0 + 1))
    )
/* undefined */
return (0);

/* rhs 1 defined */




if (
reg_is_undefined(p, prg_reg, vtxeval(regeval(prg_reg), ifte_word0 + 2))
   )
/* undefined */
return (0);

/* rhs 2 defined */


return (1);

}  /*  ifte_is_movable */






int prj_is_movable(prghdr *p, void *prg_reg)
{
/* dcl */


/* prg */


if (
reg_is_undefined(p, prg_reg, vtxeval(regeval(prg_reg), prj_word0))
    )
/* undefined */
return (0);

/* rhs 0 defined */



return (1);

}  /*  prj_is_movable */












int join_is_movable(prghdr *p, void *prg_reg)
{
/* dcl */
unsigned int i;

/* prg */


           
                    for (
i = 0; 
i < (unsigned int) regfield(prg_reg, ordlist_word0);
i++
)
                       {


if (
reg_is_undefined(
p, 
prg_reg, 
vtxeval(regfield(prg_reg, ordlist_word0 + 1), i)
)
   )
/* undefined */
return (0);

/* rhs i defined */

                       } /* for */


return (1);

}  /*  join_is_movable */







#if 0

int exec_is_movable(prghdr *p, void *prg_reg)
{
/* dcl */
unsigned int i;

/* prg */



           
                    for (
i = 1; 
i < (unsigned int) regfield(prg_reg, ordlist_word0);
i = i + 2
)
                       {


if (
reg_is_undefined(
p, 
prg_reg, 
vtxeval(regfield(prg_reg, ordlist_word0 + 1), i)
)
   )
/* undefined */
return (0);

/* rhs i defined */

                       } /* for */


return (1);

}  /*  exec_is_movable */



#endif



















/*
   HYP:  vtxeval(regeval(prg_reg), op_code) == tk_compose

   Returns true (nonzero) iff prg_reg can be moved
   (i.e. its rhs symbols are defined).

*/


int compose_is_movable(prghdr *p, void *prg_reg)
{
/* dcl */


/* prg */

/* check rhs word 0 */

if (
reg_is_undefined(p, prg_reg, vtxeval(regeval(prg_reg), compose_word0))
   )
/* undefined */
return (0);


/* word 0 defined */

if (
reg_is_undefined(p, prg_reg, vtxeval(regeval(prg_reg), compose_word0 + 2))
   )
/* undefined */
return (0);


/* word 2 defined */



/* all rhs regs defined */

return (1);




}  /*  compose_is_movable */











/* set bddvalue to NULL  */

void bdd_to_null(prghdr *p)
{
/* dcl */
void *prg_reg;

/* prg */



/*  first instruction */
prg_reg = (p -> prg);


 while (prg_reg != NULL)
  {
 
       switch( (int) vtxeval(regeval(prg_reg), op_code) )
          {

           case tk_xarg:
           case tk_boolean:
           case tk_ifte:
           case tk_compose:
           case tk_join:
           case tk_prj:
           case tk_exec:


                        vtxeval(regeval(prg_reg), bddvalue) = NULL;


                        break;



           default:  /* do nothing on query and paddings */
          
                     break;

          }




       prg_reg = vtxeval(regeval(prg_reg), ptr_down);


  }   /* while */





}   /*  bdd_to_null  */











int reg_is_undefined(
	prghdr *p, 
	void *prg_reg, /* lhs reg */
	void *arg_reg  /*  rhs reg  */ 
)
{

if ( (vtxeval(regeval(arg_reg), bddvalue) == NULL)
     &&
     (prg_reg != arg_reg)  /* fixpoint def */
   )
/* undefined */
   return (1);
else  
    /* defined */
    return (0);


 
}   /*  reg_is_undefined   */










#if (soon_flg > 10)


/*
return 1 if lhs of prg_reg is used in instruction
after prg_reg, 0 else.
*/

int is_soon_used(
	prghdr *p, 
	void *prg_reg
)
{

/* dcls  */
void *next_reg, *prg_vtx; 
unsigned int i;


/* prg  */
    
     next_reg = vtxeval(regeval(prg_reg), ptr_down);


     if ( next_reg == NULL )
        /* no next */
     { return (1); }







/*  next_reg != NULL */



      prg_vtx = regeval(next_reg);



       switch( (int) vtxeval(prg_vtx, op_code) )
          {

           case tk_xarg:
           case tk_boolean:

                        return (0);



           case tk_ifte:

                 if (prg_reg == vtxeval(regeval(prg_reg), ifte_word0))
                    /* used */
                 { return (1); }

                 if (prg_reg == vtxeval(regeval(next_reg), ifte_word0 + 1))
                    /* used */
                 { return (1); }

                 if (prg_reg == vtxeval(regeval(next_reg), ifte_word0 + 2))
                    /* used */
                 { return (1); }

                 /* nonused */

                 return (0);




           case tk_compose:


 if (prg_reg == vtxeval(regeval(next_reg), compose_word0) )
                    /* used */
                 { return (1); }



if (prg_reg == vtxeval(regeval(next_reg), compose_word0 + 2) )
                    /* used */
                 { return (1); }




                   return (0);










           case tk_prj:


                 if ( prg_reg == vtxeval(regeval(next_reg), prj_word0) )
                    /* used */
                 { return (1); }

                 /* nonused */

                 return (0);


  



           case tk_join:


          
                    for (
i = 0; 
i < (unsigned int) regfield(prg_reg, ordlist_word0);
i++
)
                       {


if ( prg_reg == vtxeval(regfield(prg_reg, ordlist_word0 + 1), i) )
                    /* used */
                 { return (1); }
                       
                        } /* for */

                return (0);







           default:            
                     return (1);

          }


 
}   /*  is_soon_used   */



#endif
