/*
*************************************
file: loopopt.c

Optimize loops in program.

*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
 



void loop_optimization(prghdr* p)
{
/* dcl */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nloop_optimization:%u: begin: program = 0x%x", count, p);
#endif

/* move booleans to prg head */
/* move xargs to prg head */
/* move defs with rhs in prg head into prg head */



#if (dbg_flag > 100)
printf("\nloop_optimization:%u: loop_optmz1", count);
#endif



/* often good, 
   sometimes may be better to disable this opt 
*/

#if 0
loop_optmz1(p);
#endif

fprintf(stderr, "\nloopopt setting: no loop1 optimization\n");



#if (dbg_flag > 100)
printf("\nloop_optimization:%u: loop_optmz2", count);
#endif




/* move defs towards head for remaining defs in prg */
/* this needs an hash table, use that of symbol table */


#if 0
loop_optmz2(p);
#endif


#if (dbg_flag > 100)
printf("\nloop_optimization:%u: end", count);
#endif



}   /* prg  */



