/*
*************************************
file: query.c

Position queries into program.
HYP:
loopback, free already inserted.

Free adr for reg stored in loopback field of
reg.
This has been done by free.



Note:
A better positioning for queries would be:
answer a query on p as soon as p is well defined.

Stacking queries on p above free p
means:
answer queries on p just before p is freed.
*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */





void position_query(prghdr* p)
{
/* dcl */
void *query_reg, *new_reg;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\nposition_query:%u: begin: program = 0x%x", count, p);
#endif


/*  first instruction  */
query_reg = p -> querylist;


 while (query_reg != NULL)
  {

#if (dbg_flag > 100)
printf("\nposition_query:%u: begin while query_reg = 0x%x", count, query_reg);
#endif


 /* save present query_reg */
  new_reg = query_reg;

/* move to next query */
       query_reg = regfield(query_reg, ptr_down);


/* stack query on free of reg */
#if (dbg_flag > 100)
printf("\nposition_query:%u: stack query 0x%x on free 0x%x", count, 
new_reg,
regfield(regfield(new_reg, query_word0), loopback)
);
#endif


       stack_newreg(new_reg, 
                    regfield(regfield(new_reg, query_word0), loopback)
                   );





  }   /* while */



/* reset query list */

p -> querylist = NULL;


#if (dbg_flag > 100)
printf("\nposition_query:%u: end: program = 0x%x", count, p);
#endif


}   /* prg  */






