/*
*************************************
file: cehckord.c


Check if ordlist is well defined,
i.e. it defines a permutation.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 


int check_ordlist(void* ordlist_reg  /* != NULL */)
{

/* dcl  */
unsigned int *pos_array;

unsigned int 
	i, pos_size;

void *buffer;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/*  prg  */




#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: varord = 0x%x", 
count, ordvtx);
#endif



pos_size = 
(unsigned int) 
vtxeval(regeval(ordlist_reg), /* ordlist_vtx */
         ordlist_word0
        );  

#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: fws_size = %u", count, fws_size);
#endif

pos_array = 
(unsigned int *) 
vtxeval(regeval(ordlist_reg), /* ordlist_vtx */
         ordlist_word0 + 1
        );  

#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: fws_array = 0x%x", count, fws_array);
#endif


/* 
   Test if each number in 0 ... (pos_size - 1) 
   occurs exactly one in pos_array
*/


/* buffer for markers */
buffer = get_prgvtx(pos_size);

/* initialize buffer  */
for (i = 0; i < pos_size; i++) vtxeval(buffer, i) = (void *) 0;


/* check pos_array  */
for (i = 0; i < pos_size; i++)
   {

      if ( pos_array[i] >= pos_size )  
      /*  error: out of range  */
       {
          printf("\nError: ordlist ox%x: entry[%u] = %u >= %u\n",
                   ordlist_reg, i, pos_array[i], pos_size);

          return (1);

       }


/* range ok */

 
      if ( (unsigned int) vtxeval(buffer, pos_array[i]) != 0 )  
      /*  error: redefinition  */
       {
          printf("\nError: ordlist ox%x: entry[%u] = %u occurs more than once\n",
                   ordlist_reg, i, pos_array[i]);

          return (2);

       }


/* ok: mark */
vtxeval(buffer, pos_array[i]) = (void *) 1;


   }  /* for i */


/*  free buffer */
free(buffer);



return (0);


}  /* check_ordlist */



