/*
*************************************
file: cehckord.c


Check if ordlist is well defined,
i.e. it defines a permutation.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 


void check_xlist(void* xlist_reg  /* != NULL */)
{

/* dcl  */
unsigned int *pos_array;

unsigned int 
	i, pos_size;

void *buffer;

unsigned int buf_size;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/*  prg  */




#if (dbg_flag > 10)
printf("\ncheck_xlist:%u: varord = 0x%x", 
count, ordvtx);
#endif



pos_size = 
(unsigned int) 
vtxeval(regeval(xlist_reg), /* ordlist_vtx */
         xlist_word0
        );  


pos_array = 
(unsigned int *) 
vtxeval(regeval(xlist_reg),   /* xlist_vtx */
         xlist_word0 + 1
        );  



/* 
   Test if each number in 0 ... (pos_size - 1) 
   occurs at most one in pos_array
*/


/* get max entry in pos_array  */

buf_size = 0;

for (i = 0; i < pos_size; i++)
   {

if (pos_array[i] > buf_size)
buf_size = pos_array[i];

   }


buf_size++;


/* buffer for markers */
buffer = get_prgvtx(buf_size);

/* initialize buffer  */
for (i = 0; i < buf_size; i++) vtxeval(buffer, i) = (void *) 0;


/* check pos_array  */
for (i = 0; i < pos_size; i++)
   {


/* range ok */

 
      if ( (unsigned int) vtxeval(buffer, pos_array[i]) != 0 )  
      /*  error: redefinition  */
       {
          printf("\nError: in xlist %s: entry %u = %u occurs more than once\n",
vtxeval(xlist_reg, 1), 
i, 
pos_array[i]
);

          exit (1);

       }


/* ok: mark */
vtxeval(buffer, pos_array[i]) = (void *) 1;


   }  /* for i */


/*  free buffer */
free(buffer);



}  /* check_xlist */



