
/*
*************************************
file: exec.c

Read term from file set in lexan.

Returns pointer to array of void*
containing token codes or strin pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 




void* read_exec(void* *p  /* token */)
{
/*  dcl  */
unsigned int listsize = 0;
unsigned int i;

void* listq_fifo;
void* tlist_vtx;

void* result;
void* vtx;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */


#if (dbg_flag > 100)
printf("\nread_reglist:%u: ckp 100: (begin)", count);
#endif





/* Opcode is in p[0].  */


vtx = get_prgvtx(size_reglist);

((void* *) vtx)[op_code] = p[0];




/* read string */

read_new_token(p);
if (p[0] != (void *) tk_string)
/* error */
{
   printf("\nerror in file %s line %u: found tk_code %u: tk_code %u (string) expected after exec",
lexan_fname(), lex_line_number(), 
p[0],
tk_string
);

                 exit (1);
}






listq_fifo = create_fifo();

/* listsize == 0 */

in_fifo(listq_fifo, (unsigned int) p[1]);
listsize++;





/* read id list   */
/* read '(' */
read_new_token(p);
if (p[0] != (void *) tk_leftpar)
/* error  */
  {
       printf("\nerror in file %s line %u: '(' expected",
               lexan_fname(), lex_line_number()
             );
       exit (1000);
  }


/* ok ( found */
#if (dbg_flag > 100)
printf("\nread_join:%u: ckp 300: found '('", count);
#endif




/* read id num ... id num */

while (1)
     {

      read_new_token(p);

      switch ( (unsigned int) p[0] )
            {

                case tk_rightpar:  /*  end list */

#if (dbg_flag > 100)
printf("\nread_join:%u: ckp 400: found ')'", count);
#endif

                       break;




                case tk_id:  /*  id  */

#if (dbg_flag > 100)
printf("\nread_join:%u: ckp 500: found id: %s", count, 
read_stbk_key(p[1]));
#endif


 check_newdef(p); 

                       in_fifo(
listq_fifo, 
(unsigned int) read_stbk_info(p[1])
);


                       listsize++;



                       continue;




                case tk_num:  /*  num  */

#if (dbg_flag > 100)
printf("\nread_join:%u: ckp 500: found num: %u", count, 
p[1]);
#endif

                       in_fifo(listq_fifo, (unsigned int) p[1]);

                       listsize++;

                       continue;




                default:
       printf("\nerror in file %s line %u: found tkcode %u in exec rhs %u: id or ')' expected",
                lexan_fname(), lex_line_number(),
p[0],
listsize
);

              exit (1000);


            }

/*  ) found, exit while */

         break;
     }







/* listsize > 0  */


tlist_vtx =  get_prgvtx(listsize);






/* store listq_fifo  */
emptyfifo2vtx(listq_fifo, tlist_vtx, listsize);



/* store listsize */
((void* *) vtx)[reglist_word0] = (void *) listsize;


/* store tlist_vtx */
((void* *) vtx)[reglist_word0 + 1] = (void *) tlist_vtx;


/* define result as pointer to (fresh) id  */

result = get_newid_vtx();
*((void* *) result) = vtx;





/* mark ids as defined */

for (i = 1; i < listsize; i = i + 2)
   {

/* mark id as defined */
regeval(vtxeval(tlist_vtx, i)) = result;

   }



return ( result );


}  /*  read_exec()  */

