/*
*************************************
file: query.c


Read id def via boole.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_query(void* *p  /* token */ )
{
/*  dcl  */
void *vtx, *result;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_boo:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in p[0].
   We need to read 1 id and an unsigned int
*/



vtx = get_prgvtx(size_query);
((void* *) vtx)[op_code] = p[0];


read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_id  */

((void* *) vtx)[query_word0] = read_stbk_info(p[1]);





/* NOTE: no ordlist in bsi queries */

/* read string */

read_new_token(p);
if (p[0] != (void *) tk_string)
/* error */
{
                 printf("\nerror in file %s line %u: string expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}


/* ok: p[0] == tk_string  */
((void* *) vtx)[query_word0 + 1] = p[1];

   



/* define result as pointer to (fresh) id  */

result = get_newid_vtx();
*((void* *) result) = vtx;


return ( result );


}  /*  read_query  */ 












