/*
*************************************
file: bsacmp.c

Print bsacmp instruction.
I.e. translate bsi compose into
bsa compose using dummy vars.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */


void fprint_bsacmp(FILE* fileptr, void* prg_reg)
{
/* dcl */

unsigned int i, xlist_size, reglist_size;

void *xlist_array, *reglist_array;


/* prg  */


#if (dbg_flag > 0)
printf("\nfprint_bsacmp: begin: prg_reg 0x%x", prg_reg);
#endif



xlist_size = 
(unsigned int) regfield(regfield(prg_reg, compose_word0 + 1), xlist_word0);

xlist_array = regfield(regfield(prg_reg, compose_word0 + 1), xlist_word0 + 1);

reglist_size = 
(unsigned int) regfield(regfield(prg_reg, compose_word0 + 2), reglist_word0);

reglist_array = regfield(regfield(prg_reg, compose_word0 + 2), reglist_word0 + 1);


/* Note: xlist_size == reglist_array already checked in parser */


/* Note:  xlist_size > 0 */





if (xlist_size == 1)
/*  xlist_size == 1  */
  {

  /* no need to refresh */

                      fprintf(fileptr, "compose %s %s %u %s\n",
vtxeval(prg_reg, 1),
vtxeval(regfield(prg_reg, compose_word0), 1),
vtxeval(xlist_array, 0),
vtxeval(vtxeval(reglist_array, 0), 1)
);

   return;

  }




/*  xlist_size > 1  */

/* refresh needed */

/* create dummy var */



for (i = 0; i < xlist_size; i++)
  {


/* dummy */


                      fprintf(fileptr, "xarg %s%s_x%u %u\n",
signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i)) + 1,
((unsigned int) vtxeval(xlist_array, i)) + 1
);



  }   /*  for i  */








 
/* refresh var with dummy */

                      fprintf(fileptr, "compose %s%s_d%u %s %u %s%s_x%u\n",
signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, 0)),

vtxeval(regfield(prg_reg, compose_word0), 1),

((unsigned int) vtxeval(xlist_array, 0)),

signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, 0)) + 1
);








for (i = 1; i < xlist_size; i++)
  {


/* refresh var with dummy */

                      fprintf(fileptr, "compose %s%s_d%u %s%s_d%u %u %s%s_x%u\n",
signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i)),

signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i - 1)),

((unsigned int) vtxeval(xlist_array, i)),

signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i)) + 1

);


  }   /*  for i  */












/* compose dummy with reg in reglist */

                       fprintf(fileptr, "compose %s%s_r%u %s%s_d%u %u %s\n",
signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, 0)),

signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, xlist_size - 1)),

((unsigned int) vtxeval(xlist_array, 0)) + 1,

vtxeval(vtxeval(reglist_array, 0), 1)
);








for (i = 1; i < xlist_size - 1; i++)
  {



/* compose dummy with reg in reglist */

                       fprintf(fileptr, "compose %s%s_r%u %s%s_r%u %u %s\n",
signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i)),

signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i - 1)),

((unsigned int) vtxeval(xlist_array, i)) + 1,

vtxeval(vtxeval(reglist_array, i), 1)
);



  }   /*  for i  */





/* i == xlist_size - 1  */


/* compose dummy with reg in reglist */

                       fprintf(fileptr, "compose %s %s%s_r%u %u %s\n",
vtxeval(prg_reg, 1),

signe(), vtxeval(prg_reg, 1),
((unsigned int) vtxeval(xlist_array, i - 1)),

((unsigned int) vtxeval(xlist_array, i)) + 1,

vtxeval(vtxeval(reglist_array, i), 1)
);




}  /*  fprint_bsacmp  */

















