/*
*************************************
file: bsaprt.c

Print bsa translation.

Hyp: prg -> ordlist != NULL
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */


void fprint_bsareg(FILE* fileptr, prghdr* prg, void* p_lab)
{
/* p_lab: pointer to prgvtx */

/* dcl  */
unsigned int i;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
printf("\nfprint_bsareg: ckp 100: (begin)");
#endif


/* note p_lab is a reg */


p =  regeval(p_lab);


       switch ( (unsigned int) ((void* *) p)[op_code] )
          {

              case tk_ifte:
 
                      fprintf(fileptr, "ifte %s %s %s %s\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, ifte_word0), 1),
vtxeval(vtxeval(p, ifte_word0 + 1), 1),
vtxeval(vtxeval(p, ifte_word0 + 2), 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_ifte);
fprintf(fileptr, " */\n");
#endif



                     break;







              case tk_compose:
 

    fprint_bsacmp(fileptr, p_lab);


 
                        break;








                   case tk_xarg:



                      fprintf(fileptr, "xarg %s %u\n",
vtxeval(p_lab, 1),
vtxeval(p, xarg_word0)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif



#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_xarg);
fprintf(fileptr, " */\n");
#endif

 
                        break;











                    case tk_boolean:


                      fprintf(fileptr, "boole %s %u\n",
vtxeval(p_lab, 1),
vtxeval(p, boole_word0)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_boole);
fprintf(fileptr, " */\n");
#endif



                        break;










           case tk_isone:  /* query isone  */



                      fprintf(fileptr, "isone %s %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(prg -> ordlist, 1), 
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;






           case tk_eval: /* eval  */




                      fprintf(fileptr, "eval %s %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(prg -> ordlist, 1), 
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;









           case tk_satasg:  /* satasg  */




                      fprintf(fileptr, "satasg %s %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(prg -> ordlist, 1), 
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;








           case tk_C:  /* C function */




                      fprintf(fileptr, "C_code %s %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(prg -> ordlist, 1), 
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;










            case tk_ordlist:  

                      fprintf(fileptr, "ordlist %s (",
vtxeval(p_lab, 1)
);


              
                    for (i = 0; i < ((unsigned int) ((void* *) p)[ordlist_word0]); i++)
                       {
fprintf(fileptr, "%u ",
((unsigned int *) ((void* *) p)[ordlist_word0 + 1])[i]
 );

                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_ordlist);
fprintf(fileptr, " */\n");
#endif


 
                        break;






                   case tk_prj:



                      fprintf(fileptr, "prj %s %s %u\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, prj_word0), 1),
vtxeval(p, prj_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif



#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_prj);
fprintf(fileptr, " */\n");
#endif

 
                        break;







            case tk_join:  

                      fprintf(fileptr, "join %s (",
vtxeval(p_lab, 1)
);


              
                    for (
i = 0; 
i < ((unsigned int) ((void* *) p)[reglist_word0]); 
i++
)
                       {

fprintf(fileptr, "%s ",
vtxeval(vtxeval(regfield(p_lab, reglist_word0 + 1), i), 1)
 );

                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_reglist);
fprintf(fileptr, " */\n");
#endif


 
                        break;







            case tk_exec:  

                     fprintf(fileptr, "exec \"%s\" (",
vtxeval(regfield(p_lab, reglist_word0 + 1), 0)
);



              
                    for (
i = 1; 
i < (unsigned int) regfield(p_lab, reglist_word0); 
i = i + 2
)
                       {
fprintf(fileptr, "%s ",
vtxeval(vtxeval(regfield(p_lab, reglist_word0 + 1), i), 1)
 );

fprintf(fileptr, "%u ",
vtxeval(regfield(p_lab, reglist_word0 + 1), i + 1)
 );


                       } /* for */

                      fprintf(fileptr, ")\n");




#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_reglist);
fprintf(fileptr, " */\n");
#endif


 
                        break;





           case tk_begin:  
           case tk_end:
                          /* These are internal instructions
                             only used for padding.
                             No printing 
                           */

                         break;




                 default:  /* error  */
                          printf("\nfprint_bsareg: error: token %c found: unknown prog. instruction",
(unsigned int) ((void* *) p)[op_code]
);


                          exit (1);
        

          }  /* switch */



#if (dbg_flag > 0)
printf("\nfprint_bsareg: ckp 1100 (end)");
#endif



}  /*  prg  */




















