/*
*************************************
file: absidx.c

Computes absolute indexes from ordlist.

absidx assumes that ordlist exists,

i.e. p -> ordlist != NULL.


*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




static
void abs_xarg(prghdr *p, void *prg_reg);

static
void abs_xlist(prghdr *p, void *prg_reg);




void def_abs_idx(prghdr* p)
{
/* dcl */
void* prg_reg;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/* prg  */

#if (dbg_flag > 100)
printf("\ndef_abs_idx:%u: begin: program = 0x%x", count, p);
#endif


/*  first instruction  */
prg_reg = p -> prg;


 while (prg_reg != NULL)
  {


       switch( (int) regfield(prg_reg, op_code) )
          {

 
             case tk_xarg:  /* update xarg abs_xarg */

#if (dbg_flag > 100)
printf("\ndef_abs_idx:%u: absidx for xarg reg 0x%x", count, prg_reg);
#endif

                            abs_xarg(p, prg_reg);

                            

                            break;





           default:  /* do nothing  */

          
                     break;

          }




       prg_reg = regfield(prg_reg, ptr_down);


  }   /* while */




/* note: only xlistreg's in this list */


/*  first xlist  */
prg_reg = p -> xlist;


 while (prg_reg != NULL)
  {

#if (dbg_flag > 100)
printf("\ndef_abs_idx:%u: absidx for xlist reg 0x%x", count, prg_reg);
#endif

 /* update abs_xlist  */

                            abs_xlist(p, prg_reg);


       prg_reg = regfield(prg_reg, ptr_down);


  }   /* while */





#if (dbg_flag > 100)
printf("\ndef_abs_idx:%u: end: program = 0x%x", count, p);
#endif


}   /* prg  */














void abs_xarg(prghdr *p, void *prg_reg)
{
/* dcl */


/* prg */

regfield(prg_reg, xarg_word0) = 
(void *) (2 * argpos(p, regfield(prg_reg, xarg_word0)));


}  /* abs_xarg  */


   




void abs_xlist(prghdr *p, void *prg_reg)
{
/* dcl */

unsigned int i, reg_size;

void *reg_array;


/* prg */



/*  check rhs_reglist  (word 2) */

reg_size = (unsigned int) regfield(prg_reg, xlist_word0);

reg_array = regfield(prg_reg, xlist_word0 + 1);


for (i = 0; i < reg_size; i++)
   {
      vtxeval(reg_array, i) = 
(void *) (2*argpos(p, vtxeval(reg_array, i)));
   }


}  /*  abs_xlist  */







