/*
*************************************
file: argpos.c

Return position absolute bddvar index
(argument position)
for program prg and argument arg.

Works also when p -> ordlist == NULL.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 



static
unsigned int ordlist_argpos(
void* ordlist_reg,   /* ordlist register != NULL  */
unsigned int arg
);





/*
Get argpos from def prgvtx
*/

unsigned int argpos(
prghdr* prg, 
unsigned int arg
)
{

/* dcl  */


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/*  prg  */


#if (dbg_flag > 10)
printf("\nreg_argpos:%u: begin/end: reg = 0x%x, arg %u", 
count, reg, arg);
#endif


return ( ordlist_argpos(prg -> ordlist, arg) );



}  /* reg_argpos  */













/*
Get argpos from orderd prgvtx
*/

unsigned int ordlist_argpos(
void* ordlist_reg,   /* ordlist register != NULL  */
unsigned int arg
)
{

/* dcl  */
unsigned int *pos_array;

unsigned int pos_size;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/*  prg  */




#if (dbg_flag > 10)
printf("\nordlist_argpos:%u: ordlist = 0x%x", 
count, ordlist_reg);
#endif


/* check if default varorder */

if (ordlist_reg == NULL )
/* default varord  */
  { return (arg); }






/* ordlist_reg != NULL: nondefault varord  */



pos_size = 
(unsigned int) regfield(ordlist_reg, ordlist_word0);



#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: fws_size = %u", count, fws_size);
#endif

pos_array = 
(unsigned int *) 
regfield(ordlist_reg, ordlist_word0 + 1);



#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: fws_array = 0x%x", count, fws_array);
#endif


/* define position arg in varorder */
if (arg < pos_size)
/* ord in pos_array */
   {
     return ( pos_array[arg] );
    
   }
else /* default order */
   {
     return ( arg );
    
   }
 



}  /* ordlistreg_argpos  */





/*
******************************
print argpos for first arity args of reg
******************************
*/


void fprint_argpos(FILE* fileptr, 
prghdr* prg, 
unsigned int arity
)
{  /* dcl */
  unsigned int i;

  /* prg */

  fprintf(fileptr, "argpos of arity %u for prg 0x%x:\n", arity, prg);

  for (i = 0; i < arity; i++)
    {
       fprintf(fileptr, "%u ", argpos(prg, i));
    }


}  /*  prg  */

