/*
**************************
prgvtx.h
**************************
*/


#ifndef prgvtx_h
#define prgvtx_h

#include <stdlib.h>
#include <stdio.h>



#define regeval(L) (*((void **) L))
#define vtxeval(v, i) ((void **) v)[i]
#define regfield(L, i) vtxeval(regeval(L), i)

/* note: regeval(L) = vtxeval(L, 0)  */



#if (dbg_flag > 100)
printf("\nupdate_compose:%u: key %s, reglist_reg = 0x%x, reglist_size = %u", 
count,
key,
vtxeval(regeval(calling_reg), compose_word0 + 2),
reglist_size
);
#endif


#define ptr_up 0
#define ptr_down 1
#define op_code 2
#define loopback 3
#define bddvalue 4



/*
**************************
begin, end (used only for padding)
Note: no words.
Vertex Format:
ptr_up ptr_down opcode 
**************************
*/

#define size_begin 3
#define size_end 3


/*
**************************
0op: generic boolean operator
Vertex Format:
ptr_up ptr_down opcode
id ... id
Actual size = size_0op + arity
**************************
*/

#define size_0op 3






/*
**************************
ifte, compose
Vertex Format:
ptr_up ptr_down opcode
id id id 
**************************
*/

#define size_ifte 6
#define ifte_word0 3

#define size_compose 6
#define compose_word0 3




/* query: isone, satasg, eval, C
Vertex Format:
ptr_up ptr_down opcode id string
*/
#define size_query 5
#define query_word0 3





/* boole:
Vertex Format:
ptr_up ptr_down opcode boolean_value
*/
#define size_boole 4
#define boole_word0 3


/* xarg:
Vertex Format:
ptr_up ptr_down opcode unsigned_int
*/
#define size_xarg 4
#define xarg_word0 3



/* prj:
Vertex Format:
ptr_up ptr_down opcode id unsigned_int
*/
#define size_prj 5
#define prj_word0 3

/* join as reglist  */



/* ordlist
Vertex Format:
ptr_up ptr_down opcode size_fws_list fws_list
*/
#define size_ordlist 5
#define ordlist_word0 3


/* xlist
Vertex Format:
ptr_up ptr_down opcode size_xlist xlist
*/
#define size_xlist 5
#define xlist_word0 3


/* reglist
Vertex Format:
ptr_up ptr_down opcode size_reglist reglist
*/
#define size_reglist 5
#define reglist_word0 3





/*
***************************************
prg header:
ord: arg order;
prg: program;
reg: reglists;
xlist: xlists;
pc: program counter
mode: (mode: set, reset)
target: (target: prg instruction up to which resetting)
*****************************************
*/




#define compose_reglist_size(L) \
(unsigned int) vtxeval(regeval(regfield(L, compose_word0 + 2)), reglist_word0)

#define compose_reglist_array(L)  \
vtxeval(regeval(regfield(L, compose_word0 + 2)), reglist_word0 + 1)





typedef struct Program_Header
{

  void *prg;
  void *pc;  /* program counter */
  void *ordlist;
  void *xlist;
  void *reglist;
  unsigned int maxarg;
} prghdr;









void* get_prgvtx(unsigned int size);


void fprint_prgvtx(FILE* fileptr, void* p);


prghdr* get_prghdr();


void* get_prgreg();


void fprt2bsi_reg(FILE* fileptr, void* p_lab);

char* signe();

#endif

