/*
*************************************
file: loadkeys.c
Load keywords in symbol table T.
*************************************
*/


#include "local.h"



#define debug 0     /* normal value: 0  */
 


void load_keywords(void* T)
{
/* declarations  */


void* p;   /*  bucket  */

char *key;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* programs  */


#if (dbg_flag > 0)
printf("\n\nload_keywords:%u: ckp 100: symbol_table = 0x%x",
count,
T
);
#endif





/* Load keywords  */


p = get_new_stbk();
write_stbk_key(p, "(");
write_stbk_tkcode(p, tk_leftpar);
write_stbk_info(p, NULL);
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, ")");
write_stbk_tkcode(p, tk_rightpar);
write_stbk_info(p, NULL);
write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "{");
write_stbk_tkcode(p, tk_leftcurl);
write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "}");
write_stbk_tkcode(p, tk_rightcurl);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "=");
write_stbk_tkcode(p, tk_equal);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "ifte");
write_stbk_tkcode(p, tk_ifte);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);




p = get_new_stbk();
write_stbk_key(p, "compose");
write_stbk_tkcode(p, tk_compose);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "xarg");
write_stbk_tkcode(p, tk_xarg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 



p = get_new_stbk();
write_stbk_key(p, "boole");
write_stbk_tkcode(p, tk_boolean);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

  
p = get_new_stbk();
write_stbk_key(p, "xlist");
write_stbk_tkcode(p, tk_xlist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  



p = get_new_stbk();
write_stbk_key(p, "reglist");
write_stbk_tkcode(p, tk_reglist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 

p = get_new_stbk();
write_stbk_key(p, "ordlist");
write_stbk_tkcode(p, tk_ordlist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p); 




p = get_new_stbk();
write_stbk_key(p, "isone");
write_stbk_tkcode(p, tk_isone);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


p = get_new_stbk();
write_stbk_key(p, "eval");
write_stbk_tkcode(p, tk_eval);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  



p = get_new_stbk();
write_stbk_key(p, "satasg");
write_stbk_tkcode(p, tk_satasg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


  
p = get_new_stbk();
write_stbk_key(p, "C_code");
write_stbk_tkcode(p, tk_C);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

  
p = get_new_stbk();
write_stbk_key(p, "and");
write_stbk_tkcode(p, tk_and);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "and";
write_symbtab_bucket(T, p);
  


p = get_new_stbk();
write_stbk_key(p, "or");
write_stbk_tkcode(p, tk_or);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "or";
write_symbtab_bucket(T, p);
  


p = get_new_stbk();
write_stbk_key(p, "not");
write_stbk_tkcode(p, tk_not);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 1;  /* arity */
((char* *) read_stbk_info(p))[1] = "not";
write_symbtab_bucket(T, p);
  


p = get_new_stbk();
write_stbk_key(p, "xor");
write_stbk_tkcode(p, tk_xor);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "xor";
write_symbtab_bucket(T, p);
  


p = get_new_stbk();
write_stbk_key(p, "eq");
write_stbk_tkcode(p, tk_eq);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "eq";
write_symbtab_bucket(T, p);
  

p = get_new_stbk();
write_stbk_key(p, "nor");
write_stbk_tkcode(p, tk_nor);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "nor";
write_symbtab_bucket(T, p);
  

p = get_new_stbk();
write_stbk_key(p, "nand");
write_stbk_tkcode(p, tk_nand);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "nand";
write_symbtab_bucket(T, p);
  

p = get_new_stbk();
write_stbk_key(p, "exists");
write_stbk_tkcode(p, tk_exists);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "exists";
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, "forall");
write_stbk_tkcode(p, tk_forall);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "forall";
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, "imp");
write_stbk_tkcode(p, tk_imp);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "imp";
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, "join");
write_stbk_tkcode(p, tk_join);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "join";
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, "prj");
write_stbk_tkcode(p, tk_prj);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 2;  /* arity */
((char* *) read_stbk_info(p))[1] = "prj";
write_symbtab_bucket(T, p);



p = get_new_stbk();
write_stbk_key(p, "exec");
write_stbk_tkcode(p, tk_exec);
write_stbk_info(p, get_newid_vtx()); 
((void* *) read_stbk_info(p))[0] = (void *) 0;  /* variable */
((char* *) read_stbk_info(p))[1] = "exec";
write_symbtab_bucket(T, p);










#if 0
p = get_new_stbk();
write_stbk_key(p, "i");
write_stbk_tkcode(p, tk_ifte);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "c");
write_stbk_tkcode(p, tk_compose);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

 p = get_new_stbk();
write_stbk_key(p, "x");
write_stbk_tkcode(p, tk_xarg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "b");
write_stbk_tkcode(p, tk_boolean);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);

p = get_new_stbk();
write_stbk_key(p, "L");
write_stbk_tkcode(p, tk_xlist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

 p = get_new_stbk();
write_stbk_key(p, "R");
write_stbk_tkcode(p, tk_reglist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "X");
write_stbk_tkcode(p, tk_ordlist);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  



p = get_new_stbk();
write_stbk_key(p, "q");
write_stbk_tkcode(p, tk_isone);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "e");
write_stbk_tkcode(p, tk_eval);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  

p = get_new_stbk();
write_stbk_key(p, "s");
write_stbk_tkcode(p, tk_satasg);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);


p = get_new_stbk();
write_stbk_key(p, "C");
write_stbk_tkcode(p, tk_C);
write_stbk_info(p, NULL); write_symbtab_bucket(T, p);  


#endif

}  /* prg  */







#if 0

char* get_key_string(char* key)
{
/* dcl */
unsigned int size;
char *result;


/* prg */

size = strlen(key) + 1;


result = (char *) malloc(size*sizeof(char));

if (result == NULL)
/* error */
{
   printf("\nget_key_string: error no malloc space\n");
   exit (1);
}


/* ok */


return ( strcpy(result, key) );

}  /* get_key_string */


#endif
