/*
*************************************
file: download.c



Write program p in file filename.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
#define print_ord 100  /* normal value: 0  */
#define argpos_arity 20  /* used in print argpos */




void bsi_download(prghdr* phdr, /* program header */
              char *filename)
{

/* dcl  */
FILE* fileptr;
void* p;  /* prg label for instruction  */
void *p_vtx;   /* prg vertex  */
unsigned int i;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nbsi_download:%u: begin, open file", count);
#endif


/* initialize lexan  */

fileptr = fopen(filename, "w");



#if (dbg_flag > 100)
printf("\nbsi_download:%u: print reglist", count);
#endif



/*
*************************
Print reglists
*************************
*/

fprintf(fileptr, "\n\n/* Reg lists */\n\n");

/*  first instruction */
p = phdr -> reglist;

 while (p != NULL)
  {
       /* print line, p != NULL */

p_vtx = *((void* *) p);

       fprt2bsi_reg(fileptr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */



/*  add reg __r0, __r1   */

   fprintf(fileptr, "reglist %s%sr0 (%s%s0)\n",
signe(), signe(), 
signe(), signe()
);
   fprintf(fileptr, "reglist %s%sr1 (%s%s1)\n",
signe(), signe(), 
signe(), signe()
);



#if (dbg_flag > 100)
printf("\nbsi_download:%u: print xlist", count);
#endif




/*
*************************
Print xlists
*************************
*/

fprintf(fileptr, "\n\n/* xlists */\n\n");

/*  first instruction */
p = phdr -> xlist;

 while (p != NULL)
  {
       /* print line, p != NULL */

p_vtx = *((void* *) p);

       fprt2bsi_reg(fileptr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */




#if (dbg_flag > 100)
printf("\nbsi_download:%u: print ordlist", count);
#endif


/*
*************************
Print ordlists
*************************
*/

fprintf(fileptr, "\n\n/* Ordlist (at most one) */\n\n");

/*  first instruction */
p = phdr -> ordlist;

 while (p != NULL)
  {
       /* print line, p != NULL */

p_vtx = *((void* *) p);

       fprt2bsi_reg(fileptr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */







#if (dbg_flag > 100)
printf("\nbsi_download:%u: print program", count);
#endif


/*
*************************
Print program instructions
*************************
*/
fprintf(fileptr, "\n\n/* Program Instructions */\n\n");




/*  add reg __0, __1   */

   fprintf(fileptr, "boole %s%s0 0\n", signe(), signe());
   fprintf(fileptr, "boole %s%s1 1\n", signe(), signe());




/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       p_vtx = *((void* *) p);

       fprt2bsi_reg(fileptr, p);

       p = ((void* *) p_vtx)[ptr_down];

  }   /* while */







#if (dbg_flag > 100)
printf("\nbsi_download:%u: close file", count);
#endif



fclose(fileptr);


#if (dbg_flag > 10)
printf("\nbsi_download:%u: end", count);
#endif




}  /*  prg  */





















