/*
*************************************
file: xlist.c

Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or strin pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 




void* read_xlist(void* *p  /* token */)
{
/*  dcl  */
unsigned int listsize = 0;

void* listq_fifo;
void* tlist_vtx;

void* result;
void* vtx;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */


#if (dbg_flag > 100)
printf("\nread_xlist:%u: ckp 100: (begin)", count);
#endif



/* Opcode is in p[0].  */


vtx = get_prgvtx(size_xlist);

((void* *) vtx)[op_code] = p[0];








/* read xlist id */

read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}



/* ok: p[0] == tk_id  */
check_newdef(p);

result = read_stbk_info(p[1]);
*((void* *) result) = vtx;



/* read xlist of intervals */
/* read '(' */
read_new_token(p);
if (p[0] != (void *) tk_leftpar)
/* error  */
  {
       printf("\nerror in file %s line %u: '(' expected",
               lexan_fname(), lex_line_number()
             );
       exit (1000);
  }


/* ok ( found */
#if (dbg_flag > 100)
printf("\nread_xlist:%u: ckp 300: found '('", count);
#endif

listq_fifo = create_fifo();

/* listsize == 0 */
while (1)
     {

      switch (read_new_token(p))
            {

                case tk_rightpar:  /*  end list */

#if (dbg_flag > 100)
printf("\nread_xlist:%u: ckp 400: found ')'", count);
#endif

                       break;

                case tk_num:  /*  num  */

#if (dbg_flag > 100)
printf("\nread_xlist:%u: ckp 500: found num %u", count, p[1]);
#endif

                       in_fifo(listq_fifo, (unsigned int) p[1]);
                       listsize++;




                       continue;





                default:
                     printf("\nerror in file %s line %u: number or ')' expected",
                     lexan_fname(), lex_line_number());

              exit (1000);


            }

/*  ) found, exit while */

         break;
     }



/* listsize >= 0   */

if (listsize == 0)
{ tlist_vtx = NULL;}
else /* listsize >= 1 */
    {
      tlist_vtx =  get_prgvtx(listsize);
   }



/* store listq_fifo  */



/* store listq_fifo  */
emptyfifo2vtx(listq_fifo, tlist_vtx, listsize);




/* store listsize */
((void* *) vtx)[xlist_word0] = (void *) listsize;



/* store tlist_vtx */
((void* *) vtx)[xlist_word0 + 1] = tlist_vtx;



return ( result );




}  /*  read_xlist()  */

