/*
*************************************
file: upload.c

Print prgvtx on file
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */

#define prt_op 0  /* normal value: 0  */





void fprt2bsi_reg(FILE* fileptr, void* p_lab)
{
/* p_lab: pointer to prgvtx */

/* dcl  */
unsigned int i;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
printf("\nfprt2bsi_reg: begin: print reg 0x%x", p_lab);
#endif


/* note p_lab is a reg */


p =  regeval(p_lab);

#if (dbg_flag > 0)
printf("\nfprt2bsi_reg: opcode: %c", ((void* *) p)[op_code] );
#endif


       switch ( (unsigned int) ((void* *) p)[op_code] )
          {

              case tk_ifte:
 
                      fprintf(fileptr, "ifte %s %s %s %s\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, ifte_word0), 1),
vtxeval(vtxeval(p, ifte_word0 + 1), 1),
vtxeval(vtxeval(p, ifte_word0 + 2), 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_ifte);
fprintf(fileptr, " */\n");
#endif



                     break;


              case tk_compose:
 
                      fprintf(fileptr, "compose %s %s %s %s\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, compose_word0), 1),
vtxeval(vtxeval(p, compose_word0 + 1), 1),
vtxeval(vtxeval(p, compose_word0 + 2), 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_compose);
fprintf(fileptr, " */\n");
#endif

 
                        break;










                   case tk_xarg:



                      fprintf(fileptr, "xarg %s %u\n",
vtxeval(p_lab, 1),
vtxeval(p, xarg_word0)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif



#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_xarg);
fprintf(fileptr, " */\n");
#endif

 
                        break;











                    case tk_boolean:


                      fprintf(fileptr, "boole %s %u\n",
vtxeval(p_lab, 1),
vtxeval(p, boole_word0)
);

#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_boole);
fprintf(fileptr, " */\n");
#endif



                        break;










           case tk_isone:  /* query isone  */




                      fprintf(fileptr, "isone %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;







           case tk_eval: /* eval  */




                      fprintf(fileptr, "eval %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;





           case tk_satasg:  /* satasg  */




                      fprintf(fileptr, "satasg %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;



           case tk_C:  /* C function */




                      fprintf(fileptr, "C_code %s \"%s\"\n",
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;





            case tk_xlist:  

                      fprintf(fileptr, "xlist %s (",
vtxeval(p_lab, 1)
);


              
                    for (i = 0; i < ((unsigned int ) ((void* *) p)[xlist_word0]); i++)
                       {
fprintf(fileptr, "%u ",
((unsigned int *) ((void* *) p)[xlist_word0 + 1])[i]
 );
                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_xlist);
fprintf(fileptr, " */\n");
#endif

 
                        break;






            case tk_reglist:  

                      fprintf(fileptr, "reglist %s (",
vtxeval(p_lab, 1)
);


              
                    for (i = 0; i < (unsigned int) vtxeval(p, reglist_word0); i++)
                       {
fprintf(fileptr, "%s ",
vtxeval(vtxeval(regfield(p_lab, reglist_word0 + 1), i), 1)
 );
                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_reglist);
fprintf(fileptr, " */\n");
#endif


 
                        break;



            case tk_join:  

                      fprintf(fileptr, "join %s (",
vtxeval(p_lab, 1)
);


              
                    for (i = 0; i < (unsigned int) vtxeval(p, reglist_word0); i++)
                       {
fprintf(fileptr, "%s ",
vtxeval(vtxeval(regfield(p_lab, reglist_word0 + 1), i), 1)
 );
                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_reglist);
fprintf(fileptr, " */\n");
#endif


 
                        break;





                   case tk_prj:



                      fprintf(fileptr, "prj %s %s %u\n",
vtxeval(p_lab, 1),
vtxeval(vtxeval(p, prj_word0), 1),
vtxeval(p, prj_word0 + 1)
);



#if (longprint > 10)
fprintf(fileptr, "/* vtx=0x%x  up=0x%x  down=0x%x  loopback=0x%x */\n",
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down],
((void* *) p)[loopback]
);
#endif



#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_xarg);
fprintf(fileptr, " */\n");
#endif

 
                        break;









            case tk_ordlist:  

                      fprintf(fileptr, "ordlist %s (",
vtxeval(p_lab, 1)
);


              
                    for (i = 0; i < ((unsigned int) ((void* *) p)[ordlist_word0]); i++)
                       {
fprintf(fileptr, "%u ",
((unsigned int *) ((void* *) p)[ordlist_word0 + 1])[i]
 );

                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_ordlist);
fprintf(fileptr, " */\n");
#endif


 
                        break;





           case tk_begin:  
           case tk_end:
                          /* These are internal instructions
                             only used for padding.
                             No printing 
                           */

                         break;











       case tk_and:

#if (prt_op > 10)
fprintf(fileptr, "/* and */\n");
#endif

                  and(fileptr, p_lab);
                  break;



       case tk_or:

#if (prt_op > 10)
fprintf(fileptr, "/* or  */\n");
#endif

                  or(fileptr, p_lab);
                  break;



       case tk_xor:

#if (prt_op > 10)
fprintf(fileptr, "/* xor */\n");
#endif

                  xor(fileptr, p_lab);
                  break;



       case tk_eq:

#if (prt_op > 10)
fprintf(fileptr, "/* eq */\n");
#endif

                  eq(fileptr, p_lab);
                  break;




       case tk_nor:


#if (prt_op > 10)
fprintf(fileptr, "/* nor */\n");
#endif

                  nor(fileptr, p_lab);
                  break;


       case tk_nand:


#if (prt_op > 10)
fprintf(fileptr, "/* nand */\n");
#endif

                  nand(fileptr, p_lab);
                  break;


       case tk_imp:

#if (prt_op > 10)
fprintf(fileptr, "/* imp */\n");
#endif

                  imp(fileptr, p_lab);
                  break;


  



         case tk_not:


#if (prt_op > 10)
fprintf(fileptr, "/* not */\n");
#endif

                  not(fileptr, p_lab);
                  break;




       case tk_exists: 


#if (prt_op > 10)
fprintf(fileptr, "/* exists */\n");
#endif

                  exists(fileptr, p_lab);
                  break;



       case tk_forall: 

#if (prt_op > 10)
fprintf(fileptr, "/* forall */\n");
#endif

                  forall(fileptr, p_lab);
                  break;






            case tk_exec:  

                      fprintf(fileptr, "exec \"%s\" (",
vtxeval(regfield(p_lab, reglist_word0 + 1), 0)
);


              
                    for (
i = 1; 
i < (unsigned int) regfield(p_lab, reglist_word0); 
i = i + 2
)
                       {
fprintf(fileptr, "%s ",
vtxeval(vtxeval(regfield(p_lab, reglist_word0 + 1), i), 1)
 );

fprintf(fileptr, "%u ",
vtxeval(regfield(p_lab, reglist_word0 + 1), i + 1)
 );


                       } /* for */

                      fprintf(fileptr, ")\n");


#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif

#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_reglist);
fprintf(fileptr, " */\n");
#endif


 
                        break;






                 default:  /* error  */
                          printf("\nfprt2bsi_reg: error: unknown prog. instruction");
                          exit (1);
        

          }  /* switch */



#if (dbg_flag > 0)
printf("\nfprt2bsi_reg: ckp 1100 (end)");
#endif



}  /*  prg  */



















