/*
**************************
lextkns.h

Token codes for lexan.

Note token codes for keuwords are 8 bits (char).
Thus in 0 - 255.
**************************
*/



#ifndef lextkns_h
#define lextkns_h



/*  
******************************************
lexan token codes 
******************************************
*/

#define tk_unk 1000
#define tk_num 1001
#define tk_eof 1002
#define tk_string 1003
#define tk_id 1004
#define tk_newid 1005
#define tk_oldid 1006



/*  keywords  */
#define tk_leftpar '('
#define tk_leftcurl '{'
#define tk_rightpar ')'
#define tk_rightcurl '}'
#define tk_equal '='


#define tk_xarg 'x'

#define tk_boolean 'b'

#define tk_isone 'q'
#define tk_eval 'e'
#define tk_satasg 's'
#define tk_C 'C'
#define tk_exec 'V'

#define tk_xlist 'L'
#define tk_reglist 'R'
#define tk_ordlist 'X'

#define tk_ifte 'i'
#define tk_compose 'c'

#define tk_and '&'
#define tk_or '+'
#define tk_not '~'
#define tk_xor '^'
#define tk_eq '#'
#define tk_nor '!'
#define tk_nand '@'
#define tk_exists 'E'
#define tk_forall 'A'
#define tk_imp '>'
#define tk_join 'j'
#define tk_prj 'p'

/* begin, end are only used in 
   the internal representation
   of program for padding
   purposes
*/

#define tk_begin '0'
#define tk_end '1'

#endif

