/*
**************************
prgvtx.h
**************************
*/


#ifndef prgvtx_h
#define prgvtx_h

#include <stdlib.h>
#include <stdio.h>



#define regeval(L) (*((void **) L))
#define vtxeval(v, i) ((void **) v)[i]
#define regfield(L, i) vtxeval(regeval(L), i)

/* note: regeval(L) = vtxeval(L, 0)  */



#define ptr_up 0
#define ptr_down 1
#define op_code 2
#define bop_arity 3
#define bop_word0 4




/*
**************************
bop
Vertex Format:
ptr_up ptr_down opcode bop_arity
id ... id 
**************************
*/


/*
**************************
begin, end (used only for padding)
Note: no words.
Vertex Format:
ptr_up ptr_down opcode 
**************************
*/

#define size_begin 3
#define size_end 3








/* query: isone, satasg, eval, C
Vertex Format:
ptr_up ptr_down opcode id string
*/
#define size_query 5
#define query_word0 3






/*
***************************************
prg header:
ord: arg order;
prg: program;
reg: reglists;
xlist: xlists;
pc: program counter
mode: (mode: set, reset)
target: (target: prg instruction up to which resetting)
*****************************************
*/




#define compose_reglist_size(L) \
(unsigned int) vtxeval(regeval(regfield(L, compose_word0 + 2)), reglist_word0)

#define compose_reglist_array(L)  \
vtxeval(regeval(regfield(L, compose_word0 + 2)), reglist_word0 + 1)





typedef struct Program_Header
{

  void *prg;
  void *pc;  /* program counter */
  void *ordlist;
  void *xlist;
  void *reglist;
  unsigned int maxarg;
} prghdr;









void* get_prgvtx(unsigned int size);


void fprint_prgvtx(FILE* fileptr, void* p);


prghdr* get_prghdr();


void* get_prgreg();


char* signe();


#endif

