/*
*************************************
file: binop.c


Read id def via binary operator:
and
or
xor
eq
nor
nand
imp.

HYP: op string in reg.

In arity num of rhs id's found.
Thus total id's = lhs.ids + rhs.ids = 1 + arity.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_boole_op(void* *p  /* token */, unsigned int *arity)
{
/*  dcl  */
unsigned int listsize = 0;

void* result;
void *listq_fifo, *tlist_vtx;

void *bop_opcode;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_boole_op:%u: begin: opcode: %c: %s", count,
p[0],
keywstring((unsigned int) p[0])
);
#endif


/* 
   Opcode is in token[0].
   All arg's are id's.
   The first one is the one being defined.
*/



/* store opcode */
bop_opcode = p[0];



/* read lhs */


read_new_token(p);
if (p[0] != (void *) tk_id)
/* error */
{
                 printf("\nerror in file %s line %u: id expected",
                          lexan_fname(), lex_line_number());

                 exit (1);
}

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: lhs id: %s", count, read_stbk_key(p[1]));
#endif



/* ok: p[0] == tk_id  */

check_newdef(p);


result = read_stbk_info(p[1]);




/* read rhs's */


listq_fifo = create_fifo();

/* listsize == 0 */

while (1)
     {


      read_new_token(p);

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: while: token code: %u", count, p[0]);
#endif


      switch ( (unsigned int) p[0] )
            {

                case tk_rightpar:  /*  end list */

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: switch: found ')'", count);
#endif

                       break;





                case tk_id:  /*  id  */

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: switch: found id %s", count, read_stbk_key(p[1]));
#endif

                       in_fifo(listq_fifo, (unsigned int) read_stbk_info(p[1]));
                       listsize++;




                       continue;





                default:

                     printf(
"\nerror in file %s line %u: found token code %u: id or ')' expected",
      lexan_fname(), lex_line_number(), p[0]
);

              exit (1);


            }

/*  ) found, exit while */

         break;
     }



/* listsize >= 0   */

/* define arity */
*arity = listsize;


tlist_vtx =  get_prgvtx(bop_word0 + listsize);

vtxeval(tlist_vtx, op_code) = bop_opcode;
regeval(result) = tlist_vtx;
  



/* store listq_fifo  */



/* store listq_fifo  */
eptybopfifo2vtx(listq_fifo, tlist_vtx, listsize);



/* return result */

return (result);


}  /*  read_boole_op()  */ 












