/*
*************************************
file: cehckord.c


Check if ordlist is well defined,
i.e. it defines a permutation.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 


int check_ordlist(void* ordlist_reg  /* != NULL */)
{

/* dcl  */

unsigned int 
	i, pos_size;

void *buffer;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/*  prg  */




#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: varord = 0x%x", 
count, ordvtx);
#endif



pos_size = (unsigned int) regfield(ordlist_reg, bop_arity);


#if (dbg_flag > 10)
printf("\nordlistreg_argpos:%u: fws_size = %u", count, fws_size);
#endif



/* 
   Test if each number in 0 ... (pos_size - 1) 
   occurs exactly one in pos_array
*/


/* buffer for markers */
buffer = get_prgvtx(pos_size);

/* initialize buffer  */
for (i = 0; i < pos_size; i++) vtxeval(buffer, i) = (void *) 0;


/* check pos_array  */
for (i = 0; i < pos_size; i++)
   {

      if ( (unsigned int) regfield(ordlist_reg, bop_word0 + i) >= pos_size )  
      /*  error: out of range  */
       {
          printf("\nError: ordlist ox%x: entry[%u] = %u >= %u\n",
                   ordlist_reg, i, 
regfield(ordlist_reg, bop_word0 + i), 
pos_size);

          return (1);

       }


/* range ok */

 
      if ( (unsigned int) vtxeval(buffer, 
(unsigned int) regfield(ordlist_reg, bop_word0 + i)
) != 0 )  
      /*  error: redefinition  */
       {
          printf("\nError: ordlist ox%x: entry[%u] = %u occurs more than once\n",
                   ordlist_reg, i, regfield(ordlist_reg, bop_word0 + i));

          return (2);

       }


/* ok: mark */
vtxeval(buffer, (unsigned int) regfield(ordlist_reg, bop_word0 + i)) = (void *) 1;


   }  /* for i */


/*  free buffer */
free(buffer);



return (0);


}  /* check_ordlist */



