/*
*************************************
file: compose.c


Read id def via ifte or compose.
In general op of arity arity.


Returns pointer to id defined.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 


void* read_compose(void* *p  /* token */)
{
/*  dcl  */
void* result;
unsigned int arity;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif


/*  prg  */


#if (dbg_flag > 1000)
printf("\nread_compose:%u: ckp 100 (begin)", count);
#endif


/* 
   Opcode is in token[0].
   We need to read 4 ids.  
   The first id is the one being defined.
*/


result = read_boole_op(p, &arity);




if ( arity != 3 )
/* error */
  {
                 printf("\nerror in file %s line %u: 1 rhs arg expected",
                          lexan_fname(), lex_line_number());

                 exit (1);

  }

/* ok  */





/* check that xlist and reglist have same size */


if (  regfield(regfield(result, bop_word0 + 1), /* xlist_reg */
               bop_arity)
      !=

      regfield(regfield(result, bop_word0 + 2), /* reglist_reg */
               bop_arity)
   )
/*  error  */
  {
  printf("\nerror in file %s line %u: same size expected for xlist and reglist",
                          lexan_fname(), lex_line_number());

                 exit (1);



  }





/* return result */

return (result);


}  /*  read_compose()  */ 












