/*
*************************************
file: upload.c

Load program in file into RAM.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 

prghdr* upload(char *filename)
{

/* dcl  */

FILE* lexinput;

prghdr* p;  /*  program header  */

void 	*tail_prg, 
	*tail_xlist, *tail_reglist, *tail_ordlist,
	*bsaterm, *bsa_vtx;

unsigned int xlist_size, i;


/* prg  */


#if (dbg_flag > 0)
printf("\nupload: begin: open input file, start lexan");
#endif



/* initialize lexan  */

lexinput = fopen(filename, "r");
begin_lexan();
set_lexan(lexinput, filename);





#if (dbg_flag > 0)
printf("\nupload: init. prg. hdr.");
#endif


/* create program header  */
p = get_prghdr();

/*  p -> argord = NULL;  */

p -> xlist = NULL;
p -> ordlist = NULL;
p -> reglist = NULL;



tail_prg = NULL;
tail_xlist = NULL;
tail_reglist = NULL;
tail_ordlist = NULL;


/* initialize maxarg */
p -> maxarg = 0;


#if (dbg_flag > 0)
printf("\nupload: pad prg with begin");
#endif

p -> prg = get_prgreg();
vtxeval(p -> prg, 0) = get_prgvtx(size_begin);
vtxeval(p -> prg, 1) = "begin";

vtxeval(regeval(p -> prg), ptr_up) = NULL;
vtxeval(regeval(p -> prg), ptr_down) = NULL;
vtxeval(regeval(p -> prg), op_code) = (void *) tk_begin;
tail_prg = p -> prg;


/* 
   p -> prg != NULL 
   tail_prg != NULL
*/



#if (dbg_flag > 0)
printf("\nupload: read terms");
#endif

/* read all terms in program  */ 

while ( (bsaterm = read_new_term()) != NULL)
     {
       /* bsaterm != NULL */
    

/* move to prgvtx  */

bsa_vtx =  *((void* *) bsaterm);


#if (dbg_flag > 0)
printf("\nupload: bsa_vtx = 0x%x: op_code = %u = 0x%x = %c",
bsa_vtx,
((void* *) bsa_vtx)[op_code],
((void* *) bsa_vtx)[op_code],
((void* *) bsa_vtx)[op_code]
);
#endif


switch ( (unsigned int) ((void* *) bsa_vtx)[op_code] )
      {
           case tk_ifte:
           case tk_compose:
           case tk_boolean:

       case tk_and:
       case tk_or:
       case tk_not:
       case tk_xor:
       case tk_eq:
       case tk_nor:
       case tk_nand:
       case tk_imp:

       case tk_join:
       case tk_prj:


       case tk_exists: 
       case tk_forall: 
       case tk_exec: 





                        /* program instruction
                           as well as definition 
                       */

/* tail_prg != NULL */

(*((void** *) tail_prg))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_prg; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in program */
tail_prg = bsaterm;



                        break;




           case tk_xarg:


                       /* program instruction 
                            as well as definition 
                            update maxarg
                       */



/* tail_prg != NULL */

(*((void** *) tail_prg))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_prg; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in program */
tail_prg = bsaterm;



if ( 1 + (unsigned int) regfield(tail_prg, bop_word0) 
      >  
     (p -> maxarg)
   )
/* update maxarg */
  {

p -> maxarg = 
     1 + (unsigned int) regfield(tail_prg, bop_word0);

  }



                        break;




           case tk_isone:  /* query isone  */
           case tk_eval: /* eval  */
           case tk_satasg:  /* satasg  */
           case tk_C:  /* C function */

                       /* program instruction but not
                          definition, 
                          varord

                       */


/* tail_prg != NULL */

 (*((void** *) tail_prg))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_prg; 
((void* *) bsa_vtx)[ptr_down] = NULL;  


/* last instruction in program */
tail_prg = bsaterm;


                 
                         break;







            case tk_xlist:  

/* xlist: not a prg instr. nor a def. */



if (tail_xlist == NULL)
     p -> xlist = bsaterm;
else (*((void** *) tail_xlist))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_xlist; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in xlist list */
tail_xlist = bsaterm;


/* update maxarg  */

xlist_size = (unsigned int) regfield(bsaterm, bop_arity);

for (i = 0; i < xlist_size; i++)
   {

if ( 1 + ((unsigned int) regfield(bsaterm, bop_word0 + i)) >  (p -> maxarg) )
/* update maxarg */
  {

p -> maxarg =  1 + ((unsigned int) regfield(bsaterm, bop_word0 + i));

  }


   }   /*  for i  */



                      break;




            case tk_reglist:  

/* reglist: not a prg instr. nor a def. */



if (tail_reglist == NULL)
     p -> reglist = bsaterm;
else (*((void** *) tail_reglist))[ptr_down] = bsaterm; 


((void* *) bsa_vtx)[ptr_up] = tail_reglist; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in xlist list */
tail_reglist = bsaterm;


                      break;






            case tk_ordlist:  

/* ordlist: not a prg instr. nor a def. */



if (tail_ordlist == NULL)
/* first ordlist in file */
   {
     p -> ordlist = bsaterm;
   }
else /* error */
   {
      printf(
"\nparse error in file %s line %u: \nfound second ordlist, \
at most one expected",
          lexan_fname(), lex_line_number());

      exit (1);

   }


((void* *) bsa_vtx)[ptr_up] = tail_ordlist; 
((void* *) bsa_vtx)[ptr_down] = NULL; 
  

/* last instruction in ordlist list */
tail_ordlist = bsaterm;


                      break;




           default:  /* error  */

      printf(
"\nupload: parse error in file %s line %u: unknown instruction: code %c = %s",
          lexan_fname(), 
lex_line_number(), 
regfield(bsaterm, op_code),
keywstring((unsigned int) regfield(bsaterm, op_code))
);

                     exit (1);

      }  /* switch */





     }  /* while  */



#if (dbg_flag > 0)
printf("\nupload: no more terms: pad with end");
#endif



/* tail_prg != NULL */
regfield(tail_prg, ptr_down) = get_prgreg();
bsa_vtx = get_prgvtx(size_end);

vtxeval(regfield(tail_prg, ptr_down), 0) = bsa_vtx;
vtxeval(regfield(tail_prg, ptr_down), 1) = "end";

vtxeval(bsa_vtx, ptr_up) = tail_prg;
vtxeval(bsa_vtx, ptr_down) = NULL;
vtxeval(bsa_vtx, op_code) = (void *) tk_end;

/* no need to update tail_prg */
/* tail_prg = vtxeval(regeval(tail_prg), ptr_down); */


#if (dbg_flag > 0)
printf("\nupload: close lexan");
#endif


end_lexan();



#if (dbg_flag > 0)
printf("\nupload: close input file");
#endif


fclose(lexinput);


#if (dbg_flag > 0)
printf("\nupload: return prg.hdr 0x%x", p);
#endif



return (p);


}  /*  prg  */





















