/*
*************************************
file: upload.c

Print prgvtx on file
*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */


void fprint_prgvtx(FILE* fileptr, void* p_lab)
{
/* p_lab: pointer to prgvtx */

/* dcl  */
unsigned int i;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
printf("\nfprint_prgvtx: begin: print reg 0x%x", p_lab);
#endif


/* note p_lab is a reg */


p =  regeval(p_lab);

#if (dbg_flag > 0)
printf("\nfprint_prgvtx: opcode: %c", ((void* *) p)[op_code] );
#endif


       switch ( (unsigned int) ((void* *) p)[op_code] )
          {







       case tk_ifte:
       case tk_and:
       case tk_or:
       case tk_xor:
       case tk_eq:
       case tk_nor:
       case tk_nand:
       case tk_imp:
       case tk_not:
       case tk_reglist:  
       case tk_compose:
       case tk_exists: 
       case tk_forall: 




#if (dbg_flag > 0)
printf("\nfprint_prgvtx: binary boole op");
#endif


    fprintf(fileptr, "(%s %s ", 
keywstring((unsigned int) regfield(p_lab, op_code)),
vtxeval(p_lab, 1)
);

              
                    for (i = 0; i < (unsigned int) regfield(p_lab, bop_arity); i++)
                       {
fprintf(fileptr, "%s ",
vtxeval(regfield(p_lab, bop_word0 + i), 1)
 );

                       } /* for */

                      fprintf(fileptr, ")\n");

  


                  break;













           case tk_xarg:
           case tk_boolean:
           case tk_xlist:  
           case tk_ordlist:  


    fprintf(fileptr, "(%s %s ", 
keywstring((unsigned int) regfield(p_lab, op_code)),
vtxeval(p_lab, 1)
);

              
                    for (i = 0; i < (unsigned int) regfield(p_lab, bop_arity); i++)
                       {
fprintf(fileptr, "%u ",
regfield(p_lab, bop_word0 + i)
 );

                       } /* for */

                      fprintf(fileptr, ")\n");

  


                  break;











           case tk_isone:  /* query isone  */
           case tk_eval: /* eval  */
           case tk_satasg:  /* satasg  */
           case tk_C:  /* C function */




                      fprintf(fileptr, "(%s %s \"%s\")\n",
keywstring((unsigned int) regfield(p_lab, op_code)),
vtxeval(vtxeval(p, query_word0), 1),
vtxeval(p, query_word0 + 1)
);

#if (longprint > 10)
fprintf(fileptr, "/* id 0x%x vtx 0x%x up 0x%x down 0x%x */\n",
p_lab,
p,
((void* *) p)[ptr_up],
((void* *) p)[ptr_down]
);
#endif


#if (print_dump > 10)
fprintf(fileptr, "/* ");
dump_reg(fileptr, p_lab, size_query);
fprintf(fileptr, " */\n");
#endif

 
                        break;









           case tk_begin:  
           case tk_end:
                          /* These are internal instructions
                             only used for padding.
                             No printing 
                           */

                         break;












                 default:  /* error  */
                          printf("\nfprint_prgvtx: error: unknown prog. instruction");
                          exit (1);
        

          }  /* switch */



#if (dbg_flag > 0)
printf("\nfprint_prgvtx: ckp 1100 (end)");
#endif



}  /*  prg  */






void dump_reg(FILE* fileptr, void* p, unsigned int size)
{
/* dcl */
unsigned int i;

/* prg */
fprintf(fileptr, "dump id = 0x%x, vtx = *id = 0x%x:\n",
p, *((void**) p));

for (i = 0; i < size; i++)
   fprintf(fileptr, "vtx[%u] = 0x%x ", i, (*((void***) p))[i]);


}  /*  dump_reg  */

















