/*
*************************************
file: upload.c

Print prgvtx on file
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */

#define prt_op 0  /* normal value: 0  */





void fprt_trans_reg(FILE* fileptr, void* p_lab)
{
/* p_lab: pointer to prgvtx */

/* dcl  */
unsigned int i;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
printf("\nfprt_trans_reg: begin: print reg 0x%x, opcode %c: %s", 
p_lab,
regfield(p_lab, op_code),
keywstring((unsigned int) regfield(p_lab, op_code))
);
#endif


/* note p_lab is a reg */


p =  regeval(p_lab);

#if (dbg_flag > 0)
printf("\nfprt_trans_reg: vtx opcode: %c: %s", 
((void* *) p)[op_code],
keywstring((unsigned int) vtxeval(p, op_code))
);
#endif


       switch ( (unsigned int) ((void* *) p)[op_code] )
          {

              case tk_ifte:


                    ifte(fileptr, p_lab);

 
                     break;

 




       case tk_and:

#if (prt_op > 10)
fprintf(fileptr, "/* and */\n");
#endif

                  and(fileptr, p_lab);
                  break;



       case tk_or:

#if (prt_op > 10)
fprintf(fileptr, "/* or  */\n");
#endif

                  or(fileptr, p_lab);
                  break;



       case tk_xor:

#if (prt_op > 10)
fprintf(fileptr, "/* xor */\n");
#endif

                  xor(fileptr, p_lab);
                  break;



       case tk_eq:

#if (prt_op > 10)
fprintf(fileptr, "/* eq */\n");
#endif

                  eq(fileptr, p_lab);
                  break;




       case tk_nor:


#if (prt_op > 10)
fprintf(fileptr, "/* nor */\n");
#endif

                  nor(fileptr, p_lab);
                  break;


       case tk_nand:


#if (prt_op > 10)
fprintf(fileptr, "/* nand */\n");
#endif

                  nand(fileptr, p_lab);
                  break;


       case tk_imp:

#if (prt_op > 10)
fprintf(fileptr, "/* imp */\n");
#endif

                  imp(fileptr, p_lab);
                  break;


  



         case tk_not:


#if (prt_op > 10)
fprintf(fileptr, "/* not */\n");
#endif

                  not(fileptr, p_lab);
                  break;









                   case tk_xarg:



                    xarg(fileptr, p_lab);

 
                     break;





                    case tk_boolean:



                    boole(fileptr, p_lab);

 
                     break;






            case tk_compose:



                    compose(fileptr, p_lab);

 
                     break;




       case tk_exists: 


#if (prt_op > 10)
fprintf(fileptr, "/* exists */\n");
#endif

                  exists(fileptr, p_lab);
                  break;



       case tk_forall: 

#if (prt_op > 10)
fprintf(fileptr, "/* forall */\n");
#endif

                  forall(fileptr, p_lab);
                  break;









            case tk_xlist:  


                    xlist(fileptr, p_lab);

                     break;






            case tk_reglist:  

                    reglist(fileptr, p_lab);

                     break;




            case tk_join:  

                    join(fileptr, p_lab);

                     break;





            case tk_prj:  

                    prj(fileptr, p_lab);

                     break;



           case tk_isone:  /* query isone  */
           case tk_eval: /* eval  */
           case tk_satasg:  /* satasg  */
           case tk_C:  /* C function */



                    query(fileptr, p_lab);

 
                     break;





           case tk_begin:  
           case tk_end:
                          /* These are internal instructions
                             only used for padding.
                             No printing 
                           */

                         break;



            case tk_ordlist: 
 
                      ordlist(fileptr, p_lab);

                     break;




            case tk_exec:  

                    exec(fileptr, p_lab);

                     break;




                 default:  /* error  */
                          printf("\nfprt_trans_reg: error: unknown prog. instruction");
                          exit (1);
        

          }  /* switch */



#if (dbg_flag > 0)
printf("\nfprt_trans_reg: end");
#endif



}  /*  prg  */



















