/*
*************************************
file: loadkeys.c
Load keywords in symbol table T.
*************************************
*/


#include "local.h"



#define debug 0     /* normal value: 0  */
 
#define KEYWORDS 256





static
void add_key(void* T, char* key, unsigned int tokencode);


static char* keystrtab[KEYWORDS];


void load_keywords(void* T)
{
/* declarations  */


void* p;   /*  bucket  */

char *key;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* programs  */


#if (dbg_flag > 0)
printf("\n\nload_keywords:%u: ckp 100: symbol_table = 0x%x",
count,
T
);
#endif





/* Load keywords  */

add_key(T, "(", tk_leftpar);

add_key(T, ")", tk_rightpar);

add_key(T, "ifte", tk_ifte);

add_key(T, "xarg", tk_xarg);

add_key(T, "boole", tk_boolean);

add_key(T, "xlist", tk_xlist);

add_key(T, "reglist", tk_reglist);
 
add_key(T, "ordlist", tk_ordlist);
 
add_key(T, "isone", tk_isone);
 
add_key(T, "eval", tk_eval);

add_key(T, "satasg", tk_satasg);

add_key(T, "C_code", tk_C);

add_key(T, "and", tk_and);

add_key(T, "or", tk_or);

add_key(T, "not", tk_not);

add_key(T, "xor", tk_xor);

add_key(T, "eq", tk_eq);

add_key(T, "nor", tk_nor);

add_key(T, "nand", tk_nand);
  
add_key(T, "exists", tk_exists);
    
add_key(T, "forall", tk_forall);

add_key(T, "imp", tk_imp);

add_key(T, "uint", tk_uint);

add_key(T, "exec", tk_exec);



   
add_key(T, "def", tk_def);

add_key(T, "dcl", tk_dcl);

add_key(T, "join", tk_join);

add_key(T, "prj", tk_prj);

add_key(T, "record", tk_record);

add_key(T, "array", tk_array);

add_key(T, "@", tk_compose);
add_key(T, "compose", tk_compose);


add_key(T, "$", tk_dollar);

add_key(T, "b0", tk_b0);

add_key(T, "b1", tk_b1);

add_key(T, "argord", tk_argord);


}  /* prg  */







#if 0

char* get_key_string(char* key)
{
/* dcl */
unsigned int size;
char *result;


/* prg */

size = strlen(key) + 1;


result = (char *) malloc(size*sizeof(char));

if (result == NULL)
/* error */
{
   printf("\nget_key_string: error no malloc space\n");
   exit (1);
}


/* ok */


return ( strcpy(result, key) );

}  /* get_key_string */


#endif





void add_key(void* T, char* key, unsigned int tokencode)
{
/* dcl */
void* p;   /*  bucket  */

/* prg */
p = get_new_stbk();
write_stbk_key(p, key);
write_stbk_tkcode(p, tokencode);
write_stbk_info(p, NULL); 
keystrtab[tokencode] = key;
write_symbtab_bucket(T, p);
  
}




char* keywstring(unsigned int tokencode)
{
return ( keystrtab[tokencode] );
}
