/*
*************************************
file: atom.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 

/* id in token p */


void* atom_id(void* p[2]   /*  token  */)
{
/* dcl */



void  *tlist_vtx;




#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\natom_id:%u: begin: p[0] = %u: id: ", 
count, 
p[0]
);
printf("%s", 
vtxeval(read_stbk_info(p[1]), lexid_string)
);
#endif





/* define arity */

#if 0
/* old: no sharing */
tlist_vtx =  get_prgvtx(op_word0 + id_args);
#endif



/* new: sharing */
tlist_vtx =  vtxeval(read_stbk_info(p[1]), lexid_tkid);

#if (dbg_flag > 100)
printf("\natom_id:%u: tlist_vtx = 0x%x", 
count, 
tlist_vtx
);
#endif


vtxeval(tlist_vtx, op_code) = p[0];  
vtxeval(tlist_vtx, op_args) = (void *) id_args;
vtxeval(tlist_vtx, op_word0) = read_stbk_info(p[1]);
  
#if (dbg_flag > 100)
printf("\natom_id:%u: read_stbk_info(p[1]) = 0x%x; return", 
count, 
read_stbk_info(p[1])
);
#endif


/* return result */

return (tlist_vtx);








}   /* prg  */









/* num in token p */


void* atom_num(void* p[2]   /*  token  */)
{
/* dcl */



void  *tlist_vtx;




#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\natom_num:%u: begin: p[0] = %u: value: %u", 
count, 
p[0], 
p[1]
);
#endif




/* define arity */

tlist_vtx =  get_prgvtx(op_word0 + num_args);

vtxeval(tlist_vtx, op_code) = p[0];  
vtxeval(tlist_vtx, op_args) = (void *) num_args;
vtxeval(tlist_vtx, op_word0) = p[1];
  


/* return result */

return (tlist_vtx);








}   /* prg  */


















/* string in token p */


void* atom_string(void* p[2]   /*  token  */)
{
/* dcl */



void  *tlist_vtx;




#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\natom_string:%u: begin: p[0] = %u: string: \"%s\"", 
count, 
p[0], 
p[1]
);
#endif





/* define arity */

tlist_vtx =  get_prgvtx(op_word0 + string_args);

vtxeval(tlist_vtx, op_code) = p[0];  
vtxeval(tlist_vtx, op_args) = (void *) string_args;
vtxeval(tlist_vtx, op_word0) = p[1];
  


/* return result */

return (tlist_vtx);








}   /* prg  */









/* string in token p */


void* atom_keyword(void* p[2]   /*  token  */)
{
/* dcl */



void  *tlist_vtx;




#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\natom_keyword:%u: begin: p[0] = %c: keyword: %s", 
count, 
p[0], 
keywstring((int) p[0])
);
#endif





/* define arity */

tlist_vtx =  get_prgvtx(op_word0);

vtxeval(tlist_vtx, op_code) = p[0];  
vtxeval(tlist_vtx, op_args) = (void *) 0;
  


/* return result */

return (tlist_vtx);








}   /* prg  */





