/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0    /* normal value: 0  */
 



void* print_term(FILE *fileptr, void* term)
{
/* dcl */

unsigned int i;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\nprint_term:%u: begin: term = 0x%x: op_code = %c = %u", 
count, term,
vtxeval(term, op_code),
vtxeval(term, op_code)
);
#endif



      switch ( (unsigned int) vtxeval(term, op_code) )
            {



       case tk_id:  /* id  */


#if (dbg_flag > 100)
printf("\nprint_term:%u: id: %s", 
count, 
vtxeval(vtxeval(term, op_word0), lexid_string)
);
#endif

             fprintf(fileptr, "%s ", 
                       vtxeval(vtxeval(term, op_word0), lexid_string)
                    );
             return;



      case tk_num:  /* num  */

#if (dbg_flag > 100)
printf("\nprint_term:%u: num: %u", count, vtxeval(term, op_word0));
#endif

            fprintf(fileptr, "%d ", 
                       vtxeval(term, op_word0)
                    );
             return;


      case tk_string:  /* id  */


#if (dbg_flag > 100)
printf("\nprint_term:%u: string: \"%s\"", count, vtxeval(term, op_word0));
#endif

            fprintf(fileptr, "\"%s\" ", 
                       vtxeval(term, op_word0)
                    );
             return;


       default:  /* keyword,  */



              if ( (unsigned int) vtxeval(term, op_args) == 0 )
              /* atom */
              {

#if (dbg_flag > 100)
printf("\nprint_term:%u: atom keyword: %s", count, 
keywstring((unsigned int) vtxeval(term, op_code))
);
#endif

            fprintf(fileptr, "%s ", 
                       keywstring((unsigned int) vtxeval(term, op_code))
                    );
             return;


              }

#if (dbg_flag > 100)
printf("\nprint_term:%u: nonatom_keyword: %s args: %u", count, 
keywstring((unsigned int) vtxeval(term, op_code)),
vtxeval(term, op_args)
);
#endif

/* non atom */
            fprintf(fileptr, "(%s ", 
                       keywstring((unsigned int) vtxeval(term, op_code))
                    );


            for (i = 0; 
                 i < (unsigned int) vtxeval(term, op_args);
                 i++
                )
             {
                print_term(fileptr, vtxeval(term, op_word0 + i));
             }


             fprintf(fileptr, ") ");


            }  /*  switch */








}   /* prg  */

















