/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0    /* normal value: 0  */
 



void* read_op(void* p[2]   /*  token  */)
{
/* dcl */


unsigned int listsize = 0;

void *listq_fifo, *tlist_vtx;

void *op_opcode;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\nread_op:%u: begin: token code = %c == (", count, p[0]);
#endif

/* p[0] = tk_leftpar */

/* read operator */

read_new_token(p);




/* store opcode */
op_opcode =  p[0];

/* this shuold be a keyword: no id no num no string */

if ( ( (unsigned int) op_opcode == tk_id )
     ||
     ( (unsigned int) op_opcode == tk_num )
     ||
     ( (unsigned int) op_opcode == tk_string )
   )
{

                  printf("\nparse error in file %s line %u: keyword expected",
                          lexan_fname(), lex_line_number());

                 exit (1);




}


#if (dbg_flag > 1000)
printf("\nread_op:%u: nonatom keyword: %s", 
count, 
keywstring((unsigned int) p[0])
);
#endif




/* read args */


listq_fifo = create_fifo();

/* listsize == 0 */

while (1)
     {


      read_new_token(p);



      switch ( (unsigned int) p[0] )
            {

                case tk_rightpar:  /*  end term */

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: switch: found ')'", count);
#endif

                       break;


                case tk_leftpar:  /*  begin new term */

#if (dbg_flag > 100)
printf("\nread_boole_op:%u: switch: found '('", count);
#endif

                       in_fifo(listq_fifo, (unsigned int) read_op(p));
                       listsize++;

                       continue;





       case tk_eof:  /* EOF: no term to read  */

#if (dbg_flag > 1000)
printf("\nread_op:%u: switch: found EOF", count);
#endif

                  printf("\nparse error in file %s line %u: unexpected eof",
                          lexan_fname(), lex_line_number());

                 exit (1);







       case tk_id:  /* id  */


#if (dbg_flag > 1000)
printf("\nread_op:%u: switch: found id: %s", 
count, 
vtxeval(read_stbk_info(p[1]), lexid_string)
);
#endif


             in_fifo(listq_fifo, (unsigned int) atom_id(p));
             listsize++;
                  
                   continue;  


      case tk_num:  /* id  */

#if (dbg_flag > 1000)
printf("\nread_op:%u: switch: found num: %u", 
count, 
p[1]
);
#endif

             in_fifo(listq_fifo, (unsigned int) atom_num(p));
             listsize++;
                  
                   continue;  


      case tk_string:  /* id  */

#if (dbg_flag > 1000)
printf("\nread_op:%u: switch: found string: %s", 
count, 
p[1]
);
#endif

             in_fifo(listq_fifo, (unsigned int) atom_string(p));
             listsize++;
                  
                   continue;  


       default:  /* atom: keyword,  */

#if (dbg_flag > 1000)
printf("\nread_op:%u: switch: found atom keyword: %s", 
count, 
keywstring((unsigned int) p[0])
);
#endif

             in_fifo(listq_fifo, (unsigned int) atom_keyword(p));
             listsize++;
                  
                   continue;  



            }



/*  ) found, exit while */

         break;


     }





/* listsize >= 0   */




/* define arity */

tlist_vtx =  get_prgvtx(op_word0 + listsize);

vtxeval(tlist_vtx, op_code) = op_opcode;
vtxeval(tlist_vtx, op_args) = (void *) listsize;
  


/* store listq_fifo  */
eptybopfifo2vtx(listq_fifo, tlist_vtx, listsize);

#if (dbg_flag > 1000)
printf("\nread_op:%u: read term 0x%x:\n", count, tlist_vtx);
print_term(stdout, tlist_vtx);
printf("\n");
#endif


/* return result */

return (tlist_vtx);








}   /* prg  */

















