/*
*************************************
file: download.c


Check that all ids in program are defined.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void ck_prgid_def(prghdr *phdr)
{
/* dcl  */
void  *p;
void *term;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nck_prgid_def:%u: begin", count);
#endif




/*  first instruction */
p = phdr -> prg;


 while (p != NULL)
  {
       /* print line, p != NULL */

       term = vtxeval(p, prgwrd_value);


       ck_id_def(term);


       p = vtxeval(p, ptr_down);

}




#if (dbg_flag > 10)
printf("\nck_prgid_def:%u: end", count);
#endif

}  /*  prg  */
















void ck_id_def(void *term)
{
/* dcl  */
unsigned int lhsop, numargs, i;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */





#if (dbg_flag > 0)
fprintf(stderr, "\n\nck_id_def: begin: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch ( (unsigned int) vtxeval(term, op_code) )
     {



        case tk_id:  /* id */

#if (dbg_flag > 0)
fprintf(stderr, "\nck_id_def: id %s: check:",
vtxeval(vtxeval(term, op_word0), lexid_string)
);
#endif


if (
vtxeval(vtxeval(term, op_word0), lexid_def)
==
NULL
   )
/*  error  */
{

fprintf(stderr, "\nck_id_def: error: id %s undefined",
vtxeval(vtxeval(term, op_word0), lexid_string)
);

exit (1); 



}



#if (dbg_flag > 0)
fprintf(stderr, "\ndefine_lexid_def: dcl, def: end");
#endif

                  return;






           
          case tk_dcl:


 ck_id_def( vtxeval(term, op_word0) );

            return;




          case tk_exec:

/* nothing to be done */

             return;





          case tk_def:

#if 0
/*
not needed
*/

 ck_id_def( vtxeval(term, op_word0) );

#endif




 ck_id_def( vtxeval(term, op_word0 + 1) );



            return;








       default :

/*
record, array, bops, prj, join, uint, etc
*/



numargs = (unsigned int) vtxeval(term, op_args);



for (i = 0; i < numargs; i++)
   {


switch ( (int) vtxeval(vtxeval(term, op_word0 + i), op_code) )
       {

          case tk_id:

             ck_id_def( vtxeval(term, op_word0 + i) );
     
             break;





          case tk_num:
          case tk_b0:
          case tk_b1:



              break;

         
          default:  /* error */

             fprintf(stderr, "\nck_id_def: Error: unexpected symbol\n");
             print_term(stderr, vtxeval(term, op_word0 + i) );
             fprintf(stderr, "\n");
             exit (1);



       }  /*  switch  */



   }   /*  for i  */




               return;



}  /* switch  */





}  /* ck_id_def()  */





