/*
*************************************
file: download.c



syn10 does the following:

1.
Get rid of double definitions (def p q)
replacing all occurrences of p with q in
the program, (def p q) removed.

2.
Defines vctsize for dcl's and remove dcl.

3.
Define id_type
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
#define dbg_exec 0  /* normal value: 0  */



void def_id_info(prghdr* phdr)
{
/* dcl  */
void  *p, *next_p, *rhs_term;  /* prg label for instruction  */
void *term;
unsigned int lhsop, rhs_op;



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndefine_lexid_def:%u: begin", count);
#endif





#if (dbg_flag > 100)
printf("\ndefine_lexid_def:%u: print program", count);
#endif


/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       term = vtxeval(p, prgwrd_value);

       next_p = vtxeval(p, ptr_down);


       fly_def_id_info(term);


       p = next_p;

 
  }   /* while */






#if (dbg_flag > 10)
printf("\ndefine_lexid_def:%u: end", count);
#endif

}  /*  prg  */






























void* fly_def_id_info(void *term)
{
/* dcls */
void  *rhs_term;  /* prg label for instruction  */
unsigned int lhsop, rhs_op;

unsigned int i, tmp_op_args;


/* prg  */

#if 0
if (term == NULL) return (NULL);

/* term != NULL */
#endif


lhsop = (unsigned int) vtxeval(term, op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\ndefine_lexid_def: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {



        case tk_def:  /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\ndefine_lexid_def: switch: dcl, def");
#endif


vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_def)
=
term;


#if (dbg_flag > 0)
fprintf(stderr, "\ndefine_lexid_def: dcl, def: end");
#endif

  
rhs_op = (unsigned int) vtxeval(vtxeval(term, op_word0 + 1), op_code);

rhs_term = vtxeval(term, op_word0 + 1);






             switch (rhs_op)
      {



       case tk_record:


#if (dbg_flag > 0)
fprintf(stderr, "\ndef_id_info: switch: record: ");
#endif

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_record;



                  break;






      case tk_array:


#if (dbg_flag > 0)
fprintf(stderr, "\ndef_id_info:: switch: array ");
#endif

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_array;




                    break;












        case tk_prj:



/* if rhs id type is array or record then prj is dollar */

if (
     ( (unsigned int) vtxeval(
                      vtxeval(vtxeval(rhs_term, op_word0), op_word0),
                      lexid_type
                           )
       ==
     
       id_record
    )
    ||
     ( (unsigned int) vtxeval(
                      vtxeval(vtxeval(rhs_term, op_word0), op_word0),
                      lexid_type
                           )
       ==
     
       id_array
    )
  )
/* use dollar type */
{


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_dollar;



}

else
/* bfun  */
{


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


}




vtxeval(
      vtxeval(vtxeval(term, op_word0), op_word0),
      lexid_vctsize
        ) 
=
(void *) 1;


                break;






     case tk_dollar:

/* error  */

fprintf(stderr, "\nid_def: error id of type dollar found\n");
exit (1);


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_dollar;




vtxeval(
      vtxeval(vtxeval(term, op_word0), op_word0),
      lexid_vctsize
        ) 
=
(void *) 1;



                       break;







        default:  /* bfun */


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


                  break;        



     }   /*  switch rhs */


        break;








       case tk_exec:  /* definition */

#if (dbg_exec > 100)
fprintf(stderr, "\ndefine_lexid_def: switch: exec\n");
print_term(stderr, term);
#endif

/*
vtxeval(term, op_word0): string
vtxeval(term, op_word0 + 1 + 2*k): id
vtxeval(term, op_word0 + 1 + 2*k + 1): num
*/


tmp_op_args = (unsigned int) vtxeval(term, op_args);

#if (dbg_exec > 100)
fprintf(stderr, "\ndefine_lexid_def: tmp_op_args = %u", tmp_op_args);
#endif


for (i = 1; i < tmp_op_args; i = i + 2)
   {
vtxeval(vtxeval(vtxeval(term, op_word0 + i), op_word0), lexid_def)
=
term;


vtxeval( 
   vtxeval(vtxeval(term, op_word0 + i), op_word0),
   lexid_type
       ) = (void *) id_bfun;


vtxeval(
      vtxeval(vtxeval(term, op_word0 + i), op_word0),
      lexid_vctsize
        ) 
=
(void *) vtxeval(vtxeval(term, op_word0 + i + 1), op_word0);

#if (dbg_exec > 100)
fprintf(stderr, "\ndefine_lexid_def: i = %u, vtxeval(vtxeval(term, op_word0 + i + 1), op_word0) = %u", 
i,
vtxeval(vtxeval(term, op_word0 + i + 1), op_word0)
);
#endif

 
    }  /* for i */



#if (dbg_flag > 0)
fprintf(stderr, "\ndefine_lexid_def: dcl, def: end");
#endif

  
rhs_op = (unsigned int) vtxeval(vtxeval(term, op_word0 + 1), op_code);

rhs_term = vtxeval(term, op_word0 + 1);


                  break;



      default:  /* do nothing */

                 break;




}   /*  switch op  */





return (term);


}   /*   fly_def_id_info()    */
