/*
*************************************
file: download.c



syn10 does the following:

1.
Get rid of double definitions (def p q)
replacing all occurrences of p with q in
the program, (def p q) removed.

2.
Defines vctsize for dcl's and remove dcl.

3.
Define id_type
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void rm_dcl_dup(prghdr* phdr)
{
/* dcl  */
void  *p, *next_p;  /* prg label for instruction  */
void *term, *rhs_term;
unsigned int lhsop, rhs_op, new_vctsize;

void *array_term;
unsigned int i, array_size, record_size, record_args;

void *record_term, *record_term_def;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ntranslate:%u: begin", count);
#endif





#if (dbg_flag > 100)
printf("\ntranslate:%u: print program", count);
#endif


/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       term = vtxeval(p, prgwrd_value);

       next_p = vtxeval(p, ptr_down);


       rm_dcl_dup_term(phdr, p, term);


       p = next_p;

 
  }   /* while */






#if (dbg_flag > 10)
printf("\ntranslate:%u: end", count);
#endif

}  /*  prg  */
















void rm_dcl_dup_term(prghdr* phdr, void *p, void *term)
{
/* dcls */

void *rhs_term;
unsigned int lhsop, rhs_op, new_vctsize;

void *array_term;
unsigned int i, array_size, record_size, record_args;

void *record_term, *record_term_def;




/*  prg  */



lhsop = (unsigned int) vtxeval(term, op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nrm_dcl_dup: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

        case tk_dcl:  /* declaration */


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: remove dcl term");
#endif


vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_vctsize)
=
vtxeval(vtxeval(term, op_word0 + 1), op_word0);

/* remove */

remove_prgword(phdr, p);


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: end dcl");
#endif

                    break;





        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: def term");
#endif


/* check if rhs is id */

rhs_op = (unsigned int) vtxeval(vtxeval(term, op_word0 + 1), op_code);

rhs_term = vtxeval(term, op_word0 + 1);






             switch (rhs_op)
      {



       case tk_record:


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: record: ");
print_term(stderr, term);
#endif


/* define record size  */


record_term = vtxeval(term, op_word0 + 1);

record_args = (unsigned int) vtxeval(record_term, op_args);


record_size = 0;

for (i = 0; i < record_args; i++)
   {

record_term_def = 
    vtxeval(
           vtxeval(vtxeval(record_term, op_word0 + i), op_word0),
           lexid_def
        );



check_lexid_def(term, record_term_def);



/*  ok  */


record_size = 
     record_size +
     ((unsigned int)
     vtxeval(
           vtxeval(vtxeval(record_term_def, op_word0), op_word0),
           lexid_vctsize
        ));


   }   /*  for i  */



vtxeval(
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
       )
=
(void *) record_size;


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: record %s size = %u ",
vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    ),
record_size
);
#endif


              break;





       case tk_array:


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: array: ");
print_term(stderr, term);
#endif



/*  store array size */

array_term = vtxeval(term, op_word0 + 1);
array_size = (unsigned int) 
             vtxeval(vtxeval(array_term, op_word0), op_word0);

vtxeval(
      vtxeval(vtxeval(term, op_word0), op_word0),
      lexid_vctsize
        ) 
=
(void *) array_size;

/* increment numbvar counter */

phdr -> numbvar = (phdr -> numbvar) + array_size;



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: array %s size = %u ",
vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    ),
array_size
);
#endif




              break;





      case tk_dollar:
      case tk_prj:

                  /* nothing to do here */

                   break;






              case tk_b0:  
              case tk_b1:
              case tk_ifte:
              case tk_and:
              case tk_or:
              case tk_xor:
              case tk_eq:
              case tk_nor:
              case tk_nand:
              case tk_imp:
              case tk_not:
              case tk_join:
              case tk_exists:
              case tk_forall:
              case tk_compose:
              case tk_uint:




#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun:\n\t");
print_term(stderr, term);
#endif




/* vctsize is sum of components as in record  */


record_term = vtxeval(term, op_word0 + 1);


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: rhs term:\n\t");
print_term(stderr, record_term);
#endif


switch ((int) vtxeval(record_term, op_code) )
      {

        case tk_b0:
        case tk_b1:


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: b0, b1");
#endif

                     record_size = 1;
                     break;



        case tk_uint:

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: b0, b1");
#endif

                     record_size =
(unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0 + 1), op_word0),
                  op_word0
                      ); 




                     break;




        case tk_compose:


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: compose");
#endif


record_term_def = 
    vtxeval(
           vtxeval(vtxeval(record_term, op_word0), op_word0),
           lexid_def
        );



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: done: record_term_def = 0x%x:\n\t",
record_term_def
);
print_term(stderr, record_term_def);
#endif


check_lexid_def(term, record_term_def);


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: done: check_lexid_def");
#endif

record_size = 
     ((unsigned int)
     vtxeval(
           vtxeval(vtxeval(record_term_def, op_word0), op_word0),
           lexid_vctsize
        )
      );


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: record_size = %u, end compose",
record_size
);
#endif


                      break;






        case tk_exists:
        case tk_forall:

record_term_def = 
    vtxeval(
           vtxeval(vtxeval(record_term, op_word0 + 1), op_word0),
           lexid_def
        );



check_lexid_def(term, record_term_def);


record_size = 
     ((unsigned int)
     vtxeval(
           vtxeval(vtxeval(record_term_def, op_word0), op_word0),
           lexid_vctsize
        )
      );



                      break;








        case tk_join:



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun: default: rhs: ");
print_term(stderr, record_term);
#endif


record_args = (unsigned int) vtxeval(record_term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun: default: args = %u",
record_args
);
#endif


record_size = 0;

for (i = 0; i < record_args; i++)
   {



record_size = 
     record_size +
     term_id_vctsize(term, vtxeval(record_term, op_word0 + i) );



   }   /*  for i  */


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun: default: break: i = %u, record_size = %u",
i,
record_size
);
#endif



                  break;









        default:

/* 
In this case vctsize is equal to max vctsize.
Moreover all args have size max or 1.
Note record_args > 0.
*/

   

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun: default: rhs: ");
print_term(stderr, record_term);
#endif


record_args = (unsigned int) vtxeval(record_term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun: default: args = %u",
record_args
);
#endif

record_size = 1;

for (i = 0; i < record_args; i++)
   {

new_vctsize = 
term_id_vctsize(term, vtxeval(record_term, op_word0 + i) );


if (new_vctsize > 1)
{
  if (record_size == 1)
  /* update */
  { record_size = new_vctsize; }
  else
    if (record_size != new_vctsize)
    /* type error */
    {
       fprintf(stderr, 
"type error: size of 1 or %u expected in arg %u of term:\n", 
record_size, 
i
);
       print_term(stderr, record_term);

    }


}


   }   /*  for i  */


#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun: default: break: i = %u, record_size = %u",
i,
record_size
);
#endif



                  break;

}        /* switch */




/* chek   size  */
 


/*  record_size is 1 or there should have beed a dcl */
/* note: vctsize initialiazed to 1 */

   
#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: check size: record_size = %u",
record_size
);
#endif

           

if ( (record_size != 1)
      &&
(   vtxeval(
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
           )
!=
    (void *) record_size
)
  )
/*  error  */
{

   fprintf(stderr, "\nerror id %s: dcl size = %u, found size %u\n",
vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    ),
vtxeval(
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
       ),
record_size
);

exit (1);


}


/*
vtxeval(
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
           )
==
    (void *) record_size

*/

  
#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: size ok: record_size = %u",
record_size
);
#endif



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: bfun %s size = %u ",
vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    ),
record_size
);
#endif




              break;







                 default:  /* error  */
 fprintf(stderr, "\nrm_dcl_dup: error: unknown prog. instruction:\n");
print_term(stderr, term);

                          exit (1);


          }  /* switch */



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dcl_dup: switch: end def");
#endif



               break;









        default:  /* do nothing */

                  break;        



     }   /*  switch */



}     /* rm_dcl_dup_term()    */














void* fly_rm_dcl_dup(prghdr* phdr)
{




}     /* rm_dcl_dup_term()    */


