/*
*************************************
file: download.c



syn10 does the following:

1.
Get rid of double definitions (def p q)
replacing all occurrences of p with q in
the program, (def p q) removed.

2.
Defines vctsize for dcl's and remove dcl.

3.
Define id_type
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void rm_dup_ids(prghdr* phdr)
{
/* dcl  */
void *term;
void  *p, *next_p;  /* prg label for instruction  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nrm_dup_ids:%u: begin", count);
#endif




/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       term = vtxeval(p, prgwrd_value);

       next_p = vtxeval(p, ptr_down);


        rm_dup_ids_term(phdr, p, term);





       p = next_p;

 
  }   /* while */






#if (dbg_flag > 10)
printf("\nrm_dup_ids:%u: end", count);
#endif

}  /*  prg  */

















void rm_dup_ids_term(prghdr* phdr, void *p, void *term)
{
/* dcls */


void *rhs_term;
unsigned int lhsop, rhs_op, new_vctsize;

void *array_term;
unsigned int i, array_size, record_size, record_args;

void *record_term, *record_term_def;






/* prg  */


lhsop = (unsigned int) vtxeval(term, op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nrm_dup_ids: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

  


        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: def term");
#endif


/* check if rhs is id */

rhs_op = (unsigned int) vtxeval(vtxeval(term, op_word0 + 1), op_code);

rhs_term = vtxeval(term, op_word0 + 1);






             switch (rhs_op)
      {


                case tk_id:

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: remove dup ids: ");
print_term(stderr, term);
#endif

#if 0
/* old: no sharing */
vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_string)
=
vtxeval(vtxeval(vtxeval(term, op_word0 + 1), op_word0), lexid_string);


vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_type)
=
vtxeval(vtxeval(vtxeval(term, op_word0 + 1), op_word0), lexid_type);


vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_def)
=
vtxeval(vtxeval(vtxeval(term, op_word0 + 1), op_word0), lexid_def);

  

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_vctsize)
=
vtxeval(vtxeval(vtxeval(term, op_word0 + 1), op_word0), lexid_vctsize);

           

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_idcount)
=
vtxeval(vtxeval(vtxeval(term, op_word0 + 1), op_word0), lexid_idcount);
#endif


/* new: sharing of tkid. */
/*
***************************
Choose, if possible, id not starting with _
***************************
*/

if (
((char *)
vtxeval(
  vtxeval(vtxeval(term, op_word0), op_word0),
  lexid_string
       ))[0]
!=
'_'
)
/* keep lhs */
{

free( vtxeval(vtxeval(term, op_word0 + 1), op_word0) );

vtxeval(vtxeval(term, op_word0 + 1), op_word0) =
vtxeval(vtxeval(term, op_word0), op_word0);

}
else  /* keep rhs  */
{

free( vtxeval(vtxeval(term, op_word0), op_word0) );

vtxeval(vtxeval(term, op_word0), op_word0) =
vtxeval(vtxeval(term, op_word0 + 1), op_word0);

}




#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: new dup term: ");
print_term(stderr, term);
#endif

remove_prgword(phdr, p);

         
             break;




        default:  /* do nothing */

                  break;        


          }  /* switch */



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: end def");
#endif



               break;









        default:  /* do nothing */

                  break;        



     }   /*  switch */





}     /*  rm_dup_ids_term()     */






















void* fly_rm_dup_ids(void *term)
{
/* dcls */


void *rhs_term;
unsigned int lhsop, rhs_op, new_vctsize;

void *array_term;
unsigned int i, array_size, record_size, record_args;

void *record_term, *record_term_def;







/* prg  */

if (term == NULL) return (NULL);

/* term != NULL */



lhsop = (unsigned int) vtxeval(term, op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nrm_dup_ids: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

  


        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: def term");
#endif


/* check if rhs is id */

rhs_op = (unsigned int) vtxeval(vtxeval(term, op_word0 + 1), op_code);

rhs_term = vtxeval(term, op_word0 + 1);






             switch (rhs_op)
      {


                case tk_id:

#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: remove dup ids: ");
print_term(stderr, term);
#endif


/* new: sharing of tkid. */
/*
***************************
Choose, if possible, id not starting with _
***************************
*/

if (
((char *)
vtxeval(
  vtxeval(vtxeval(term, op_word0), op_word0),
  lexid_string
       ))[0]
!=
'_'
)
/* keep lhs */
{

free( vtxeval(vtxeval(term, op_word0 + 1), op_word0) );

vtxeval(vtxeval(term, op_word0 + 1), op_word0) =
vtxeval(vtxeval(term, op_word0), op_word0);

}
else  /* keep rhs  */
{

free( vtxeval(vtxeval(term, op_word0), op_word0) );

vtxeval(vtxeval(term, op_word0), op_word0) =
vtxeval(vtxeval(term, op_word0 + 1), op_word0);

}




#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: new dup term: ");
print_term(stderr, term);
#endif



/* removing is simply done by returning NULL  */

return (NULL);





        default:  /* do nothing */


 return (term);

    

          }  /* switch */



#if (dbg_flag > 0)
fprintf(stderr, "\nrm_dup_ids: switch: end def");
#endif



               break;









        default:  /* do nothing */

return (term);




     }   /*  switch */





}     /*  fly_rm_dup_ids()     */




