/*
*************************************
file: and.c

Map array to bsh.
prg_reg points to a term: 
(argord f1 w1 s2
        f2 w2 s2
         ............
)

This order refers to arrays as they appear
in progam.

Hyp: type checking done in syntax.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void argord(FILE* fileptr, prghdr* phdr, void* term)
{
/* dcl */
unsigned int *buf;
unsigned int op_num_args, i, j, k;

unsigned int x_from, x_width;
int x_step;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: begin: numbvar = %u: argord term: 0x%x:\n", 
count, 
phdr -> numbvar,
term
);
print_term(stderr, term);
#endif


/* malloc buf  */

buf = (unsigned int *) malloc(sizeof(unsigned int) * (phdr -> numbvar));

if (buf == NULL)
/* error */
{
   fprintf(stderr, "\nargord: no malloc space\n");
   exit (1);
}

/*  ok:  buf != NULL  */



#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: buf = 0x%x", 
count
);
#endif


op_num_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: op_num_args = %u", 
count,
op_num_args
);
#endif

if (op_num_args%3 != 0)
/* error */
{
   fprintf(stderr, "\nargord: op_num_args = %u, expected op_num_args%3 == 0\n",
op_num_args
);
   exit (1);
}



k = 0;
for (i = 0; i < op_num_args; i = i + 3)
   {
       /* arg i is from, (i + 1) width, (i + 2) step  */

x_from = (unsigned int) vtxeval(vtxeval(term, op_word0 + i), op_word0);
x_width = (unsigned int) vtxeval(vtxeval(term, op_word0 + i + 1), op_word0);
x_step =  (int) vtxeval(vtxeval(term, op_word0 + i + 2), op_word0);


#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: i = %u: fws = %u %u %d", 
count,
i,
x_from,
x_width,
x_step
);
#endif


       for (j = 0; j < x_width; j++)
          {

#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: j = %u", 
count,
j
);
#endif


            buf[k] = x_from + j*x_step;


#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: buf[%u] = %u", 
count,
k,
buf[k]
);
#endif


k++;

          }  /*  for j */

   }  /* for i */




#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: buf defined: k = %u", 
count,
k
);
#endif




if (k != (phdr -> numbvar))
/* error */
{
   fprintf(stderr, "\nargord: error: ordered %u bvar, expected %u\n",
k,
(phdr -> numbvar)
);
   exit (1);


}


#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: print ordlist", 
count
);
#endif




/*  print ordlist  */

fprintf(fileptr, "(ordlist %s_argord", signe());

for (j = 0; j < (phdr -> numbvar); j++)
   {
        fprintf(fileptr, " %u", buf[j]);
   }

fprintf(fileptr, ")\n");


#if (dbg_flag > 10)
fprintf(stderr, "\nargord:%u: end.", 
count
);
#endif




}  /*  array  */

















