/*
*************************************
file: and.c

Map array to bsh.
prg_reg points to a term: 
(def A (array 10))

We need to print:
xarg's for array entries; (_faiA)
(join A xargs)


These are not printed.
xlists and reglist printed when needed.
xlist for array; (_fXA)
xlist for each array entry; (_fxiA)
reglist for array; (_fRA)
reglist for each array entry (_friA).

*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */


/*
****************
When mkpins > 10 
file pins.h
is produced.
****************
*/
#define mkpins 1000



void array(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, array_size, *buf;

void *array_term;
char *array_name;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif

#if (mkpins > 10)
static unsigned int ipin = 0;
static FILE *pinptr;
#endif


/* prg  */

#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


array_term = vtxeval(term, op_word0 + 1);
array_size = (unsigned int) 
             vtxeval(vtxeval(array_term, op_word0), op_word0);

array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    );


if (array_size == 0)
/* error */
{
fprintf(stderr, "\n\nError: array %s has size 0\n\n",
array_name
);
exit (1);
}


#if (mkpins > 10)
if (ipin == 0)
/* first call */
{
/* init pinptr */
pinptr = fopen("pins.h", "w"); 
}
else
/* open to append  */
{
pinptr = fopen("pins.h", "a"); 
}

fprintf(pinptr, "\n#define %s %u",
array_name,
ipin
);

/* update ipin */
ipin = ipin + array_size;

fclose(pinptr);
#endif






#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: array term", count, array_term);
print_term(stderr, array_term);
fprintf(stderr, "\n");
fprintf(stderr, "\narray:%u: array_size = %u, array_name = %s", 
count, 
array_size,
array_name
);
#endif



/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_array;


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}


/* define vctsize */
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
       ) = (void *) array_size;


#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: id_type = %u == %u, defterm = 0x%x == 0x%x: vctsize = %u", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_array,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
       )
);
#endif





/* define  new args in buf */

buf = (unsigned int *) get_prgvtx(array_size);

for (i = 0; i < array_size; i++)
   {
      buf[i] = new_argindx();

   }  /* for  i */


#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: buf = 0x%x defined", 
count, 
buf
);
#endif


/* 
store args in op_info.
This will be used by record
*/
vtxeval(vtxeval(term, op_word0), op_info) = (void *) buf;



/*
xarg's for array entries; (_faiA)
*/

for (i = 0; i < array_size; i++)
   {

      fprintf(fileptr, "(xarg %sa%u%s %u)\n",
signe(),
i,
array_name,
buf[i]
);


   }


#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: xarg's for array entries defined", 
count
);
#endif



#if 0
/* Not needed */

/*
join xarg's  (_faiA)
*/

   fprintf(fileptr, "(join %s", array_name);


for (i = 0; i < array_size; i++)
   {

      fprintf(fileptr, " %sa%u%s",
signe(),
i,
array_name
);


   }

   fprintf(fileptr, ")\n");




#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: join of xarg's defined", 
count
);
#endif


#endif







#if 0
/*
xlist for array; (_fXA)
*/

    fprintf(fileptr, "(xlist %sX%s ",
signe(),
array_name
);


for (i = 0; i < array_size; i++)
   {
      fprintf(fileptr, "%u ", buf[i]);
   }


    fprintf(fileptr, ")\n");




#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: xlist for array defined", 
count
);
#endif

#endif




#if 0

/*
xlist for each array entry; (_fxiA)
*/


for (i = 0; i < array_size; i++)
   {
      fprintf(fileptr, "(xlist %sx%u%s %u)\n", 
signe(),
i,
array_name,
buf[i]
);
   }





#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: xlist for each array entry defined", 
count
);
#endif

#endif




#if 0
/*
reglist for array; (_fRA)
*/


    fprintf(fileptr, "(reglist %sR%s ",
signe(),
array_name
);


for (i = 0; i < array_size; i++)
   {
      fprintf(fileptr, "%sa%u%s ", 
signe(),
i,
array_name
);
   }


    fprintf(fileptr, ")\n");




#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: reglist for array defined", 
count
);
#endif

#endif




#if 0


/*
reglist for each array entry (_friA)
*/


for (i = 0; i < array_size; i++)
   {
      fprintf(fileptr, "(reglist %sr%u%s %sa%u%s)\n", 
signe(),
i,
array_name,
signe(),
i,
array_name
);
   }




#if (dbg_flag > 10)
fprintf(stderr, "\narray:%u: reglist for each array entry defined (end)", 
count
);
#endif

#endif





}  /*  array  */

















