/*
*************************************
file: aryargs.c

Print recursively all args in record.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */



unsigned int print_array_args(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, rhs_size, *buf;

void *rhs_term;
char *rhs_name;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nprint_array_args:%u: begin: def array term: 0x%x:\n", 
count, 
term
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



rhs_term = vtxeval(term, op_word0 + 1);

rhs_size = (unsigned int) vtxeval(vtxeval(rhs_term, op_word0), op_word0);

rhs_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    );





#if (dbg_flag > 10)
fprintf(stderr, "\nprint_array_args:%u: rhs term 0x%x: ", count, rhs_term);
print_term(stderr, rhs_term);
fprintf(stderr, "\n");
fprintf(stderr, "\nprint_array_args:%u: rhs_size = %u, rhs_name = %s", 
count, 
rhs_size,
rhs_name
);
#endif




buf = vtxeval(vtxeval(term, op_word0), op_info);


#if (dbg_flag > 10)
fprintf(stderr, "\nprint_array_args:%u: buf = 0x%x:  ", 
count,
buf
);
#endif


for (i = 0; i < rhs_size; i++)
   {


#if (dbg_flag > 10)
fprintf(stderr, "\nprint_array_args:%u: buf[%u] = %u ", 
count,
i,
buf[i]
);
#endif

fprintf(fileptr, "%u ", buf[i]);

   }



#if (dbg_flag > 10)
fprintf(stderr, "\nprint_array_args:%u: end. ", 
count
);
#endif


return (rhs_size);


}  /*  prg  */
















