/*
*************************************
file: binder1.c

Map binder operators (exists, forall) to bsh.
term points to a term: 
(def A (binder X q))

id X: array, record, dollar
id q: array, record, dollar, bfun.

HYP: type checking done.
vctsize well defined.

Translate component i.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void binder_component(FILE* fileptr, void* term, unsigned int i)
{
/* dcl */
unsigned int j, bop_args;

void *bop_term;
char *bop_name, *lhs_name;
unsigned int bop_outsize;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nbinder_component:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_term = vtxeval(term, op_word0 + 1);
bop_args = (unsigned int) 
             vtxeval(bop_term, op_args);




bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));

lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );

bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );

#if (dbg_flag > 10)

fprintf(stderr, "\nbinder_component:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\nbinder_component:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



for (j = 0; j < bop_args; j++)
   {
   
      def_binder_arg(fileptr, term, i, j);


   }  /* for  i */



if ( bop_outsize == 1 )
/* no prj */
{
fprintf(fileptr, "(%s %s", bop_name, lhs_name);
}
else /* bop_outsize > 1 */
{

fprintf(fileptr, "(%s _prj_%s_%u", bop_name, lhs_name, i);

}



/* binder vars  */
#if 0
 prt_binder_var(fileptr, term, i, 0);
#endif

fprintf(fileptr, " %s_x_%s", signe(), lhs_name);




for (j = 1; j < bop_args; j++)
   {
   
      prt_binder_arg(fileptr, term, i, j);


   }  /* for  j */




fprintf(fileptr, ")\n");



#if (dbg_flag > 10)
fprintf(stderr, "\nbinder_component:%u: end", count);
#endif


}  /*  binder_component */

















