/*
*************************************
file: binders.c

Map binder operators (exists, forall) to bsh.
term points to a term: 
(def A (binder X q))

id X: array, record, dollar
id q: array, record, dollar, bfun.

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void binders(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, bop_outsize, bop_args;
unsigned int lhs_idcount;

char *lhs_name;

void *bop_term;
void *arg_term;
unsigned int arg_size;


#if (dbg_flag > 0)
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nbinders:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );

lhs_idcount = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_idcount
                      );


bop_term = vtxeval(term, op_word0 + 1);

#if (dbg_flag > 10)
bop_term = vtxeval(term, op_word0 + 1);
bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));


fprintf(stderr, "\nbinders:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\nbinders:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\nbinders:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_bfun,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif



/* define bind vars' */
fprintf(fileptr, "(xlist %s_x_%s", signe(), lhs_name);
arg_term = vtxeval(bop_term, op_word0);
arg_size = (unsigned int) 
           vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize);

    for (i = 0; i < arg_size; i++)
       {
          prt_cmp_xlist(fileptr, term, i, 0); 
       }
 
fprintf(fileptr, ")\n");






for (i = 0; i < bop_outsize; i++)
   {
      binder_component(fileptr, term, i);

   }  /* for  i */


if ( bop_outsize > 1)
/* make join */
{

fprintf(fileptr, "(join %s", lhs_name);


for (i = 0; i < bop_outsize; i++)
   {
      
       fprintf(fileptr, " _prj_%s_%u", lhs_name, i);

   }  /* for  i */


fprintf(fileptr, ")\n");


}



#if (dbg_flag > 10)
fprintf(stderr, "\nbinders:%u: end", count);
#endif


}  /*  binders */

















