/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void boole_op(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, bop_outsize, bop_args;

char *lhs_name;



#if (dbg_flag > 0)
void *bop_term;
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nboole_op:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );



#if (dbg_flag > 10)
bop_term = vtxeval(term, op_word0 + 1);
bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));


fprintf(stderr, "\nboole_op:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\nboole_op:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\nboole_op:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_bfun,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif





/* define  new args in buf */


for (i = 0; i < bop_outsize; i++)
   {
      bop_component(fileptr, term, i);

   }  /* for  i */


if ( bop_outsize > 1)
/* make join */
{

fprintf(fileptr, "(join %s", lhs_name);


for (i = 0; i < bop_outsize; i++)
   {
      
       fprintf(fileptr, " _prj_%u_%s", i, lhs_name);

   }  /* for  i */


fprintf(fileptr, ")\n");


}



#if (dbg_flag > 10)
fprintf(stderr, "\nboole_op:%u: end", count);
#endif


}  /*  boole_op */

















