/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void compose(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, j, bop_outsize, bop_args, arg_size;

char *lhs_name;
void *bop_term, *arg_term;



#if (dbg_flag > 0)
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );


bop_term = vtxeval(term, op_word0 + 1);
bop_args = (unsigned int) 
             vtxeval(bop_term, op_args);

#if (dbg_flag > 10)
bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));

fprintf(stderr, "\ncompose:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\ncompose:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_bfun,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif


fprintf(fileptr, "(xlist %s_x_%s", signe(), lhs_name);
for (j = 1; j < bop_args; j = j + 2)
  { 
arg_term = vtxeval(bop_term, op_word0 + j);
arg_size = (unsigned int) 
           vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize);

    for (i = 0; i < arg_size; i++)
       {
          prt_cmp_xlist(fileptr, term, i, j); 
       }
  }
fprintf(fileptr, ")\n");





#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: print reglist: bop_args = %u", 
count, bop_args);
#endif


/*  define reglist elements */

for (j = 2; j < bop_args; j = j + 2)
  {


arg_term = vtxeval(bop_term, op_word0 + j);


switch ( (unsigned int) vtxeval(arg_term, op_code)  )
   {

     case tk_b0:
     case tk_b1:
           
           arg_size = 1;
           break;


     case tk_id:  
arg_size = (unsigned int) 
           vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize);

             break;



    default: /* error   */

fprintf(stderr, "\ncompose: Error: unexpected token in arg  %u in term:\n", j);
print_term(stderr, term);

            exit (1);

   }



    for (i = 0; i < arg_size; i++)
       { 

def_bop_arg(fileptr, term, i, j);

       }   /*  for i  */


  }  /*  for j  */








/* define reglist  */


fprintf(fileptr, "(reglist %s_r_%s", signe(), lhs_name);
for (j = 2; j < bop_args; j = j + 2)
  {

#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: def arg_term: arg j = %u", 
count, j);
#endif


arg_term = vtxeval(bop_term, op_word0 + j);



#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: cmp i = %u: arg_term = 0x%x: ", 
count, 
i, 
arg_term
);
print_term(stderr, arg_term);
#endif



switch ( (unsigned int) vtxeval(arg_term, op_code)  )
   {

     case tk_b0:
     case tk_b1:
           
           arg_size = 1;
           break;


     case tk_id:  
arg_size = (unsigned int) 
           vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize);

             break;



    default: /* error   */

fprintf(stderr, "\ncompose: Error: unexpected token in arg  %u in term:\n", j);
print_term(stderr, term);

            exit (1);

   }


#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: cmp i = %u: arg_size = %u", 
count, 
i, 
arg_size
);
#endif


    for (i = 0; i < arg_size; i++)
       { 

#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: begin print reg: cmp i = %u, arg j = %u", 
count, i, j);
#endif


          prt_cmp_reglist(fileptr, term, i, j); 

#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: end print reg: cmp i = %u, arg j = %u", 
count, i, j);
#endif

       }

#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: end print cmp i = %u", 
count, i);
#endif

  }



fprintf(fileptr, ")\n");





#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: define cmp components", 
count, i, j);
#endif


if ( bop_outsize > 1)
/* def prj */
{



for (i = 0; i < bop_outsize; i++)
   {

#if 0
       fprintf(fileptr, "(prj _prj_hd_%s_%u %s %u)\n", 
lhs_name, 
i,

vtxeval(
                  vtxeval(vtxeval(bop_term, op_word0), op_word0),
                  lexid_string
                      ),

i
);
#endif

      def_bop_arg(fileptr, term, i, 0);



   }  /* for  i */




}


for (i = 0; i < bop_outsize; i++)
   {
      cmp_component(fileptr, term, i);

   }  /* for  i */


if ( bop_outsize > 1)
/* make join */
{


fprintf(fileptr, "(join %s", lhs_name);

for (i = 0; i < bop_outsize; i++)
   {
       fprintf(fileptr, " _prj_%s_%u", lhs_name, i);

   }  /* for  i */


fprintf(fileptr, ")\n");


}



#if (dbg_flag > 10)
fprintf(stderr, "\ncompose:%u: end", count);
#endif


}  /*  compose */

















