/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Translate component i.

xlist, reglist defined
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void cmp_component(FILE* fileptr, void* term, unsigned int i)
{
/* dcl */
unsigned int j, bop_args;

void *bop_term;
char *bop_name, *lhs_name;
unsigned int bop_outsize;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, 
"\ncmp_component:%u: begin: cmp i = %u: def array term: 0x%x:\n", 
count, i, term);
print_term(stderr, term);
#endif


bop_term = vtxeval(term, op_word0 + 1);
bop_args = (unsigned int) 
             vtxeval(bop_term, op_args);




bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));

lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );

bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );

#if (dbg_flag > 10)

fprintf(stderr, "\ncmp_component:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\ncmp_component:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif





if ( bop_outsize == 1 )
/* no prj */
{
fprintf(fileptr, "(compose %s %s %s_x_%s %s_r_%s)\n", 
lhs_name,

 vtxeval(
                  vtxeval(vtxeval(bop_term, op_word0), op_word0),
                  lexid_string
                      ),

signe(),
lhs_name,

signe(),
lhs_name
);

}


else /* bop_outsize > 1 */
{

#if 0
fprintf(fileptr, "(compose _prj_%s_%u _prj_hd_%s_%u %s_x_%s %s_r_%s)\n", 
lhs_name,
i,

lhs_name,
i,

signe(),
lhs_name,

signe(),
lhs_name
);
#endif


fprintf(fileptr, "(compose _prj_%s_%u", 
lhs_name,
i
);


prt_bop_arg(fileptr, term, i, 0);


fprintf(fileptr, " %s_x_%s", 
signe(),
lhs_name
);



fprintf(fileptr, " %s_r_%s)\n", 
signe(),
lhs_name
);

}




#if (dbg_flag > 10)
fprintf(stderr, "\ncmp_component:%u: end", count);
#endif


}    /*  cmp_component */

















