/*
*************************************
file: bop.c


Map binder operators (exists, forall) to bsh.
term points to a term: 
(def A (binder X q))

id X: array, record, dollar
id q: array, record, dollar, bfun.

HYP: type checking done.
vctsize well defined.


Define component i, arg j.

Note: arg 0 (j == 0) should be array, record or dollar.
This is checked at type checking (syntax).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void def_binder_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
)
{
/* dcl */

void *arg_term;
unsigned int lhs_idcount;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\ndef_binder_arg:%u: begin: term 0x%x: cmp i = %u, arg j = %u\n", count, 
term,
i,
j
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


lhs_idcount = (unsigned int) vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_idcount
                      );



arg_term = vtxeval(
             vtxeval(term, op_word0 + 1),
             op_word0 + j
                  );



/* check if prj needed */
/* 
prj is needed for ids  of type bfun with
   vctsize > 1
*/

if (  ( (unsigned int) vtxeval(arg_term, op_code) == tk_id )
      &&
      ( vtxeval(vtxeval(arg_term, op_word0), lexid_type) 
         == 
        (void *) id_bfun
      )
      &&
       ( (unsigned int) 
         vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
         > 1
       )
   )
 /* prj needed */
   {

   fprintf(fileptr, "(prj _prj_%u_%s_%u %s %u)\n",
lhs_idcount,
vtxeval(vtxeval(arg_term, op_word0), lexid_string),
i,
vtxeval(vtxeval(arg_term, op_word0), lexid_string),
i
);
    }




#if (dbg_flag > 10)
fprintf(stderr, "\ndef_binder_arg:%u: end", count);
#endif


}  /*  def_binder_arg  */

















