/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Define component i, arg j.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void def_bop_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
)
{
/* dcl */

void *arg_term;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\ndef_bop_arg:%u: begin: term 0x%x: cmp i = %u, arg j = %u\n", count, 
term,
i,
j
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif




arg_term = vtxeval(
             vtxeval(term, op_word0 + 1),
             op_word0 + j
                  );



/* check if prj needed */
/* 
prj is needed for ids  of type bfun with
   vctsize > 1
*/


#if (dbg_flag > 10)
fprintf(stderr, "\ndef_bop_arg:%u: prj conditions:", count);
fprintf(stderr, "\narg_term = 0x%x", arg_term);

fprintf(stderr, "\n(unsigned int) vtxeval(arg_term, op_code) = %u == %u = tk_id", 
(unsigned int) vtxeval(arg_term, op_code),
tk_id
);

if ( (unsigned int) vtxeval(arg_term, op_code) == tk_id )
{
fprintf(stderr, "\nvtxeval(vtxeval(arg_term, op_word0), lexid_type) = %u == %u = id_bfun", 
vtxeval(vtxeval(arg_term, op_word0), lexid_type),
id_bfun
);
   
   if (
          vtxeval(vtxeval(arg_term, op_word0), lexid_type) 
         == 
        (void *) id_bfun
      )
     {
fprintf(stderr, "\nvtxeval(vtxeval(arg_term, op_word0), lexid_vctsize) = %u (> 1)", 
(unsigned int) 
vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
);
      }
}
#endif







if (  ( (unsigned int) vtxeval(arg_term, op_code) == tk_id )
      &&
      ( vtxeval(vtxeval(arg_term, op_word0), lexid_type) 
         == 
        (void *) id_bfun
      )
      &&
       ( (unsigned int) 
         vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
         > 1
       )
      &&
       ( (unsigned int) 
         vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
         > i
       )
   )
 /* prj needed */
   {


#if (dbg_flag > 10)
fprintf(stderr, "\ndef_bop_arg:%u: prj needed", count);
#endif


   fprintf(fileptr, "(prj _prj_%u_%u_%u %s %u)\n",

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_idcount),
vtxeval(vtxeval(arg_term, op_word0), lexid_idcount),
i,

vtxeval(vtxeval(arg_term, op_word0), lexid_string),
i
);
    }




#if (dbg_flag > 10)
fprintf(stderr, "\ndef_bop_arg:%u: end", count);
#endif


}  /*  boole_op */

















