/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Define component i, arg j.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void def_join_arg(
FILE* fileptr, 
void* term, 
unsigned int i, 
unsigned int j
)
{
/* dcl */

void *arg_term;
char *lhs_name;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\ndef_join_arg:%u: begin: term 0x%x: cmp i = %u, arg j = %u\n", count, 
term,
i,
j
);
print_term(stderr, term);
#endif


arg_term = vtxeval(
             vtxeval(term, op_word0 + 1),
             op_word0 + j
                  );






switch ( (int) vtxeval(arg_term, op_code) )
     {

           case tk_b0:
           case tk_b1:

/* nothing to be defined  */

             return;




          case tk_id: /* check vctsize */

             break;




          default: /* error */

               fprintf(stderr, "\nError: unexpected symbol in term\n");
               print_term(stderr, term);
               exit (1);


     }




/*  arg_term is an id */

#if (dbg_flag > 10)
fprintf(stderr, "\ndef_join_arg:%u: ", count);
fprintf(stderr, "argterm = 0x%x,  ", arg_term);
fprintf(stderr, "vtxeval(arg_term, op_word0) = 0x%x, ", 
vtxeval(arg_term, op_word0)
);
#if 1
fprintf(stderr, "vctsize = %u", 
vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
);
#endif
#endif





/*
******************************
There is an object to be defined only if
i < obj size.
*******************************
*/


if (i >= (unsigned int) 
         vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
   )
/* nothing to be defined */
{
return;
}

/*
*****************

i < (unsigned int) 
         vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
******************
*/



lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );



#if (dbg_flag > 10)
fprintf(stderr, "\ndef_join_arg:%u: lhs_name = %s", count, lhs_name);
#endif


/* check if prj needed */
/* 
prj is needed for ids  of type bfun with
   vctsize > 1
*/

if (  ( (unsigned int) vtxeval(arg_term, op_code) == tk_id )
      &&
      ( vtxeval(vtxeval(arg_term, op_word0), lexid_type) 
         == 
        (void *) id_bfun
      )
      &&
       ( (unsigned int) 
         vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
         > 1
       )
   )
 /* prj needed */
   {

   fprintf(fileptr, "(prj _%u_%u_%u %s %u)\n",
vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_idcount
                      ),
vtxeval(vtxeval(arg_term, op_word0), lexid_idcount),
i,

vtxeval(vtxeval(arg_term, op_word0), lexid_string),
i
);
    }




#if (dbg_flag > 10)
fprintf(stderr, "\ndef_join_arg:%u: end", count);
#endif


}  /*  boole_op */

















