/*
*************************************
file: and.c

Map array to bsh.
prg_reg points to a term: 
(def Y ($ A 10))

We need to print:
Not printed.
xlist, reglist printed when needed.
xlist for array entry; (_fxdY)
reglist for array entry (_frdY).

*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void dollar(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, array_entry, array_size, *array_buf;

void *dollar_term, *array_def;
char *array_name, *dollar_name;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
#endif


dollar_term = vtxeval(term, op_word0 + 1);

dollar_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    );


#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: dollar_name = %s, dollar_term: = 0x%x:\n", 
count,
dollar_name, 
dollar_term
);
print_term(stderr, dollar_term);
#endif


switch ( (int) 
         vtxeval(vtxeval(vtxeval(dollar_term, op_word0), op_word0), lexid_type)
       )
{

      case id_array:   /* get component i */

#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: switch: dollar_term is id_array", 
count
);
#endif



              array_def = vtxeval(
               vtxeval(vtxeval(dollar_term, op_word0), op_word0),
               lexid_def
                   );

              array_entry = (unsigned int)
                 vtxeval(vtxeval(dollar_term, op_word0 + 1), op_word0);
   
  
               break;


      case id_record: 


#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: switch: dollar_term is id_record", 
count
);
#endif


array_def = record_entry(
vtxeval(vtxeval(vtxeval(dollar_term, op_word0), op_word0), lexid_def), 
(unsigned int) vtxeval(vtxeval(dollar_term, op_word0 + 1), op_word0),
&array_entry
);

#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: array for entry %u of id_record dollar_term \n", 
count,
vtxeval(vtxeval(dollar_term, op_word0 + 1), op_word0)
);
print_term(stderr, array_def);
#endif


                break;



             default: /* error */

               fprintf(stderr, "\ndollar: error: id of type record or array expected in term\n");
               print_term(stderr, dollar_term);

               exit (1);


}  /* switch */





array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(array_def, op_word0), op_word0),
               lexid_string
                    );


#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: array_name = %s", 
count,
array_name
);
#endif


array_buf = (unsigned int *) 
  vtxeval(     
       vtxeval(array_def, op_word0),
       op_info
          );
   
           
#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: array_buf = 0x%x", 
count,
array_buf
);
#endif

array_size = (unsigned int) 
vtxeval(vtxeval(vtxeval(array_def, op_word0 + 1), op_word0), op_word0);

#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: array_size = %u", 
count,
array_size
);
#endif


#if 0
vtx_tknum(     
   vtxeval(
       vtxeval(
            vtx_tkid(vtxeval(dollar_term, op_word0), lexid_def),
            op_word0 + 1
              ),
       op_word0
          )
        );
#endif
              




#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: def array: 0x%x:\n", count, array_def);

print_term(stderr, array_def);


fprintf(stderr, "\ndollar:%u: array term: 0x%x:\n", count, 
 vtxeval(array_def,
             op_word0 + 1
              )
);

print_term(stderr, 
 vtxeval(array_def,
             op_word0 + 1
              )
);


fprintf(stderr, "\ndollar:%u: array_size = %u", 
count, 
array_size
);
#endif



#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: dollar term", count, dollar_term);
print_term(stderr, dollar_term);
fprintf(stderr, "\n");
fprintf(stderr, "\ndollar:%u: dollar_name = %s, array_name = %s, array_entry = %u, array_size = %u, array_buf = 0x%x", 
count, 
dollar_name,
array_name,
array_entry,
array_size,
array_buf
);
#endif


/* check entry < size */
if (array_entry >= array_size)
/* error */
{

fprintf(stderr, "\nError in term: ");
print_term(stderr, term);
fprintf(stderr, "\nentry %u does not exist in array %s of size %u\n",
array_entry,
array_name,
array_size
);

exit (1);


}


/* size ok  */


/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{


fprintf(stderr, "\ndollar: error: id with undefined type found\n");

exit (1);



vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_dollar;


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_dollar,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif




/*  store array_def, array_entry  */

#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: store: array_def = 0x%x, array_entry = %u\n", 
count,
array_def,
array_entry
);
print_term(stderr, array_def);
#endif


vtxeval(vtxeval(vtxeval(term, op_word0), op_word0),
        lexid_array_def) = array_def;

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0),
        lexid_array_entry) = (void *) array_entry;





#if 0

#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: define xlist for array entry %u", 
count,
array_entry
);
#endif


/*
xlist for array entry; (_fxdA)
*/


      fprintf(fileptr, "(xlist %sxd%s %u)\n", 
signe(),
dollar_name,
array_buf[array_entry]
);
   




#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: xlist for array entry defined", 
count
);
#endif


#endif








#if 0

#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: define reglist for array entry %u", 
count,
array_entry
);
#endif

/*
reglist for each array entry (_frdA)
*/


      fprintf(fileptr, "(reglist %srd%s %sa%u%s)\n", 
signe(),
dollar_name,
signe(),
array_entry,
array_name
);
   







#if (dbg_flag > 10)
fprintf(stderr, "\ndollar:%u: reglist for  array entry defined (end)", 
count
);
#endif

#endif



}  /*  dollar  */

















