/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Translate component i.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void join_flat(FILE* fileptr, void* term, unsigned int i)
{
/* dcl */
unsigned int j, bop_args;

void *bop_term;
char *bop_name, *lhs_name;
unsigned int bop_outsize;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\njoin_flat:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_term = vtxeval(term, op_word0 + 1);
bop_args = (unsigned int) 
             vtxeval(bop_term, op_args);




bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));

lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );

bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );

#if (dbg_flag > 10)

fprintf(stderr, "\njoin_flat:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\njoin_flat:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



for (j = 0; j < bop_args; j++)
   {
   
      def_join_arg(fileptr, term, i, j);


   }  /* for  i */




for (j = 0; j < bop_args; j++)
   {
   
      prt_join_arg(fileptr, term, i, j);


   }  /* for  i */





#if (dbg_flag > 10)
fprintf(stderr, "\njoin_flat:%u: end", count);
#endif


}  /*  boole_op */

















