/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void join(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, j, bop_outsize, bop_args;

char *lhs_name;
void *bop_term;



#if (dbg_flag > 0)
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: begin: def join term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



bop_term = vtxeval(term, op_word0 + 1);



#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: bop_term = 0x%x", count, bop_term);
#endif



bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );




#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: bop_outsize = %u", count, bop_outsize);
#endif



/*  ok  */


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );




#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: lhs_name = %s", count, lhs_name);
#endif



bop_args = (unsigned int) 
             vtxeval(bop_term, op_args);



#if (dbg_flag > 10)
bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));


fprintf(stderr, "\njoin:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\njoin:%u: lhs_name = %s, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{



#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: define lexid_type", count);
#endif


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: define lexid_def", count);
#endif


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_bfun,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif





/* define  join */

for (j = 0; j < bop_args; j++)
   {

for (i = 0; i < bop_outsize; i++)
   {
    

#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: begin def arg i = %u, j = %u", count, i, j);
#endif
   
      def_join_arg(fileptr, term, i, j);


#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: end def arg i = %u, j = %u", count, i, j);
#endif


   }  /* for  i  */


   }  /* for  j */





fprintf(fileptr, "(join %s", lhs_name);

for (j = 0; j < bop_args; j++)
   {
   

for (i = 0; i < bop_outsize; i++)
   {
          

#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: begin prt arg i = %u, j = %u", count, i, j);
#endif

      prt_join_arg(fileptr, term, i, j);


#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: end prt arg i = %u, j = %u", count, i, j);
#endif

   }  /* for  i  */


   }  /* for  j */



fprintf(fileptr, ")\n");




#if (dbg_flag > 10)
fprintf(stderr, "\njoin:%u: end", count);
#endif


}  /*  boole_op */

















