/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Define component i, arg j.
*************************************
*/


#include "local.h"



#define dbg_flag 0    /* normal value: 0  */




void prt_bop_arg(FILE* fileptr, void* term, unsigned int i, unsigned int j)
{
/* dcl */

void *arg_term, *rhs_term;
void* array_def;
char* array_name;
unsigned int array_entry;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: begin: term 0x%x: i = %u, j = %u\n", count, 
term,
i,
j
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif




arg_term = vtxeval(
             vtxeval(term, op_word0 + 1),
             op_word0 + j
                  );



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: arg_term 0x%x: i = %u, j = %u\n", count, 
arg_term,
i,
j
);
print_term(stderr, arg_term);
fprintf(stderr, "\n");
#endif




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: arg_term op_code = %u\n", count, 
vtxeval(arg_term, op_code)
);
#endif



/* check for keywords: b0, b1 */

switch ( (unsigned int) vtxeval(arg_term, op_code)  )
   {

     case tk_b0:
           fprintf(fileptr, " b0");
           return;


     case tk_b1:
           fprintf(fileptr, " b1");
           return;


     case tk_id:  /* next switch */
             break;



    default: /* error   */

fprintf(stderr, "\nprt_bop_arg: Error: unexpected token in arg (%u, %u) in term:\n", i, j);
print_term(stderr, term);

            exit (1);

   }






#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: id found: id type: %u", 
count,
vtxeval(vtxeval(arg_term, op_word0), lexid_type)
);
#endif



/* id found   */

switch ( (unsigned int) vtxeval(vtxeval(arg_term, op_word0), lexid_type) )
   {




     case id_bfun:


   if 
        ( (unsigned int) 
          vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
          > 1
        )

     {  /* vctsize > 1 */


         if 
             ( (unsigned int) 
                vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
                > i
              )

          {
   fprintf(fileptr, " _prj_%u_%u_%u",

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_idcount),
vtxeval(vtxeval(arg_term, op_word0), lexid_idcount),
i
);
         return;
           }
     else
/*

        ( (unsigned int) 
          vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
          <= i
        )


*/
   /* use sustain lst component   */
         {
   
   fprintf(fileptr, " _prj_%u_%u_%u",

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_idcount),
vtxeval(vtxeval(arg_term, op_word0), lexid_idcount),
((unsigned int) 
 vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)) - 1
);

           return;
         }

    }  /* then: vctsize > 1 */


else   { 


/*
( (unsigned int) 
          vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
          <= 1
        )
*/

/* no prj */

   fprintf(fileptr, " %s",
vtxeval(vtxeval(arg_term, op_word0), lexid_string)
);




                 return;

      }




      case id_array:   /* get component i */
   

         if 
             ( (unsigned int) 
                vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
                > i
              )

          {
                   fprintf(fileptr, " %sa%u%s",
signe(),
i,
vtxeval(vtxeval(arg_term, op_word0), lexid_string)
);

                     return;
         }

else
   /*  susteain */
         {
   
                   fprintf(fileptr, " %sa%u%s",
signe(),
((unsigned int) vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)) - 1,
vtxeval(vtxeval(arg_term, op_word0), lexid_string)
);



           return;
         }











      case id_record:   /* get component i */



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: switch: found id_record: begin", 
count);
#endif




         if 
             ( (unsigned int) 
                vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
                <= i
              )

          {
/* sustain */



array_def = record_entry(
vtxeval(vtxeval(arg_term, op_word0), lexid_def), 
((unsigned int) vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)) - 1,
&array_entry
);

array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(array_def, op_word0), op_word0),
               lexid_string
                    );



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: switch: found id_record: sustain", 
count);
fprintf(stderr, "\narray_name = %s; array_entry = %u; record def = 0x%x:\n",
array_name,
array_entry,
vtxeval(vtxeval(arg_term, op_word0), lexid_def)
);
print_term(stderr, vtxeval(vtxeval(arg_term, op_word0), lexid_def));
fprintf(stderr, "\narray_def = 0x%x:\n",
array_def
);
print_term(stderr, array_def);
#endif



                  fprintf(fileptr, " %sa%u%s",
signe(),
array_entry,
array_name
);




           return;


          }



else
        {



array_def = record_entry(
vtxeval(vtxeval(arg_term, op_word0), lexid_def), 
i,
&array_entry
);

array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(array_def, op_word0), op_word0),
               lexid_string
                    );



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: switch: found id_record: no sustain", 
count);
fprintf(stderr, "\narray_name = %s; array_entry = %u; record def = 0x%x:\n",
array_name,
array_entry,
vtxeval(vtxeval(arg_term, op_word0), lexid_def)
);
print_term(stderr, vtxeval(vtxeval(arg_term, op_word0), lexid_def));
fprintf(stderr, "\narray_def = 0x%x:\n",
array_def
);
print_term(stderr, array_def);
#endif



                  fprintf(fileptr, " %sa%u%s",
signe(),
array_entry,
array_name
);





                     return;



}  /* else */








     
      case id_dollar:   /* size 1, get array entry */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: id_dollar", 
count
);
#endif


         if 
             ( (unsigned int) 
                vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
                <= i
              )

          {
/* sustain */



rhs_term = vtxeval(vtxeval(vtxeval(arg_term, op_word0), lexid_def), 
                   op_word0 + 1);

#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: id_dollar: rhs_term = 0x%x: ", 
count,
rhs_term
);
print_term(stderr, rhs_term);
fprintf(stderr, "\nprt_bop_arg:%u: num: %u ", 
count,
vtxeval(vtxeval(rhs_term, op_word0 + 1),  op_word0)
);
fprintf(stderr, "\nprt_bop_arg:%u: string: %s", 
count,
vtxeval(
   vtxeval(vtxeval(rhs_term, op_word0), op_word0),
   lexid_string
       )
);
#endif




#if 0

               fprintf(fileptr, " %sa%u%s",
signe(),
vtxeval(vtxeval(rhs_term, op_word0 + 1),  op_word0),
vtxeval(
   vtxeval(vtxeval(rhs_term, op_word0), op_word0),
   lexid_string
       )
);


#endif








array_def = record_entry(
vtxeval(
   vtxeval(vtxeval(rhs_term, op_word0), op_word0),
   lexid_def
       ), 
(unsigned int) vtxeval(vtxeval(rhs_term, op_word0 + 1),  op_word0),
&array_entry
);

array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(array_def, op_word0), op_word0),
               lexid_string
                    );



                  fprintf(fileptr, " %sa%u%s",
signe(),
array_entry,
array_name
);



           return;


          }



else
        {


rhs_term = vtxeval(vtxeval(vtxeval(arg_term, op_word0), lexid_def), 
                   op_word0 + 1);

#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: id_dollar: rhs_term = 0x%x: ", 
count,
rhs_term
);
print_term(stderr, rhs_term);
fprintf(stderr, "\nprt_bop_arg:%u: num: %u ", 
count,
vtxeval(vtxeval(rhs_term, op_word0 + 1),  op_word0)
);
fprintf(stderr, "\nprt_bop_arg:%u: string: %s", 
count,
vtxeval(
   vtxeval(vtxeval(rhs_term, op_word0), op_word0),
   lexid_string
       )
);
#endif




#if 0

               fprintf(fileptr, " %sa%u%s",
signe(),
vtxeval(vtxeval(rhs_term, op_word0 + 1),  op_word0),
vtxeval(
   vtxeval(vtxeval(rhs_term, op_word0), op_word0),
   lexid_string
       )
);


#endif








array_def = record_entry(
vtxeval(
   vtxeval(vtxeval(rhs_term, op_word0), op_word0),
   lexid_def
       ), 
(unsigned int) vtxeval(vtxeval(rhs_term, op_word0 + 1),  op_word0),
&array_entry
);

array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(array_def, op_word0), op_word0),
               lexid_string
                    );


                  fprintf(fileptr, " %sa%u%s",
signe(),
array_entry,
array_name
);




                    return;



}  /* else  */





    default: /* error   */

fprintf(stderr, 
"Error: id expected in arg (%u, %u) in term:\n", 
i, j);
print_term(stderr, term);

            exit (1);





   }




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_bop_arg:%u: end", count);
#endif


}  /*  prt_bop_arg  */

















