/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Define component i, arg j.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void prt_cmp_reglist(FILE* fileptr, void* term, unsigned int i, unsigned int j)
{
/* dcl */

void *arg_term, *rhs_term;
void* array_def;
char* array_name;
unsigned int array_entry;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: begin: term 0x%x: i = %u, j = %u\n", count, 
term,
i,
j
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif




arg_term = vtxeval(
             vtxeval(term, op_word0 + 1),
             op_word0 + j
                  );



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: arg_term 0x%x: i = %u, j = %u\n", count, 
arg_term,
i,
j
);
print_term(stderr, arg_term);
fprintf(stderr, "\n");
#endif




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: arg_term op_code = %u\n", count, 
vtxeval(arg_term, op_code)
);
#endif



/* check for keywords: b0, b1 */

switch ( (unsigned int) vtxeval(arg_term, op_code)  )
   {

     case tk_b0:
           fprintf(fileptr, " b0");
           return;


     case tk_b1:
           fprintf(fileptr, " b1");
           return;


     case tk_id:  /* next switch */
             break;



    default: /* error   */

fprintf(stderr, "\nprt_cmp_reg: Error: unexpected token in arg (%u, %u) in term:\n", i, j);
print_term(stderr, term);

            exit (1);

   }






#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: id found: id type: %u", 
count,
vtxeval(vtxeval(arg_term, op_word0), lexid_type)
);
#endif



/* id found   */

switch ( (unsigned int) vtxeval(vtxeval(arg_term, op_word0), lexid_type) )
   {




     case id_bfun:


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: found bfun", 
count
);
#endif


   if ( (unsigned int) 
        vtxeval(vtxeval(arg_term, op_word0), lexid_vctsize)
        > 1
      )
   /* use prj */
     {

#if 0
   fprintf(fileptr, " _prj_%s_%u",
vtxeval(vtxeval(arg_term, op_word0), lexid_string),
i
);
#endif



  fprintf(fileptr, " _prj_%u_%u_%u",

vtxeval(vtxeval(vtxeval(term, op_word0), op_word0), lexid_idcount),
vtxeval(vtxeval(arg_term, op_word0), lexid_idcount),
i
);



    }

 else  /* no prj  */
    {
   fprintf(fileptr, " %s",
vtxeval(vtxeval(arg_term, op_word0), lexid_string)
);


    }

#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u:  end: bfun", 
count
);
#endif


                 return;




      case id_array:   /* get component i */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: found array", 
count
);
#endif

   
                   fprintf(fileptr, " %sa%u%s",
signe(),
i,
vtxeval(vtxeval(arg_term, op_word0), lexid_string)
);


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: end array", 
count
);
#endif

                     return;











      case id_record:   /* get component j */




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: record found: def=0x%x:  ", 
count,
vtxeval(vtxeval(arg_term, op_word0), lexid_def)
);
print_term(
stderr, 
vtxeval(vtxeval(arg_term, op_word0), lexid_def)
);
#endif


array_def = record_entry(
vtxeval(vtxeval(arg_term, op_word0), lexid_def), 
i,
&array_entry
);



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: array_entry = %u, array_def = 0x%x: ", 
count,
array_entry,
array_def
);
print_term(stderr, array_def); 
#endif


array_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(array_def, op_word0), op_word0),
               lexid_string
                    );


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: array_name: %s", 
count,
array_name
);
#endif


                  fprintf(fileptr, " %sa%u%s",
signe(),
array_entry,
array_name
);


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u:  end: printed: %sa%u%s", 
count,
signe(),
array_entry,
array_name
);
#endif


                     return;











     
      case id_dollar:   /* size 1, get array entry */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: id_dollar", 
count
);
#endif


array_def = vtxeval(vtxeval(arg_term, op_word0),
                    lexid_array_def);

array_entry = (unsigned int) 
             vtxeval(
                vtxeval(arg_term, op_word0), 
                lexid_array_entry);



               fprintf(fileptr, " %sa%u%s",
signe(),
array_entry,
vtxeval(
   vtxeval(vtxeval(array_def, op_word0), op_word0),
   lexid_string
       )
);


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: end dollar", 
count
);
#endif


                    return;







    default: /* error   */

fprintf(stderr, 
"Error: id expected in arg (%u, %u) in term:\n", 
i, j);
print_term(stderr, term);

            exit (1);





   }




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_reg:%u: end", count);
#endif


}  /*  prt_cmp_reg  */

















