/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

Define component i, arg j.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */



/*
record, array, or dollar id expected
*/



void prt_cmp_xlist(FILE* fileptr, void* term, unsigned int i, unsigned int j)
{

/* dcl */

void *arg_term, *rhs_term;
void* array_def;
char* array_name;
unsigned int array_entry, *buf;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: begin: term 0x%x: i = %u, j = %u\n", count, 
term,
i,
j
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif




arg_term = vtxeval(
             vtxeval(term, op_word0 + 1),
             op_word0 + j
                  );



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: arg_term 0x%x: i = %u, j = %u\n", count, 
arg_term,
i,
j
);
print_term(stderr, arg_term);
fprintf(stderr, "\n");
#endif




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: arg_term op_code = %u\n", count, 
vtxeval(arg_term, op_code)
);
#endif



/* check for keywords: b0, b1 */
if (  (unsigned int) vtxeval(arg_term, op_code) 
      !=
      tk_id
   )
/* error */
{
fprintf(stderr, "\nprt_cmp_xlist: Error: record, array or dollar id expected as token in arg (%u, %u) in term:\n", i, j);
print_term(stderr, term);

            exit (1);



}



/* id found */





#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: id found: id type: %u", 
count,
vtxeval(vtxeval(arg_term, op_word0), lexid_type)
);
#endif



/* id found   */

switch ( (unsigned int) vtxeval(vtxeval(arg_term, op_word0), lexid_type) )
   {



      case id_array:   /* get component i */

array_def = vtxeval(vtxeval(arg_term, op_word0), lexid_def);
buf = (unsigned int *) vtxeval(vtxeval(array_def, op_word0), op_info);

   
                   fprintf(fileptr, " %u", buf[i]);

                     return;











      case id_record:   /* get component j */




array_def = record_entry(
vtxeval(vtxeval(arg_term, op_word0), lexid_def), 
i,
&array_entry
);


buf = (unsigned int *) vtxeval(vtxeval(array_def, op_word0), op_info);


                  fprintf(fileptr, " %u", buf[array_entry]);

                     return;











     
      case id_dollar:   /* size 1, get array entry */


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: id_dollar", 
count
);
#endif

/* note: tkid and bucket shared */
array_def = vtxeval(vtxeval(arg_term, op_word0), lexid_array_def);


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: array_def = 0x%x", 
count,
array_def
);
#endif


array_entry = (unsigned int)
               vtxeval(vtxeval(arg_term, op_word0),
                         lexid_array_entry
                      );



#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: array_entry = %u", 
count,
array_entry
);
#endif


buf = (unsigned int *) vtxeval(vtxeval(array_def, op_word0), op_info);


#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: buf = 0x%x", 
count,
buf
);
#endif



      fprintf(fileptr, " %u", buf[array_entry]);

                     return;







    default: /* error   */

fprintf(stderr, 
"Error: id expected in arg (%u, %u) in term:\n", 
i, j);
print_term(stderr, term);

            exit (1);





   }




#if (dbg_flag > 10)
fprintf(stderr, "\nprt_cmp_xlist:%u: end", count);
#endif


}  /*  prt_cmp_xlist  */

















