/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void prj(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, bop_outsize, bop_args;

char *lhs_name;
void *bop_term;



#if (dbg_flag > 0)
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nprj:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



bop_term = vtxeval(term, op_word0 + 1);


/* if rhs id type is array or record then prj is dollar  */
if (

     ( (unsigned int) vtxeval(
                      vtxeval(vtxeval(bop_term, op_word0), op_word0),
                      lexid_type
                           )
       ==
     
       id_record
    )
    ||

     ( (unsigned int) vtxeval(
                      vtxeval(vtxeval(bop_term, op_word0), op_word0),
                      lexid_type
                           )
       ==
     
       id_array
    )
  )
/* use dollar */
{

dollar(fileptr, term);
return;


}


/*
********************************
rhs id is not record or array
********************************
*/


bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );

if (bop_outsize != 1)
/* error */
{

fprintf(stderr, "\nprj: error lhs id has size != 1 in term: ");
print_term(stderr, term);

exit (1);

}


/*  ok  */


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );




bop_args = (unsigned int) 
             vtxeval(bop_term, op_args);



#if (dbg_flag > 10)
bop_name = keywstring((unsigned int) vtxeval(bop_term, op_code));


fprintf(stderr, "\nprj:%u: bop term", count, bop_term);
print_term(stderr, bop_term);
fprintf(stderr, "\n");
fprintf(stderr, "\nprj:%u: lhs_name = %, bop_name = %s, bop_outsize = %u, bop_args = %u", 
count, 
lhs_name,
bop_name,
bop_outsize,
bop_args
);
#endif



/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_bfun;


vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\nprj:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_bfun,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif





/* define  prj  */


fprintf(fileptr, "(prj %s %s %u)\n", 
lhs_name, 
vtxeval(vtxeval(vtxeval(bop_term, op_word0), op_word0), lexid_string),
vtxeval(vtxeval(bop_term, op_word0 + 1), op_word0)
);



#if (dbg_flag > 10)
fprintf(stderr, "\nprj:%u: end", count);
#endif


}  /*  boole_op */

















