/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void query(FILE* fileptr, prghdr* phdr, void* term)
{
/* dcl */
unsigned int i, bop_outsize, bop_args;

char *lhs_name;



#if (dbg_flag > 0)
void *bop_term;
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nquery:%u: begin: def array term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_vctsize
                      );


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );



#if (dbg_flag > 10)
fprintf(stderr, "\nquery:%u: (%s %s): lhs_outsize = %u", 
count, 
keywstring((unsigned int) vtxeval(term, op_code)),
lhs_name,
bop_outsize
);
#endif








/* define  projections if needed  */

if (bop_outsize > 1)
{

for (i = 0; i < bop_outsize; i++)
   {
      fprintf(fileptr,"(prj %s%x_%s_%u %s %u)\n",
signe(),
term,
lhs_name,
i,

lhs_name,

i
);

fprintf(fileptr, "(%s %s%x_%s_%u \"%s_%u\")\n",

keywstring((unsigned int) vtxeval(term, op_code)),

signe(),
term,
lhs_name,
i,

lhs_name,
i
);

   }  /* for  i */


}
else  /*  bop_outsize == 1  */
{

fprintf(fileptr, "(%s %s \"%s\")\n",

keywstring((unsigned int) vtxeval(term, op_code)),

lhs_name,

lhs_name
);


}



#if (dbg_flag > 10)
fprintf(stderr, "\nquery:%u: end", count);
#endif


}  /*  query */

















