/*
*************************************
file: recxlist.c

term points to (def r (record ... ))
or to (def r (array n))



returns pointer to (def A (array ...))
containing component j of r,
*ar_entry is A component containing
component j of r.
*************************************

*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




void* record_entry(
void* term, 
unsigned int rec_entry,
unsigned int *ar_entry
)
{
/* dcl */
unsigned int i, record_size, arg_size;

int id_type;

void *record_term;
char *record_name;
void *aux_term;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: begin: term: 0x%x:, record_entry = %u\n", 
count, 
term,
rec_entry
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



record_term = vtxeval(term, op_word0 + 1);




if ( vtxeval(record_term, op_code) == (void *) tk_array)
/* term is array */
{

*ar_entry = rec_entry;

return ( term );


}





/* record expected */



if ( vtxeval(record_term, op_code) != (void *) tk_record)
/* fprintf  */
{

 fprintf(stderr, 
"\nrecord_entry: error: record or array expected as argument 1\n");

exit (1);

}


/*  OK record found */





record_size = (unsigned int) vtxeval(record_term, op_args);

record_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    );




#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: record term: 0x%x:\n", 
count, record_term);
print_term(stderr, record_term);
fprintf(stderr, "\nrecord_entry:%u: record_size = %u, record_name = %s", 
count, 
record_size,
record_name
);
#endif




for (i = 0; i < record_size; i++)
   {

aux_term = vtxeval(record_term, op_word0 + i);

arg_size = (unsigned int)
           vtxeval(vtxeval(aux_term, op_word0), lexid_vctsize);


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: i=%u: aux_term = 0x%x: record_entry = %u, arg_size = %u  ", 
count,
i,
aux_term,
rec_entry,
arg_size
);
print_term(stderr, aux_term);
#endif

if (rec_entry < arg_size)
/* get component, leave for  */
{ break; }
else 
{
rec_entry = rec_entry - arg_size;
}


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: for: i=%u, rec_entry = %u, arg_size = %u", 
count,
i,
rec_entry,
arg_size
);
print_term(stderr, aux_term);
#endif

   }  /* for i  */




/* get component rec_entry from aux_term  */


id_type = (int) vtxeval(vtxeval(aux_term, op_word0), lexid_type);


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: id_type = %u", 
count,
id_type
);
#endif


      switch ( id_type )
            {
               case id_record:



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: switch: record %s", 
count,
vtxeval(vtxeval(aux_term, op_word0), lexid_string)
);
#endif



return (
record_entry(
vtxeval(vtxeval(aux_term, op_word0), lexid_def), 
rec_entry,
ar_entry
)
      );




               case id_array:



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u:  switch: array: %s; *ar_entry = %u", 
count,
vtxeval(vtxeval(aux_term, op_word0), lexid_string),
rec_entry
);
#endif


*ar_entry = rec_entry;

return (
vtxeval(vtxeval(aux_term, op_word0), lexid_def)
       );



               default: /* error: record or array expected */

                        fprintf(stderr, 
"\nerror in term (def %s (record ... )): record or array expected in body\n",
record_name
);
        
                        exit (1);



            } /* switch */





#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_entry:%u: end.", 
count,
i
);
#endif






}  /*  record_entry  */

















