/*
*************************************
file: record.c

Map record to bsh.
prg_reg points to a term: 
(def A (record X_1 ... X_n))

We need to print:
Not printed.
xlist, reglist printed when needed.
xlist for record; (_fXA)
reglist for record; (_fRA)

record also defines vctsize.
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void record(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, record_size, *buf;

char *record_name;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord:%u: begin: def record term: 0x%x:\n", 
count, 
term
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



record_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    );




#if (dbg_flag > 10)
fprintf(stderr, "\nrecord:%u: record_name = %s", 
count, 
record_name
);
#endif




/* if id_type undefined define it */
if (
     (unsigned int) vtxeval(
                      vtxeval(vtxeval(term, op_word0), op_word0),
                      lexid_type
                           )
     ==
     
    id_undef
  )
/* define id_type */
{

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ) = (void *) id_record;

vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ) = term;


}




#if (dbg_flag > 10)
fprintf(stderr, "\nrecord:%u: id_type = %u == %u, defterm = 0x%x == 0x%x", 
count, 
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_type
       ),
id_record,
vtxeval( 
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_def
       ),
term
);
#endif





#if 0
/*
xlist for record; (_fXA)
*/

    fprintf(fileptr, "(xlist %sX%s ",
signe(),
record_name
);

record_xlist(fileptr, term);


    fprintf(fileptr, ")\n");





#if (dbg_flag > 10)
fprintf(stderr, "\nrecord:%u: xlist for record defined", 
count
);
#endif

#endif





#if 0

/*
reglist for record; (_fRA)
*/


    fprintf(fileptr, "(reglist %sR%s ",
signe(),
record_name
);




/* print reg list and define vctsize */

vtxeval(
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
       )
=
(void *) record_reglist(fileptr, term);



    fprintf(fileptr, ")\n");



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord:%u: reglist for record defined (end)", 
count
);
#endif

#endif













#if 0

/*
***************************
join for record; (_fRA)


Not needed
***************************
*/


    fprintf(fileptr, "(join %s ", record_name);




/* print reg list and define vctsize */

vtxeval(
   vtxeval(vtxeval(term, op_word0), op_word0),
   lexid_vctsize
       )
=
(void *) record_reglist(fileptr, term);



    fprintf(fileptr, ")\n");



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord:%u: join for record defined (end)", 
count
);
#endif

#endif




}  /*  record   */

















