/*
*************************************
file: recxlist.c

Print recursively all args in record.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */




unsigned int record_reglist(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, record_size;
unsigned int result = 0;

int id_type;

void *record_term;
char *record_name;
void *aux_term;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: begin: def record term: 0x%x:\n", 
count, 
term
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif

record_term = vtxeval(term, op_word0 + 1);

record_size = (unsigned int) vtxeval(record_term, op_args);

record_name = (char *) 
             vtxeval(
               vtxeval(vtxeval(term, op_word0), op_word0),
               lexid_string
                    );




#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: record term: ", count, record_term);
print_term(stderr, record_term);
fprintf(stderr, "\n");
fprintf(stderr, "\nrecord_reglist:%u: record_size = %u, record_name = %s", 
count, 
record_size,
record_name
);
#endif




for (i = 0; i < record_size; i++)
   {

aux_term = vtxeval(record_term, op_word0 + i);



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: i=%u: aux_term = 0x%x:  ", 
count,
i,
aux_term
);
print_term(stderr, aux_term);
#endif


id_type = (int) vtxeval(vtxeval(aux_term, op_word0), lexid_type);


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: i=%u: id_type = %u", 
count,
i,
id_type
);
#endif


      switch ( id_type )
            {
               case id_record:



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: i=%u: switch: record", 
count,
i
);
#endif


                           result = 
result +
record_reglist(
fileptr, 
vtxeval(vtxeval(aux_term, op_word0), lexid_def)
);
                           break;





               case id_array:



#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: i=%u: switch: array", 
count,
i
);
#endif

result =
result + 
print_array_regs(
fileptr, 
vtxeval(vtxeval(aux_term, op_word0), lexid_def)
);



                   break;



               default: /* error: record or array expected */

                        fprintf(stderr, 
"\nerror in term (def %s (record ... )): record or array expected in body\n",
record_name
);
        
                        exit (1);



            } /* switch */


#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: i=%u: end switch", 
count,
i
);
#endif



   }  /*  for i  */




#if (dbg_flag > 10)
fprintf(stderr, "\nrecord_reglist:%u: end.", 
count,
i
);
#endif





return (result);





}  /*  record_reglist  */

















