/*
*************************************
file: upload.c

Print prgvtx on file

No dcl,
No duplication, i.e. only

(def id atomic_keyword)
(def id (op ....))

Never (def id id)
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */





void fprt_trans_reg(
FILE* fileptr, 
prghdr* phdr,
void* term
)
{
/* term: pointer to prgvtx */

/* dcl  */
unsigned int i, lhsop;
void *p;  /* prgvtx */



/* prg  */


#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: begin: translate term 0x%x:\n", term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



lhsop = (unsigned int) vtxeval(term, op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: lhsop = %u", lhsop);
#endif


switch (lhsop)
     {


#if 0

/*
When this function is called (in translate)
all (dcl ...) terms have been removed by syntax.
Thus if there is one something is wrong.
For this reason finding dcl terms now
is an error case.
*/

        case tk_dcl:  /* declaration */


#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: switch: dcl term");
#endif

             dcl(fileptr, term);
             break;



                    break;

#endif




        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: switch: def term");
#endif


             trans_def(fileptr, term);
             break;




        case tk_argord: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: switch: argord");
#endif


             argord(fileptr, phdr, term);
             break;







           case tk_isone:  /* query isone  */
           case tk_eval: /* eval  */
           case tk_satasg:  /* satasg  */
           case tk_C:  /* C function */




#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: switch: query");
#endif


             query(fileptr, phdr, term);
             break;





           case tk_exec:  /* exec function */




#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: switch: exec");
#endif


             print_term(fileptr, term);
             fprintf(fileptr, "\n");
             break;




        default:  /* error */

               fprintf(stderr,
"\nfprt_trans_reg: error: dcl or def expected");

                          exit (1);
        



     }   /*  switch */



#if (dbg_flag > 0)
fprintf(stderr, "\nfprt_trans_reg: end translation term 0x%x", term);
#endif


}  /*  prg  */



















