/*
*************************************
file: upload.c

Print prgvtx on file
*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */
#define longprint 0  /* normal value: 0  */
#define print_dump 0   /* normal value: 0  */

#define prt_op 0  /* normal value: 0  */





void trans_def(FILE* fileptr, void* term)
{
/* term: pointer to prgvtx */

/* dcl  */
unsigned int i, rhsop;
void *p;  /* prgvtx */

/* prg  */


#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: begin: translate def term 0x%x\n", 
term);
print_term(stderr, term);
fprintf(stderr, "\n");

#endif



rhsop = (unsigned int) vtxeval(vtxeval(term, op_word0 + 1), op_code);




#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: rhsop = %u", rhsop);
#endif


       switch ( rhsop )
          {


              case tk_array:


#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: switch: array");
#endif

                    array(fileptr, term);

 
                     break;




              case tk_record:

#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: switch: record");
#endif


                    record(fileptr, term);

 
                     break;





              case tk_dollar:

#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: switch: $");
#endif


                    dollar(fileptr, term);

 
                     break;




              case tk_b0:

#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: switch: b0");
#endif


                    b0b1(fileptr, term, 0);

 
                     break;



              case tk_b1:

#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: switch: b1");
#endif


                    b0b1(fileptr, term, 1);

 
                     break;






              case tk_ifte:
              case tk_and:
              case tk_or:
              case tk_xor:
              case tk_eq:
              case tk_nor:
              case tk_nand:
              case tk_imp:
              case tk_not:


                   boole_op(fileptr, term);

 
                     break;

 


              case tk_prj:
 
                   prj(fileptr, term);

 
                     break;


  



              case tk_join:
 
                   join(fileptr, term);

 
                     break;


  



       case tk_exists: 
       case tk_forall: 


#if (prt_op > 10)
fprintf(fileptr, "/* exists, forall */\n");
#endif

                  binders(fileptr, term);
                  break;








            case tk_compose:



                    compose(fileptr, term);

 
                     break;





            case tk_uint:



                    bsp_uint(fileptr, term);

 
                     break;






#if 0


            case tk_xlist:  


                    xlist(fileptr, term);

                     break;






            case tk_reglist:  

                    reglist(fileptr, term);

                     break;



#endif





           case tk_begin:  
           case tk_end:
                          /* These are internal instructions
                             only used for padding.
                             No printing 
                           */

                         break;



            case tk_ordlist: 
 
                      ordlist(fileptr, term);

                     break;





                 default:  /* error  */
                          fprintf(stderr, "\ntrans_def: error: unknown prog. instruction");
                          exit (1);
        

          }  /* switch */



#if (dbg_flag > 0)
fprintf(stderr, "\ntrans_def: end");
#endif



}  /*  prg  */



















