/*
*************************************
file: bop.c

Map boolean operator to bsh.
term points to a term: 
(def A (op t_0 ... t_{n - 1}))

HYP: type checking done.
vctsize well defined.

*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void bsp_uint(FILE* fileptr, void* term)
{
/* dcl */
unsigned int i, bop_outsize, bop_args, bvalue;

char *lhs_name;



#if (dbg_flag > 0)
void *bop_term;
char *bop_name;
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nuint:%u: begin: def term: 0x%x:\n", count, term);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


bop_outsize = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0 + 1), op_word0),
                  op_word0
                      );


bvalue = (unsigned int) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0 + 1), op_word0 + 1),
                  op_word0
                      );


lhs_name = (char *) 
               vtxeval(
                  vtxeval(vtxeval(term, op_word0), op_word0),
                  lexid_string
                      );




#if (dbg_flag > 10)
fprintf(stderr, "\nuint:%u: %s: lhs_outsize = %u, bvalue = %u", 
count, 
lhs_name,
bop_outsize,
bvalue
);
#endif



if (bop_outsize < 1)
/*  error  */
{

fprintf(stderr, "\nuint: error: arg2 = %u, expected arg2 > 0\n",
bop_outsize
);

exit (1);


}




/* bop_outsize >= 1  */


if (bop_outsize == 1)
/*  no join needed  */
{

    fprintf(fileptr,"(boole %s %u)\n", 
                    lhs_name, (bvalue & 0x1));
   

    return ;

}





/* bop_outsize > 1: join needed */




/* join  */

    fprintf(fileptr,"(join %s", lhs_name);


for (i = 0; i < bop_outsize; i++)
   {
     fprintf(fileptr, " b%u", (bvalue & 0x1));

     bvalue = (bvalue >> 1);
   }

    fprintf(fileptr,")\n");



#if (dbg_flag > 10)
fprintf(stderr, "\nuint:%u: end", count);
#endif


}  /*  uint  */

















