/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */

#define prt_outsize 0  /* normal value: 0 */




void* print_term(FILE *fileptr, void* term)
{
/* dcl */

unsigned int i;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\nprint_term:%u: begin: term = 0x%x: op_code = %c = %u", 
count, term,
vtxeval(term, op_code),
vtxeval(term, op_code)
);
#endif



      switch ( (unsigned int) vtxeval(term, op_code) )
            {



       case tk_id:  /* id  */


#if (dbg_flag > 100)
printf("\nprint_term:%u: begin id:", count);
printf("\nvtxeval(term, op_word0) = 0x%x", 
vtxeval(term, op_word0)
);
printf("\nidarray(vtxeval(term, op_word0)) = 0x%x", 
idarray(vtxeval(term, op_word0))
);
printf("\nvtxeval(idarray(vtxeval(term, op_word0)), lexid_string) = 0x%x",
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
);
printf("\nid = %s",
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
);
#endif


#if (prt_outsize > 0)
fprintf(fileptr, "[%u]", 
vtxeval(idarray(vtxeval(term, op_word0)), lexid_vctsize)
                    );
#endif


             fprintf(fileptr, "%s ", 
                       vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
                    );


             return;


#if (dbg_flag > 100)
printf("\nprint_term:%u: end id: %s", 
count, 
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
);
#endif





      case tk_num:  /* id  */

#if (dbg_flag > 100)
printf("\nprint_term:%u: num: %u", count, vtxeval(term, op_word0));
#endif

            fprintf(fileptr, "%d ", 
                       vtxeval(term, op_word0)
                    );
             return;


      case tk_string:  /* id  */


#if (dbg_flag > 100)
printf("\nprint_term:%u: string: \"%s\"", count, vtxeval(term, op_word0));
#endif

            fprintf(fileptr, "\"%s\" ", 
                       vtxeval(term, op_word0)
                    );
             return;



      case tk_ap:  /* ap  */

  
#if (dbg_flag > 100)
printf("\nprint_term:%u: found tk_ap: ", count);
#endif


/* Parser guarantees: 
   (unsigned int) vtxeval(term, op_args) > 1 
*/


#if (prt_outsize > 0)
fprintf(fileptr, "[%u]", 
vtxeval(term, outsize)
                    );
#endif


             fprintf(fileptr, "(");

            for (i = 0; 
                 i < (unsigned int) vtxeval(term, op_args);
                 i++
                )
             {
                print_term(fileptr, vtxeval(term, op_word0 + i));
             }


             fprintf(fileptr, ") ");



               return;




       default:  /* keyword  */


#if (dbg_flag > 100)
printf("\nprint_term:%u: keyword: %s", count, 
keywstring((unsigned int) vtxeval(term, op_code))
);
#endif

            fprintf(fileptr, "%s ", 
                       keywstring((unsigned int) vtxeval(term, op_code))
                    );



             return;





            }  /*  switch */








}   /* prg  */

















