/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */
 



void* read_new_term()
{
/* dcl */

void* p[2];  /*  token  */



#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */


#if (dbg_flag > 100)
printf("\nread_new_term:%u: begin", count);
#endif



while (1)
{

read_new_token(p);

switch ( (unsigned int) p[0] )
    {


       case tk_leftpar:  /* begin term: next token may be an operator or an id */

#if (dbg_flag > 100)
printf("\nread_new_term:%u: switch: found '('", count);
#endif

                         return ( read_op(p) );



       case tk_eof:  /* EOF: no term to read  */

#if (dbg_flag > 1000)
printf("\nread_new_term:%u: switch: found EOF", count);
#endif

                     return (NULL);



                case tk_rightpar:  /*  error */


#if (dbg_flag > 100)
printf("\nread_new_term:%u: switch: found ')'", count);
#endif

                  printf("\nparse error in file %s line %u: unexpected ')' found",
                          lexan_fname(), lex_line_number());

                 exit (1);






       case tk_id:  /* id  */


#if (dbg_flag > 100)
printf("\nread_new_term:%u: switch: found id: %s ", count,
vtxeval(read_stbk_info(p[1]), lexid_string)
);
#endif

             return ( atom_id(p) );
   

      case tk_num:  /* id  */

#if (dbg_flag > 100)
printf("\nread_new_term:%u: switch: found num: %u", count,
p[1]
);
#endif

          return ( atom_num(p) );



      case tk_string:  /* id  */

#if (dbg_flag > 100)
printf("\nread_new_term:%u: switch: found string: %s", count,
p[1]
);
#endif

          return ( atom_string(p) );


       default:  /* atom: keyword,  */

#if (dbg_flag > 100)
printf("\nread_new_term:%u: atom keyword: %s", count,
keywstring((unsigned int) p[0])
);
#endif

         return ( atom_keyword(p) );




    }  /*  switch  */



}  /* while */




}   /* prg  */

















