/*
*************************************
file: get.c


Given a term returns a prg vertex.

*************************************
*/


#include "local.h"

#define REGSIZE 2

#define dbg_flag 0 /* normal value: 0  */
 



#if 1

/*   
*******************
New version:
To be used when only current term is kept in RAM
*******************
*/


void* get_prgvtx(unsigned int size)
{
/* dcl */


/* prg  */


return ( (void *) new_pool_block(sizeof(void *) * size) );


}   /* prg  */


#endif










 

#if 0

/*   
*******************
old version:
To be used when all terms are kept in RAM
*******************
*/

void* get_prgvtx(unsigned int size)
{
/* dcl */

void* p;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */




p = (void *) malloc(sizeof(void *) * size);

if (p == NULL)
/* error  */
{
   printf("\nget_prgvtx: error: no malloc space\n");
   exit (1000); 
 
}

/* ok  */


#if (dbg_flag > 100)
printf("\nget_prgvtx:%u: ckp 100: p = 0x%x", count, p);
#endif

return (p);


}   /* prg  */

#endif







prghdr* get_prghdr()
{
/* dcl */

void* p;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */




p = (prghdr *) malloc(sizeof(prghdr));

if (p == NULL)
/* error  */
{
   printf("\nget_prgvtx: error: no malloc space\n");
   exit (1000); 
 
}

/* ok  */


#if (dbg_flag > 100)
printf("\nget_prghdr:%u: ckp 100: p = 0x%x", count, p);
#endif


return (p);


}   /* prg  */











/* 
A register has size 2:
0: void* (value);
1: char* (name);
*/



void* get_prgreg()
{
/* dcl */

void* p;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */




p = (void *) malloc(sizeof(void *) * REGSIZE);

if (p == NULL)
/* error  */
{
   printf("\nget_prgreg: error: no malloc space\n");
   exit (1000); 
 
}

/* ok  */


#if (dbg_flag > 100)
printf("\nget_prgreg:%u: ckp 100: p = 0x%x", count, p);
#endif

return (p);


}   /* prg  */















