/*
*************************************
file: join.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"


#define dbg_flag 0   /* normal value: 0  */





/*
************************
(def p (join A)) --> (def p A)


term =
(def p (join ...))
************************
*/


void join(FILE* fileptr,  void* term)
{
/* dcl  */

unsigned int join_outsize;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\njoin:%u: begin: term:\n", count);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\njoin:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


join_outsize = (unsigned int) vtxeval(rhs_term, outsize);



#if (dbg_flag > 10)
printf("\njoin:%u: join_outsize = %u", 
count, 
join_outsize
);
#endif


if ( join_outsize == 1 ) 
/* get rid of join */
{


#if (dbg_flag > 10)
printf("\njoin:%u: remove join", count);
#endif



fprintf(fileptr, "(def %s %s)\n",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       ),


singleton( vtxeval(rhs_term, op_word0 + 1) )


);


return;


}



#if (dbg_flag > 10)
printf("\njoin:%u: join_outsize = %u > 1", count, join_outsize);
#endif

/* no change */

print_term(fileptr, term);


}  /*  join  */


