/*
*************************************
file: prj.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"


#define dbg_flag 0   /* normal value: 0  */





/*
************************
(def p (prj A 0))  --> (def p A)  (when A has size 1)



Also check for the following errors:


(def p (prj A i)) when i >= size(A).



term =
(def p (prj A i))
************************
*/


void prj(FILE* fileptr,  void* term)
{
/* dcl  */

unsigned int prj_index, rhs_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nprj:%u: begin: term:\n", count);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\nprj:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


rhs_size = 
(unsigned int)
vtxeval( vtxeval(rhs_term, op_word0 + 1), outsize);




prj_index = 
(unsigned int)
vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0);



#if (dbg_flag > 10)
printf("\nprj:%u: size of rhs terms = %u", 
count, 
rhs_size,
prj_index
);
#endif


if (prj_index >= rhs_size)
/* error  */
{

fprintf(stderr, 
"\nprj: Error: taking prj %u of array of size %u in term:\n",
prj_index,
rhs_size
);

print_term(stderr, term);

fprintf(stderr, "\n");
exit (1);

}



/* prj_index < rhs_size */


if ( 
      (prj_index == 0)  &&
      (rhs_size == 1)
   )
/* get rid of prj */
{


#if (dbg_flag > 10)
printf("\nprj:%u: remove prj", count);
#endif



fprintf(fileptr, "(def %s %s)\n",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       ),

singleton( vtxeval(rhs_term, op_word0 + 1) )

);


return;


}



#if (dbg_flag > 10)
printf("\nprj:%u: no change", count);
#endif

/* no change */

print_term(fileptr, term);


}  /*  prj  */


