/*
*************************************
file: pstate.c


Defines outsize for all terms.

Hyp: 
array, records, dcl, def.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */






/*
**************
term is (transition (update ...) ... )
**************
*/


void check_transition(void* term)
{
/* dcl  */
unsigned int i, numargs;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf(""\ncheck_transition:%u: begin", count);
#endif



if (vtxeval(term, op_code) != tk_ap)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, "\n(... ) expected\n");
exit (1);

}

/* ok ap */


if (vtxeval(vtxeval(term, op_word0), op_code) != tk_transition)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, "\n(transition ...) expected\n");
exit (1);

}

/* ok */



check_update( vtxeval(term, op_word0 + 1) );



numargs = vtxeval(term, op_args);




if (numargs < 2)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, "\n(transition (...) ... ) expected\n");
exit (1);

}





for (i = 2; i < numargs; i++)
   {

term_outsize( vtxeval(term, op_word0 + i) );


   }   /* for i */



/* ok */


vtxeval(term, outsize) = (void *) 1;




#if (dbg_flag > 10)
printf(""\ncheck_transition:%u: end", count);
#endif

}  /*  prg  */
















