/*
*************************************
file: nstate.c


Defines outsize for all terms.

Hyp: 
array, records, dcl, def.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */






/*
**************
term is (next_state )
**************
*/


void check_next_state(void* term)
{
/* dcl  */
unsigned int i, numargs;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ncheck_next_state:%u: begin", count);
#endif



if (vtxeval(term, op_code) != (void *) tk_ap)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, "\n( ...) expected\n");
exit (1);

}

/* ok ap */


if (vtxeval(vtxeval(term, op_word0), op_code) != (void *) tk_nstate)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, "\n(next_state ...) expected\n");
exit (1);

}

/* ok */


numargs = (unsigned int) vtxeval(term, op_args);




if (numargs < 2)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, "\n(next_state  ... ) expected at least one arg\n");
exit (1);

}





for (i = 1; i < numargs; i++)
   {

/* record or array or dollar expected */
if ( vtxeval(vtxeval(term, op_word0 + i), op_code) != (void *) tk_id)
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, 
"\n(next_state id ... ) expected id as arg %u: founr op_code %u\n",
i,
vtxeval(vtxeval(term, op_word0 + i), op_code)
);
exit (1);

}


/* id found */

#if 0
if ( 
(vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + i), op_word0)),
  lexid_type
       ) != (void *) id_record)
&&
(vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + i), op_word0)),
  lexid_type
       ) != (void *) id_array)
&&
(vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + i), op_word0)),
  lexid_type
       ) != (void *) id_dollar)
   )
/* error */
{
fprintf(stderr, "\nError in term:\n");
print_term(stderr, term);
fprintf(stderr, 
"\n(next_state  ... ) expected record/array id as arg %u: found lexid_type %u\n",
i,
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + i), op_word0)),
  lexid_type
       )
);
exit (1);

}
#endif



   }   /* for i */



/* ok */



#if (dbg_flag > 10)
printf("\ncheck_next_state:%u: end", count);
#endif

}  /*  prg  */
















