/*
*************************************
file: eqv.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





/*
************************
To be implemented

term is
=
(def p (eqv p1 p2))


************************
*/


void eqv(FILE* fileptr,  void* term)
{
/* dcl  */

int i, lhs_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\neqv:%u: begin", count);
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\neqv:%u: rhs_term = 0x%x: ", count, rhs_term);
print_term(stderr, rhs_term);
#endif


lhs_size = 
(int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
    lexid_vctsize
       );


#if (dbg_flag > 10)
printf("\neqv:%u: size of rhs terms = %u", count, lhs_size);
#endif



i = 0;

fprintf(fileptr, "(def %s_%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i,

singleton(vtxeval(rhs_term, op_word0 + 1)),

i

);


#if (dbg_flag > 10)
printf("\neqv:%u:  defined %s_%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i
);
#endif



fprintf(fileptr, "(def %s_%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1,

singleton(vtxeval(rhs_term, op_word0 + 2)),

i

);






#if (dbg_flag > 10)
printf("\neqv:%u:  defined %s_%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1
);
#endif









fprintf(fileptr, "(def %s_%u_%u (eq %s_%u_%u %s_%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 3,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1

);







#if (dbg_flag > 10)
printf("\neqv:%u:  defined %s_%u_%u", count, 
signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 2
);
#endif


/* define transitions */

for (i = 1; i < lhs_size; i++)
   {


#if (dbg_flag > 10)
printf("\neqv:%u:  begin for i = %u", count, i);
#endif

fprintf(fileptr, "(def %s_%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i,

singleton(vtxeval(rhs_term, op_word0 + 1)),

i

);


fprintf(fileptr, "(def %s_%u_%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1,

singleton(vtxeval(rhs_term, op_word0 + 2)),

i

);

fprintf(fileptr, "(def %s_%u_%u (eq %s_%u_%u %s_%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 2,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 1

);



fprintf(fileptr, "(def %s_%u_%u (and %s_%u_%u %s_%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 3,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*(i - 1) + 3,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*i + 2

);




#if (dbg_flag > 10)
printf("\neqv:%u:  end for i = %u", count, i);
#endif


   }   /* for i */


/* i = lhs_size  */



fprintf(fileptr, "(def %s %s_%u_%u)\n",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       ),


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
4*(i - 1) + 3

);




#if (dbg_flag > 10)
printf("\neqv:%u: end", count);
#endif

}  /* eqv */


