/*
*************************************
file: less.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"


#define MOD 8


#define dbg_flag 0   /* normal value: 0  */


static unsigned int tmp_name = 0;





/*
************************
term is
=
(def p (less p1 p2))

return 1 iff p1 < p2
************************
*/


void less(FILE* fileptr,  void* term)
{
/* dcl  */

unsigned int  rhs_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nless:%u: begin", count);
#endif


rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\nless:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


rhs_size = 
(unsigned int) 
vtxeval( vtxeval(rhs_term, op_word0 + 1), outsize);


#if (dbg_flag > 10)
printf("\nless:%u: size of rhs terms = %u", count, lhs_size);
#endif


less_step(fileptr, term , rhs_size - 1);





fprintf(fileptr, "(def %s %s%uL%u)\n",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       ),


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
rhs_size - 1

);


#if (dbg_flag > 10)
printf("\nless:%u: end", count);
#endif

}  /* less */




















/*
*************************
Translate bits from kth to MSB
*************************
*/




void less_step(FILE* fileptr,  void* term, unsigned int k)
{
/* dcl  */

unsigned int  rhs_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nless:%u: begin", count);
#endif



rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\nless:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


rhs_size = 
(unsigned int) 
vtxeval( vtxeval(rhs_term, op_word0 + 1), outsize);



#if (dbg_flag > 10)
printf("\nless:%u: size of rhs terms = %u", count, lhs_size);
#endif


fprintf(fileptr, "(def %s%uA%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,

singleton(vtxeval(rhs_term, op_word0 + 1)),

k

);


fprintf(fileptr, "(def %s%uB%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


singleton(vtxeval(rhs_term, op_word0 + 2)),


k

);






fprintf(fileptr, "(def %s%uN%u (not %s%uA%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k

);






if ( k == 0 )
/* terminal case */
{


fprintf(fileptr, "(def %s%uL%u (and %s%uN%u %s%uB%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k

);


return;

}




/* k > 0:  nonterminal case */


less_step(fileptr, term, k - 1);



fprintf(fileptr, "(def %s%uD%u (and %s%uN%u %s%uB%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k

);




fprintf(fileptr, "(def %s%uE%u (eq %s%uA%u %s%uB%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k

);



fprintf(fileptr, "(def %s%uC%u (and %s%uE%u %s%uL%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - 1

);




fprintf(fileptr, "(def %s%uL%u (or %s%uD%u %s%uC%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k

);







#if (dbg_flag > 10)
printf("\nless:%u: end", count);
#endif

}  /* less */


