/*
*************************************
file: mult.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"


#define dbg_flag 0   /* normal value: 0  */





/*
************************
term is
=
(def p (mult p1 p2))

************************
*/


void mult(FILE* fileptr,  void* term)
{
/* dcl  */

unsigned int i, k, x_size, y_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nmult:%u: begin", count);
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\nmult:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


x_size = 
(unsigned int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
    lexid_vctsize
       );


y_size = 
(unsigned int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0)),
    lexid_vctsize
       );


#if (dbg_flag > 10)
printf("\nmult:%u: x_size = %u, y_size = %u", count, x_size, y_size);
#endif


if (x_size != y_size)
/* error */
{
fprintf(stderr, "\nError: mult arg sizes are not equal in term\n");
print_term(stderr, rhs_term);

exit (1);

}


/* ok: x_size == y_size  */


/* define input prj  */


for (i = 0; i < x_size; i++)
  {


fprintf(fileptr, "(def %s%uX%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
   lexid_string
       ),
i

);




fprintf(fileptr, "(def %s%uY%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0)),
   lexid_string
       ),
i

);


  }  /* for i */







for (k = 0; k < x_size; k++)
  {


for (i = 0; i <= k; i++)
   {

/* i <= k */



fprintf(fileptr, "(def %s%uA%u_%u (and %s%uX%u %s%uY%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - i


);



if ( (i == 0) && (k == 0))
{


fprintf(fileptr, "(def %s%uM%u_%u %s%uA%u_%u)\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i

);



fprintf(fileptr, "(def %s%uK%u_%u b0)\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i


);




}





if ( (i == 0) && (k > 0))
{


fprintf(fileptr, "(def %s%uM%u_%u (xor %s%uA%u_%u %s%uK%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - 1,
i


);




if (k + 1 < x_size)
{
fprintf(fileptr, "(def %s%uK%u_%u (and %s%uA%u_%u %s%uK%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - 1,
i


);
}





}




if ( (i > 0) && (i < k) && (k > 0))
{


fprintf(fileptr, "(def %s%uM%u_%u (xor %s%uA%u_%u %s%uM%u_%u %s%uK%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i - 1,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - 1,
i


);





/* K  needed only when k < x_size - 1 */

if (k + 1 < x_size)
{

fprintf(fileptr, "(def %s%ua%u_%u (and %s%uA%u_%u %s%uM%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i - 1

);




fprintf(fileptr, "(def %s%ub%u_%u (and %s%uA%u_%u %s%uK%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - 1,
i


);






fprintf(fileptr, "(def %s%uc%u_%u (and %s%uM%u_%u %s%uK%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,





signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i - 1,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k - 1,
i


);







fprintf(fileptr, "(def %s%uK%u_%u (or %s%ua%u_%u %s%ub%u_%u %s%uc%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i



);

}  /* k */




}


















if ( (i == k) && (k > 0))
{


fprintf(fileptr, "(def %s%uM%u_%u (xor %s%uA%u_%u %s%uM%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i - 1


);





/* K  needed only when k < x_size - 1 */

if (k + 1 < x_size)
{
fprintf(fileptr, "(def %s%uK%u_%u (and %s%uA%u_%u %s%uM%u_%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i,



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k,
i - 1


);
}




}






   }  /* for i */

/* i == k  */


  }  /* for k */




/*  define output  */

fprintf(fileptr, "(def %s (join",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       )
);




for (i = 0; i < x_size; i++)
   {

fprintf(fileptr, " %s%uM%u_%u",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,
i

);


   }


fprintf(fileptr, "))\n");



#if (dbg_flag > 10)
printf("\nmult:%u: end", count);
#endif

}  /* mult */


