/*
*************************************
file: mux.c

HYP:
No terms nested in bp63.


*************************************
*/


#include "local.h"

#include <math.h>



#define dbg_flag 0   /* normal value: 0  */





/*
************************
To be implemented

term is
=
(def p (eqv p1 p2))


************************
*/


void mux(FILE* fileptr,  void* term)
{
/* dcl  */

unsigned int i, X_size, Y_size, min_XY;
unsigned int pow_X_size;

void *rhs_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nmux:%u: begin", count);
#endif

rhs_term = vtxeval(term, op_word0 + 2);



#if (dbg_flag > 10)
printf("\nmux:%u: rhs_term = 0x%x", count, rhs_term);
print_term(stderr, rhs_term);
#endif


X_size = 
(unsigned int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
    lexid_vctsize
       );


Y_size = 
(unsigned int) 
vtxeval(
    idarray(vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0)),
    lexid_vctsize
       );


#if (dbg_flag > 10)
printf("\nmux:%u: X_size = %u, Y_size = %u", count, X_size, Y_size);
#endif



/* define X, (not X) */

for (i = 0; i < X_size; i++)
  {

fprintf(fileptr, "(def %s%uX%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 1), op_word0)),
   lexid_string
       ),
i

);

fprintf(fileptr, "(def %s%uN%u (not %s%uX%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i

);


  }  /* for i */











/* define Y */

for (i = 0; i < Y_size; i++)
  {

fprintf(fileptr, "(def %s%uY%u (prj %s %u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,

vtxeval(
   idarray(vtxeval(vtxeval(rhs_term, op_word0 + 2), op_word0)),
   lexid_string
       ),
i

);

  }  /* for i */




/* define min between 2^X_size, Y_size */

pow_X_size = (unsigned int) pow(2, X_size);


#if (dbg_flag > 10)
printf("\nmux:%u: 2^%u = pow_X_size = %u", 
count, X_size, pow_X_size);
#endif



if (pow_X_size <= Y_size)
/* min X */
  { min_XY = pow_X_size; }
else /* min Y */
  {min_XY = Y_size; }




i = 0;

fprintf(fileptr, "(def %s%uR%u (and",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i

);

mux_term(fileptr, term, i, X_size);

fprintf(fileptr, "))\n");





for (i = 1; i < min_XY; i++)
  {

fprintf(fileptr, "(def %s%uA%u (and",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i

);


mux_term(fileptr, term, i, X_size);


fprintf(fileptr, "))\n");






fprintf(fileptr, "(def %s%uR%u (or %s%uR%u %s%uA%u))\n",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i,

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i - 1,


signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i

);



  }  /* for i */


/*  i = min_XY  */



/* define result  */



fprintf(fileptr, "(def %s %s%uR%u)\n",

vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_string
       ),



signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i - 1

);




#if (dbg_flag > 10)
printf("\nmux:%u: end", count);
#endif

}  /* mux */













void mux_term(
FILE* fileptr, 
void *term, 
unsigned int k, 
unsigned int X_size
)
{
/* dcl */

unsigned int i;




#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nmux_term:%u: begin", count);
#endif


/*
********************
Note k < 2^32.
Thus k can be and'ed bitwise
with X to form adr
********************
*/



for (i = 0; i < X_size; i++)
  {

if ( ((k >> i) & 0x1) == 0x1 )
/* bit i of k is 1 */
{

fprintf(fileptr, " %s%uX%u",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i

);


}
else  /* bit i of k is 0 */
{

fprintf(fileptr, " %s%uN%u",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
i

);


}



  } /* for i */



/* component k of Y  */



fprintf(fileptr, " %s%uY%u",

signe(),
vtxeval(
    idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
    lexid_idcount
       ),
k

);



#if (dbg_flag > 10)
printf("\nmux_term:%u: end", count);
#endif

}  /* mux_term */

