/*
*************************************
file: trans.c

HYP:
No terms nested in bp65.


*************************************
*/


#include "local.h"




#define dbg_flag 0   /* normal value: 0  */





/*
************************
return 0 iff all ok
************************
*/


int term_trans(
FILE* fileptr, 
void* term
)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nterm_trans:%u: begin", count);
#endif




#if (dbg_flag > 0)
fprintf(stderr, "\n\nterm_trans: term: ");
print_term(stderr, term);
#endif

switch ( (unsigned int) vtxeval(term, op_code) )
     {
         case tk_ap: 

         
                   return (nonatom_trans(fileptr, term));


         default:  /* atom */

                   return (atom_trans(fileptr, term));
   

     }






#if (dbg_flag > 10)
printf("\nterm_trans:%u: end", count);
#endif

}  /*  prg  */







/*
**********************
return 0 iff all ok.

atoms:
keywords: b0, b1,
ids
num
**********************
*/

int atom_trans(FILE* fileptr, void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\natom_outsize:%u: begin", count);
#endif



print_term(fileptr, term);

fprintf(fileptr, "\n");


return (0);



}  /*  atom_outsize  */





/*
**************
term is (ap id/keyword .... )
**************
*/



int nonatom_trans(FILE* fileptr, void* term)
{
/* dcl  */
unsigned int lhsop;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nnonatom_trans:%u: begin", count);
#endif




lhsop = (unsigned int) vtxeval(vtxeval(term, op_word0), op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nnonatom_trans: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

        case tk_dcl:  /* declaration */


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_trans: switch: dcl: term = 0x%x",
term
);
#endif



print_term(fileptr, term);
fprintf(fileptr, "\n");




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_trans: dcl end: id %s",
vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_string
)
);
#endif



                  return ( 0 );







        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_trans: switch: def term 0x%x",
term
);
#endif

             switch ( 
(int) vtxeval(vtxeval(term, op_word0 + 2), op_code)
                    )
                {
                    case tk_ap:

                       return (defapterm_trans(fileptr, term));




                    default:  /* id, b0, b1, in, out, tau: no need unfolding */

                       print_term(fileptr, term);
fprintf(fileptr, "\n");

                       return (0);


                }




        default: /* query */

print_term(fileptr, term);
fprintf(fileptr, "\n");

           return (0);




}   /*  switch  */




}  /*  term_trans  */
























/*
**************************
term = (def id (...))
**************************
*/



int defapterm_trans(FILE* fileptr, void* term)
{
/* dcl  */
void *apterm;
unsigned int lhsop;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: begin", count);
#endif



apterm = vtxeval(term, op_word0 + 2);


lhsop = (unsigned int) vtxeval(vtxeval(apterm, op_word0), op_code);



switch (lhsop)
  {

         case tk_eqv:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: eqv", count);
#endif


               eqv(fileptr, term);

               fprintf(fileptr, "\n");

                return (0);







         case tk_add:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: add", count);
#endif


               add(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);



         case tk_sub:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: sub", count);
#endif


               sub(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);



         case tk_mult:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: mul", count);
#endif


               mult(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);









         case tk_mux:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: mux", count);
#endif


               mux(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);







         case tk_less:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: less", count);
#endif


               less(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);




         case tk_leq:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: leq", count);
#endif


               leq(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);









         case tk_grt:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: grt", count);
#endif


               grt(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);


         





         case tk_geq:


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: grt", count);
#endif


               geq(fileptr, term);

               fprintf(fileptr, "\n");

               return (0);





         default: /* known operator in bp60 */
            

#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: default", count);
#endif


               print_term(fileptr, term);
               fprintf(fileptr, "\n");

               return (0);

  }



#if (dbg_flag > 0)
fprintf(stderr, "\ndefapterm_trans: end: lhsop = %u: term: ", 
lhsop
);
print_term(stderr, term);
#endif


}  /* prg  */








































