/*
*************************************
file: upload.c

Load program in file into RAM.
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */
 

prghdr* upload(char *filename)
{

/* dcl  */

FILE* lexinput;

prghdr* p;  /*  program header  */

void 	*tail_prg, *bsaterm, *prg_word;

/* prg  */


#if (dbg_flag > 0)
printf("\nupload: begin: open input file, start lexan");
#endif



/* initialize lexan  */

lexinput = fopen(filename, "r");
begin_lexan();
set_lexan(lexinput, filename);





#if (dbg_flag > 0)
printf("\nupload: init. prg. hdr.");
#endif


/* create program header  */
p = get_prghdr();

/*  p -> argord = NULL;  */


tail_prg = NULL;



#if (dbg_flag > 0)
printf("\nupload: read terms");
#endif


/* read all terms in program  */ 

while ( (bsaterm = read_new_term()) != NULL)
     {
       /* bsaterm != NULL */
 
   
/* store term */
prg_word = get_prgvtx(prgwrd_size);

#if (dbg_flag > 0)
printf("\nupload: store in prg word 0x%x term 0x%x", 
prg_word,
bsaterm
);
#endif

vtxeval(prg_word, ptr_down) = NULL;
vtxeval(prg_word, ptr_up) = tail_prg;
vtxeval(prg_word, prgwrd_value) = bsaterm;


if (tail_prg == NULL)
     p -> prg = prg_word;
else vtxeval(tail_prg, ptr_down) = prg_word;


/* update tail_prg to last instruction in program */
tail_prg = prg_word;



     }  /* while  */



#if (dbg_flag > 0)
printf("\nupload: no more terms: pad with end");
#endif



#if (dbg_flag > 0)
printf("\nupload: close lexan");
#endif


end_lexan();



#if (dbg_flag > 0)
printf("\nupload: close input file");
#endif


fclose(lexinput);


#if (dbg_flag > 0)
printf("\nupload: return prg.hdr 0x%x", p);
#endif



return (p);


}  /*  prg  */





















