/*
*************************************
file: trans.c

HYP:
No terms nested in bp65.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */





/*
************************
To be implemented

term is
=
(def p
   (defprocess 
            (present_state ...) 
            (next_state ...)
            (transition (update ...)
                    ...
            )
            ...
   )
)


************************
*/


void defprocess(
FILE* fileptr, 
void* term
)
{
/* dcl  */

unsigned int i, numargs;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndefprocess:%u: begin", count);
#endif


numargs = (unsigned int) vtxeval(vtxeval(term, op_word0 + 2), op_args);



/* define transitions */

for (i = 3; i < numargs; i++)
   {
     transition(
fileptr, 
term, 
i
               );
   }








if (numargs <= 4)
/* no or */
{

fprintf(fileptr, "(def %s",

vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_string
       )

);

     fprintf(fileptr, " %s_%u_%u)\n",

signe(),

vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),

3

);

return ;

}





/* or  transitions */

fprintf(fileptr, "(def %s (or",

vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_string
       )

);



for (i = 3; i < numargs; i++)
   {

     fprintf(fileptr, " %s_%u_%u",

signe(),

vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),

i

);



   }


 fprintf(fileptr, "))");



#if (dbg_flag > 10)
printf("\ndefprocess:%u: end", count);
#endif

}   /*  prg  */









void transition(
FILE* fileptr, 
void* term,
unsigned int j
)
{
/* dcl  */

unsigned int i, numargs;
void *subterm;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ntransition:%u: begin", count);
#endif

/* define stability */

stability(fileptr, term, j);



/* and stability and transition args */

subterm = vtxeval(vtxeval(term, op_word0 + 2), op_word0 + j);

numargs = (unsigned int) vtxeval(subterm, op_args);



fprintf(fileptr, "(def %s_%u_%u (and %s_%u_s%u",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j,


signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j
);



for (i = 2; i < numargs; i++)
   {


/* hyp: no nestings */

fprintf(fileptr, " ");
print_term(fileptr, vtxeval(subterm, op_word0 + i));



   }


fprintf(fileptr, "))\n");


#if (dbg_flag > 10)
printf("\ntransition:%u: end", count);
#endif

}  /* transition */












/*
All pstates not in update are stable
*/

void stability(
FILE* fileptr, 
void* term,
unsigned int j
)
{
/* dcl  */

unsigned int i, k, pstate_size, update_size;
void *pstate_term, *nstate_term, *update_term;

unsigned int *buf;
unsigned int stable_states = 0;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nstability:%u: begin: transition %u", count, j);
#endif

/* define stability */

pstate_term = vtxeval(vtxeval(term, op_word0 + 2), op_word0 + 1);


#if (dbg_flag > 10)
printf("\nstability:%u: pstate_term = 0x%x:\n", count, pstate_term);
print_term(stderr, pstate_term);
#endif

nstate_term = vtxeval(vtxeval(term, op_word0 + 2), op_word0 + 2);


#if (dbg_flag > 10)
printf("\nstability:%u: nstate_term = 0x%x:\n", count, nstate_term);
print_term(stderr, nstate_term);
#endif

update_term = 
vtxeval(
  vtxeval(vtxeval(term, op_word0 + 2), op_word0 + j),
  op_word0 + 1
       );


#if (dbg_flag > 10)
printf("\nstability:%u: update_term = 0x%x:\n", count, update_term);
print_term(stderr, update_term);
#endif





pstate_size = (unsigned int) vtxeval(pstate_term, op_args);


#if (dbg_flag > 10)
printf("\nstability:%u: pstate_size = %u", count,
pstate_size
);
#endif


update_size = (unsigned int) vtxeval(update_term, op_args);


#if (dbg_flag > 10)
printf("\nstability:%u: update_size = %u", count,
update_size
);
#endif



buf = (unsigned int *) get_prgvtx(pstate_size);



for (i = 1; i < pstate_size; i++)
   {


#if (dbg_flag > 10)
printf("\nstability:%u:  begin for i = %u", count, i);
#endif

buf[i] = 0;

      for (k = 1; k < update_size; k++)
         {


#if (dbg_flag > 10)
printf("\nstability:%u:  begin for k = %u", count, k);
#endif

/* check if pstate i is update k */


#if (dbg_flag > 10)
printf("\nstability:%u:  pstate i = %u:\n", count, i);
print_term(stderr, vtxeval(pstate_term, op_word0 + i));
#endif


#if (dbg_flag > 10)
printf("\nstability:%u:  update k = %u:\n", count, k);
print_term(stderr, vtxeval(update_term, op_word0 + k));
#endif


if (
idarray(vtxeval(vtxeval(pstate_term, op_word0 + i), op_word0))
==
idarray(vtxeval(vtxeval(update_term, op_word0 + k), op_word0))
    )
/* pstate i updated: no stability */
{

#if (dbg_flag > 10)
printf("\nstability:%u:  pstate i = %u updated in k = %u", count, i, k);
#endif

buf[i] = 1;
break;
}


#if (dbg_flag > 10)
printf("\nstability:%u: pstate i = %u not updated in k = %u", count, i, k);
#endif


          }  /* for k */



#if (dbg_flag > 10)
printf("\nstability:%u: buf[%u] = %u", count,
i,
buf[i]
);
#endif


if (buf[i] == 0)
/* pstate i is not in update: add stability */
/* pstate stable */
{

#if (dbg_flag > 10)
printf("\nstability:%u: pstate i = %u stable: begin", count,
i
);
#endif


stable_states++;

fprintf(fileptr, "(def %s_%u_%u_%u (eqv ",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j,
i
);

print_term(fileptr, vtxeval(pstate_term, op_word0 + i));
fprintf(fileptr, " ");
print_term(fileptr, vtxeval(nstate_term, op_word0 + i));
fprintf(fileptr, "))\n");


#if (dbg_flag > 10)
printf("\nstability:%u: pstate i = %u stable: end", count,
i
);
#endif


}





#if (dbg_flag > 10)
printf("\nstability:%u: end for i = %u", count,
i
);
#endif



   }  /* for i  */






/* and of stability */



#if (dbg_flag > 10)
printf("\nstability:%u: stability j = %u", count, j);
#endif


if (stable_states == 0)
/* no and */
{

fprintf(fileptr, "(def %s_%u_s%u b1)\n",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j
);



return;


}



/* stable_states > 0 */




if (stable_states == 1)
/* no and */
{



fprintf(fileptr, "(def %s_%u_s%u",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j
);




for (i = 1; i < pstate_size; i++)
   {


if (buf[i] == 0)
/* pstate i is not in update: add stability */
/* pstate stable */
{

fprintf(fileptr, " %s_%u_%u_%u)\n",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j,
i
);
}


}  /* for i */


return;


}





/* stable_states > 1 */




fprintf(fileptr, "(def %s_%u_s%u (and",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j
);








for (i = 1; i < pstate_size; i++)
   {



if (buf[i] == 0)
/* pstate i is not in update: add stability */
/* pstate stable */
{

fprintf(fileptr, " %s_%u_%u_%u",

signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
j,
i
);



}


   }  /* for i */


fprintf(fileptr, "))\n");




#if (dbg_flag > 10)
printf("\nstability:%u: end", count);
#endif

}  /* stability */


