/*
**************************
lextkns.h

Token codes for lexan.

Note token codes for keuwords are 8 bits (char).
Thus in 0 - 255.
**************************
*/



#ifndef lextkns_h
#define lextkns_h

/*
*********************************
macro to get id info
*********************************
*/

#define idarray(L)  *((void **)L)



/*  
******************************************
lexan token codes 
******************************************
*/

#define tk_unk 1000
#define tk_num 1001
#define tk_eof 1002
#define tk_string 1003
#define tk_id 1004
#define tk_newid 1005
#define tk_oldid 1006



/*  keywords  */
#define tk_leftpar 0
#define tk_leftcurl 1
#define tk_rightpar 2
#define tk_rightcurl 3
#define tk_equal 4


#define tk_xarg 5

#define tk_boolean 6

#define tk_isone 7
#define tk_eval 8
#define tk_satasg 9
#define tk_C 10

#define tk_xlist 11
#define tk_reglist 12
#define tk_ordlist 13

#define tk_ifte 14
#define tk_compose 15

#define tk_and 16
#define tk_or 17
#define tk_not 18
#define tk_xor 19
#define tk_eq 20
#define tk_nor 21
#define tk_nand 22
#define tk_exists 23
#define tk_forall 24
#define tk_imp 25

#define tk_def 26
#define tk_dcl 27
#define tk_join 28
#define tk_prj 29
#define tk_record 30
#define tk_array 31
#define tk_apply 32
#define tk_dollar 33

#define tk_b0 34
#define tk_b1 35

#define tk_argord 36
#define tk_uint 37

#define tk_ap 38  /* used in parser tree */





/* 
arithmetic is always module n = vector size
*/

#define tk_add 39
#define tk_mult 40
#define tk_sub 41
#define tk_div 42
#define tk_defprocess 43
#define tk_ccspar 44
#define tk_ccsrestrict 45
#define tk_ccsrelabel 46
#define tk_in 47
#define tk_out 48
#define tk_tau 49
#define tk_enum 50
#define tk_eqv 51    /* componentwise equality */
#define tk_inc 52  /* increment arg2 of arg1 */
#define tk_dec 53  /* decrement aarg2 of arg1 */
#define tk_pstate 54
#define tk_nstate 55
#define tk_transition 56
#define tk_update 57
#define tk_mux 58




#define tk_less 59
#define tk_leq 60
#define tk_grt 61
#define tk_geq 62
#define tk_lts 63




/* begin, end are only used in 
   the internal representation
   of program for padding
   purposes
*/


#define lexid_string 0
#define lexid_type 1
#define lexid_def 2
#define lexid_vctsize 3  /* initialized to 1 in lexan */
#define lexid_idcount 4
#define lexid_array_def 5    /* array def for dollar id */
#define lexid_array_entry 6  /* array entry for dollar id */
#define lexid_size 7


/* id types: 
record, 
array, 
boolean function,
dollar
*/

/* id type initialized to id_undef by lexan */
#define id_undef 0
#define id_record 1
#define id_array 2
#define id_bfun 3
#define id_dollar 4



#endif

