/*
*************************************
file: outsize.c


Defines outsize for all terms.

Hyp: 
array, records, dcl, def.


*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */




void prg_outsize(prghdr* phdr)
{
/* dcl  */
void  *p;  /* prg label for instruction  */
void *term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nprg_outsize:%u: begin", count);
#endif



/*  first instruction */
p = phdr -> prg;




 while (p != NULL)
  {
       /* print line, p != NULL */

       term_outsize(vtxeval(p, prgwrd_value));

       p = vtxeval(p, ptr_down);


  }



#if (dbg_flag > 10)
printf("\nprg_outsize:%u: end", count);
#endif

}  /*  prg  */







unsigned term_outsize(void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nterm_outsize:%u: begin: term 0x%x:\n", count, term);
print_term(stderr, term);
#endif


switch ( (unsigned int) vtxeval(term, op_code) )
     {
         case tk_ap: 

         
                   return (nonatom_outsize(term));


         default:  /* atom */

                   return (atom_outsize(term));
   

     }






#if (dbg_flag > 10)
printf("\nterm_outsize:%u: end", count);
#endif

}  /*  prg  */







/*
**********************
atoms:
keywords: b0, b1,
ids
num
**********************
*/

unsigned atom_outsize(void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\natom_outsize:%u: begin", count);
#endif

switch ( (int) vtxeval(term, op_code) )
     {


         case tk_id:
                    


vtxeval(term, outsize) = 
vtxeval(idarray(vtxeval(term, op_word0)), lexid_vctsize);


                      return (
             (unsigned int) vtxeval(term, outsize) 
                              );






         case tk_num:  /* dummy */
  

               vtxeval(term, outsize) = (void *) 1;

               return (1);






         default: /* keywords */


               vtxeval(term, outsize) = (void *) 1;

               return (1);

    }  /* switch */



}  /*  atom_outsize  */





/*
**************
term is (ap id/keyword .... )
**************
*/


unsigned nonatom_outsize(void* term)
{
/* dcl  */
void *op_term, *rhs_term;
unsigned int lhsop, rhs_op, new_vctsize;

void *array_term;
unsigned int i, array_size, record_size, record_args;

void *record_term, *record_term_def;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
fprintf(stderr, "\nnonatom_outsize:%u: begin: term 0x%x\n", count, term);
print_term(stderr, term);
#endif




lhsop = (unsigned int) vtxeval(vtxeval(term, op_word0), op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize:%u: lhsop = %u:", count, lhsop);
#endif



switch (lhsop)
     {

        case tk_dcl:  /* declaration */


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: dcl: term = 0x%x",
term
);
#endif


vtxeval(term, outsize)
=
vtxeval(vtxeval(term, op_word0 + 2), op_word0);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: vtxeval(0x%x, outsize) = %u",
term,
vtxeval(term, outsize)
);
#endif



vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_vctsize
)
=
vtxeval(vtxeval(term, op_word0 + 2), op_word0);



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: dcl end: id %s",
vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_string
)
);
#endif



                  return ( (unsigned int) vtxeval(term, outsize) );







        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: def term 0x%x",
term
);
#endif



vtxeval(term, outsize)
=
(void *) term_outsize( vtxeval(term, op_word0 + 2) );



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: def: vtxeval(0x%x, outsize) = %u",
term,
vtxeval(term, outsize)
);
#endif



vtxeval(
      idarray( vtxeval(vtxeval(term, op_word0 + 1), op_word0)), 
      lexid_vctsize
       )
=
vtxeval(term, outsize);




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: end def: id = %s",
vtxeval(
      idarray( vtxeval(vtxeval(term, op_word0 + 1), op_word0)), 
      lexid_string
       )
);
#endif





                  return (  (unsigned int) vtxeval(term, outsize) );







       case tk_record:


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: record: term = 0x%x",
term
);
#endif


/* define record size  */

record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: record args = %u",
record_args
);
#endif


record_size = 0;

for (i = 1; i < record_args; i++)
   {


#if 0
check_lexid_def(term, record_term_def);
#endif



/*  ok  */


record_size = 
     record_size +
     ((unsigned int) 
vtxeval(
           idarray(
              vtxeval(vtxeval(term, op_word0 + i), op_word0)
                  ),
           lexid_vctsize
        )
     );



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: record_size = %u",
record_size
);
#endif


   }   /*  for i  */


vtxeval(term, outsize) = (void *) record_size;



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: vtxeval(0x%x, outsize) = %u",
term,
vtxeval(term, outsize)
);
#endif


                  return ( (unsigned int) vtxeval(term, outsize) );






       case tk_array:


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: array: ");
#endif



/*  store array size */

array_size = (unsigned int) 
             vtxeval(vtxeval(term, op_word0 + 1), op_word0);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: array_size = %u",
array_size
);
#endif



vtxeval(term, outsize) = (void *) array_size;


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: vtxeval(term, outsize) = %u",
vtxeval(term, outsize)
);
#endif



#if 0
/* increment numbvar counter */

phdr -> numbvar = (phdr -> numbvar) + array_size;
#endif



     return ( (unsigned int) vtxeval(term, outsize) );









      case tk_dollar:
      case tk_prj:

                

term_outsize( vtxeval(term, op_word0 + 1) );

vtxeval(term, outsize)
=
(void *) 1;

                   return ( (unsigned int) vtxeval(term, outsize) );










        case tk_b0:
        case tk_b1:


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: b0, b1");
#endif

                     fprintf(stderr, 
"\nnonatom_outsize: error unexpected b0, b1\n"
);

                     exit (1);









        case tk_uint:

#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: uint");
#endif


vtxeval(term, outsize) = 
vtxeval(vtxeval(term, op_word0 + 1), op_word0);



     return ( (unsigned int) vtxeval(term, outsize) );







        case tk_compose:


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: compose");
#endif






/*
******************
Define outsize for args.

******************
*/


record_args = (unsigned int) vtxeval(term, op_args);


/* old: for (i = 1; i < record_args; i = i + 2) */

for (i = 1; i < record_args; i++)
   {

term_outsize( vtxeval(term, op_word0 + i) );


   }   /*  for i  */



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: scanned compose args");
#endif




vtxeval(term, outsize) 
= 
vtxeval(vtxeval(term, op_word0 + 1), outsize);




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: end compose: vtxeval(0x%x, outsize) = %d",
term, 
vtxeval(term, outsize)
);
#endif



     return ( (unsigned int) vtxeval(term, outsize) );





        case tk_exists:
        case tk_forall:




/* note rhs can be id or term */


term_outsize( vtxeval(term, op_word0 + 1) );


vtxeval(term, outsize)
=
(void *) term_outsize( vtxeval(term, op_word0 + 2) );




     return ( (unsigned int) vtxeval(term, outsize) );









        case tk_join:



#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: join: term 0x%x", term);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


record_size = 0;

for (i = 1; i < record_args; i++)
   {



record_size = 
     record_size +
     term_outsize( vtxeval(term, op_word0 + i) );



   }   /*  for i  */


vtxeval(term, outsize) = (void *) record_size;


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: end join: vtxeval(0x%x, outsize) = %d", 
term,
vtxeval(term, outsize)
);
#endif



     return ( (unsigned int) vtxeval(term, outsize) );








              case tk_ifte:
              case tk_and:
              case tk_or:
              case tk_xor:
              case tk_eq:
              case tk_nor:
              case tk_nand:
              case tk_imp:
              case tk_not:



/* 
In this case vctsize is equal to max vctsize.
Moreover all args have size max or 1.
Note record_args > 0.
*/

   

#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: bop: %s",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: bop args = %u",
record_args
);
#endif

record_size = 1;

for (i = 1; i < record_args; i++)
   {

new_vctsize = 
term_outsize( vtxeval(term, op_word0 + i) );


if (new_vctsize > 1)
{
  if (record_size == 1)
  /* update */
  { record_size = new_vctsize; }
  else
    if (record_size != new_vctsize)
    /* type error */
    {
       fprintf(stderr, 
"type error: size of 1 or %u expected in arg %u of term:\n", 
record_size, 
i
);
       print_term(stderr, term);

    }


}


   }   /*  for i  */





     vtxeval(term, outsize) = (void *) record_size;


     return ( (unsigned int) vtxeval(term, outsize) );










         case tk_add:  
         case tk_sub:  
         case tk_mult:  
         case tk_div:  

/* outsize same as size of arguments  */




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s args = %u",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) ),
record_args
);
#endif

if (record_args != 3)
/* error */
{
fprintf(stderr, "\nError in term: \n");
print_term(stderr, term);
fprintf(stderr, "\nFound %u args for %s, expected 2\n",
record_args - 1,
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

exit (1);

}


/* record_args == 3 */


record_size = term_outsize( vtxeval(term, op_word0 + 1) );


for (i = 2; i < record_args; i++)
   {

new_vctsize = 
term_outsize( vtxeval(term, op_word0 + i) );


if (new_vctsize != record_size)
/*  error  */
{

fprintf(stderr, "\nError in term: \n");

print_term(stderr, term);

fprintf(stderr, "\nargs of %s do not have same size\n",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

exit (1);

}

/* ok */



   }   /*  for i  */





     vtxeval(term, outsize) = (void *) record_size;


     return ( (unsigned int) vtxeval(term, outsize) );










         case tk_eqv:  
         case tk_less:  
         case tk_leq:  
         case tk_grt:  
         case tk_geq:  


/* outsize 1  */




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s args = %u",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) ),
record_args
);
#endif

if (record_args != 3)
/* error */
{
fprintf(stderr, "\nError in term: \n");
print_term(stderr, term);
fprintf(stderr, "\nFound %u args for %s, expected 2\n",
record_args - 1,
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

exit (1);

}


/* record_args == 3 */


record_size = term_outsize( vtxeval(term, op_word0 + 1) );


for (i = 2; i < record_args; i++)
   {

new_vctsize = 
term_outsize( vtxeval(term, op_word0 + i) );


if (new_vctsize != record_size)
/*  error  */
{

fprintf(stderr, "\nError in term: \n");

print_term(stderr, term);

fprintf(stderr, "\nargs of %s do not have same size:\n",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

fprintf(stderr, "\nsize arg1 = %u, size arg2 = %u\n",
vtxeval(vtxeval(term, op_word0 + 1), outsize),
vtxeval(vtxeval(term, op_word0 + 2), outsize)
);


exit (1);

}

/* ok */



   }   /*  for i  */





     vtxeval(term, outsize) = (void *) 1;


     return ( (unsigned int) vtxeval(term, outsize) );

























         case tk_mux:  

/* outsize 1  */




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s args = %u",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) ),
record_args
);
#endif

if (record_args != 3)
/* error */
{
fprintf(stderr, "\nError in term: \n");
print_term(stderr, term);
fprintf(stderr, "\nFound %u args for %s, expected 2\n",
record_args - 1,
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

exit (1);

}


/* record_args == 3 */


for (i = 1; i < record_args; i++)
   {

term_outsize( vtxeval(term, op_word0 + i) );


   }   /*  for i  */





     vtxeval(term, outsize) = (void *) 1;


     return ( (unsigned int) vtxeval(term, outsize) );
















         case tk_inc:  
         case tk_dec:  

/* outsize same as size of arguments  */




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s args = %u",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) ),
record_args
);
#endif

if (record_args != 2)
/* error */
{
fprintf(stderr, "\nError in term: \n");
print_term(stderr, term);
fprintf(stderr, "\nFound %u args for %s, expected 1\n",
record_args - 1,
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

exit (1);

}


/* record_args == 2  */



     vtxeval(term, outsize) = 
(void *) term_outsize( vtxeval(term, op_word0 + 1) );


     return ( (unsigned int) vtxeval(term, outsize) );







        case tk_defprocess:
/*

(defprocess  (present_state a1 a2 a3 ...)

             (next_state b1 b2 b3 ...)
             
             (transition (update B1 B2 B3 ...)

                         term
                         ...
                         term

             )


             (transition (update B1 B2 B3 ...)

                         term
                         ...
                         term

             )

....


)


*/


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);
#endif


record_args = (unsigned int) vtxeval(term, op_args);


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_outsize: switch: %s args = %u",
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) ),
record_args
);
#endif

if (record_args < 4)
/* error */
{
fprintf(stderr, "\nError in term: \n");
print_term(stderr, term);
fprintf(stderr, "\nFound %u args for %s, expected > 2\n",
record_args - 1,
keywstring( (unsigned int) vtxeval(vtxeval(term, op_word0), op_code) )
);

exit (1);

}


/* record_args >= 4 */



/* check present_state  */

check_present_state( vtxeval(term, op_word0 + 1) );


/* check next_state */

check_next_state( vtxeval(term, op_word0 + 2) );





/* check transitions  */


for (i = 3; i < record_args; i++)
   {

check_transition( vtxeval(term, op_word0 + i) );



   }   /*  for i  */





     vtxeval(term, outsize) = (void *) 1;

     return ( (unsigned int) vtxeval(term, outsize) );










              case tk_ccspar:
              case tk_ccsrestrict:
              case tk_ccsrelabel:


     vtxeval(term, outsize) = (void *) 1;

     return ( (unsigned int) vtxeval(term, outsize) );














         case tk_argord:  

                       

     vtxeval(term, outsize) =  vtxeval(term, op_args);

     return ( (unsigned int) vtxeval(term, outsize) );







         case tk_isone:  
         case tk_eval:  
         case tk_satasg:  
         case tk_C:  


                       

     vtxeval(term, outsize) =  (void *) 1;

     return ( (unsigned int) vtxeval(term, outsize) );







                 default:  /* error  */
 fprintf(stderr, "\nnonatom_outsize: error: unknown term \n");
print_term(stderr, term);

                          exit (1);


          }  /* switch */





#if (dbg_flag > 10)
printf("\nnonatom_outsize:%u: end", count);
#endif

}  /*  prg  */
















