/*
*************************************
file: default.c
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */



/*
*******************************
term =
(defprocess 
             (present_state ... no unfolding ...)
             (next_state ... no unfolding ...)

             (transition (update ... no unfolding ...)
                          
                         term_to_unfold
                         ...
                         term_to_unfold
             )

....

             (transition (update ... no unfolding ...)
                          
                         term_to_unfold
                         ...
                         term_to_unfold
             )
)


Map defprocess to bdd calls in file <processid>.lts
Insert
(lts <processid>.lts)
as translation result in file tmpbp*.bsp


*******************************
*/



int lts2bdd(FILE *fileptr, void* term)
{
/* dcl */
void * apterm;
unsigned int rhs_args;
unsigned int i, j, trn_args;
char *buf;
FILE *outfileptr;
static unsigned long int processid = 0;
char outfname[200];


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndefprocess:%u: begin", count);
#endif


processid++;

sprintf(outfname, "%s.lts", 
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        )
);


outfileptr = fopen(outfname, "w+");


fprintf(outfileptr, "\n/* test translation process: %s */\n\n\n", 
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        )
);

print_term(outfileptr, term);


/* (exec "op nofile etc" id outsize ... id outsize) 
id outsize ... id outsize: lists dcls for ids defined with exec
*/

#if 1
fprintf(fileptr, "\n(exec \"lts %s\" %s 1)\n",
outfname,
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        )
);
#endif



#if 0
/* just for testing */
fprintf(fileptr, "\n(def %s (or %s b1))\n ",
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        ),
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        )
);
#endif



return;



apterm = vtxeval(term, op_word0 + 2);

rhs_args = (unsigned int) vtxeval(apterm, op_args);


/* Hyp: rhs_args >= 3  */


/* unfold args */

for (i = 3; i < rhs_args; i++)
   {
       transition(fileptr, term, i);
   }





fprintf(fileptr, "(def %s (%s ",

vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_string
        ),

keywstring(
  (unsigned int) vtxeval(vtxeval(apterm, op_word0), op_code)
          )

);


/* pstate */
fprintf(fileptr, "\n");
print_term(fileptr, vtxeval(apterm, op_word0 + 1));


/* nstate */
fprintf(fileptr, "\n");
print_term(fileptr, vtxeval(apterm, op_word0 + 2));



for (i = 3; i < rhs_args; i++)
   {

/* transition i */

fprintf(fileptr, "\n");
fprintf(fileptr, "(%s ",
keywstring(
(unsigned int)
vtxeval(vtxeval(vtxeval(apterm, op_word0 + i), op_word0), op_code)
          )
);


/* update */
print_term(
fileptr, 
vtxeval(vtxeval(apterm, op_word0 + i), op_word0 + 1)
          );


trn_args = (unsigned int) vtxeval(vtxeval(apterm, op_word0 + i), op_args);

for (j = 2; j < trn_args; j++)
   {

/* print arg j transition i */

if ( 
(int) vtxeval(vtxeval(vtxeval(apterm, op_word0 + i), op_word0 + j), op_code) 
== 
tk_ap 
   )
/* unfolded */
{
buf = get_char_buf(BUF_SIZE);

sprintf(buf, "%s%u_%u_%u",
signe(),
vtxeval(
   idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
   lexid_idcount
       ),
i,
j
);

mkaux(buf);

fprintf(fileptr, " %s ", buf);
free(buf);

}
else /* not unfolded: tk_id, tk_num, atom keyword */
  {

fprintf(fileptr, " ");
print_term(
fileptr, 
vtxeval(vtxeval(apterm, op_word0 + i), op_word0 + j)
          );

  }



   }  /* for j */

/* end transition i  */

fprintf(fileptr, ")");


}  /* for i */


/* end of defprocess */

fprintf(fileptr, "))\n");




return (0);



#if (dbg_flag > 10)
printf("\ndefprocess:%u: end", count);
#endif


}  /*  defprocess  */





#if 0


void transition(FILE* fileptr, void *term, unsigned int i)
{
/* dcl */
void * apterm;
unsigned int j, trn_args;
char *buf;


#if (dbg_flag > 0)
static int count = 0;
count++;
#endif

/* prg */


apterm = vtxeval(term, op_word0 + 2);

trn_args = (unsigned int) vtxeval(vtxeval(apterm, op_word0 + i), op_args);

for (j = 2; j < trn_args; j++)
   {

/* unfold arg */

if ( 
(int) vtxeval(vtxeval(vtxeval(apterm, op_word0 + i), op_word0 + j), op_code) 
== 
tk_ap 
   )
/* unfold */
{

buf = get_char_buf(BUF_SIZE);

sprintf(buf, "%s%u_%u_%u",
signe(),
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + 1), op_word0)),
  lexid_idcount
        ),
i,
j
);
mkaux(buf);

/* sprintf(buf, " _%s", buf); */


bopterm_trans(
buf, 
fileptr, 
vtxeval(vtxeval(apterm, op_word0 + i), op_word0 + j)
); 

free(buf);
}



   }  /* for j */



 }   /*  transition  */


#endif
