/*
*************************************
file: outsize.c


Defines outsize for all terms.

Hyp: 
array, records, dcl, def.


*************************************
*/


#include "local.h"



#define dbg_flag 0 /* normal value: 0  */





/*
************************
return 0 iff all ok
************************
*/


int term_trans(
FILE* fileptr, 
void* term
)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nterm_trans:%u: begin", count);
#endif




#if (dbg_flag > 0)
fprintf(stderr, "\n\nterm_trans: term: ");
print_term(stderr, term);
#endif

switch ( (unsigned int) vtxeval(term, op_code) )
     {
         case tk_ap: 

         
                   return (nonatom_trans(fileptr, term));


         default:  /* atom */

                   return (atom_trans(fileptr, term));
   

     }






#if (dbg_flag > 10)
printf("\nterm_trans:%u: end", count);
#endif

}  /*  prg  */







/*
**********************
return 0 iff all ok.

atoms:
keywords: b0, b1,
ids
num
**********************
*/

int atom_trans(FILE* fileptr, void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\natom_outsize:%u: begin", count);
#endif



print_term(fileptr, term);

fprintf(fileptr, "\n");


return (0);



}  /*  atom_outsize  */





/*
**************
term is (ap id/keyword .... )
**************
*/



int nonatom_trans(FILE* fileptr, void* term)
{
/* dcl  */
unsigned int lhsop;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nnonatom_trans:%u: begin", count);
#endif




lhsop = (unsigned int) vtxeval(vtxeval(term, op_word0), op_code);



#if (dbg_flag > 0)
fprintf(stderr, "\n\nnonatom_trans: lhsop = %u: term: ", lhsop);
print_term(stderr, term);
#endif


switch (lhsop)
     {

        case tk_dcl:  /* declaration */


#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_trans: switch: dcl: term = 0x%x",
term
);
#endif



print_term(fileptr, term);
fprintf(fileptr, "\n");




#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_trans: dcl end: id %s",
vtxeval(
   idarray(
      vtxeval(vtxeval(term, op_word0 + 1), op_word0)
          ), 
   lexid_string
)
);
#endif



                  return ( 0 );







        case tk_def: /* definition */

#if (dbg_flag > 0)
fprintf(stderr, "\nnonatom_trans: switch: def term 0x%x",
term
);
#endif

             switch ( 
(int) vtxeval(vtxeval(term, op_word0 + 2), op_code)
                    )
                {
                    case tk_ap:

                       return (defapterm_trans(fileptr, term));



                    default:  /* id, b0, b1: no need unfolding */

                       print_term(fileptr, term);
fprintf(fileptr, "\n");

                       return (0);


                }




        default: /* query */

print_term(fileptr, term);
fprintf(fileptr, "\n");

           return (0);




}   /*  switch  */




}  /*  term_trans  */
























/*
**************************
term = (def id (...))
**************************
*/



int defapterm_trans(FILE* fileptr, void* term)
{
/* dcl  */

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: begin", count);
#endif



#if (dbg_flag > 0)
fprintf(stderr, "\n\ndefapterm_trans: lhsop = %u:  term: \n", 
vtxeval(vtxeval(term, op_word0 + 2), op_word0)
);
print_term(stderr, term);
#endif


switch (
(int) vtxeval(vtxeval(vtxeval(term, op_word0 + 2), op_word0), op_code) 
       )
   {


    case tk_defprocess:

        return ( defprocess(fileptr, term) ); 





    default :


      return ( case_default(fileptr, term) ); 


   }  /* switch */





#if (dbg_flag > 10)
printf("\ndefapterm_trans:%u: end", count);
#endif

}  /*  prg  */
















/*
******************************
term = (op ...   )
******************************
*/


int bopterm_trans(char *prfxname, FILE* fileptr, void* term)
{
/* dcl  */
unsigned int i, record_args;

char *buf;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif



/* prg  */


#if (dbg_flag > 10)
printf("\nbopterm_trans:%u: begin unfolding term 0x%x\n", count, term);
print_term(stderr, term);
#endif



if ( vtxeval(term, op_code) != (void *) tk_ap )
/* notihng to unfold */
{
return (0);
}


/*  unfolding needed */




record_args = (unsigned int) vtxeval(term, op_args);


/* unfold args */

for (i = 1; i < record_args; i++)
   {

if ( (int) vtxeval(vtxeval(term, op_word0 + i), op_code) == tk_ap )
/* unfold */
{

buf = get_char_buf(BUF_SIZE);

sprintf(buf, "%s_%u", prfxname, i);

bopterm_trans(buf, fileptr, vtxeval(term, op_word0 + i)); 

free(buf);

}


   }   /*  for i  */




#if (dbg_flag > 10)
printf("\nbopterm_trans:%u: vtxeval(0x%x, outsize) = %u", 
count, 
term,
vtxeval(term, outsize)
);
#endif




if ( (unsigned int) vtxeval(term, outsize) > 1)
/* dcl needed */
{

#if (dbg_flag > 10)
printf("\nbopterm_trans:%u: vtxeval(0x%x outsize) = %u: write dcl", 
count, 
term,
vtxeval(term, outsize)
);
#endif


fprintf(fileptr, "(dcl %s %u)\n",

prfxname,

vtxeval(term, outsize)
);

}




fprintf(fileptr, "(def %s (%s ",

prfxname,

keywstring(
  (unsigned int) vtxeval(vtxeval(term, op_word0), op_code)
          )

);








for (i = 1; i < record_args; i++)
   {



switch ( (int) vtxeval(vtxeval(term, op_word0 + i), op_code) )
{

     case tk_id:  /* var */

           fprintf(fileptr, "%s ",
vtxeval(
  idarray(vtxeval(vtxeval(term, op_word0 + i), op_word0)),
  lexid_string
        )
);

         break;



 case tk_num:  /* var */

           fprintf(fileptr, "%u ",
  vtxeval(vtxeval(term, op_word0 + i), op_word0)
 );

         break;


   case tk_ap:

      fprintf(fileptr, "%s_%u ",
prfxname,
i
);


         break;



     default:  /* atom keyword  */

 fprintf(fileptr, "%s ",
keywstring(
  (unsigned int) vtxeval(vtxeval(term, op_word0 + i), op_code)
          )
);



         break;

   
}   /* switch */


   }   /*  for i  */


fprintf(fileptr, "))\n");



return (0);



#if (dbg_flag > 10)
printf("\nbopterm_trans:%u: end", count);
#endif

}  /*  prg  */










































