/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */

/*
HYP: term is an id
*/


void trans_id(FILE *fileptr, void* term)
{
/* dcl */

unsigned int i, enum_size, enum_offset;
void *def_term;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\n\ntrans_id:%u: begin translation id term 0x%x: \n", 
count, 
term
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif





      switch ( 
(unsigned int) 
vtxeval(idarray(vtxeval(term, op_word0)), lexid_type)
             )
            {



       case id_const:  /* const */


#if (dbg_flag > 100)
printf("\nterm_trans:%u: id %s is const id with value %u", 
count,
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string),
vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)
);
#endif



            fprintf(fileptr, "%u ", 
                       vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)
                    );



             return;









      case id_enum:


def_term = vtxeval(idarray(vtxeval(term, op_word0)), lexid_def);


#if (dbg_flag > 100)
printf("\nterm_trans:%u: id %s is enum id: (uint %u %u)", 
count,
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string),

eval_expr( vtxeval(def_term, op_word0 + 1) ),

eval_expr( vtxeval(def_term, op_word0 + 2) ) + 
(unsigned int)
vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)

);
#endif



   fprintf(fileptr, " (uint %u %u) ", 

eval_expr( vtxeval(def_term, op_word0 + 1) ),

eval_expr( vtxeval(def_term, op_word0 + 2) ) + 
(unsigned int)
vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)

         );



               return;




    



          case id_lambda:


#if (dbg_flag > 100)
printf("\nterm_trans:%u: id %s is lambda id: (uint %u %u)", 
count,
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string),

eval_expr( vtxeval(def_term, op_word0 + 1) ),

eval_expr( vtxeval(def_term, op_word0 + 2) ) + 
(unsigned int)
vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)

);
#endif

   fprintf(fileptr, " (uint %u %u) ", 

vtxeval(idarray(vtxeval(term, op_word0)), lexid_bitsize),

vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)

         );


               return;






          case id_macro_arg:


#if (dbg_flag > 100)
printf("\nterm_trans:%u: id %s is macro_arg: actual value:\n", 
count,
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
);

print_term(stderr, 
vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)
          );
fprintf(stderr, "\n");

#endif


if ( vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)
     ==
     (void *) NULL
   )
/*  error  */
{

fprintf(stderr, "\ntrans_id: error: no binding for id %s in term\n",
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
);


print_term(stderr, term);
fprintf(stderr, "\n");


exit (1);
}


/* OK  */



term_trans(fileptr, 
vtxeval(idarray(vtxeval(term, op_word0)), lexid_value)
          );

             return;









      default:



#if (dbg_flag > 100)
printf("\nterm_trans:%u: id %s is usual id", 
count,
vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
);
#endif



             fprintf(fileptr, "%s ", 
                       vtxeval(idarray(vtxeval(term, op_word0)), lexid_string)
                    );



             return;



       }  /*  switch  */





}   /* prg  */

















