/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0  /* normal value: 0  */

/*
HYP: term is (lambda (i bitsize max) body_term)
*/


void lambda(FILE *fileptr, void* term)
{
/* dcl */

unsigned int i, bitsize, lambdasize;
void *lambda_id, *body_term;

void* old_id_type;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\n\ntrans_id:%u: begin translation id term 0x%x: \n", 
count, 
term
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif


/* Mark  lambda id  */


lambda_id = vtxeval(vtxeval(term, op_word0 + 1), op_word0);

bitsize = eval_expr( vtxeval(vtxeval(term, op_word0 + 1), op_word0 + 1) );

lambdasize = eval_expr( vtxeval(vtxeval(term, op_word0 + 1), op_word0 + 2) );


body_term = vtxeval(term, op_word0 + 2);




old_id_type = vtxeval(idarray(vtxeval(lambda_id, op_word0)), lexid_type);


vtxeval(idarray(vtxeval(lambda_id, op_word0)), lexid_type) = 
(void *) id_lambda;

vtxeval(idarray(vtxeval(lambda_id, op_word0)), lexid_bitsize) = 
(void *) bitsize;


if (lambdasize == 0)
/* error */
{

fprintf(stderr, 
"\nlambda: error: found dummy id size = 0, expected > 0: term:\n");
print_term(stderr, term);
fprintf(stderr, "\n");

exit (1);


}


/* lambdasize > 0 */




  fprintf(fileptr, "(join ");


for (i = 0; i < lambdasize; i++)
   {

vtxeval(idarray(vtxeval(lambda_id, op_word0)), lexid_value) = 
(void *) i;

term_trans(fileptr, body_term);

   }



  fprintf(fileptr, " ) ");


/* reset id type  */

vtxeval(idarray(vtxeval(lambda_id, op_word0)), lexid_type) = old_id_type;



    return ;



}   /* prg  */

















