/*
*************************************
file: term.c


Read term from file set in lexan.

Peturns pointer to array of void*
containing token codes or string pointers.
Returns NULL if there is no term to read (eof).
*************************************
*/


#include "local.h"



#define dbg_flag 0   /* normal value: 0  */

/*
HYP: term is (f ... )

where f is an id of type id_macro
*/


void macro(FILE *fileptr, void* term)
{
/* dcl */

unsigned int i, macro_args;
void *macro_par, *macro_def;

void* old_id_type;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif




/* prg  */



#if (dbg_flag > 100)
printf("\n\nmacro:%u: begin translation macro term 0x%x: \n", 
count, 
term
);
print_term(stderr, term);
fprintf(stderr, "\n");
#endif



/*  macro id */




/* bind formal parameters to actual par */


macro_def = vtxeval(idarray(
              vtxeval(vtxeval(term, op_word0), op_word0)
                    ), lexid_def);


#if (dbg_flag > 100)
printf("\n\nmacro:%u: macro_def = 0x%x: \n", 
count, 
macro_def
);
print_term(stderr, macro_def);
fprintf(stderr, "\n");
#endif


macro_par = vtxeval(macro_def, op_word0 + 1);


#if (dbg_flag > 100)
printf("\n\nmacro:%u: macro_par = 0x%x: \n", 
count, 
macro_par
);
print_term(stderr, macro_par);
fprintf(stderr, "\n");
#endif



macro_args = (unsigned int) vtxeval(macro_par, op_args);


#if (dbg_flag > 100)
printf("\n\nmacro:%u: macro_args = %u", 
count, 
macro_args
);
#endif

/* bind */

for (i = 1; i < macro_args; i++)
   {

vtxeval(
idarray(vtxeval(vtxeval(macro_par, op_word0 + i), op_word0)),
lexid_type
       ) = (void *) id_macro_arg;



vtxeval(
idarray(vtxeval(vtxeval(macro_par, op_word0 + i), op_word0)),
lexid_value
       ) = vtxeval(term, op_word0 + i);

   }


/* binding done */

#if (dbg_flag > 100)
printf("\n\nmacro:%u: binding done: vtxeval(macro_def, op_word0 + 2) = 0x%x", 
count,
vtxeval(macro_def, op_word0 + 2)
);
#endif



/* expand */

term_trans(fileptr, vtxeval(macro_def, op_word0 + 2) );


/* reset formal par */

#if (dbg_flag > 100)
printf("\n\nmacro:%u: reset formal par", 
count
);
#endif


for (i = 1; i < macro_args; i++)
   {

vtxeval(
idarray(vtxeval(vtxeval(macro_par, op_word0 + i), op_word0)),
lexid_type
       ) = (void *) id_undef;


vtxeval(
idarray(vtxeval(vtxeval(macro_par, op_word0 + i), op_word0)),
lexid_value
       ) = NULL;

   }



    return ;


#if (dbg_flag > 100)
printf("\n\nmacro:%u: end\n", count);
#endif


}   /* prg  */

















