/*
*************************************
file: ckauxid.c

Store max auxid found in file
*************************************
*/


#include "local.h"


#define dbg_flag 0       /* normal value: 0  */



void ckauxid(char *buf)
{
/* dcls */
unsigned long int aux;


if (buf[0] != '_')
/* no aux id */
{
  return ;
}



/* buf[0] == '_' */
/* aux id then buf++ is a a string
   representing 0x number
*/

buf++;
aux = strtoul(buf, NULL, ID_BASE);

if (aux > max_auxid)
/* update */
{
max_auxid = aux;
}


#if (dbg_flag > 10)
fprintf(stderr, "\nckauxid: found: _%s, max_auxid = %u = 0x%x",
buf, 
max_auxid,
max_auxid
);
#endif


}  /*  ckauxid  */










unsigned long int get_new_auxid()
{
/* dcls */

/* prg */

max_auxid++;
return (max_auxid);

}






