/*
*************************************
file: trsymtab.c

Symbol table for translation process.

Usage:



begin_trans_symtab();

.... do whatever .....

end_trans_symtab()();  

Primes:
%  Primes:  101, 1009, 5003, 10007, 19997, 40993, 50021, 70001,
%  80021, 100003, 120011, 140009, 
%  150001, 200003, 250007, 300007, 350003, 
%  400009, 500009
%  101, 9997, 19997, 30011, 40009, 50021

*************************************
*/


#include "local.h"
#include "symbtab.h"



#define debug 0      /* normal value: 0  */
#define print_stb 0  /* normal value: 0  */

#define ST_SIZE 100003   /* should be a prime number  */



void begin_trans_symtab()
{


#if (debug > 10)
printf("\nbegin_trans_symtab: max_auxid = %u = 0x%x", 
max_auxid, max_auxid);
#endif



/* size symbol table prime number  */
Trans_Table = create_symb_table(ST_SIZE);

}






void end_trans_symtab()
{


#if (print_stb > 10)
/*
*******************************
Print Symbol table for debug
*******************************
*/
printf("\n\n\n\n\n");
printf("\n*******************************************");
printf("\nSymbol Table");
printf("\n*******************************************");
print_symbtab(stdout, Trans_Table);
#endif


#if (debug > 10)
printf("\nend_trans_symtab: max_auxid = %u = 0x%x", 
max_auxid, max_auxid);
#endif

delete_symbtab(Trans_Table);

#if (debug > 10000)
printf("\nend_trans_symtab: end");
#endif

}





