/*
*************************************
file: pool.c

*************************************
*/


#include "local.h"



#define dbg_flag 0      /* normal value: 0  */

#define POOL_SIZE 5000000   /* size in bytes  */



static char pool[POOL_SIZE];

static unsigned long int first_av_adr = 0;






char* new_pool_block(unsigned long int size)
{
/* dcls */
char *result;


/* prg */


if (first_av_adr + size >= POOL_SIZE)
/* no space */
{

  fprintf(stderr, 
"\nnewblock: no more space in pool: first_av_adr = %u, size = %u, POOL_SIZE = %u",
first_av_adr,
size,
POOL_SIZE
);

  return (NULL);
}


/* ok */


result = pool + first_av_adr;

first_av_adr = first_av_adr + size;


return (result);


}  /* new_pool_block()    */








void free_pool()
{

first_av_adr = 0;

}
