/*
*************************************
file: trans.c
*************************************
*/


#include "local.h"
#include "symbtab.h"



#define debug 0      /* normal value: 0  */
#define print_stb 0  /* normal value: 0  */


static char local_buf[200];







unsigned long int string2auxid(char *buf)
{
/* dcls */
void *temp;



/* prg */
temp = read_symbtab_bucket(Trans_Table, buf);


if (temp != NULL)
/* id not new  */
{
   return ( (unsigned long int) read_stbk_info(temp));
}


/* id new */

temp = get_new_stbk();
write_stbk_key(temp, duplicate_key(buf));
write_stbk_info(temp, get_new_auxid()); 
write_symbtab_bucket(Trans_Table, temp);


return ( (unsigned long int) read_stbk_info(temp));


}  /* def_auxid */







/* 
    in buf k represented in base base
    (2 <= base <= 36)
*/

char uint2char(unsigned int k, unsigned int base)
{

    if (k < 10)
       return ('0' + k);
    
    /* k >= 10 */

    if (k < base)
      return ('a' + k - 10);

    else /* error */
        {

  fprintf(stderr, 
"\nuint2char: error k = %u >= %u = base", k, base);
   
  exit (1);
        }

}



void ul2str(char *buf, unsigned long int k, int base)
{
/* dcls */
unsigned long int i = 0;
int j;
char temp;


/* prg */

#if (debug > 10)
printf("\nul2str: begin: k = %u, base = %u", 
k, base);
#endif
 

do 
  {

     buf[i] = uint2char(k%base, base);

#if (debug > 10)
printf("\nul2str: buf[%u] = %c", i, buf[i]);
#endif

     k = (k - k%base)/base;
     i++;

  } while (k > 0);


buf[i] = '\0';


#if (debug > 10)
printf("\nul2str: while end: buf = %s", buf);
#endif

/* reverse buf */


/* i is number of digits  */
/* (i - 1) is adr of MSB   */

for (j = 0; j < i/2; j++)
  {
#if (debug > 10)
printf("\nul2str: for j = %u: buf[%u] = %c, buf[%u] = %c",
j,
j,
buf[j],
i - 1 - j,
buf[i - 1 - j]
);
#endif

    temp = buf[j];
    buf[j] = buf[i - 1 - j];
    buf[i - 1 - j] = temp;
  
  }

#if (debug > 10)
printf("\nul2str: end: buf = %s", buf);
#endif

}  /*  ul2str()   */





unsigned long int lngid2shrtid(char *buf, char *shortid)
{
/* dcls */
void *temp;



/* prg */
temp = read_symbtab_bucket(Trans_Table, buf);


if (temp != NULL)
/* id not new  */
{
   ul2str(shortid, (unsigned long int) read_stbk_info(temp), ID_BASE);
   return ( (unsigned long int) read_stbk_info(temp));
}


/* id new */

temp = get_new_stbk();
write_stbk_key(temp, duplicate_key(buf));
write_stbk_info(temp, get_new_auxid()); 
write_symbtab_bucket(Trans_Table, temp);


ul2str(shortid, (unsigned long int) read_stbk_info(temp), ID_BASE);
return ( (unsigned long int) read_stbk_info(temp));


}  /* def_auxid */




void mkaux(char *buf)
{

#if (debug > 10)
printf("\nmkaux: begin: buf = %s", buf);
#endif

lngid2shrtid(buf, local_buf);

#if (debug > 10)
printf("\nmkaux: local_buf = %s", local_buf);
#endif

sprintf(buf, "_%s", local_buf);

#if (debug > 10)
printf("\nmkaux: end: buf = %s", buf);
#endif

}
