/*
******************
file autord2.c

Reads file (stdin)

with process definition

and computes information coupling

******************
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <limits.h>



#define dbgflag 0  /* normal value: 0  */


#define szA 60

#define USIZE 200

#define SZ_HORIZON 4



struct vertex
{
  unsigned int info;
  struct vertex *next;
};


unsigned int A[szA][szA];
unsigned int marked[szA];

unsigned int try_vtx[szA];



unsigned int min_pindx = UINT_MAX;
unsigned int max_pindx = 0;



void best_ord();

int join_edge(
struct vertex **start, 
struct vertex **end
);

int best_nodes(
unsigned int *nodes, 
unsigned int i, 
unsigned int start, 
unsigned int end
);

void get_seed(
struct vertex **start, 
struct vertex **end
);


int best_nodes_1(
unsigned int *nodes, 
unsigned int i, 
unsigned int start, 
unsigned int end
);




int join_edge_1(
struct vertex **start, 
struct vertex **end
);




main()
{
/* dcls */

unsigned int i = 0;
unsigned int j = 0;
unsigned int k[5];


char sigbuf[USIZE];

char buf[1000];

unsigned int B[szA]; 

int in_proc_def = 0;
int in_trans_def = 0;


/* prg  */


#if (dbgflag > 0)
setbuf(stdout, NULL);
setbuf(stderr, NULL);
#endif

/* init  */

for (i = 0; i < szA; i++)
    {

     B[i] = 0;

     for (j = 0; j < szA; j++)
       {
          A[i][j] = 0;
       }

    }  /* for i */





#if (dbgflag > 0)
fprintf(stderr, "\nautord: begin");
#endif


while ( gets(buf) != NULL )
{

#if (dbgflag > 100)
fprintf(stderr, "\nautord: begin while: %s", buf);
#endif




            if ( sscanf(buf, " (def %s", sigbuf) == 1 )
               {

#if (dbgflag > 100)
fprintf(stderr, "\nautord: found (def %s", sigbuf);
#endif


                 if ( strcmp(sigbuf, "C1_R_nonr") == 0 )
                    /* in proc def */
                    {

#if (dbgflag > 100)
fprintf(stderr, "\nautord: in proc def: %s", sigbuf);
#endif

                      in_proc_def = 1;
                      continue;
                    }
                  else /* out of proc def */
                    {
#if (dbgflag > 100)
fprintf(stderr, "\nautord: def out of proc def: %s", sigbuf);
#endif

                      in_proc_def = 0;
                      continue;
                    }
               }



            if ( sscanf(buf, " (%s", sigbuf) == 1 )
              {
#if (dbgflag > 100)
fprintf(stderr, "\nautord: (:  %s", sigbuf);
#endif

                 if (    (strcmp(sigbuf, "and") == 0 )
                      && (in_proc_def == 1)
                    )
                    /* in trans def */
                  {
#if (dbgflag > 100)
fprintf(stderr, "\nautord: in trans def", sigbuf);
#endif
                    in_trans_def = 1;
                     continue;
                  }
              }



            if ( sscanf(buf, " %s", sigbuf) == 1 )
              {

#if (dbgflag > 100)
fprintf(stderr, "\nautord: test end trans");
#endif

                 if (    (strcmp(sigbuf, ")") == 0 )
                      && (in_proc_def == 1)
                      && (in_trans_def == 1)
                   )
                    /* end of trans def */
                  {

#if (dbgflag > 100)
fprintf(stderr, "\nautord:  end of trans def: update A, reset B");
#endif

                     in_trans_def = 0;


                     /* update A  */
for (i = 1; i <= B[0]; i++)
    {
        for (j = i + 1; j <= B[0]; j++)
           {
             A[B[i]][B[j]] = A[B[i]][B[j]] + 1;
           }  /*  for j */
    }  /* for i */


B[0] = 0;

#if (dbgflag > 100)
fprintf(stderr, "\nautord: A updated, B resetted");
#endif



                     continue;
                  }
              }






            if ( sscanf(buf, " %s", sigbuf) == 1 )
              {

#if (dbgflag > 100)
fprintf(stderr, "\nautord:  test end of proc def");
#endif

                 if (    (strcmp(sigbuf, "))") == 0 )
                      && (in_proc_def == 1)
                      && (in_trans_def == 0)
                   )
                    /* end of proc def */
                  {

#if (dbgflag > 100)
fprintf(stderr, "\nautord:  end of proc def");
#endif


                     in_proc_def = 0;
                      continue;
                  }
              }







            if (
( sscanf(buf, " (compose C1_C%u_R C1_C%u_a C1_C%u_a%u)", 
&(k[0]), 
&(k[1]),
&(k[2]), 
&(k[3])
) == 4 )

&& (in_proc_def == 1)
&& (in_trans_def == 1)
               )
        /* sync found. */
       {
#if (dbgflag > 100)
fprintf(stderr, "\nautord: sync C1_C%u_a%u: %s", k[2], k[3], buf);
#endif

/* check hyp: */

if (k[0] != k[1]) 
   /* error */
  {
    fprintf(stderr, "\nerror: k[0] = %u != %u = k[1]\n", k[0], k[1]);
    exit (1);
  }


if (k[0] != k[2]) 
   /* error */
  {
    fprintf(stderr, "\nerror: k[0] = %u != %u = k[2]\n", k[0], k[2]);
    exit (1);
  }


/* ok: insert in B */

B[0] = B[0] + 1;
B[B[0]] = k[2];

if (k[2] < min_pindx) { min_pindx = k[2];}
if (k[2] > max_pindx) { max_pindx = k[2];}

if (max_pindx >= szA)
   /* error */
  {
     fprintf(stderr, "\n\nerror A too small\n\n");
     exit (1);
  }


         continue;
       }


#if (dbgflag > 100)
fprintf(stderr, "\nautord:  nothing to be done");
#endif


/* nothing to be done  */

    continue;





#if (dbgflag > 100)
fprintf(stderr, "\nautord: end while");
#endif

}      /* while */

 
#if (dbgflag > 100)
fprintf(stderr, "\nautord:  print A");
#endif

/* print A  */

for (i = 0; i < szA; i++)
    {
        for (j = i + 1; j < szA; j++)
           {
             if (A[i][j] != 0)
                {
                   printf("\nA[%u][%u] = %u", i, j, A[i][j]);
                }

           }  /*  for j */
    }  /* for i */




#if (dbgflag > 10)
fprintf(stderr, "\nautord: find best ord, min_pindx = %u, max_pindx = %u",
min_pindx,
max_pindx
);
#endif

printf("\n\n proc order \n\n");

best_ord();


#if (dbgflag > 0)
fprintf(stderr, "\nautord: end");
#endif


}  /* main */









void best_ord()
{
/* dcls  */
unsigned int i, old;

struct vertex *start, *end, *p;

unsigned int total = 0;



/* prg */

/* init  */

for (i = 0; i < szA; i++)
   { marked[i] = 0; }


get_seed(&start, &end);


while ( join_edge_1(&start, &end) != 0 );


/* print order  */

p = start;
i = 0;

printf("\n%u: \tproc %u; \twsofar = %u", i, p -> info, total);
old = p -> info;
p = p -> next;
i++;

while (p != NULL)
  {

    if (old < p -> info)
       { total = total + A[old][p -> info];}
     else
       { total = total + A[p -> info][old];}
      
    old = p -> info;


    printf("\n%u: \tproc %u; \twsofar = %u", i, p -> info, total);
    p = p -> next;
    i++;

 
  }




}









int join_edge(
struct vertex **start, 
struct vertex **end,
unsigned int k
)
{
/* dcls */
int result = 0;
int found1 = 0;
unsigned int max_sofar = 0;
unsigned int best_sofar[3];
unsigned int i;

struct vertex *p;
unsigned int nodes[5];


/* prg  */

/* while no more new sz_horizon tuples, do */

/* choose sz_horizon unmarked vertices */

/* choose one among (sz_horizon + 1) positions of start-end w.r.t
   chosen unamrked vertices 
*/

/* eval goodnes and update best_sofar as appropriate */

/* end while */



   for (i = min_pindx; i <= max_pindx; i++)
          {
             /* skip marked nodes */
             if (marked[i] != 0) continue;



/* marked[i] == 0  */

              found1 = best_nodes(nodes, i, 
(*start) -> info, 
(*end) -> info
);

              if (    found1 
                  &&  ( (nodes[2] > max_sofar) || !result )
                 )
                 {
               best_sofar[0] = nodes[0];  /* this is start or end */
               best_sofar[1] = i;         /* fresh */
               best_sofar[2] = nodes[1];  /* fresh */
               
               result = 1;

               max_sofar = nodes[2];
            
                 }            

          }  /* for i */




if (result == 0)
   /* no element found */
   {

#if (dbgflag > 20)
fprintf(stderr, "\njoin_edge: start = %u, end = %u, return 0",
(*start) -> info,
(*end) -> info
);
#endif

       return (0);
   }




/* result != 0 */


if (best_sofar[0] == (*start) -> info)
   /* prepend on start */
   {
   
#if (dbgflag > 20)
fprintf(stderr, "\njoin_edge: prepend to start: %u, %u : %u",
best_sofar[2],
best_sofar[1],
(*start) -> info
);
#endif



     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\njoin_edge: no malloc space\n");
          exit (1);
        }


     p -> info = best_sofar[1];
     p -> next = *start;
     *start = p;
     marked[p -> info] = 1;



     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\njoin_edge: no malloc space\n");
          exit (1);
        }


     p -> info = best_sofar[2];
     p -> next = *start;
     *start = p;
     marked[p -> info] = 1;

 
    } 
else
   /* append on end */
   {

#if (dbgflag > 20)
fprintf(stderr, "\njoin_edge: append to end: %u: %u, %u",
(*end) -> info,
best_sofar[1],
best_sofar[2],
(*start) -> info
);
#endif

 
     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\njoin_edge: no malloc space\n");
          exit (1);
        }


     p -> info = best_sofar[1];
     p -> next = NULL;
     (*end) -> next = p;
     *end = p;
     marked[p -> info] = 1;

      

     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\njoin_edge: no malloc space\n");
          exit (1);
        }


     p -> info = best_sofar[2];
     p -> next = NULL;
     (*end) -> next = p;
     *end = p;
     marked[p -> info] = 1;

   }




return (1);


 
}   /* join_edge  */








/*
*********************
best_nodes computes
best sol with horizon szhrzn
given start and end
*********************
*/


int best_nodes(
unsigned int *nodes, 
unsigned int i, 
unsigned int start, 
unsigned int end,
unsigned int szhrzn
)
{

/* dcls */
int found1 = 0;
unsigned int new_sum = 0;
unsigned int j, k;


/* prg  */



if ( (szhrzn == 0) || (num_unmarked == 0) )
/* compute best sol w.r.t. start, end */
   {

    for (i = 0; i <= nodes[0]; i++)
      {





      }  /* for i */





     return;





   }













/* (szhrzn > 0) && (num_unmarked > 0): recursion  */

 for (i = min_pindx; i <= max_pindx; i++)
   {
       if (marked[i] == 0)
         {
           marked[i] = 1;
           num_unmarked--;
           
           /* insert i in nodes */
           nodes[0] = nodes[0] + 1;
           nodes[nodes[0]] = i;

           new_max = best_nodes(nodes, start, end, szhrzn - 1);

           if ( (new_max > max_sofar) || !found1 )
              /* upd best_sol_sofar */
               {

                   for (j = 0; j <= nodes[0]; j++)
                      {
                          best_sol_sofar[j] = nodes[j];
                      } 

                   found1 = 1;

               }
            else /* no upd, unmark  */
              {
                marked[i] = 0;
                num_unmarked++;
                   
              }

         }  /* then */

   }  /* for i */




return (max_sofar);


}  /* best_nodes()  */



nodes[2] = 0;

for (j = i + 1; j <= max_pindx; j++)
   {

     for (k = j + 1; k <= max_pindx; k++)
       {

#if (dbgflag > 2000)
fprintf(stderr, 
"\nbest_nodes: i = %u: for j = %u, k = %u, found1 = %u",
i,
j,
k,
found1
);
#endif



           if (    (marked[j] == 0) /* new */
                  && (    (start == k)  
                       || (end == k) )  /* link */
                )
            /* good candidate */
              {



                new_sum = A[i][j] + A[i][k];
                


                if ( (new_sum > nodes[2]) || !found1 )
                   /* update best */
                    {
#if (dbgflag > 20)
fprintf(stderr, 
"\nbest_nodes: i = %u, j = %u, k = %u = (s,e), nodes[2] = %u, new_sum = %u:",
i,
j,
k,
nodes[2],
new_sum
);
#endif

#if (dbgflag > 20)
fprintf(stderr, " upd(k)");
#endif

                       nodes[2] = new_sum;
                       nodes[0] = k;
                       nodes[1] = j;
                       found1 = 1;
                       continue;
                    }


              }  /*  then */





           if   (    (marked[k] == 0) /* new */
                  && (    (start == j)  
                       || (end == j) )  /* link */
                )
            /* good candidate */
              {
                new_sum = A[i][j] + A[i][k];
                



                if ( (new_sum > nodes[2]) || !found1 )

                   /* update best */
                    {
#if (dbgflag > 20)
fprintf(stderr, 
"\nbest_nodes: i = %u, j = %u = (s,e), k = %u, nodes[2] = %u, new_sum = %u:",
i,
j,
k,
nodes[2],
new_sum
);
#endif

#if (dbgflag > 20)
fprintf(stderr, " upd(j)");
#endif

                       nodes[2] = new_sum;
                       nodes[0] = j;
                       nodes[1] = k;
                       
                       found1 = 1;
                       continue;
                    }


              }  /*  then */




       }  /* for k */



   }  /* for j */




#if (dbgflag > 20)
fprintf(stderr, "\nbest_nodes: i = %u, start = %u, end = %u, return %u",
i,
start,
end,
found1
);
#endif



return (found1);



}  /*  best_nodes()  */






/*
************
all unmarked
************
*/


void get_seed(
struct vertex **start, 
struct vertex **end
)
{


/* dcls */
int found1 = 0;
unsigned int new_sum = 0;
unsigned int i, j, k;
unsigned int nodes[4];

struct vertex *p;

/* prg  */

nodes[0] = 0;
nodes[1] = 0;
nodes[2] = 0;
nodes[3] = 0;

for (i = min_pindx; i <= max_pindx; i++)
{
for (j = i + 1; j <= max_pindx; j++)
   {
     for (k = j + 1; k <= max_pindx; k++)
       {
               
            new_sum = A[i][j] + A[i][k];
                
            if ( (new_sum > nodes[3]) || !found1 )
                   /* update best */
                {
                       nodes[3] = new_sum;
                       nodes[0] = i;
                       nodes[1] = j;
                       nodes[2] = k;
                       found1 = 1;
                }



       }  /* for k */
   }  /* for j */
 }  /* for i */


/* seed in nodes */

#if (dbgflag > 20)
fprintf(stderr, "\nget_seed: found seed: %u %u %u",
nodes[1],
nodes[0],
nodes[2]
);
#endif


     *end = (struct vertex *) malloc(sizeof(struct vertex));

      if (*end == NULL)
        {
          fprintf(stderr, "\nget_seed: no malloc space\n");
          exit (1);
        }


     (*end) -> info = nodes[2];
     (*end) -> next = NULL;
     marked[(*end) -> info] = 1;

      

     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\nget_seed: no malloc space\n");
          exit (1);
        }


     p -> info = nodes[0];
     p -> next = *end;
     marked[p -> info] = 1;




     (*start) = (struct vertex *) malloc(sizeof(struct vertex));
      if (*start == NULL)
        {
          fprintf(stderr, "\nget_seed: no malloc space\n");
          exit (1);
        }


     (*start) -> info = nodes[1];
     (*start) -> next = p;
     marked[(*start) -> info] = 1;




}  /* get_seed()   */



















/*
**************
Hyp: marked[i] == 0

**************
*/


int best_nodes_1(
unsigned int *nodes, 
unsigned int i, 
unsigned int start, 
unsigned int end
)
{

/* dcls */
int found1 = 0;
unsigned int new_sum = 0;
unsigned int j, k;


/* prg  */


nodes[2] = 0;

for (j = i + 1; j <= max_pindx; j++)
   {


#if (dbgflag > 2000)
fprintf(stderr, 
"\nbest_nodes_1: i = %u: for j = %u, found1 = %u",
i,
j,
found1
);
#endif



           if (    (marked[j] == 0) /* new */
                  && (    (start == i)  
                       || (end == i) )  /* link */
                )
            /* good candidate */
              {



                new_sum = A[i][j];
                


                if ( (new_sum > nodes[2]) || !found1 )
                   /* update best */
                    {
#if (dbgflag > 20)
fprintf(stderr, 
"\nbest_nodes_1: i = %u (s,e), j = %u, nodes[2] = %u, new_sum = %u:",
i,
j,
nodes[2],
new_sum
);
#endif

#if (dbgflag > 20)
fprintf(stderr, " upd(i)");
#endif

                       nodes[2] = new_sum;
                       nodes[0] = i;
                       nodes[1] = j;
                       found1 = 1;
                       continue;
                    }


              }  /*  then */





           if   (    (marked[i] == 0) /* new */
                  && (    (start == j)  
                       || (end == j) )  /* link */
                )
            /* good candidate */
              {
                new_sum = A[i][j];
                



                if ( (new_sum > nodes[2]) || !found1 )

                   /* update best */
                    {
#if (dbgflag > 20)
fprintf(stderr, 
"\nbest_nodes_1: i = %u, j = %u = (s,e), nodes[2] = %u, new_sum = %u:",
i,
j,
nodes[2],
new_sum
);
#endif

#if (dbgflag > 20)
fprintf(stderr, " upd(j)");
#endif

                       nodes[2] = new_sum;
                       nodes[0] = j;
                       nodes[1] = i;
                       
                       found1 = 1;
                       continue;
                    }


              }  /*  then */





   }  /* for j */




#if (dbgflag > 20)
fprintf(stderr, "\nbest_nodes_1: i = %u, start = %u, end = %u, return %u",
i,
start,
end,
found1
);
#endif



return (found1);



}  /*  best_nodes_1()  */


















int join_edge_1(
struct vertex **start, 
struct vertex **end
)
{
/* dcls */
int result = 0;
int found1 = 0;
unsigned int max_sofar = 0;
unsigned int best_sofar[3];
unsigned int i;

struct vertex *p;
unsigned int nodes[5];


/* prg  */

   for (i = min_pindx; i <= max_pindx; i++)
          {

              found1 = best_nodes_1(nodes, i, 
(*start) -> info, 
(*end) -> info
);

              if (    found1 
                  &&  ( (nodes[2] > max_sofar) || !result )
                 )
                 {
               best_sofar[0] = nodes[0];  /* this is start or end */
               best_sofar[1] = nodes[1];  /* fresh */
               
               result = 1;

               max_sofar = nodes[2];
            
                 }            

          }  /* for i */




if (result == 0)
   /* no element found */
   {

#if (dbgflag > 20)
fprintf(stderr, "\njoin_edge_1: start = %u, end = %u, return 0",
(*start) -> info,
(*end) -> info
);
#endif

       return (0);
   }




/* result != 0 */


if (best_sofar[0] == (*start) -> info)
   /* prepend on start */
   {
   
#if (dbgflag > 20)
fprintf(stderr, "\njoin_edge_1: prepend to start: %u -> %u",
best_sofar[1],
(*start) -> info
);
#endif



     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\njoin_edge_1: no malloc space\n");
          exit (1);
        }


     p -> info = best_sofar[1];
     p -> next = *start;
     *start = p;
     marked[p -> info] = 1;

 
    } 
else
   /* append on end */
   {

#if (dbgflag > 20)
fprintf(stderr, "\njoin_edge_1: append to end: %u -> %u",
(*end) -> info,
best_sofar[1]
);
#endif

 
     p = (struct vertex *) malloc(sizeof(struct vertex));
      if (p == NULL)
        {
          fprintf(stderr, "\njoin_edge_1: no malloc space\n");
          exit (1);
        }


     p -> info = best_sofar[1];
     p -> next = NULL;
     (*end) -> next = p;
     *end = p;
     marked[p -> info] = 1;

   }




return (1);


 
}   /* join_edge_1()  */




