/*
******************
file fwimgfc2.c

Computes forward image for fc2 processes.

HYP:
Processo R formato da parallelo fc2 di
4 processi: C1, C2, C3 , C4.

Ciascun processo Ci formato da parallelo
fc2 di processi Ci_Cj.

Processi base Ci_Cj

Eccezione: C3 e' un processo base.

******************
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>



#define dbgflag 0  /* normal value: 0  */

#define C_SZ 6
#define ACT_SZ 200
#define ACTLST_SZ 200
#define AND_SZ 20
#define STATE_SZ 30
#define HX "F_3F_1"


#define USIZE 200

static int *****C;

static int state[STATE_SZ][STATE_SZ];

static FILE *f1, *f2;



void explode_cmp(int pridx, int act, int* tmp);

void def_records(int state[STATE_SZ][STATE_SZ], int *tmp, int tail);

static int HX_counter = 0;

void reset_state();

void make_records(int state[STATE_SZ][STATE_SZ], int *tmp, int tail);





main(int argc, char* argv[])
{
/* dcls */

int pr_indx = -1;
int act_indx = -1;

int tmp[10];

char buf[200];
char str[200];
char str2[200];
char str3[200];



/* prg  */


#if (dbgflag > 0)
setbuf(stdout, NULL);
setbuf(stderr, NULL);
#endif


if (argc != 3)
/* error */
{
  fprintf(stderr, "\n\nerror: found %d args, expected 2\n\n", argc - 1);
  exit (1);
}


#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: begin");
#endif

/* init  */

C = (int *****) malloc(sizeof(int ****)*C_SZ);

if (C == NULL)
{
   fprintf(stderr, "\n\nerror: no malloc space for C\n\n");
   exit (1);
}


for (tmp[0] = 0; tmp[0] < C_SZ; tmp[0] = tmp[0] + 1)
{
C[tmp[0]] = (int ****) malloc(sizeof(int ***)*ACT_SZ);

if (C[tmp[0]] == NULL)
{
   fprintf(stderr, "\n\nerror: no malloc space for C[%d]\n\n", tmp[0]);
   exit (1);
}


 for (tmp[1] = 0; tmp[1] < ACT_SZ; tmp[1] = tmp[1] + 1)
   {
C[tmp[0]][tmp[1]] = (int ***) malloc(sizeof(int **)*ACTLST_SZ);

if (C[tmp[0]][tmp[1]] == NULL)
{
   fprintf(stderr, "\n\nerror: no malloc space for C[%d][%d]\n\n", 
tmp[0], tmp[1]);
   exit (1);
}

      C[tmp[0]][tmp[1]][0] = ((int **) 0);

      for (tmp[2] = 1; tmp[2] < ACTLST_SZ; tmp[2] = tmp[2] + 1)
         {
C[tmp[0]][tmp[1]][tmp[2]] = (int **) malloc(sizeof(int *)*AND_SZ);

if (C[tmp[0]][tmp[1]][tmp[2]] == NULL)
{
   fprintf(stderr, "\n\nerror: no malloc space for C[%d][%d][%d]\n\n", 
tmp[0], tmp[1], tmp[2]
);
   exit (1);
}



C[tmp[0]][tmp[1]][tmp[2]][0] = (int *) 0;

         for (tmp[3] = 1; tmp[3] < AND_SZ; tmp[3] = tmp[3] + 1)
             {
C[tmp[0]][tmp[1]][tmp[2]][tmp[3]] = (int *) malloc(sizeof(int)*2);

if (C[tmp[0]][tmp[1]][tmp[2]][tmp[3]] == NULL)
{
   fprintf(stderr, "\n\nerror: no malloc space for C[%d][%d][%d][%d]\n\n", 
tmp[0], tmp[1], tmp[2], tmp[3]
);
   exit (1);
}


             }
         }
   }
}


      




while ( gets(buf) != NULL )
{

#if (dbgflag > 10000)
fprintf(stderr, "\nfwimgfc2: begin while: buf = %s", buf);
#endif

sscanf(buf, " %s %s", str, str2);


            if (
sscanf(buf, " (def C%d_R", &tmp[0]) == 1
               )
        /* adj */
       {

sprintf(str3, "C%d_R", tmp[0]);

          if ( strcmp(str3, str2) == 0 )
            { /* pr def found */

#if (dbgflag > 10)
fprintf(stderr, "\nfwimgfc2: %s", buf);
#endif

pr_indx = tmp[0];


#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: reading def process C%d", pr_indx);
#endif



         continue;

            }  /* pr def found */

       }







          if (
                (strcmp(str, "(def") == 0)  &&
                (strcmp(str2, "R") == 0) 
             )
             {

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: found root process: %s %s", str, str2);
#endif
               pr_indx = 0;

                 continue;

             }






if ( 
       (pr_indx == 1)  ||
       (pr_indx == 2)  ||
       (pr_indx == 4)  
   )
/* check for C proc def */
   { /* then ck C */

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: ck C: pr_indx = %d", pr_indx);
#endif


            if (
sscanf(buf, " (eqv C%d_a C%d_a%d)", &tmp[0], &tmp[1], &tmp[2]) == 3
               )
        /* adj */
       {
#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: ck C: reading %s: C%d_a C%d_a%d", 
buf,
tmp[0],
tmp[1],
tmp[2]
);
#endif

           if (   
                  (tmp[0] != pr_indx) ||
                  (tmp[1] != pr_indx)
              )
              /* error */
            {

fprintf(stderr, 
"\nfwimgfc2: error: expected C%d... found C%d_a C%d_a%d", 
pr_indx,
tmp[0],
tmp[1],
tmp[2]
);

exit (1);
         
            }

/* ok */

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: ck C: set act_indx = %d", tmp[2]);
#endif

act_indx = tmp[2];

/* begin new transition for act_indx */

C[pr_indx][act_indx][0] = 
(int **)
( ((int) C[pr_indx][act_indx][0]) + 1 );

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: ck C: C[%d][%d][0] = %d",
pr_indx,
act_indx,
C[pr_indx][act_indx][0]
);
#endif


         continue;

       }

   } /* then ck C */


    

 


if  (pr_indx == 0) 
/* check for R proc def */
   { /* then ck R */

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: root process: pr_indx = %d", pr_indx);
#endif

            if (
sscanf(buf, " (eqv a a%d)", &tmp[2]) == 1
               )
        /* adj */
       {
#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: root %s: a%d", buf, tmp[2]);
#endif


/* ok */

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: R: set act_indx = %d", tmp[2]);
#endif

act_indx = tmp[2];

/* begin new transition for act_indx */

C[pr_indx][act_indx][0] = 
(int **)
( ((int) C[pr_indx][act_indx][0]) + 1 );

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: R: C[%d][%d][0] = %d", 
pr_indx,
act_indx,
C[pr_indx][act_indx][0]
);
#endif

         continue;

       }

   } /* then ck R */


     




if ( 
       (pr_indx == 1)  ||
       (pr_indx == 2)  ||
       (pr_indx == 4)  
   )
/* check for C proc def */
   { /* then ck C */


            if (
sscanf(buf, " (compose C%d_C%d_R C%d_C%d_a C%d_C%d_a%d)", 
&tmp[0], &tmp[1], 
&tmp[2], &tmp[3],
&tmp[4], &tmp[5], &tmp[6]
) == 7
               )
        /* adj */
       {
#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: C compose: reading %s", buf);
#endif

           if (   
                  (tmp[0] != pr_indx) ||
                  (tmp[2] != pr_indx) ||
                  (tmp[4] != pr_indx)
              )
              /* error */
            {

fprintf(stderr, 
"\nfwimgfc2: error: expected C%d... found C%d... C%d ... C%d", 
pr_indx,
tmp[0],
tmp[2],
tmp[4]
);

exit (1);
         
            }

/* ok */

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: upd act_indx = %d list", act_indx);
#endif


C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0] = 
(int *) 
( ((int) C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0]) + 1);

tmp[7] = (int) C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0];

C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][tmp[7]][0] = tmp[5];

C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][tmp[7]][1] = tmp[6];

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: list updated: C[%d][%d]",
pr_indx,
act_indx
);

fprintf(stderr, "[%d][0] = ",
(int) C[pr_indx][act_indx][0]
);

fprintf(stderr, "%d",
C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0]
);
#endif

         continue;

       }

   } /* then ck C */






if (pr_indx == 0) 
/* check for C proc def */
   { /* then ck R */


            if (
sscanf(buf, " (compose C%d_R C%d_a C%d_a%d)", 
&tmp[0],  
&tmp[1], 
&tmp[2], &tmp[3]
) == 4
               )
        /* adj */
       {
#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: root: reading %s", buf);
#endif


/* ok */

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: upd act_indx = %d list", act_indx);
#endif


C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0] = 
(int *) 
( ((int) C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0]) + 1);

tmp[7] = (int) C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0];

C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][tmp[7]][0] = tmp[2];

C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][tmp[7]][1] = tmp[3];

#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: root pr: list updated: C[%d][%d]",
pr_indx,
act_indx
);

fprintf(stderr, "[%d][0] = ",
(int) C[pr_indx][act_indx][0]
);

fprintf(stderr, "%d",
C[pr_indx][act_indx][(int) C[pr_indx][act_indx][0]][0]
);
#endif


         continue;

       }

   } /* then ck R */




#if (dbgflag > 10000)
fprintf(stderr, "\nfwimgfc2: end while body");
#endif

}      /* while */




#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: explode transitions in R");
#endif


f1 = fopen(argv[1], "w+");
f2 = fopen(argv[2], "w+");

reset_state();




for (tmp[0] = 0; tmp[0] < ACT_SZ; tmp[0] = tmp[0] + 1)
   {
    /* pick action in tmp[0]  */

#if (dbgflag > 1000)
fprintf(stderr, "\nfwimgfc2: exploding a%d: occurrences = C[0][%d][0] = %d",
tmp[0],
tmp[0],
C[0][tmp[0]][0]
);
#endif


    for (tmp[1] = 1; tmp[1] <= (int) C[0][tmp[0]][0]; tmp[1] = tmp[1] + 1)
        { 
            /* pick tr with given act in tmp[1]  */

#if (dbgflag > 1000)
fprintf(stderr, 
"\nfwimgfc2: exploding occurrence %d of a%d: list_sz = C[0][%d][%d][0] = %d",
tmp[1],
tmp[0],

tmp[0],
tmp[1],
C[0][tmp[0]][tmp[1]][0]
);
#endif

if ( (int) C[0][tmp[0]][tmp[1]][0] > 1)
   {
fprintf(f1, "\n\n(def R_%d_%d_1 (and", tmp[0], tmp[1]);
   }


          
             for (tmp[2] = 1; 
                  tmp[2] <= (int) C[0][tmp[0]][tmp[1]][0]; 
                  tmp[2] = tmp[2] + 1)
               { 
                   /* explode tr component  */
          
#if (dbgflag > 1000)
fprintf(stderr, 
"\nfwimgfc2: exploding compose %d of occ %d of a%d, C[0][%d][%d][%d][0],[1] = %d,%d",
tmp[2],
tmp[1],
tmp[0],

tmp[0],
tmp[1],
tmp[2],
C[0][tmp[0]][tmp[1]][tmp[2]][0],
C[0][tmp[0]][tmp[1]][tmp[2]][1]
);
#endif


                    explode_cmp(
C[0][tmp[0]][tmp[1]][tmp[2]][0], 
C[0][tmp[0]][tmp[1]][tmp[2]][1],
tmp
);


#if (dbgflag > 1000)
fprintf(stderr, "\nfwimgfc2: end esplode_cmp ");
#endif


               }  /* for tmp[2]  */


if ( (int) C[0][tmp[0]][tmp[1]][0] > 1)
   {
fprintf(f1, "\n)) /* R_%d_%d_1 */", tmp[0], tmp[1]);

make_records(state, tmp, 1);
   }




        }  /* for tmp[1]  */
 
   }  /* for tmp[0]  */



fprintf(f2, "\n\n\n(def %s (or F_1F_1 aux%d_%s))",
HX,
HX_counter - 1, HX
);



fclose(f1);
fclose(f2);


#if (dbgflag > 0)
fprintf(stderr, "\nfwimgfc2: end");
#endif


}  /* main */



















void explode_cmp(int pridx, int act, int *tmp)
{

/* dcls */
int aux[10];


/* prg */

#if (dbgflag > 0)
fprintf(stderr, "\n\nexplode_cmp: begin: pridx %d, act %d ",
pridx,
act
);
#endif

if (pridx == 3)
  /* atomic  */
  {

if ( (int) C[0][tmp[0]][tmp[1]][0] == 1)
   {
fprintf(f1, "\n\n(def R_%d_%d_1", tmp[0], tmp[1]); 
   }


fprintf(f1, "\n\t(compose C%d_R C%d_a C%d_a%d)",
pridx,
pridx,
pridx,
act
);

if ( (int) C[0][tmp[0]][tmp[1]][0] == 1)
   {
fprintf(f1, "\n) /* R_%d_%d_1 */", tmp[0], tmp[1]); 
make_records(state, tmp, 1);

   }

state[pridx][pridx] = 1;


return;


  }



/* nonatomic */

#if (dbgflag > 0)
fprintf(stderr, "\n\nexplode_cmp: nonatomic: pr %d, act %d has list size %d",
pridx,
act,
C[pridx][act][0]
);
#endif



if (    
      ( (int) C[0][tmp[0]][tmp[1]][0] > 1)  &&
      ((int) C[pridx][act][0] > 1)
   )
   {
fprintf(f1, "\n\t(or");
   }


    for (aux[1] = 1; aux[1] <= (int) C[pridx][act][0]; aux[1] = aux[1] + 1)
        { 
            /* pick tr with given act in aux[1]  */

#if (dbgflag > 0)
fprintf(stderr, "\nexplode_cmp: item %d of ", aux[1]);

fprintf(stderr, "%d in list for act ", C[pridx][act][0]);

fprintf(stderr, "%d of pr %d has ",
act,
pridx
);

fprintf(stderr, "%d compose",
C[pridx][act][aux[1]][0]
);

#endif

if ( (int) C[0][tmp[0]][tmp[1]][0] == 1)
   {
fprintf(f1, "\n\n(def R_%d_%d_%d", tmp[0], tmp[1], aux[1]); 
   }

if ( (int) C[pridx][act][aux[1]][0] > 1)
   {
fprintf(f1, "\n\t\t(and");
   }

          
             for (aux[2] = 1; 
                  aux[2] <= (int) C[pridx][act][aux[1]][0]; 
                  aux[2] = aux[2] + 1)
               { 
                   /* explode tr component  */
          
#if (dbgflag > 0)
fprintf(stderr, 
"\n\tcompose %d of %d in item %d of list for act %d of pr %d ... ",
aux[2],
C[pridx][act][aux[1]][0],
aux[1],
act,
pridx
);
#endif

fprintf(f1, "\n\t\t(compose C%d_C%d_R C%d_C%d_a C%d_C%d_a%d)",
pridx,
C[pridx][act][aux[1]][aux[2]][0],
pridx,
C[pridx][act][aux[1]][aux[2]][0],
pridx,
C[pridx][act][aux[1]][aux[2]][0],
C[pridx][act][aux[1]][aux[2]][1]
);
                   
state[pridx][C[pridx][act][aux[1]][aux[2]][0]] = 1;


#if (dbgflag > 0)
fprintf(stderr, "done");
#endif


               }  /* for aux[2]  */

#if (dbgflag > 0)
fprintf(stderr, "\nexplode_cmp: done with item %d", aux[1]);
#endif



if ( (int) C[pridx][act][aux[1]][0] > 1)
   {
fprintf(f1, "\n\t\t)");
   }


if ( (int) C[0][tmp[0]][tmp[1]][0] == 1)
   {
fprintf(f1, "\n) /* R_%d_%d_%d */", tmp[0], tmp[1], aux[1]); 

make_records(state, tmp, aux[1]);

   }


        }  /* for aux[1]  */


if (    
      ( (int) C[0][tmp[0]][tmp[1]][0] > 1)  &&
      ((int) C[pridx][act][0] > 1)
   )
   {
fprintf(f1, "\n\t)");
   }


#if (dbgflag > 0)
fprintf(stderr, "\n\nexplode_cmp: end: pridx %d, act %d ",
pridx,
act
);
#endif


}  /* explode_cmp  */







void def_records(int state[STATE_SZ][STATE_SZ], int *tmp, int tail)
{
/*dcls */
int i, j;

/* prg */

/* px  */

fprintf(f1, "\n\n(def R_%d_%d_%d_px (record\n", tmp[0], tmp[1], tail);

for (i = 0; i < STATE_SZ; i++)
   {

      if (i == 3)
         {

             if (state[i][i] == 1) 
                { fprintf(f1, "C3_px "); }

             continue;
         }



     for (j = 0; j < STATE_SZ; j++)        
         {
             if (state[i][j] == 1)
                {
                   fprintf(f1, "C%d_C%d_px ", i, j);
                }

         }
   
   }


fprintf(f1, "\n))  /* R_%d_%d_%d_px  */", tmp[0], tmp[1], tail);




fprintf(f1, "\n\n(def R_%d_%d_%d_nx (record\n", tmp[0], tmp[1], tail);

for (i = 0; i < STATE_SZ; i++)
   {

      if (i == 3)
         {

             if (state[i][i] == 1) 
                { fprintf(f1, "C3_nx "); }

             continue;
         }



     for (j = 0; j < STATE_SZ; j++)        
         {
             if (state[i][j] == 1)
                {
                   fprintf(f1, "C%d_C%d_nx ", i, j);
                }

         }
   
   }




fprintf(f1, "\n))  /* R_%d_%d_%d_nx  */", tmp[0], tmp[1], tail);



/* reset */

reset_state();



}  /* def_records()  */ 



void reset_state()
{

/* dcls */
int i, j;

/* prg */

for (i = 0; i < STATE_SZ; i++)
   for (j = 0; j < STATE_SZ; j++)
       state[i][j] = 0;


}








void make_records(int state[STATE_SZ][STATE_SZ], int *tmp, int tail)
{


def_records(state, tmp, tail);

fprintf(f2, "\n\n(def aux1_R_%d_%d_%d (compose %s R_%d_%d_%d_px R_%d_%d_%d_nx))",
tmp[0], tmp[1], tail,
HX,
tmp[0], tmp[1], tail,
tmp[0], tmp[1], tail
);

fprintf(f2, "\n\n(def aux2_R_%d_%d_%d (and R_%d_%d_%d aux1_R_%d_%d_%d))",
tmp[0], tmp[1], tail,
tmp[0], tmp[1], tail,
tmp[0], tmp[1], tail
);

fprintf(f2, "\n\n(def aux3_R_%d_%d_%d (exists R_%d_%d_%d_nx aux2_R_%d_%d_%d))",
tmp[0], tmp[1], tail,
tmp[0], tmp[1], tail,
tmp[0], tmp[1], tail
);


if (HX_counter <= 0)
  {

fprintf(f2, "\n\n(def aux0_%s (or %s aux3_R_%d_%d_%d))",
HX,
HX,
tmp[0], tmp[1], tail
);


  }
else  /* HX_counter > 0 */
 {

fprintf(f2, "\n\n(def aux%d_%s (or aux%d_%s aux3_R_%d_%d_%d))",
HX_counter, HX,
HX_counter - 1, HX,
tmp[0], tmp[1], tail
);

 }

HX_counter++;


fprintf(f1, "\n\n/* ******************************  */\n\n");
fprintf(f2, "\n\n/* ******************************  */\n\n");



}  /* make_records */

