/*
******************
file mkf.c
******************
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/*
   C_code_flag = 0: no C_code query
   C_code_flag > 0; C_code query
*/
#define C_code_flag 0 




#define USIZE 200



main(int argc, char* argv[])
{
/* dcls */
int i;

FILE *sigfile;

int ck_end ;

char sigbuf[USIZE];
char psuffix[USIZE];
char newsigbuf[USIZE];
char lkahsigbuf[USIZE];



/* prg  */


sigfile = fopen(argv[1], "r");

ck_end = fscanf(sigfile, "%s", psuffix);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: No plant suffix: Unexpected EOF");
fclose(sigfile);
exit (1);
}


printf("\n\n/*  Automatically generated ctr def %s  */\n\n", psuffix);


ck_end = fscanf(sigfile, "%s", sigbuf);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nmkf: error: no signals: Unexpected EOF");
fclose(sigfile);
exit (1);
}

/* ok */

/* ck if sigbuf is last signal */
ck_end = fscanf(sigfile, "%s", newsigbuf);

if (ck_end == EOF)
/*   sigbuf is last signal  */
{

printf("\n\n(def f%s_%s \n(compose fsup%s %s b1))",
psuffix,
sigbuf,

psuffix,

psuffix,
sigbuf
);

#if (C_code_flag > 0)
printf("\n(C_code f%s_%s)", 
psuffix,
sigbuf
);
#endif



return (0);

} /* then */



/* sigbuf is not last signal */


printf("\n\n(def f%s_%s \n(exists u%s1%s \n\t(compose fsup%s %s b1)))",
psuffix,
sigbuf,

psuffix,
sigbuf,

psuffix,

sigbuf
);

#if (C_code_flag > 0)
printf("\n(C_code f%s_%s)", 
psuffix,
sigbuf
);
#endif


printf("\n(def f%s2%s (compose fsup%s %s f%s_%s))",
psuffix,
sigbuf,

psuffix,

sigbuf,

psuffix,
sigbuf
);



/* sigbuf is not last signal */


i = 1;

while ( 1 )
{

/* sigbuf is not last signal */
/* next signal in newsigbuf */


/* check if newsigbuf is last signal */
ck_end = fscanf(sigfile, "%s", lkahsigbuf);


if (ck_end == EOF)
/*   newsigbuf is last signal  */
{
break;
}


/* newsigbuf is not last signal */



printf("\n\n(def f%s_%s \n(exists u%s1%s \n\t(compose f%s2%s %s b1)))",
psuffix,
newsigbuf,

psuffix,
newsigbuf,

psuffix,
sigbuf,

newsigbuf
);

#if (C_code_flag > 0)
printf("\n(C_code f%s_%s)", 
psuffix,
newsigbuf
);
#endif


i++;




printf("\n(def f%s2%s (compose f%s2%s %s f%s_%s))",
psuffix,
newsigbuf, 

psuffix,
sigbuf, 

newsigbuf,

psuffix,
newsigbuf
);



strcpy(sigbuf, newsigbuf);
strcpy(newsigbuf, lkahsigbuf);




}  /*  while */


/* newsigbuf is last signal */


printf("\n\n(def f%s_%s \n(compose f%s2%s %s b1))",
psuffix,
newsigbuf,


psuffix,
sigbuf,

newsigbuf
);


#if (C_code_flag > 0)
printf("\n(C_code f%s_%s)", 
psuffix,
newsigbuf
);
#endif

i++;



fclose(sigfile);


}  /* main */

