/*
******************
file mksup.c

Read file in format:

<planat_suffix>
sig_0
sig_1
...


argv[1] is the name of the file
containing 
<plant_suffix> and
list of signals (1 bit arrays).

Result on stdout

HYP:
Just one signal for line.
At least one signal.

Result:
opt supervisor definition
******************
*/

#include <stdlib.h>
#include <stdio.h>


#define USIZE 200


main(int argc, char* argv[])
{
/* dcls */
int i = 0;
int j;


FILE *sigfile;

int ck_end ;

char sigbuf[USIZE];
char psuffix[USIZE];



/* prg  */


sigfile = fopen(argv[1], "r");

ck_end = fscanf(sigfile, "%s", psuffix);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: No plant suffix: Unexpected EOF");
fclose(sigfile);
exit (1);
}



fclose(sigfile);





printf("\n\n\n\
/*\n\
***********************************\n\
def opt supervisor.\n\
***********************************\n\
*/"
);

printf("\n\n/*\n\
final states on nx\n\
Much better: define end directly on next states.\n\
*/"
);


printf(
"\n\n(def end%s_nx (compose end%s plant%s_px plant%s_nx))",
psuffix,
psuffix,
psuffix,
psuffix
);




printf(
"\n\n(def pnx_plant%s (exists plant%s_u plant%s))",
psuffix,
psuffix,
psuffix
);



printf(
"\n\n(def one_step%s (and pnx_plant%s end%s_nx) )",
psuffix,
psuffix,
psuffix
);




printf(
"\n\n(def g%s (or one_step%s b_all%s) )",
psuffix,
psuffix,
psuffix
);


printf(
"\n\n(def old%s (exists plant%s_nx g%s))",
psuffix,
psuffix,
psuffix
);



printf(
"\n\n(def new%s (not old%s))",
psuffix,
psuffix
);



printf(
"\n\n(def b_new%s\n\
(and\n\
\tnew%s\n\
\tpnx_plant%s\n\
\t(compose old%s plant%s_px plant%s_nx)\n\
))",
psuffix,
psuffix,
psuffix,
psuffix,
psuffix,
psuffix
);



printf(
"\n\n(def b_all%s (or b_new%s g%s))",
psuffix,
psuffix,
psuffix
);

 




printf(
"\n\n(def fsup%s (exists plant%s_nx\n\
\t (and plant%s g%s)))",
psuffix,
psuffix,
psuffix,
psuffix
);





printf(
"\n\n/*  (eval fsup%s)  */\n\n\n",
psuffix
);






}  /* main */

