/*
******************
file mkall.c

Read file in format:

<plant_suffix>
sig_0
sig_1
...


argv[1] is the name of the file
containing 
<plant_suffix> and
list of signals (1 bit arrays).

Result on stdout

HYP:
Just one signal for line.
At least one signal.

On stdout we get:

u_suffix
reversed_u_suffix

u_suffix_but_i for all i
******************
*/

#include <stdlib.h>
#include <stdio.h>


#define USIZE 200


main(int argc, char* argv[])
{
/* dcls */
unsigned int i = 0;
unsigned int j = 0;
unsigned int num_signals = 0;


FILE *sigfile;

int ck_end ;

char sigbuf[USIZE];
char sigbuf2[USIZE];
char psuffix[USIZE];



/* prg  */


sigfile = fopen(argv[1], "r");

ck_end = fscanf(sigfile, "%s", psuffix);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: No plant suffix: Unexpected EOF");
fclose(sigfile);
exit (1);
}



/*  count signals */


while (fscanf(sigfile, "%s", sigbuf) != EOF)
 {
num_signals++;
  }



/* define u_suffix_but_i  */

for (i = 0; i < num_signals; i++)
  {

rewind(sigfile);

/* read suffix  */
fscanf(sigfile, "%s", psuffix);

printf("\n(def u%s_but_%u (record\n", psuffix, i);

j = 0;
while (fscanf(sigfile, "%s", sigbuf) != EOF)
 {
   if (i != j)
      { printf("%s\n", sigbuf); }
   j++;

 } /* while */

printf("))\n", psuffix);


  }  /* for i */




fclose(sigfile);



}  /* main */

