/*
******************
file ureverse.c

Read file in format:

<plant_suffix>
sig_0
sig_1
...


argv[1] is the name of the file
containing 
<plant_suffix> and
list of signals (1 bit arrays).

Result on stdout

HYP:
Just one signal for line.
At least one signal.

On stdout we get:

reversed_u_suffix
******************
*/

#include <stdlib.h>
#include <stdio.h>

#define dbgflag 0  /* normal value: 0  */



#define USIZE 200


main(int argc, char* argv[])
{
/* dcls */
int i = 0;
unsigned int j = 0;
unsigned int num_signals = 0;
char **buf;


FILE *sigfile;

int ck_end ;

char sigbuf[USIZE];
char sigbuf2[USIZE];
char psuffix[USIZE];



/* prg  */


#if (dbgflag > 0)
setbuf(stdout, NULL);
setbuf(stderr, NULL);
#endif



#if (dbgflag > 0)
fprintf(stderr, "\nureverse: begin: input file: %s", argv[1]);
#endif


sigfile = fopen(argv[1], "r");

ck_end = fscanf(sigfile, "%s", psuffix);

if (ck_end == EOF)
/*   end of it  */
{
fprintf(stderr, "\n\nError: No plant suffix: Unexpected EOF");
fclose(sigfile);
exit (1);
}



/* define u_suffix and count signals */

printf("\n(def u%s (record\n", psuffix);


while (fscanf(sigfile, "%s", sigbuf) != EOF)
 {
num_signals++;
printf("%s\n", sigbuf);
  }

printf("))\n", psuffix);



#if (dbgflag > 0)
fprintf(stderr, "\nureverse: u_suffix done, define aux1_u_all");
#endif




/* suffix */
rewind(sigfile);

/* read suffix  */
fscanf(sigfile, "%s", psuffix);


printf("\n(def aux1_u%s (record\n", psuffix);


while (fscanf(sigfile, "%s", sigbuf) != EOF)
 {
printf("aux1_%s\n", sigbuf);
  }

printf("))\n", psuffix);



#if (dbgflag > 0)
fprintf(stderr, "\nureverse: aux_u_suffix done, malloc buf");
#endif



/* def buf  */

buf = (char **) malloc(sizeof(char *) * (num_signals + 1));

if (buf == NULL) exit(1);

/* ok, buf != NULL */

#if (dbgflag > 0)
fprintf(stderr, "\nureverse:  buf done");
#endif


rewind(sigfile);

/* read suffix  */
fscanf(sigfile, "%s", psuffix);

/* store signals */


#if (dbgflag > 0)
fprintf(stderr, "\nureverse:  store signals");
#endif

j = 0;

buf[j] = (char *) malloc(sizeof(char) * USIZE);
if (buf[j] == NULL) exit(1);

while (fscanf(sigfile, "%s", buf[j]) != EOF)
{

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: while j = %u, stored buf[%u] = %s",
j,
j,
buf[j]
);
#endif


j++;

buf[j] = (char *) malloc(sizeof(char) * USIZE);
if (buf[j] == NULL) exit(1);

 } /* while */

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: sig stored in buf");
#endif


/* get rid extra string */
free(buf[j]);


#if (dbgflag > 0)
fprintf(stderr, "\nureverse: print reversed_u_suffix");
#endif


/* print  reversed_u_suffix */

printf("\n(def reversed_u%s (record\n", psuffix);

for (i = num_signals - 1; i >= 0; i--)
  {

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: print: buf[%u] = %s", i, buf[i]);
#endif


    printf("%s\n", buf[i]); 

  }  /* for i */

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: printing done");
#endif


printf("))\n");



/* print  rev_aux1_u_suffix */

printf("\n(def rev_aux1_u%s (record\n", psuffix);

for (i = num_signals - 1; i >= 0; i--)
  {

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: print: buf[%u] = %s", i, buf[i]);
#endif


    printf("aux1_%s\n", buf[i]); 

  }  /* for i */

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: printing done");
#endif


printf("))\n");





printf("\n\n/*  Automatically generated ctr def  */\n\n");




printf(
"\n\n(def fsup_min (and fsup_all (forall aux1_u_all (imp (compose fsup_all u_all aux1_u_all) (leq reversed_u_all rev_aux1_u_all)))))\n\n" 
);



for (i = 0; i < num_signals; i++)
  {
printf("\n\n/*  %s  */", buf[i]);

printf("\n(def f_ctr_%u (exists u_all_but_%u fsup_min))", 
i, 
i
);

printf("\n(C_code f_ctr_%u)", i);

  }




fclose(sigfile);

#if (dbgflag > 0)
fprintf(stderr, "\nureverse: end");
#endif


}  /* main */

