/*
*********************************
file: usage.c
*********************************
*/



#include <stdlib.h>
#include <stdio.h>
#include <sys/time.h>
#include <sys/times.h>
#include <sys/resource.h>
#include <unistd.h>




#define dbg_flag 0  /*  normal value: 0  */




void print_rusage(FILE *fileptr)
{
/* declarations  */


struct rusage *usage;

struct tms *buf;


/* prg */


#if (dbg_flag > 0)
printf("\nprint_rusage: begin:");
#endif


#if 0
buf = (struct tms *) malloc(sizeof(*buf));

times(buf);

fprintf(fileptr, "\nuser time used: %f (sec.)", buf -> tms_utime);
fprintf(fileptr, "\nsystem time used: %f (sec.)", buf -> tms_stime);
#endif





usage = (struct rusage *) malloc(sizeof(*usage));

getrusage(RUSAGE_SELF, usage);



/* user time  */

#if 0
fprintf(fileptr, "\nusage: user time used: %f (sec.)", 
( (double) ((usage -> ru_utime).tv_sec) ) + 
( (double) ((usage -> ru_utime).tv_usec) )/((double) 1000000)
);

fprintf(fileptr, "\nusage: system time used: %f (sec.)", 
( (double) ((usage -> ru_stime).tv_sec) ) + 
( (double) ((usage -> ru_stime).tv_usec) )/((double) 1000000)
);
#endif


fprintf(fileptr, "\ncpu time: %f (sec.)",
( (double) ((usage -> ru_utime).tv_sec) ) + 
( (double) ((usage -> ru_utime).tv_usec) )/((double) 1000000)
);


#if 0
fprintf(fileptr, "\nmaximum resident set size: %ld", usage -> ru_maxrss);
fprintf(fileptr, "\nintegral shared memory size: %ld", usage -> ru_ixrss);
fprintf(fileptr, "\nintegral unshared data size: %ld", usage -> ru_idrss);
fprintf(fileptr, "\nintegral unshared stack size: %ld", usage -> ru_isrss);
fprintf(fileptr, "\npage reclaims  : %ld", usage -> ru_minflt);
#endif



/* end info */
fprintf(fileptr, "\n\n"); 


#ifdef LINUX_OS
system("ps u | egrep \"PID|bp\""); /* linux home PC */
#endif


#ifdef SOLARIS_OS
system("ps -lu $USER | egrep \"PID|bp\""); /* SUN, Solaris */
#endif

 


#if 0
fprintf(fileptr, "\n\nbye.\n\n"); 
#endif



#if (dbg_flag > 100)
printf("\nprint_rusage: end");
#endif

}    /*  main  */



