/*
******************************
Client.

Send string to server.

******************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>      /* AF_UNIX */
#include <sys/time.h>
#include <unistd.h>

#include <string.h>

#include "probes.h"

#define BUF_SIZE 100
#define NUM_BLK 100



#define DEFAULT_PROTOCOL 0 


#define dbg_flag 0  /* normal value: 0 */


static int serverLen, clientFd, result;
static struct sockaddr_un serverUNIXAddress;
static struct sockaddr *serverSockAddrPtr;

static int init_done = 0;
static int server_pid = 0;

static char buf[NUM_BLK*BUF_SIZE];


static void init_probe();


static void read_string(int fd, char *str);

static void alarm_handler();



void init_probe()
{

/* dcls */

char str[100];

/* prg */

#if (dbg_flag > 100)
fprintf(stderr, "\ninit_probe: begin");
#endif


/* install alarm handler */
signal(SIGALRM, alarm_handler);


serverSockAddrPtr = (struct sockaddr *) &serverUNIXAddress;
serverLen = sizeof(serverUNIXAddress);


clientFd = socket(AF_UNIX, SOCK_STREAM, DEFAULT_PROTOCOL);
serverUNIXAddress.sun_family = AF_UNIX;
strcpy(serverUNIXAddress.sun_path, "probe");

do
{
#if (dbg_flag > 100)
fprintf(stderr, "\ninit_probe: connecting");
#endif

 result = connect(clientFd, serverSockAddrPtr, serverLen);

#if (dbg_flag > 100)
fprintf(stderr, "\ninit_probe: connecting: result = %d", result);
#endif

 if (result == -1) sleep(1);

} while ( result == -1 );



#if (dbg_flag > 100)
fprintf(stderr, "\ninit_probe: connected: read server pid");
#endif


read_string(clientFd, str);
server_pid = atoi(str);

#if (dbg_flag > 100)
fprintf(stderr, 
"\ninit_probe:server pid = %d, send client pid = %d to server",
server_pid,
getpid()
);
#endif

sprintf(str, "%d", getpid());
write(clientFd, str, strlen(str) + 1);



}  /* init_probe()  */







void probesend(char *str)
{

int i;
static int k = 0;



#if (dbg_flag > 100)
fprintf(stderr, "\nprobesend: begin");
#endif

if (init_done == 0)
/* call init */
  {

fprintf(stderr, "\n\n\n\n**************************************");
fprintf(stderr, "\nPROBING ENABLED");
fprintf(stderr, "\n**************************************\n\n\n\n");


     init_probe();
      
     init_done = 1;

  }

#if (dbg_flag > 100)
fprintf(stderr, "\nprobesend: send string to probe server: %s", str);
#endif

if (k < NUM_BLK)
  {
strcpy(&(buf[BUF_SIZE*k]), str);


/* no need to pad buf */
#if 0
for (i = strlen(str) + 1; i < BUF_SIZE; i++)
    { buf[BUF_SIZE*k + i] = '\0'; }
#endif


    k++;

  }
else  /* k >= NUM_BLK */
  {

  write(clientFd, buf, NUM_BLK*BUF_SIZE);

  k = 0;
  }


#if (dbg_flag > 100)
fprintf(stderr, "\nprobesend: end string sending, stop server");
#endif


}  /* probesend()  */







void end_probe()
{

close(clientFd);

}  /* end_probe()  */











void read_string(int fd, char *str)
{
/* dcls */
int n;


/* prg */


do
  {

   do
     {
       n = read(fd, str, 1);
     } while (n <= 0);

  } while (*str++ != '\0');


}













void alarm_handler()
{


/* reinstall handler */

signal(SIGALRM, alarm_handler);


/* got alarm handler */

fprintf(stderr, "\nserver: got SIGALRM\n");

}  /* alarm_handler()   */

