/*
******************************
Experimenting with sockets
Client
******************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>      /* AF_UNIX */



#define DEFAULT_PROTOCOL 0 


#define dbg_flag 0  /* normal value: 0 */


void toserver(int fd);
void read_string(int fd, char *str);


main()
{

/* dcls */

int serverLen, clientFd, result;
struct sockaddr_un serverUNIXAddress;
struct sockaddr *serverSockAddrPtr;


/* prg */


serverSockAddrPtr = (struct sockaddr *) &serverUNIXAddress;
serverLen = sizeof(serverUNIXAddress);


clientFd = socket(AF_UNIX, SOCK_STREAM, DEFAULT_PROTOCOL);
serverUNIXAddress.sun_family = AF_UNIX;
strcpy(serverUNIXAddress.sun_path, "recipe");

do
{
 result = connect(clientFd, serverSockAddrPtr, serverLen);

 if (result == -1) sleep(1);

} while ( result == -1 );


#if (dbg_flag > 100)
fprintf(stderr, "\nclient: connected: talk to server");
#endif

while (1) toserver(clientFd);

#if (dbg_flag > 100)
fprintf(stderr, "\nclient: end conversation");
#endif

close(clientFd);
exit (0);

}  /* main  */





void toserver(int fd)
{
/* dcls */
char c;
char str[200];
int n;

/* prg */

/* read form server */

#if (dbg_flag > 100)
fprintf(stderr, "\ntoserver: read from server\n");
#endif


read_string(fd, str);
printf("\n%s", str);

#if (dbg_flag > 100)
fprintf(stderr, "\ntoserver: send to server: ");
#endif

/* send str to server */
scanf("%s", str);


#if (dbg_flag > 100)
fprintf(stderr, "\ntoserver: write to server: %s ", str);
#endif

write(fd, str, strlen(str) + 1);


#if (dbg_flag > 100)
fprintf(stderr, "\ntoserver: read line from server: ");
#endif

/* read answer server */

read_string(fd, str);
printf("%s", str);


#if (dbg_flag > 100)
fprintf(stderr, "\ntoserver: end with: %s", str);
#endif

} /* toserver */






void read_string(int fd, char *str)
{
/* dcls */
int n;


/* prg */


do
  {

   do
     {
       n = read(fd, str, 1);
     } while (n <= 0);

  } while (*str++ != '\0');


}


