/*
******************************
Server 

Shows on stdout strings
coming from client.

Client first send an alarm signal to server
and then send string.
******************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>      /* AF_UNIX */
#include <sys/time.h>
#include <unistd.h>



#define DEFAULT_PROTOCOL 0 


#define dbg_flag 0  /* normal value: 0 */


#define BUF_SIZE 100
#define NUM_BLK 100


void wrw(int fd);
int readLine(int fd, char *str);
void read_string(int fd, char *str);

void alarm_handler();


void read_string2(int fd, char *str);




main()
{

/* dcls */

int serverFd, clientFd, serverLen, clientLen;
struct sockaddr_un serverUNIXAddress;
struct sockaddr_un clientUNIXAddress;
struct sockaddr *serverSockAddrPtr;
struct sockaddr *clientSockAddrPtr;

char str[100];
int client_pid;


/* prg */

#if (dbg_flag > 100)
fprintf(stderr, "\nserver: begin\n");
#endif

setbuf(stdout, NULL);


/* install alarm handler */
signal(SIGALRM, alarm_handler);


signal(SIGCHLD, SIG_IGN);

serverSockAddrPtr = (struct sockaddr *) &serverUNIXAddress;
serverLen = sizeof(serverUNIXAddress);

clientSockAddrPtr = (struct sockaddr *) &clientUNIXAddress;
clientLen = sizeof(clientUNIXAddress);



serverFd = socket(AF_UNIX, SOCK_STREAM, DEFAULT_PROTOCOL);

serverUNIXAddress.sun_family = AF_UNIX;
strcpy(serverUNIXAddress.sun_path, "probe");
unlink("probe");
bind(serverFd, serverSockAddrPtr, serverLen);
listen(serverFd, 5);


while (1)
{


#if (dbg_flag > 100)
fprintf(stderr, "\nserver: call accept");
#endif

 clientFd = accept(serverFd, clientSockAddrPtr, &clientLen);

#if (dbg_flag > 100)
fprintf(stderr, "\nserver: accepted: clientFd = %u", clientFd);
#endif

 if (fork() == 0)
   {

#if (dbg_flag > 100)
fprintf(stderr, "\nserver: send server pid = %d to client\n", getpid());
#endif

sprintf(str, "%d", getpid());
write(clientFd, str, strlen(str) + 1);


#if (dbg_flag > 100)
fprintf(stderr, "\nserver: get client pid\n");
#endif

read_string(clientFd, str);
client_pid = atoi(str);


#if (dbg_flag > 100)
fprintf(stderr, "\nserver: client pid = %d; begin wrw\n", client_pid);
#endif

while (1) 
  {


#if (dbg_flag > 100)
fprintf(stderr, "\nserver: read client msg");
#endif


/* get client messagge */
     wrw(clientFd);


  }


#if (dbg_flag > 100)
fprintf(stderr, "\nserver: end wrw\n");
#endif

     
      close(clientFd);
      exit (0);
   }
 else  close(clientFd);


} /* while */


}  /* main  */














void wrw(int fd)
{
/* dcls */
int i = 0;
int n, last;
int k;

char line2[NUM_BLK*BUF_SIZE];

/* prg */


#if (dbg_flag > 100)
fprintf(stderr, "\nwrw: begin: read from client");
#endif



/* read */
read_string2(fd, line2);



#if (dbg_flag > 100)
fprintf(stderr, "\nwrw: got from client: %s", line2);
#endif


for (k = 0; k < NUM_BLK; k++)
   {
     /* echo client su stdout */
     fprintf(stdout, "%s\n", &(line2[BUF_SIZE*k]));
     
     k++;
   }





} /* wrw */










int readLine(int fd, char *str)
{
/* dcls */
int n;


/* prg */
do
  {
    n = read(fd, str, 1);

  } while (  (n > 0) &&  (*str++ != '\0') );

return (n > 0);

}



void read_string(int fd, char *str)
{
/* dcls */
int n;

fd_set rfds;
int retval;



/* prg */

/* watch fd for inputs  */

FD_ZERO(&rfds);
FD_SET(fd, &rfds);


do
  {

     retval = select(fd + 1, &rfds, NULL, NULL, NULL);

     /* there is a char to read from fd */
       n = read(fd, str, 1);


  } while (*str++ != '\0');


}  /* read ... ()  */














void read_string2(int fd, char *str)
{
/* dcls */
int n;

fd_set rfds;
int retval;



/* prg */

/* watch fd for inputs  */

FD_ZERO(&rfds);
FD_SET(fd, &rfds);

     retval = select(fd + 1, &rfds, NULL, NULL, NULL);

     /* there is a block sequence to read from fd */

read(fd, str, NUM_BLK*BUF_SIZE);



}  /* read ... ()  */








void alarm_handler()
{


/* reinstall handler */

signal(SIGALRM, alarm_handler);


/* got alarm handler */

fprintf(stderr, "\nserver: got SIGALRM\n");

}  /* alarm_handler()   */





