/*
**********************************************
Example.
server1.c, client1.c

Processes server1, client1 work as follows.

Start server1 and then client1.

The server send a string to the client
("server ready: "). 
This string is the client prompt.

At the prompt from client1
input a string (no blanks).
The client send such string to the server
which answers reversing the string and sending
it to the client which, in turn,
dipslays it on stdout.
**********************************************
*/

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>      /* AF_UNIX */



#define DEFAULT_PROTOCOL 0 


#define dbg_flag 0  /* normal value: 0 */



void wrw(int fd);
void read_string(int fd, char *str);


main()
{

/* dcls */

int serverFd, clientFd, serverLen, clientLen;
struct sockaddr_un serverUNIXAddress;
struct sockaddr_un clientUNIXAddress;
struct sockaddr *serverSockAddrPtr;
struct sockaddr *clientSockAddrPtr;


/* prg */

signal(SIGCHLD, SIG_IGN);

serverSockAddrPtr = (struct sockaddr *) &serverUNIXAddress;
serverLen = sizeof(serverUNIXAddress);

clientSockAddrPtr = (struct sockaddr *) &clientUNIXAddress;
clientLen = sizeof(clientUNIXAddress);



serverFd = socket(AF_UNIX, SOCK_STREAM, DEFAULT_PROTOCOL);
serverUNIXAddress.sun_family = AF_UNIX;
strcpy(serverUNIXAddress.sun_path, "recipe");
unlink("recipe");
bind(serverFd, serverSockAddrPtr, serverLen);
listen(serverFd, 5);


while (1)
{
 clientFd = accept(serverFd, clientSockAddrPtr, &clientLen);

 if (fork() == 0)
   {

#if (dbg_flag > 100)
fprintf(stderr, "server: begin wrw\n");
#endif

while (1) wrw(clientFd);

#if (dbg_flag > 100)
fprintf(stderr, "\nserver: end wrw\n");
#endif

     
      close(clientFd);
      exit (0);
   }
 else  close(clientFd);


} /* while */


}  /* main  */














void wrw(int fd)
{
/* dcls */
int i = 0;
int n, last;

static char* line1 = "server ready: ";
static char line2[100];
static char line3[100];

/* prg */

#if (dbg_flag > 100)
fprintf(stderr, "\nwrw: begin: send to client");
#endif

write(fd, line1, strlen(line1) + 1);

#if (dbg_flag > 100)
fprintf(stderr, "\nwrw: read from client");
#endif

/* read */

read_string(fd, line2);


#if (dbg_flag > 100)
fprintf(stderr, "\nwrw: echo to stderr: %s", line2);
#endif

/* echo client su stderr */
fprintf(stderr, "server got: %s\n", line2);


#if (dbg_flag > 100)
fprintf(stderr, "\nwrw: send reversed string to client");
#endif

/* write reversed */

for (i = strlen(line2) - 1; i >= 0; i--)
   {
      write(fd, &(line2[i]), 1);

   }


/* add '\0'   */
write(fd, &(line2[strlen(line2)]), 1);




} /* wrw */







void read_string(int fd, char *str)
{
/* dcls */
int n;


/* prg */


do
  {

   do
     {
       n = read(fd, str, 1);
     } while (n <= 0);

  } while (*str++ != '\0');


}


