
/*
**
**  file symbtab.h
**
**
**  primitives for hash table
**
*/


#ifndef symbol_table_h
#define symbol_table_h


#include <stdio.h>
#include <stdlib.h>






void* get_symbol_table();
void* create_symb_table(unsigned int  size);
void delete_symbtab(void* T);



/*
If entry with key is in symbol_table T then return pointer to bucket,
else return NULL.
*/


void* read_symbtab_bucket(void* T, char* key); 
void write_symbtab_bucket(void* T, void* bucket);
void* read_symbtab_entry(void* T, unsigned int i);


unsigned int get_symbtab_size(void* T);
unsigned int get_symbtab_elements(void* T);
unsigned int get_symbtab_nonnull(void* T);

void print_symbtab(FILE *myfile, void* T);


void* get_new_stbk();
char* read_stbk_key(void* v);
void* read_stbk_info(void* v);
void write_stbk_key(void* v, char* value);
void write_stbk_key(void* v, char* value);
unsigned int read_stbk_tkcode(void* v);
void write_stbk_tkcode(void* v, unsigned int value);

unsigned int get_st_maxsize(void* T);


char* duplicate_key(char* keyval);


void* free_symbtab_bucket(void* T, char* key);


#include "st.h"


#endif





