/*
**
**  file: delee.c
**
*/




#include "local.h"


#define dbg_flag 0  /*  normal value:  0  */



/*
*******************************
No deleting on info (value) field.

No key is deleted
since used by idreg's.
*******************************
*/









void delete_symbtab(void* T)
{

/* declarations  */
  ht_value *v, *p;
  unsigned int i;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif

/* programs  */


#if (dbg_flag > 10)
printf("\n\ndelete_symbtab:%u: begin: symbol_table = 0x%x",
count,
T
);
#endif


    for (i = 0; i < get_symbtab_size(T); i++)
       {


#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: delete row %u",
count,
i
);
#endif




          v = (ht_value *) ( ((hash_table *) T) -> table[i] );
          

 


        
          while (v != NULL)
          {

#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: delete row %u: bucket 0x%x != NULL: key = %s",
count,
i,
v,
read_stbk_key((void *) v)
);
#endif 


             p = read_stbk_next((void *) v);

#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: next bucket = 0x%x",
count,
p
);
#endif
             free(v);

#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: freed bucket = 0x%x",
count,
v
);
#endif

             v = p;


          }




#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: row %u deleted (bucket 0x%x == NULL)",
count,
i,
v
);
#endif 

          
       }



#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: all rows deleted: free table: 0x%x",
count,
((hash_table *) T) -> table
);
#endif


free(((hash_table *) T) -> table);




#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: free table header: 0x%x",
count,
T
);
#endif


free(T);


#if (dbg_flag > 10)
printf("\ndelete_symbtab:%u: end",
count
);
#endif

}  /* end program  */
