/*
**
**  file: write.lkup.table
**
*/

/*
**  Remove bucket with given key
**
**  Returns pointer to info if bucket exists,
**  NULL else.
**
*/



#include "local.h"

#define dbg_flag 0   /* normal value: 0 */
#define dbg_msg 0   /* normal value: 0 */

#define measure_non_null 0

#define donot_free_key 0  /* normal value: 0 */



void* free_symbtab_bucket(void* T, char* key)
{

/* declarations  */
  void *p, *p_old;
  unsigned int a;  
  void* value;
  void *info_ptr;

#if ( (dbg_flag > 0) || (dbg_msg > 0) )
static int count = 0;
count++;
#endif

/* programs  */


#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 100: symbol_table = 0x%x, bucket = 0x%x",
count,
T,
v);
#endif


/*  hash key   */
a = symbtab_hash(get_symbtab_size(T), key);


#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 200: key = %s, info = 0x%x, hash = %u", 
count, 
key, 
value, 
a);
#endif



   if (  (ht_value *) ( ((hash_table *) T) -> table[a] ) == NULL )
   /* then: no data with given key  */
        {

#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 300: no data with given key", count);
#endif

          return (NULL);

 
           
         };  








/*  ((hash_table *) T) -> table[a] != NULL  */

#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 400: p = 0x%x != NULL",
count,
(ht_value *) ((hash_table *) T) -> table[a]
);
#endif


   p = (ht_value *) ((hash_table *) T) -> table[a];




/*  p !=  NULL  */



    if (  strcmp(key, read_stbk_key(p)) < 0  
                           /*  key < read_stbk_key(p) */
       )
    /* then:  not in ht.  */
         {

          return (NULL);

         }




/* key >= read_stbk_key(p) */


    if (  strcmp(key, read_stbk_key(p)) == 0  
                           /*  key < read_stbk_key(p) */
       )
    /* then:  found: insert on head  */
         {

          info_ptr = read_stbk_info(p);

          ((hash_table *) T) -> table[a] = (ht_value) read_stbk_next(p);


          ((hash_table *) T) -> elements_in_table = 
                           ((hash_table *) T) -> elements_in_table - 1;

#if (donot_free_key == 0)
           free(read_stbk_key(p));
#endif

           free(p);


#if (dbg_msg > 10)
fprintf(stderr, "\nfree_symbtab_bucket:%u: free from head: st size = %u",
count,
((hash_table *) T) -> elements_in_table
);
#endif


           return (info_ptr);

          } 




/*  
**  key > read_stbk_key(p)
**  Thus while body executed at least once
*/


#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 500: key >= read_stbk_key(p)",
count
);
printf("\nread_stbk_key(p) = %s, strcmp(read_stbk_key(p), key) = %d",
read_stbk_key(p),
strcmp(read_stbk_key(p), key)
);
#endif

   while ( strcmp(read_stbk_key(p), key) < 0
                            /*    read_stbk_key(p) < key */
         ) 
      {

#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 520. p = 0x%x: strcmp(read_stbk_key(p), key) = %d",
count,
p,
strcmp(read_stbk_key(p), key)
);
printf("\nread_stbk_key(p) = %s, strcmp(read_stbk_key(p), key) = %d",
read_stbk_key(p),
strcmp(read_stbk_key(p), key)
);

#endif



        p_old = p;
        p = read_stbk_next(p);

#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 530. p = 0x%x",
count,
p
);
#endif

        if (p == NULL) break;

      }


#if (dbg_flag > 0)
printf("\nfree_symbtab_bucket:%u: ckp 600: p = 0x%x",
count,
p
);
#endif


/*  
**  key > read_stbk_key(p_old)
**  key <= read_stbk_key(p)
**  p may be NULL
**  if p != NULL then key => read_stbk_key(p)
*/

         if (p != NULL)
           {
             if ( strcmp(read_stbk_key(p), key) == 0 )
               {   /* key == read_stbk_key(p)  */

                     info_ptr = read_stbk_info(p);

                    
          ((hash_table *) T) -> elements_in_table = 
                           ((hash_table *) T) -> elements_in_table - 1;


                   write_stbk_next(p_old, read_stbk_next(p));

#if (donot_free_key == 0)
                   free(read_stbk_key(p));
#endif

                   free(p);

#if (dbg_msg > 10)
fprintf(stderr, "\nfree_symbtab_bucket:%u: free from list: st size = %u",
count,
((hash_table *) T) -> elements_in_table
);
#endif


                   return (info_ptr);
              }
           }





}  /* end program  */
