/*
**
**  file: write.lkup.table
**
*/

/*
**  insert new element in table
**
**  if data with same key already in table
**  new data inserted anyway (an the old one stays)
**
**
**  Returns bucket where writing occurs
*/



#include "local.h"

#define dbg_flag 0
#define measure_non_null 0



void write_symbtab_bucket(void* T, void* v /* bucket */)
{

/* declarations  */
  void *p, *p_old;
  unsigned int a;  
  char* key;
  void* value;

#if (dbg_flag > 0)
static int count = 0;
count++;
#endif

/* programs  */


#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 100: symbol_table = 0x%x, bucket = 0x%x",
count,
T,
v);
#endif



/*  hash key   */
key = read_stbk_key(v);
value = read_stbk_info(v);
a = symbtab_hash(get_symbtab_size(T), key);


#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 200: key = %s, info = 0x%x, hash = %u", 
count, 
key, 
value, 
a);
#endif


/* update maxsize_sofar  */
if ( ((hash_table *) T) -> elements_in_table + 1
     >
     ((hash_table *) T) -> maxsize_sofar
   )
{
((hash_table *) T) -> maxsize_sofar
=
((hash_table *) T) -> elements_in_table + 1;
}



   if (  (ht_value *) ( ((hash_table *) T) -> table[a] ) == NULL )
   /* then: no data with given key  */
        {

#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 300: no data with given key", count);
#endif

          write_stbk_next(v, NULL);
          
          ((hash_table *) T) -> table[a] = (ht_value) v;

          ((hash_table *) T) -> elements_in_table = 
						((hash_table *) T) -> elements_in_table + 1;



#if (measure_non_null > 0)
/* update non_null_entry  */
          ((hash_table *) T) -> non_null_entry = 
((hash_table *) T) -> non_null_entry + 1;
#endif



           return ;   
           
         };  



/*  ((hash_table *) T) -> table[a] != NULL  */

#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 400: p = 0x%x != NULL",
count,
(ht_value *) ((hash_table *) T) -> table[a]
);
#endif


   p = (ht_value *) ((hash_table *) T) -> table[a];




/*  p !=  NULL  */


    if (  strcmp(key, read_stbk_key(p)) <= 0  
                           /*  key < read_stbk_key(p) */
       )
    /* then:  insert on head  */
         {

          write_stbk_next(v, p);

          ((hash_table *) T) -> table[a] =  (ht_value) v;

          ((hash_table *) T) -> elements_in_table = 
                           ((hash_table *) T) -> elements_in_table + 1;

           return ;

          } 




/*  
**  key > read_stbk_key(p)
**  Thus while body executed at least once
*/


#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 500: key >= read_stbk_key(p)",
count
);
printf("\nread_stbk_key(p) = %s, strcmp(read_stbk_key(p), key) = %d",
read_stbk_key(p),
strcmp(read_stbk_key(p), key)
);
#endif

   while ( strcmp(read_stbk_key(p), key) < 0
                            /*    read_stbk_key(p) < key */
         ) 
      {

#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 520. p = 0x%x: strcmp(read_stbk_key(p), key) = %d",
count,
p,
strcmp(read_stbk_key(p), key)
);
printf("\nread_stbk_key(p) = %s, strcmp(read_stbk_key(p), key) = %d",
read_stbk_key(p),
strcmp(read_stbk_key(p), key)
);

#endif



        p_old = p;
        p = read_stbk_next(p);

#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 530. p = 0x%x",
count,
p
);
#endif

        if (p == NULL) break;

      }


#if (dbg_flag > 0)
printf("\nwrite_symbtab:%u: ckp 600: p = 0x%x",
count,
p
);
#endif


/*  
**  key > read_stbk_key(p_old)
**  key <= read_stbk_key(p)
**  p may be NULL
*/



          write_stbk_next(v, p);
          write_stbk_next(p_old, v);
          

          ((hash_table *) T) -> elements_in_table = 
                           ((hash_table *) T) -> elements_in_table + 1;



      return ;




}  /* end program  */
